﻿ 
data vendor;
  length Vendor $8 Margin $12 Cost $10 vlabl $50;
  infile datalines dlm=',' dsd;
  input x y Vendor $ Pct MCGroup Margin $ Cost $;
  vlabl = catx(': ',vendor, catt(pct,'%'));
return;
datalines;
1,2,Vendor A, 19, 1,Low Margin, High Cost
15,60,Vendor B, 2.5, 2,High Margin, High Cost
20,80,Vendor C, 11, 2,High Margin, High Cost
59,85,Vendor D, 8, 3,High Margin, Low Cost
64,64,Vendor E, 7.5 , 3,High Margin, Low Cost
86,82,Vendor F, 27, 3,High Margin, Low Cost
60,17,Vendor G, 5, 4,Low Margin, Low Cost
67,34,Vendor H, 5, 4,Low Margin, Low Cost
70,0,Vendor I, 5 ,4, Low Margin, Low Cost
89,36,Vendor J, 10, 4,Low Margin, Low Cost
;
run;

proc print data=vendor;
run;

title 'Margin Bubble';
proc sgplot data=vendor noautolegend;
  bubble x=x y=y size=pct / group=MCGroup datalabel=vlabl dataskin=gloss
    bradiusmin=15 bradiusmax=45  
      datalabelattrs=(color=black size=8pt weight=bold) ;
  inset "Low Margin, Low Cost" / position=bottomright textattrs=(size=8pt weight=bold);
  inset "High Margin, Low Cost" / position=right textattrs=(size=8pt weight=bold);
  inset "High Margin, High Cost" / position=topleft textattrs=(size=8pt weight=bold);
  inset "Low Margin, High Cost" / position=bottomleft textattrs=(size=8pt weight=bold);
  refline 50 /axis=x;
  refline 50 / axis=y;
  yaxis display=none values=(0 to 100 by 10);
  xaxis display=none values=(0 to 100 by 10);
run;

data polydata;
   input id polyx polyy;
datalines;
1  0  0
1 50  0
1 50 50
1  0 50
1  0  0
;
run;

data bubble_poly;
  set vendor polydata;
run;

title 'Margin Bubble with Poly (new in 9.4)';
proc sgplot data=bubble_poly noautolegend;
  bubble x=x y=y size=pct / group=MCGroup datalabel=vlabl dataskin=gloss
    bradiusmin=15 bradiusmax=45  
      datalabelattrs=(color=black size=8pt weight=bold) ;
  inset "Low Margin, Low Cost" / position=bottomright textattrs=(size=8pt weight=bold);
  inset "High Margin, Low Cost" / position=right textattrs=(size=8pt weight=bold);
  inset "High Margin, High Cost" / position=topleft textattrs=(size=8pt weight=bold);
  inset "Low Margin, High Cost" / position=bottomleft textattrs=(size=8pt weight=bold);
  refline 50 /axis=x;
  refline 50 / axis=y;
  yaxis display=none values=(0 to 100 by 10);
  xaxis display=none values=(0 to 100 by 10);
 

  polygon x=polyX y=polyY id=ID / fill 
           fillattrs=(color=lightblue transparency=0.75);
run;
