﻿   
** create macro variable for complete path where ODS files ;
** and images for HTML will be stored;
** this is the location I used for the 2022 presentation;
** you will need to copy the output folder from the zip file into;
** the location you choose for your results;

%let outpath=C:\temp\output;
%put path for output is: &outpath;

** if you want to write these files to a permanent library, then you need to change the LIBNAME location;
** using this form of the LIBNAME statement will allow programs with data=orion.xxx or data=work.xxx to run correctly;
libname orion (work);

ods listing;

** Turn ODS GRAPHICS off;
** in case there is an autoexec or EG open destination;
ods graphics off;
         
** Set LISTING options and style and system options;
ods listing sge=off style=listing;
options nodate nonumber gstyle orientation=portrait nofmterr;

 

proc format;
  value $GENDER 'F' = 'Female'
                'M' = 'Male';

  value ORDER_TYPE 1 = 'Retail Sale'
                   2 = 'Catalog Sale'
                   3 = 'Internet Sale';

  value $COUNTRY 'AD' = 'Andorra'
           'AE' = 'United Arab Emirates'
           'AF' = 'Afghanistan'
           'AG' = 'Antigua/Barbuda'
           'AI' = 'Anguilla'
           'AL' = 'Albania'
           'AM' = 'Armenia'
           'AN' = 'Netherlands Antilles'
           'AO' = 'Angola'
           'AQ' = 'Antarctica'
           'AR' = 'Argentina'
           'AS' = 'American Samoa'
           'AT' = 'Austria'
           'AU' = 'Australia'
           'AW' = 'Aruba'
           'AZ' = 'Azerbaijan'
           'BA' = 'Bosnia/Herzegovina'
           'BB' = 'Barbados'
           'BD' = 'Bangladesh'
           'BE' = 'Belgium'
           'BF' = 'Burkina Faso'
           'BG' = 'Bulgaria'
           'BH' = 'Bahrain'
           'BI' = 'Burundi'
           'BJ' = 'Benin'
           'BM' = 'Bermuda'
           'BN' = 'Brunei'
           'BO' = 'Bolivia'
           'BR' = 'Brazil'
           'BS' = 'Bahamas'
           'BT' = 'Bhutan'
           'BV' = 'Bouvet Island'
           'BW' = 'Botswana'
           'BY' = 'Belarus'
           'BZ' = 'Belize'
           'CA' = 'Canada'
           'CC' = 'Cocos Islands'
           'CD' = 'Congo'
           'CF' = 'Central African Rep.'
           'CG' = 'Congo'
           'CH' = 'Switzerland'
           'CI' = 'Ivory Coast'
           'CK' = 'Cook Islands'
           'CL' = 'Chile'
           'CM' = 'Cameroon'
           'CN' = 'China'
           'CO' = 'Colombia'
           'CR' = 'Costa Rica'
           'CU' = 'Cuba'
           'CV' = 'Cape Verde'
           'CX' = 'Christmas Island'
           'CY' = 'Cyprus'
           'CZ' = 'Czech Republic'
           'DA' = 'Germany'
           'DE' = 'Germany'
           'DJ' = 'Djibouti'
           'DK' = 'Denmark'
           'DM' = 'Dominica'
           'DO' = 'Dominican Republic'
           'DZ' = 'Algeria'
           'EC' = 'Ecuador'
           'EE' = 'Estonia'
           'EG' = 'Egypt'
           'EH' = 'Western Sahara'
           'ER' = 'Eritrea'
           'ES' = 'Spain'
           'ET' = 'Ethiopia'
           'FI' = 'Finland'
           'FJ' = 'Fiji'
           'FK' = 'Falkland Islands'
           'FM' = 'Micronesia'
           'FO' = 'Faroe Islands'
           'FR' = 'France'
           'GA' = 'Gabon'
           'GB' = 'United Kingdom'
           'GD' = 'Grenada'
           'GE' = 'Georgia'
           'GF' = 'French Guiana'
           'GH' = 'Ghana'
           'GI' = 'Gibraltar'
           'GL' = 'Greenland'
           'GM' = 'Gambia'
           'GN' = 'Guinea'
           'GP' = 'Guadeloupe'
           'GQ' = 'Equatorial Guinea'
           'GR' = 'Greece'
           'GT' = 'Guatemala'
           'GU' = 'Guam'
           'GW' = 'Guinea-Bissau'
           'GY' = 'Guyana'
           'HK' = 'Hong Kong'
           'HM' = 'Heard/Mcdonald'
           'HN' = 'Honduras'
           'HR' = 'Croatia'
           'HT' = 'Haiti'
           'HU' = 'Hungary'
           'ID' = 'Indonesia'
           'IE' = 'Ireland'
           'IL' = 'Israel'
           'IN' = 'India'
           'IO' = 'British Indian Ocean'
           'IQ' = 'Iraq'
           'IR' = 'Iran'
           'IS' = 'Iceland'
           'IT' = 'Italy'
           'JM' = 'Jamaica'
           'JO' = 'Jordan'
           'JP' = 'Japan'
           'KE' = 'Kenya'
           'KG' = 'Kyrgyzstan'
           'KH' = 'Cambodia'
           'KI' = 'Kiribati'
           'KM' = 'Comoros'
           'KN' = 'Saint Kitts/Nevis'
           'KP' = 'Korea, North'
           'KR' = 'Korea, South'
           'KW' = 'Kuwait'
           'KY' = 'Cayman Islands'
           'KZ' = 'Kazakhstan'
           'LA' = 'Laos'
           'LB' = 'Lebanon'
           'LC' = 'St. Lucia'
           'LI' = 'Liechtenstein'
           'LK' = 'Sri Lanka'
           'LR' = 'Liberia'
           'LS' = 'Lesotho'
           'LT' = 'Lithuania'
           'LU' = 'Luxembourg'
           'LV' = 'Latvia'
           'LY' = 'Libya'
           'MA' = 'Morocco'
           'MC' = 'Monaco'
           'MD' = 'Moldova'
           'MG' = 'Madagascar'
           'MH' = 'Marshall Islands'
           'MK' = 'Macedonia'
           'ML' = 'Mali'
           'MM' = 'Myanmar'
           'MN' = 'Mongolia'
           'MO' = 'Macau'
           'MP' = 'Northern Mariana Islands'
           'MQ' = 'Martinique'
           'MR' = 'Mauritania'
           'MS' = 'Montserrat'
           'MT' = 'Malta'
           'MU' = 'Mauritius'
           'MV' = 'Maldives'
           'MW' = 'Malawi'
           'MX' = 'Mexico'
           'MY' = 'Malaysia'
           'MZ' = 'Mozambique'
           'NA' = 'Namibia'
           'NC' = 'New Caledonia'
           'NE' = 'Niger'
           'NF' = 'Norfolk Island'
           'NG' = 'Nigeria'
           'NI' = 'Nicaragua'
           'NL' = 'Netherlands'
           'NO' = 'Norway'
           'NP' = 'Nepal'
           'NR' = 'Nauru'
           'NU' = 'Niue'
           'NZ' = 'New Zealand'
           'OM' = 'Oman'
           'PA' = 'Panama'
           'PE' = 'Peru'
           'PF' = 'French Polynesia'
           'PG' = 'Papua New Guinea'
           'PH' = 'Philippines'
           'PK' = 'Pakistan'
           'PL' = 'Poland'
           'PM' = 'St. Pierre/Miquelon'
           'PN' = 'Pitcairn Islands'
           'PR' = 'Puerto Rico'
           'PS' = 'Gaza Strip'
           'PT' = 'Portugal'
           'PW' = 'Palau'
           'PY' = 'Paraguay'
           'QA' = 'Qatar'
           'RE' = 'Reunion'
           'RO' = 'Romania'
           'RU' = 'Russia'
           'RW' = 'Rwanda'
           'SA' = 'Saudi Arabia'
           'SB' = 'Solomon Islands'
           'SC' = 'Seychelles'
           'SD' = 'Sudan'
           'SE' = 'Sweden'
           'SG' = 'Singapore'
           'SH' = 'St. Helena'
           'SI' = 'Slovenia'
           'SJ' = 'Svalbard'
           'SK' = 'Slovakia'
           'SL' = 'Sierra Leone'
           'SM' = 'San Marino'
           'SN' = 'Senegal'
           'SO' = 'Somalia'
           'SR' = 'Suriname'
           'ST' = 'Sao Tome/Principe'
           'SV' = 'El Salvador'
           'SY' = 'Syria'
           'SZ' = 'Swaziland'
           'TC' = 'Turks/Caicos Islands'
           'TD' = 'Chad'
           'TF' = 'French Southern Terr.'
           'TG' = 'Togo'
           'TH' = 'Thailand'
           'TJ' = 'Tajikistan'
           'TK' = 'Tokelau'
           'TM' = 'Turkmenistan'
           'TN' = 'Tunisia'
           'TO' = 'Tonga'
           'TP' = 'East Timor'
           'TR' = 'Turkey'
           'TT' = 'Trinidad and Tobago'
           'TV' = 'Tuvalu'
           'TW' = 'Taiwan'
           'TZ' = 'Tanzania'
           'UA' = 'Ukraine'
           'UG' = 'Uganda'
           'US' = 'United States'
           'UY' = 'Uruguay'
           'UZ' = 'Uzbekistan'
           'VC' = 'Saint Vincent/Grenadines'
           'VE' = 'Venezuela'
           'VG' = 'British Virgin Islands'
           'VI' = 'Virgin Islands (U.S.)'
           'VN' = 'Vietnam'
           'VU' = 'Vanuatu'
           'WF' = 'Wallis/Futuna Islands'
           'WS' = 'Samoa'
           'XX' = 'Zaire'
           'YE' = 'Yemen'
           'YT' = 'Mayotte'
           'YU' = 'Yugoslavia'
           'ZA' = 'South Africa'
           'ZM' = 'Zambia'
           'ZW' = 'Zimbabwe';
run;

data orion.heart;
  set sashelp.heart;
run;

** programs used to make data for original paper;
** might need to rerun these programs if you have a 64 bit system;
data ORION.BACK_ORDERS;
   attrib Orders length=8 label='Number of Backorders';
   attrib Price length=8 label='Total Retail Price';
   attrib StateCode length=$2;
   attrib Region length=$9;

   infile datalines dsd;
   input
      Orders
      Price
      StateCode
      Region
   ;
datalines4;
21,1042.39,AK,Portland
25,1327.42,AL,Raleigh
25,1179.93,AR,Beaumont
33,1975.55,AZ,Portland
127,7233.77,CA,Portland
45,2192.52,CO,Cheyenne
33,1598.92,CT,Boston
40,2009.89,DE,Boston
44,2092.23,FL,Raleigh
41,1956.01,GA,Raleigh
25,1234.88,HI,Portland
19,1060.26,IA,Cheyenne
24,1308.07,ID,Portland
49,2325.31,IL,Rockford
99,4820.24,IN,Rockford
17,820.73,KS,Cheyenne
66,3316.49,KY,Rockford
70,3628.71,LA,Beaumont
28,1473.76,MA,Boston
34,1683.87,MD,Boston
49,2531.83,ME,Boston
64,3212.88,MI,Rockford
42,2217.64,MN,Rockford
9,502.25,MO,Cheyenne
17,768.8,MS,Raleigh
44,2024.87,MT,Cheyenne
34,1633.59,NC,Raleigh
17,759.62,NE,Cheyenne
24,1203.83,NH,Boston
58,2597.64,NJ,Boston
81,3951.34,NV,Portland
72,3774.76,NY,Boston
48,2410.18,OH,Rockford
26,1198.03,OK,Beaumont
53,3139.99,OR,Portland
14,685.05,PA,Boston
38,1764.08,RI,Boston
41,2229.5,SC,Raleigh
16,747.91,SD,Cheyenne
33,1615.87,TN,Raleigh
37,1798.71,TX,Beaumont
48,2213.08,UT,Cheyenne
46,2189.44,VA,Boston
20,992.65,VT,Boston
49,2796.38,WA,Portland
18,830.57,WI,Rockford
43,2140.32,WV,Boston
19,961.58,WY,Cheyenne
;;;;
run;

data ORION.BUDGET;
   attrib Month length=8;
   attrib Yr2003 length=8 format=DOLLAR10.;
   attrib Yr2004 length=8 format=DOLLAR10.;
   attrib Yr2005 length=8 format=DOLLAR10.;
   attrib Yr2006 length=8 format=DOLLAR10.;
   attrib Yr2007 length=8 format=DOLLAR10.;

   infile datalines dsd;
   input
      Month
      Yr2003
      Yr2004
      Yr2005
      Yr2006
      Yr2007 ;
datalines4;
1,1590000,1880000,2300000,1960000,1970000
2,1290000,1550000,1830000,1480000,1640000
3,1160000,1380000,1640000,1410000,1440000
4,1710000,2100000,2420000,2130000,2270000
5,1990000,2350000,2840000,2480000,2670000
6,2560000,3020000,3580000,3070000,3410000
7,2590000,2890000,3550000,3010000,3490000
8,2550000,2840000,3580000,3030000,3500000
9,1070000,1180000,1550000,1260000,1520000
10,1160000,1270000,1600000,1360000,1700000
11,1260000,1470000,1780000,1540000,1950000
12,2870000,3120000,3760000,3210000,4370000
;;;;
run;

data ORION.CUSTOMER_ORDERS;
   attrib Customer_ID length=8 label='Customer ID' format=12.;
   attrib Customer_Name length=$40 label='Customer Name';
   attrib Customer_Country length=$2 label='Customer Country' format=$COUNTRY.;
   attrib Customer_Type length=$40 label='Customer Type Name';
   attrib Customer_Age length=3 label='Customer Age';
   attrib Customer_Age_Group length=$12 label='Customer Age Group';
   attrib Customer_Gender length=$1 label='Customer Gender' format=$GENDER.;
   attrib Order_Type length=3 label='Order Type' format=ORDER_TYPE.;
   attrib Order_ID length=8 label='Order ID' format=12.;
   attrib Order_Date length=8 label='Date Order was placed by Customer' format=DATE9.;
   attrib Delivery_Date length=8 label='Date Order was Delivered' format=DATE9.;
   attrib Order_Item_Num length=3 label='Order Item Number';
   attrib Discount length=8 label='Discount in percent of Normal Total Retail Price' format=PERCENT.;
   attrib Quantity length=3 label='Quantity Ordered';
   attrib Total_Retail_Price length=8 label='Total Retail Price for This Product' format=DOLLAR13.2;
   attrib Product_Group length=8;
   attrib Product_Category length=8;
   attrib Product_Line length=8;
   attrib Product_ID length=8 label='Product ID' format=12.;
   attrib Product_Name length=$45 label='Product Name';

   infile datalines dsd;
   input
      Customer_ID
      Customer_Name
      Customer_Country
      Customer_Type
      Customer_Age
      Customer_Age_Group
      Customer_Gender
      Order_Type
      Order_ID
      Order_Date
      Delivery_Date
      Order_Item_Num
      Discount
      Quantity
      Total_Retail_Price
      Product_Group
      Product_Category
      Product_Line
      Product_ID
      Product_Name
   ;
datalines4;
20504,Charles Wall-Ellis,US,Orion Club Gold members low activity,23,15-30 years,M,3,1230010084,15707,15709,2,,2,169.8,2202003,2202,22,220200300121,Starlite Shoes
6755,Adolf Rota,IT,Orion Club Gold members low activity,58,46-60 years,M,2,1230029680,15711,15716,3,,2,134.2,2202003,2202,22,220200300052,Armadillo Women's Running Shoes
7802,Marina Bezold,DE,Orion Club Gold members low activity,21,15-30 years,F,3,1230038244,15713,15717,1,,1,50.3,2202001,2202,22,220200100137,Big Guy Men's Multicourt Ii Shoes
22861,Leigh-Erin Duffie,US,Orion Club Gold members low activity,21,15-30 years,F,3,1230054921,15715,15720,1,,1,104.3,2202001,2202,22,220200100029,Big Guy Men's Air Baltoro Shoes
22861,Leigh-Erin Duffie,US,Orion Club Gold members low activity,21,15-30 years,F,3,1230054921,15715,15720,2,,2,251.6,2202001,2202,22,220200100057,Big Guy Men's Air Mickey Willy Shoes
5263,Wenxiao El-Zohr,US,Orion Club Gold members low activity,48,46-60 years,F,2,1230069391,15718,15722,2,,2,118,2202002,2202,22,220200200009,Cruise 1984 Men's Street Shoes
9483,Johannes Spitzer,DE,Orion Club Gold members low activity,53,46-60 years,M,3,1230109416,15726,15729,1,,1,89.5,2202001,2202,22,220200100132,Big Guy Men's Klickitat Mid Shoes
17270,Patrice Segonds,FR,Orion Club Gold members low activity,68,61-75 years,M,2,1230128106,15729,15740,1,,2,20.2,2102007,2102,21,210200700013,Slomo Balance Children's Shoes
19248,Petra Rieckhoff,DE,Orion Club Gold members low activity,43,31-45 years,F,3,1230136507,15731,15733,1,,2,191,2202002,2202,22,220200200039,Soft Cumulus Men's Running Shoes
18887,Javier Sanz de Pablos,ES,Orion Club Gold members low activity,38,31-45 years,M,2,1230143132,15732,15735,1,,1,93.1,2202003,2202,22,220200300056,Banto Light Men's Shoes
8528,Anna Ernesta Martello,IT,Orion Club Gold members low activity,58,46-60 years,F,2,1230150412,15733,15734,2,,1,71,2202003,2202,22,220200300082,Indoor Handbold Special Shoes
13049,Ranieri Pian,IT,Orion Club Gold members low activity,48,46-60 years,M,2,1230155930,15734,15735,2,,2,117,2202002,2202,22,220200200060,Soft The Move Women's Running Shoes
22469,Janet Lubke,US,Orion Club Gold members low activity,43,31-45 years,F,2,1230163255,15735,15739,1,,1,62.3,2202002,2202,22,220200200057,Soft Modesto Women's Indoor Shoes
1735,Lothar Wannags,DE,Orion Club Gold members low activity,73,61-75 years,M,2,1230231607,15748,15749,1,,1,99,2202001,2202,22,220200100077,Big Guy Men's Air Span Triax Shoes
7655,Christian Nücker,DE,Orion Club Gold members low activity,58,46-60 years,M,2,1230298849,15760,15761,1,,1,48.2,2202001,2202,22,220200100153,Big Guy Men's Understudy Cross Train. Shoes
4454,Jürgen Binsack,DE,Orion Club Gold members low activity,68,61-75 years,M,2,1230310162,15762,15764,1,,1,61,2202001,2202,22,220200100101,Big Guy Men's Air Turbulence Shoes
9478,Marie-Pierre Dulong,FR,Orion Club Gold members low activity,19,15-30 years,F,3,1230311628,15762,15768,1,,1,41.1,2102010,2102,21,210201000206,Trainer Children's Shoes
8959,Michael Twiggs,GB,Orion Club Gold members low activity,63,61-75 years,M,2,1230425315,15783,15788,1,,1,55.1,2201007,2201,22,220100700039,"Power Men's Dmx Wide, Walking Shoes"
13049,Ranieri Pian,IT,Orion Club Gold members low activity,48,46-60 years,M,2,1230425677,15783,15784,1,,2,260.8,2202003,2202,22,220200300101,Mns.winner Men's Running Shoes
15036,Carlo Alberto Venditto,IT,Orion Club Gold members low activity,58,46-60 years,M,3,1230425683,15783,15789,1,,2,209.4,2202003,2202,22,220200300062,Damaskus Women's Running Shoes
18091,Colleen Magolan,US,Orion Club Gold members low activity,53,46-60 years,F,3,1230472256,15791,15794,2,,1,59,2202002,2202,22,220200200009,Cruise 1984 Men's Street Shoes
6290,Arthur Cooke,US,Orion Club Gold members low activity,21,15-30 years,M,3,1230516018,15799,15804,1,,1,2.8,2401001,2401,24,240100100430,Shoelace Black 100 Cm
6190,Gabriella Silvestro,IT,Orion Club Gold members low activity,48,46-60 years,F,2,1230524414,15801,15803,2,,1,100.2,2201007,2201,22,220100700038,Power Dmx Wide Shoes
25003,Jacques Mommeja,FR,Orion Club Gold members low activity,21,15-30 years,M,2,1230534702,15803,15807,2,,1,33.4,2102010,2102,21,210201000202,T&l Children's Shoes
2078,Sera Letendre,US,Orion Club Gold members low activity,23,15-30 years,F,2,1230542185,15804,15806,2,,1,120.7,2202001,2202,22,220200100098,Big Guy Men's Air Tuned Max Shoes
2078,Sera Letendre,US,Orion Club Gold members low activity,23,15-30 years,F,2,1230542185,15804,15806,1,,1,150.3,2202001,2202,22,220200100021,Big Guy Men's Air 120 Soccer Shoes
22868,Paloma Gómez Gimare,ES,Orion Club Gold members low activity,53,46-60 years,F,3,1230551978,15806,15809,1,,1,90,2202002,2202,22,220200200014,Dubby Low Men's Street Shoes
15622,Rosanna Migliorin,IT,Orion Club Gold members low activity,48,46-60 years,F,3,1230553416,15806,15808,2,,1,115.5,2202001,2202,22,220200100147,Big Guy Men's Terra Humara Shoes
15622,Rosanna Migliorin,IT,Orion Club Gold members low activity,48,46-60 years,F,3,1230553416,15806,15808,1,,1,121.3,2202001,2202,22,220200100051,Big Guy Men's Air Masai Shoes
8687,Randy Ruesch,US,Orion Club Gold members low activity,23,15-30 years,M,3,1230568651,15809,15813,2,,1,70.7,2202003,2202,22,220200300155,Hardcore Men's Street Shoes
14005,Honore Audrain,FR,Orion Club Gold members low activity,58,46-60 years,M,2,1230654099,15825,15828,1,,1,33.8,2102010,2102,21,210201000167,Children's Shoes Stratosphere
17352,Viviane Slogrove,GB,Orion Club Gold members low activity,33,31-45 years,F,3,1230654865,15825,15833,2,,2,180,2201007,2201,22,220100700016,Shoes Sphinx
2833,Belve Derobertis,US,Orion Club Gold members low activity,21,15-30 years,M,3,1230683365,15830,15834,3,,1,81.2,2202003,2202,22,220200300129,Torino Men's Leather Adventure Shoes
2833,Belve Derobertis,US,Orion Club Gold members low activity,21,15-30 years,M,3,1230683365,15830,15834,1,,1,125.8,2202001,2202,22,220200100057,Big Guy Men's Air Mickey Willy Shoes
20964,Jeremy Stancil,US,Orion Club Gold members low activity,38,31-45 years,M,2,1230700968,15833,15844,1,,3,258.6,2202002,2202,22,220200200011,Cruise Platypus Men's Street Shoes
6755,Adolf Rota,IT,Orion Club Gold members low activity,58,46-60 years,M,2,1230764664,15845,15850,1,,1,99.7,2201007,2201,22,220100700024,Armadillo Road Dmx Women's Running Shoes
13177,Helge Jacquemard,DE,Orion Club Gold members low activity,73,61-75 years,M,2,1230767930,15846,15850,2,,1,88.2,2202002,2202,22,220200200066,Twain Inco Men's Street Shoes
14460,María Luisa Fernández Lobato,ES,Orion Club Gold members low activity,21,15-30 years,F,2,1230768765,15846,15850,1,,1,107.7,2202002,2202,22,220200200078,Twain Women's Exit Low 2000 Street Shoes
16442,Adrian R Malone,GB,Orion Club Gold members low activity,28,15-30 years,M,2,1230776166,15847,15848,1,,1,67,2201007,2201,22,220100700001,Classic Men's Leisure Shoes
6018,Christa Unger,DE,Orion Club Gold members low activity,43,31-45 years,F,2,1230795697,15851,15855,3,,1,70.7,2202003,2202,22,220200300155,Hardcore Men's Street Shoes
24259,Attilia Corsi,IT,Orion Club Gold members low activity,53,46-60 years,F,3,1230798010,15851,15852,1,,3,537,2202001,2202,22,220200100107,Big Guy Men's Air Zoom Citizen Shoes
19261,Chris Boothwell,GB,Orion Club Gold members low activity,58,46-60 years,M,3,1230808601,15853,15856,1,,1,51.7,2201007,2201,22,220100700022,Alexis Women's Classic Shoes
6028,Douglas Vinay,US,Orion Club Gold members low activity,63,61-75 years,M,2,1230830779,15857,15861,2,,2,220.6,2202003,2202,22,220200300142,Vishnu Women's Running Shoes
14129,Yolanda Moncho Brunengo,ES,Orion Club Gold members low activity,28,15-30 years,F,3,1230856989,15862,15866,1,,2,117.2,2202003,2202,22,220200300051,Armadillo Men's Running Shoes
2429,Silvia Arana Pérez-Malumbres,ES,Orion Club Gold members low activity,21,15-30 years,F,2,1230904598,15871,15872,1,,3,249,2202001,2202,22,220200100092,Big Guy Men's Air Terra Sebec Shoes
6414,Erich Blum,DE,Orion Club Gold members low activity,38,31-45 years,M,3,1230946842,15879,15883,1,,2,260.8,2202003,2202,22,220200300101,Mns.winner Men's Running Shoes
24898,Norbert Schleeh,DE,Orion Club Gold members low activity,58,46-60 years,M,2,1231003045,15889,15893,1,,2,159.4,2202003,2202,22,220200300060,Cross Ripple Women's Street Shoes
24995,Simon Chinnici,GB,Orion Club Gold members low activity,48,46-60 years,M,3,1231031998,15894,15895,2,,2,103.4,2201007,2201,22,220100700022,Alexis Women's Classic Shoes
2393,Sylvia Wagner,DE,Orion Club Gold members low activity,68,61-75 years,F,2,1231057800,15899,15901,3,,2,132.8,2202002,2202,22,220200200018,Lulu Men's Street Shoes
4853,Ellsworth Mulhollen,US,Orion Club Gold members low activity,21,15-30 years,M,2,1231066511,15900,15903,1,,2,30.6,2401001,2401,24,240100100434,Shoeshine Black
26706,Jenniferk Pasquino-Greco,US,Orion Club Gold members low activity,23,15-30 years,F,3,1231077587,15902,15906,2,,2,391.4,2202002,2202,22,220200200054,Soft Kayano Men's Running Shoes
22469,Janet Lubke,US,Orion Club Gold members low activity,43,31-45 years,F,2,1231158733,15917,15921,1,,2,124.6,2202002,2202,22,220200200057,Soft Modesto Women's Indoor Shoes
926,Teresa Pulley,US,Orion Club Gold members low activity,28,15-30 years,F,2,1231186586,15922,15927,1,,2,166,2202003,2202,22,220200300107,Polly Millennium Men's Tennis Shoes
20073,Volker Fehlau,DE,Orion Club Gold members low activity,43,31-45 years,M,2,1231194884,15924,15925,2,,2,117.2,2202003,2202,22,220200300051,Armadillo Men's Running Shoes
20073,Volker Fehlau,DE,Orion Club Gold members low activity,43,31-45 years,M,2,1231194884,15924,15925,1,,2,191,2202002,2202,22,220200200039,Soft Cumulus Men's Running Shoes
17391,Lothar Fürbass,DE,Orion Club Gold members low activity,48,46-60 years,M,3,1231228130,15930,15933,1,,2,141.4,2202003,2202,22,220200300155,Hardcore Men's Street Shoes
23758,Paul Veedock,US,Orion Club Gold members low activity,33,31-45 years,M,2,1231309675,15944,15949,2,,2,254.6,2202002,2202,22,220200200042,Soft Ds Trainer Women's Running Shoes
18786,Thomas Lux,DE,Orion Club Gold members low activity,43,31-45 years,M,2,1231317789,15946,15950,1,,2,150,2202003,2202,22,220200300020,Men's Skate Shoes Revel
18786,Thomas Lux,DE,Orion Club Gold members low activity,43,31-45 years,M,2,1231317789,15946,15950,2,,2,158.8,2202003,2202,22,220200300153,Hardcore Junior/Women's Street Shoes Small
17814,Patrick Legroux,FR,Orion Club Gold members low activity,63,61-75 years,M,2,1231473458,15974,15979,1,,1,10.1,2102007,2102,21,210200700013,Slomo Balance Children's Shoes
21607,Carsten Ciupke,DE,Orion Club Gold members low activity,68,61-75 years,M,2,1231570167,15992,15995,3,,1,52.1,2202003,2202,22,220200300078,Hilly Women's Crosstrainer Shoes Large
21607,Carsten Ciupke,DE,Orion Club Gold members low activity,68,61-75 years,M,2,1231570167,15992,15995,2,,1,93.1,2202003,2202,22,220200300056,Banto Light Men's Shoes
7489,Dawn Vanbrunt,US,Orion Club Gold members low activity,33,31-45 years,F,2,1231578902,15993,15994,1,,1,66.4,2202002,2202,22,220200200018,Lulu Men's Street Shoes
12768,Ingmar Lutun,FR,Orion Club Gold members low activity,53,46-60 years,F,3,1231583004,15994,15995,1,,1,36.7,2102010,2102,21,210201000183,Kola Children's Shoes
99,Geanie Riddle,US,Orion Club Gold members low activity,43,31-45 years,F,2,1231600907,15997,16002,1,,1,10.7,2102007,2102,21,210200700020,Upright Shoe Balance Shoes
10835,Hella Jännsch,DE,Orion Club Gold members low activity,38,31-45 years,F,2,1231620053,16001,16002,1,,1,61,2202001,2202,22,220200100101,Big Guy Men's Air Turbulence Shoes
19659,Katherine Mcbride,US,Orion Club Gold members low activity,73,61-75 years,F,2,1231663657,16008,16010,1,,1,84.2,2202003,2202,22,220200300116,South Peak Men's Running Shoes
24917,Kenneth Machin,GB,Orion Club Gold members low activity,21,15-30 years,M,2,1231706662,16016,16017,2,,1,57.9,2201007,2201,22,220100700027,Duration Women's Trainer Aerobic Shoes
21258,Michael Brinsfield,US,Orion Club Gold members low activity,28,15-30 years,M,3,1231712617,16017,16023,1,,1,47,2202002,2202,22,220200200005,Allinall Star Men's Canvas Shoes
3131,Julie Readyhough,GB,Orion Club Gold members low activity,21,15-30 years,F,3,1231733256,16021,16022,1,,2,69.6,2102006,2102,21,210200600064,Children's Canvas Shoes
425,Josianne Rozeron,FR,Orion Club Gold members low activity,21,15-30 years,F,2,1231760961,16026,16028,1,,2,53.8,2102009,2102,21,210200900027,Osprey Cuda Lo Jr. Shoes Synthetic
21522,Justin Puddicombe,GB,Orion Club Gold members low activity,58,46-60 years,M,3,1231761593,16026,16031,1,,1,55.1,2201007,2201,22,220100700039,"Power Men's Dmx Wide, Walking Shoes"
15622,Rosanna Migliorin,IT,Orion Club Gold members low activity,48,46-60 years,F,3,1231767702,16027,16029,1,,1,56,2201007,2201,22,220100700010,Men's Running Shoes Burn
20013,Leah Gill,US,Orion Club Gold members low activity,19,15-30 years,M,2,1231775062,16028,16033,1,,2,6,2401001,2401,24,240100100431,Shoelace Black 150 Cm
12420,Francoise Bendali,FR,Orion Club Gold members low activity,21,15-30 years,F,3,1231790290,16031,16033,2,,2,64.6,2102010,2102,21,210201000168,Children's Shoes Wilcox
9687,Malcomb Livinston,US,Orion Club Gold members low activity,28,15-30 years,M,3,1231842304,16040,16042,1,,2,37.4,2401001,2401,24,240100100229,Cruise First Star Baby Shoes
18488,Praticia Phee,GB,Orion Club Gold members low activity,73,61-75 years,F,2,1231873430,16046,16051,2,,2,210.2,2201007,2201,22,220100700009,Mc Shoes
7132,Harpreet Mcgee,US,Orion Club Gold members low activity,21,15-30 years,F,2,1231896862,16050,16051,1,,2,131.4,2202001,2202,22,220200100120,Big Guy Men's Cortez Iii Leather Shoes
26492,Mervyn Davis-Gilbert,US,Orion Club Gold members low activity,53,46-60 years,M,3,1231912840,16053,16059,1,,2,123.2,2202003,2202,22,220200300018,Men's Shoes Tegern
11393,Maria Rita Nannini,IT,Orion Club Gold members low activity,58,46-60 years,F,2,1231956052,16061,16069,1,,2,287.4,2202001,2202,22,220200100056,Big Guy Men's Air MickeyTailwind Shoes
20070,Clora Murakeozy,US,Orion Club Gold members low activity,53,46-60 years,F,2,1232008304,16070,16076,2,,3,428.7,2202001,2202,22,220200100166,Sire Air Tailwind 1v Running Shoes
12768,Ingmar Lutun,FR,Orion Club Gold members low activity,53,46-60 years,F,3,1232012671,16071,16074,2,,1,34.8,2102004,2102,21,210200400077,Tony's Children's Terra Sebec(Bg) Shoes
12768,Ingmar Lutun,FR,Orion Club Gold members low activity,53,46-60 years,F,3,1232012671,16071,16074,1,,1,46.5,2102004,2102,21,210200400040,Toddle Children's Tuco(Bp) Shoes
18083,Jens Huan,DE,Orion Club Gold members low activity,43,31-45 years,M,2,1232029865,16074,16079,2,,2,222.6,2202001,2202,22,220200100145,Big Guy Men's Structure Triax Shoes
18083,Jens Huan,DE,Orion Club Gold members low activity,43,31-45 years,M,2,1232029865,16074,16079,1,,1,86.6,2202001,2202,22,220200100066,Big Guy Men's Air Quest Shoes
15451,Carrie Beckert,DE,Orion Club Gold members low activity,23,15-30 years,F,2,1232036479,16075,16079,2,,1,99,2202001,2202,22,220200100077,Big Guy Men's Air Span Triax Shoes
2437,Giuseppe Antonio Primori,IT,Orion Club Gold members low activity,53,46-60 years,M,2,1232039344,16075,16078,1,,1,120.5,2201004,2201,22,220100400026,Vector Low Men's Shoes
15036,Carlo Alberto Venditto,IT,Orion Club Gold members low activity,58,46-60 years,M,2,1232084785,16082,16083,1,,1,94.7,2202003,2202,22,220200300036,Women's Crosstraining Shoes
22326,Carol Sieracki,US,Orion Club Gold members low activity,19,15-30 years,F,3,1232207129,16100,16104,1,,1,84,2202002,2202,22,220200200067,Twain Inco Women's Street Shoes
14429,K.R. Van Aken,NL,Orion Club Gold members low activity,58,46-60 years,M,3,1232231155,16104,16106,1,,1,111.3,2202001,2202,22,220200100145,Big Guy Men's Structure Triax Shoes
8568,Burghard Schleeh,DE,Orion Club Gold members low activity,58,46-60 years,M,3,1232274539,16111,16117,1,,1,172.4,2202001,2202,22,220200100041,Big Guy Men's Air Flight Determination Shoes
14523,Gianni Papurello,IT,Orion Club Gold members low activity,48,46-60 years,M,2,1232324100,16118,16122,1,,1,86.6,2202001,2202,22,220200100066,Big Guy Men's Air Quest Shoes
19214,Scheryl Mwihuri,US,Orion Club Gold members low activity,28,15-30 years,F,2,1232332011,16119,16122,1,,1,37.2,2202002,2202,22,220200200043,Soft Gel Court Men's Indoor Shoes
22800,Angelika Myschik,DE,Orion Club Gold members low activity,23,15-30 years,F,2,1232342189,16121,16123,1,,1,67,2202001,2202,22,220200100026,Big Guy Men's Air Align Shoes
19836,Lovely Warren,US,Orion Club Gold members low activity,19,15-30 years,F,2,1232378420,16126,16127,2,,1,86.1,2202001,2202,22,220200100100,Big Guy Men's Air Turbino F.G. Shoes
19836,Lovely Warren,US,Orion Club Gold members low activity,19,15-30 years,F,2,1232378420,16126,16127,1,,1,89.8,2202001,2202,22,220200100097,Big Guy  Men's Air Trainer Structure Plu Shoe
10777,Janette Kuner,GB,Orion Club Gold members low activity,23,15-30 years,M,2,1232383748,16127,16129,1,,1,93,2201007,2201,22,220100700023,Armadillo Road Dmx Men's Running Shoes
19431,Simone Mrocen,DE,Orion Club Gold members low activity,53,46-60 years,F,3,1232419978,16134,16140,2,,3,218.4,2202003,2202,22,220200300155,Hardcore Men's Street Shoes
19431,Simone Mrocen,DE,Orion Club Gold members low activity,53,46-60 years,F,3,1232419978,16134,16140,1,,1,103.8,2202003,2202,22,220200300071,Hgf  Low Women's Indoor Shoes
6752,Dieter Effenberger,DE,Orion Club Gold members low activity,48,46-60 years,M,2,1232451592,16139,16142,1,,1,120.7,2202001,2202,22,220200100098,Big Guy Men's Air Tuned Max Shoes
5232,A.C. Mijnen,NL,Orion Club Gold members low activity,58,46-60 years,F,3,1232475671,16142,16148,1,,2,140.6,2202003,2202,22,220200300124,The Jet Men's Running Shoes
2333,I.P.A. Van Den Berg,NL,Orion Club Gold members low activity,33,31-45 years,F,2,1232662463,16170,16173,1,,1,75.6,2202001,2202,22,220200100061,Big Guy Men's Air Orchestrate Shoes
15044,Michael Kukulies,DE,Orion Club Gold members low activity,23,15-30 years,M,2,1232677810,16173,16178,1,,3,282.9,2202001,2202,22,220200100104,Big Guy Men's Air Zoom 90 I.C. Shoes
23949,Aurora García,ES,Orion Club Gold members low activity,43,31-45 years,F,3,1232699353,16176,16181,2,,3,284.1,2202003,2202,22,220200300036,Women's Crosstraining Shoes
23949,Aurora García,ES,Orion Club Gold members low activity,43,31-45 years,F,3,1232699353,16176,16181,1,,1,61,2202001,2202,22,220200100101,Big Guy Men's Air Turbulence Shoes
2437,Giuseppe Antonio Primori,IT,Orion Club Gold members low activity,53,46-60 years,M,2,1232715645,16178,16181,1,,1,106,2201007,2201,22,220100700020,Women's Trainer Aerobic Shoes
6900,Pier Mario la Femina,IT,Orion Club Gold members low activity,53,46-60 years,M,2,1232762084,16185,16187,1,,1,157.8,2202001,2202,22,220200100099,Big Guy Men's Air Tuned Sirocco Shoes
16185,Jacques Varachaud,FR,Orion Club Gold members low activity,23,15-30 years,M,3,1232766093,16186,16189,1,,1,15.7,2401001,2401,24,240100100434,Shoeshine Black
27427,Neepa Allen,US,Orion Club Gold members low activity,23,15-30 years,F,3,1232843022,16197,16198,2,,1,61.4,2102010,2102,21,210201000193,South Peak Children's Shoes J
6414,Erich Blum,DE,Orion Club Gold members low activity,38,31-45 years,M,3,1232864884,16201,16206,2,,1,48.2,2202001,2202,22,220200100153,Big Guy Men's Understudy Cross Train. Shoes
18887,Javier Sanz de Pablos,ES,Orion Club Gold members low activity,38,31-45 years,M,2,1232901494,16206,16209,1,,1,110.3,2201007,2201,22,220100700052,Trooper Ii Dmx-2x Men's Walking Shoes
6800,Christopher Galioto,US,Orion Club Gold members low activity,23,15-30 years,M,2,1232905171,16206,16209,1,,1,18.7,2401001,2401,24,240100100229,Cruise First Star Baby Shoes
7525,Edward Stokes,US,Orion Club Gold members low activity,28,15-30 years,M,2,1232923912,16209,16214,2,,3,47.1,2401001,2401,24,240100100434,Shoeshine Black
27126,David Mclendon,US,Orion Club Gold members low activity,23,15-30 years,M,2,1232944972,16212,16213,1,,1,103.9,2202002,2202,22,220200200068,Twain Men's Exentric Ii X-Hiking Shoes
14005,Honore Audrain,FR,Orion Club Gold members low activity,58,46-60 years,M,3,1232960696,16215,16217,1,,1,35.8,2102006,2102,21,210200600064,Children's Canvas Shoes
24685,Sas Crummie,GB,Orion Club Gold members low activity,28,15-30 years,M,3,1232961498,16215,16218,1,,1,85.6,2201007,2201,22,220100700042,"Power Women's Dmx Wide, Walking Shoes"
13188,Bernd Märzluft,DE,Orion Club Gold members low activity,58,46-60 years,M,3,1232986618,16219,16224,1,,3,473.4,2202001,2202,22,220200100099,Big Guy Men's Air Tuned Sirocco Shoes
18886,Claudine Le Cam,FR,Orion Club Gold members low activity,21,15-30 years,F,2,1232988294,16219,16220,1,,1,3,2401001,2401,24,240100100431,Shoelace Black 150 Cm
3625,Allene Longley,GB,Orion Club Gold members low activity,58,46-60 years,F,3,1233076771,16232,16235,2,,3,309.6,2201007,2201,22,220100700038,Power Dmx Wide Shoes
23949,Aurora García,ES,Orion Club Gold members low activity,43,31-45 years,F,3,1233121479,16239,16244,1,,2,315.6,2202001,2202,22,220200100099,Big Guy Men's Air Tuned Sirocco Shoes
9238,Brigitte Mütze,DE,Orion Club Gold members low activity,73,61-75 years,F,2,1233147116,16243,16245,2,,2,199.2,2202003,2202,22,220200300117,South Peak Women's Light Indoor Shoes
9238,Brigitte Mütze,DE,Orion Club Gold members low activity,73,61-75 years,F,2,1233147116,16243,16245,1,,2,168.4,2202003,2202,22,220200300014,Men's Running Shoes Ozweego
1735,Lothar Wannags,DE,Orion Club Gold members low activity,73,61-75 years,M,2,1233246180,16258,16261,2,,2,215,2202002,2202,22,220200200050,Soft Integral Men's Running Shoes
1735,Lothar Wannags,DE,Orion Club Gold members low activity,73,61-75 years,M,2,1233246180,16258,16261,1,,3,104.7,2202001,2202,22,220200100160,Eclipse Mens Off Court Tennis Shoes
2259,Perrin Shannon,US,Orion Club Gold members low activity,21,15-30 years,M,2,1233256717,16259,16264,1,,3,100.2,2202001,2202,22,220200100126,Big Guy Men's Gts Canvas Plus Shoes
7155,Maral Bullard,US,Orion Club Gold members low activity,19,15-30 years,F,3,1233270882,16261,16265,2,,2,254.6,2202002,2202,22,220200200042,Soft Ds Trainer Women's Running Shoes
24582,Victoria Canas,US,Orion Club Gold members low activity,33,31-45 years,F,3,1233309579,16267,16271,1,,2,82.6,2102006,2102,21,210200600032,Atx 7500 Ch Children's Shoes
19896,Michael Peters,GB,Orion Club Gold members low activity,33,31-45 years,M,3,1233314476,16268,16270,1,,2,177.8,2201004,2201,22,220100400020,Ultra M802 All Terrain Men's Shoes
11393,Maria Rita Nannini,IT,Orion Club Gold members low activity,58,46-60 years,F,2,1233340446,16272,16276,2,,2,262,2202002,2202,22,220200200077,Twain Women's Exit Iii Mid Cd X-Hiking Shoes
11393,Maria Rita Nannini,IT,Orion Club Gold members low activity,58,46-60 years,F,2,1233340446,16272,16276,1,,3,187.8,2202001,2202,22,220200100035,Big Guy Men's Air Deschutz Viii Shoes
1030,Linda Warne,GB,Orion Club Gold members low activity,23,15-30 years,M,2,1233361383,16275,16280,1,,3,361.5,2201004,2201,22,220100400026,Vector Low Men's Shoes
681,Thomasine Arnold,US,Orion Club Gold members low activity,48,46-60 years,F,2,1233382902,16278,16283,2,,3,254.7,2202003,2202,22,220200300115,South Peak Men's Light Low Indoor Shoes
4286,Benjamín Basurco,ES,Orion Club Gold members low activity,48,46-60 years,M,2,1233414396,16283,16288,1,,3,30.3,2102007,2102,21,210200700013,Slomo Balance Children's Shoes
20571,Birgit Schiff,DE,Orion Club Gold members low activity,23,15-30 years,F,2,1233459396,16290,16293,1,,2,156.6,2202003,2202,22,220200300106,Multi Women's Running Shoes
8374,Anne Baker,US,Orion Club Gold members low activity,19,15-30 years,F,2,1233463968,16290,16295,1,,2,251.6,2202001,2202,22,220200100057,Big Guy Men's Air Mickey Willy Shoes
19559,Maurizio Franchinetti,IT,Orion Club Gold members low activity,63,61-75 years,M,2,1233481758,16293,16296,1,,2,107.4,2201007,2201,22,220100700022,Alexis Women's Classic Shoes
425,Josianne Rozeron,FR,Orion Club Gold members low activity,21,15-30 years,F,2,1233494172,16295,16297,2,,2,73.4,2102010,2102,21,210201000183,Kola Children's Shoes
15544,Rosita Zangiacomi,IT,Orion Club Gold members low activity,53,46-60 years,F,3,1233688249,16324,16326,1,,1,18.2,2201009,2201,22,220100900004,Osprey Bermuda Canvas Shoes
23230,Alberto Prieto Ursúa,ES,Orion Club Gold members low activity,38,31-45 years,M,3,1233786553,16339,16340,2,,2,142,2202003,2202,22,220200300082,Indoor Handbold Special Shoes
23230,Alberto Prieto Ursúa,ES,Orion Club Gold members low activity,38,31-45 years,M,3,1233786553,16339,16340,1,,2,218.8,2202003,2202,22,220200300069,Hgf Incentive Men's Tennis Shoes
24485,Pierre Karcher,FR,Orion Club Gold members low activity,28,15-30 years,M,2,1234043768,16378,16379,1,,1,33.8,2102010,2102,21,210201000167,Children's Shoes Stratosphere
8011,Sabrina Tepel,DE,Orion Club Gold members low activity,43,31-45 years,F,3,1234056092,16380,16384,1,,1,70.8,2202003,2202,22,220200300143,W.a..trainer Leather Shoes
23481,Jeffery Mccoll,US,Orion Club Gold members low activity,43,31-45 years,M,3,1234118974,16389,16394,1,,1,81.2,2202003,2202,22,220200300129,Torino Men's Leather Adventure Shoes
5750,Colin Turvey,GB,Orion Club Gold members low activity,63,61-75 years,M,2,1234151069,16394,16398,2,,1,127.8,2201007,2201,22,220100700031,Jog Dmx 6 Iii Shoes
8544,Vida Armin,DE,Orion Club Gold members low activity,53,46-60 years,F,2,1234155195,16395,16396,1,,1,199.2,2202002,2202,22,220200200052,Soft Kayano Men's Running Shoes VI
12732,Ángel Manuel Arístegui,ES,Orion Club Gold members low activity,68,61-75 years,M,2,1234243667,16408,16410,2,,2,66.8,2202001,2202,22,220200100126,Big Guy Men's Gts Canvas Plus Shoes
15865,Laurent Richard,FR,Orion Club Gold members low activity,33,31-45 years,M,2,1234244409,16408,16412,1,,2,67.6,2102010,2102,21,210201000167,Children's Shoes Stratosphere
2243,Iris Sengotta,DE,Orion Club Gold members low activity,48,46-60 years,F,3,1234249987,16409,16412,2,,4,404,2202003,2202,22,220200300016,Men's Running Shoes Supernova
1549,Patrizia Haag,DE,Orion Club Gold members low activity,21,15-30 years,F,2,1234275303,16413,16418,1,,2,74.4,2202002,2202,22,220200200043,Soft Gel Court Men's Indoor Shoes
871,Trevor Fischel,GB,Orion Club Gold members low activity,21,15-30 years,M,3,1234299490,16416,16420,1,,2,107.4,2201007,2201,22,220100700022,Alexis Women's Classic Shoes
15544,Rosita Zangiacomi,IT,Orion Club Gold members low activity,53,46-60 years,F,3,1234305565,16417,16419,1,,2,166.6,2202003,2202,22,220200300153,Hardcore Junior/Women's Street Shoes Small
26742,Mariola Ilmstetter,DE,Orion Club Gold members low activity,38,31-45 years,F,2,1234316056,16419,16421,1,,2,121.2,2202003,2202,22,220200300110,Qrs Men's Street Shoes
22779,Robert Mcfadden,US,Orion Club Gold members low activity,58,46-60 years,M,2,1234342023,16422,16426,1,,2,146.8,2202003,2202,22,220200300157,Hardcore Men's Street Shoes Large
3065,Demetrics Maccullough,US,Orion Club Gold members low activity,48,46-60 years,F,3,1234367225,16426,16427,1,,2,186.8,2202003,2202,22,220200300158,Hardcore Shoes
14433,David Mcginty,US,Orion Club Gold members low activity,58,46-60 years,M,3,1234426606,16435,16436,1,,2,66.8,2202001,2202,22,220200100126,Big Guy Men's Gts Canvas Plus Shoes
7997,Jochen Kish,NL,Orion Club Gold members low activity,68,61-75 years,M,2,1234430640,16436,16441,1,,2,146.8,2202003,2202,22,220200300157,Hardcore Men's Street Shoes Large
19650,Álvaro Martínez Cárdenas,ES,Orion Club Gold members low activity,28,15-30 years,M,2,1234467506,16441,16444,2,,1,138.6,2202003,2202,22,220200300086,Mns Gazelle Men's Running Shoes
14814,Jörg Breininger,DE,Orion Club Gold members low activity,21,15-30 years,M,2,1234476566,16442,16446,1,,2,110.8,2202001,2202,22,220200100060,Big Guy Men's Air One Eighty  Shoes
15544,Rosita Zangiacomi,IT,Orion Club Gold members low activity,53,46-60 years,F,3,1234563591,16450,16465,1,,1,105.4,2202001,2202,22,220200100142,Big Guy Men's Span Triax Shoes
23616,Kolena Pampari,US,Orion Club Gold members low activity,43,31-45 years,F,3,1234616502,16455,16456,2,,2,150,2202003,2202,22,220200300020,Men's Skate Shoes Revel
23616,Kolena Pampari,US,Orion Club Gold members low activity,43,31-45 years,F,3,1234616502,16455,16456,1,,1,134.8,2202002,2202,22,220200200079,Twain Women's Expresso X-Hiking Shoes
25599,Allison Grueneich,US,Orion Club Gold members low activity,23,15-30 years,F,3,1234649132,16458,16461,1,,1,104.7,2202003,2202,22,220200300062,Damaskus Women's Running Shoes
10654,A.C. Van Raamsdonk,NL,Orion Club Gold members low activity,38,31-45 years,M,3,1234654949,16459,16462,1,,2,212.2,2202002,2202,22,220200200069,Twain Men's Exit Ii Low X-Hiking Shoes
2703,Thomas Riedel,DE,Orion Club Gold members low activity,21,15-30 years,M,3,1234699923,16464,16466,1,,2,207.6,2202003,2202,22,220200300071,Hgf  Low Women's Indoor Shoes
27008,Falk-E. Gauß,DE,Orion Club Gold members low activity,48,46-60 years,M,3,1234700437,16464,16469,1,,1,71,2202003,2202,22,220200300082,Indoor Handbold Special Shoes
5087,I.H.H.M. Lokhorst,NL,Orion Club Gold members low activity,21,15-30 years,F,3,1234744653,16468,16472,1,,1,88.8,2202002,2202,22,220200200062,Top C-Tech 6000 Tennis Shoes
12645,Eltas Keene,GB,Orion Club Gold members low activity,21,15-30 years,M,3,1234753034,16469,16471,1,,1,109.3,2201007,2201,22,220100700009,Mc Shoes
13389,Elgenia Tancrelle,US,Orion Club Gold members low activity,19,15-30 years,F,2,1234826635,16476,16479,1,,1,92.6,2202002,2202,22,220200200066,Twain Inco Men's Street Shoes
25959,María Milagros Fons Gómez,ES,Orion Club Gold members low activity,28,15-30 years,F,3,1234903527,16484,16490,1,,1,76.9,2201004,2201,22,220100400012,Bill V-3-London Calling Shoes
24240,Werner-Ludwig Weithofer,DE,Orion Club Gold members low activity,58,46-60 years,M,3,1234973032,16491,16492,2,,1,34.9,2202001,2202,22,220200100160,Eclipse Mens Off Court Tennis Shoes
24240,Werner-Ludwig Weithofer,DE,Orion Club Gold members low activity,58,46-60 years,M,3,1234973032,16491,16492,1,,1,125.8,2202001,2202,22,220200100057,Big Guy Men's Air Mickey Willy Shoes
22467,Chandrashekhar Edgerton-Lewis,US,Orion Club Gold members low activity,43,31-45 years,F,2,1234990706,16492,16496,1,,1,54.4,2202001,2202,22,220200100134,Big Guy Men's Maniacal Shoes
18763,Srinivas Ullah,US,Orion Club Gold members low activity,21,15-30 years,M,3,1235019196,16495,16497,1,,1,89.8,2202001,2202,22,220200100097,Big Guy  Men's Air Trainer Structure Plu Shoe
24057,M.P. Shepard,NL,Orion Club Gold members low activity,68,61-75 years,F,2,1235072203,16499,16501,1,,1,177.8,2202001,2202,22,220200100010,Atmosphere Mickey Shoes
1452,Annetta Baehrle,DE,Orion Club Gold members low activity,48,46-60 years,F,2,1235115562,16504,16506,1,,1,55.4,2202001,2202,22,220200100060,Big Guy Men's Air One Eighty  Shoes
2135,R.N. Roijen,NL,Orion Club Gold members low activity,21,15-30 years,M,2,1235132108,16505,16509,1,,2,183.6,2202001,2202,22,220200100062,Big Guy Men's Air Outland Shoes
10654,A.C. Van Raamsdonk,NL,Orion Club Gold members low activity,38,31-45 years,M,3,1235151912,16507,16510,1,,1,47.9,2202002,2202,22,220200200031,Soft 1040 Women's Running Shoes
8544,Vida Armin,DE,Orion Club Gold members low activity,53,46-60 years,F,3,1235187791,16511,16517,1,,2,241.4,2202001,2202,22,220200100098,Big Guy Men's Air Tuned Max Shoes
13184,Mariette Biannic,FR,Orion Club Gold members low activity,28,15-30 years,F,3,1235222062,16514,16518,1,,1,39.7,2102010,2102,21,210201000175,Freestyle Children's Velcro Shoes
10835,Hella Jännsch,DE,Orion Club Gold members low activity,38,31-45 years,F,3,1235237932,16516,16519,1,,2,300.6,2202001,2202,22,220200100021,Big Guy Men's Air 120 Soccer Shoes
22033,H.W.E. Pruis Ra,NL,Orion Club Gold members low activity,73,61-75 years,M,2,1235243351,16516,16518,2,,1,64.9,2202003,2202,22,220200300079,Hilly Women's Crosstrainer Shoes
22033,H.W.E. Pruis Ra,NL,Orion Club Gold members low activity,73,61-75 years,M,2,1235243351,16516,16518,1,,1,120.7,2202001,2202,22,220200100098,Big Guy Men's Air Tuned Max Shoes
11816,Detlev Jônsson,DE,Orion Club Gold members low activity,43,31-45 years,M,2,1235258731,16518,16521,1,,2,225.2,2202002,2202,22,220200200041,Soft Ds Trainer Men's Running Shoes
24836,Melvarene Pirrotta,US,Orion Club Gold members low activity,58,46-60 years,F,3,1235276548,16519,16524,1,,1,81.2,2202003,2202,22,220200300129,Torino Men's Leather Adventure Shoes
11553,Sandra Stößer-Carstens,DE,Orion Club Gold members low activity,58,46-60 years,F,3,1235307966,16523,16529,1,,1,141.2,2202001,2202,22,220200100113,Big Guy Men's Air Zoom Pivot Mid Ii Shoes
25053,Joshua Swarr,US,Orion Club Gold members low activity,38,31-45 years,M,2,1235315412,16523,16527,1,,1,37.4,2102004,2102,21,210200400041,Toddle Children's Understudy(Bg) Shoes
22439,Adriano Rumazza,IT,Orion Club Gold members low activity,58,46-60 years,M,2,1235355932,16527,16529,2,,2,209.2,2201007,2201,22,220100700024,Armadillo Road Dmx Women's Running Shoes
12390,Sylvia Kollbach,DE,Orion Club Gold members low activity,43,31-45 years,F,3,1235511194,16543,16547,1,,1,120.7,2202001,2202,22,220200100098,Big Guy Men's Air Tuned Max Shoes
579,Alan Pollins,GB,Orion Club Gold members low activity,28,15-30 years,M,3,1235534945,16545,16550,2,,1,54.4,2201007,2201,22,220100700037,Original Women's Nylon Street Shoes
22033,H.W.E. Pruis Ra,NL,Orion Club Gold members low activity,73,61-75 years,M,2,1235596727,16551,16553,2,,1,90,2202002,2202,22,220200200014,Dubby Low Men's Street Shoes
2979,Anita Poortman,NL,Orion Club Gold members low activity,38,31-45 years,F,2,1235658100,16557,16562,2,,3,220.2,2202003,2202,22,220200300157,Hardcore Men's Street Shoes Large
23822,Laurence Cortial,FR,Orion Club Gold members low activity,33,31-45 years,F,3,1235695494,16561,16564,2,,4,194.8,2102004,2102,21,210200400029,Toddle Children's Air Terra Grande Shoes
27211,Patricia Fernández,ES,Orion Club Gold members low activity,43,31-45 years,F,2,1235755394,16567,16570,1,,1,101,2202003,2202,22,220200300016,Men's Running Shoes Supernova
7412,Jian-Feng Bondoux,FR,Orion Club Gold members low activity,33,31-45 years,M,3,1235778816,16569,16574,2,,3,101.4,2102010,2102,21,210201000167,Children's Shoes Stratosphere
10686,Karen Mikell,US,Orion Club Gold members low activity,28,15-30 years,F,3,1235783548,16569,16573,1,,1,36.1,2102004,2102,21,210200400014,Kid Trainer Lite(Bp) Street Shoes
11244,Mekella Manasso,US,Orion Club Gold members low activity,43,31-45 years,F,2,1235830925,16574,16577,1,,1,100.2,2202003,2202,22,220200300070,Hgf Low Men's Indoor Shoes
9277,John Berberich,US,Orion Club Gold members low activity,48,46-60 years,M,3,1235853829,16576,16578,1,,3,362.1,2202001,2202,22,220200100098,Big Guy Men's Air Tuned Max Shoes
23815,Gianfranco Stanziani,IT,Orion Club Gold members low activity,63,61-75 years,M,2,1235890975,16580,16584,2,,3,183,2202001,2202,22,220200100101,Big Guy Men's Air Turbulence Shoes
23815,Gianfranco Stanziani,IT,Orion Club Gold members low activity,63,61-75 years,M,2,1235890975,16580,16584,1,,1,87.7,2202001,2202,22,220200100091,Big Guy Men's Air Terra Rise Shoes
17681,G.J.H.l. Williams,NL,Orion Club Gold members low activity,53,46-60 years,M,2,1235913089,16582,16584,2,,3,220.2,2202003,2202,22,220200300157,Hardcore Men's Street Shoes Large
14429,K.R. Van Aken,NL,Orion Club Gold members low activity,58,46-60 years,M,2,1235943673,16585,16587,1,,1,50.2,2202001,2202,22,220200100146,Big Guy Men's Tennis Classic Shoes
3535,M.E. Damen,NL,Orion Club Gold members low activity,58,46-60 years,F,3,1236023739,16593,16599,1,,2,254.6,2202002,2202,22,220200200042,Soft Ds Trainer Women's Running Shoes
14251,Johanna Schwald,DE,Orion Club Gold members low activity,38,31-45 years,F,3,1236049090,16596,16598,1,,2,208.2,2202002,2202,22,220200200071,Twain Men's Exit Low 2000 Street Shoes
2979,Anita Poortman,NL,Orion Club Gold members low activity,38,31-45 years,F,2,1236103609,16601,16606,1,,3,185.7,2202001,2202,22,220200100011,Atmosphere Mic Plus.Men's Running Shoe
2979,Anita Poortman,NL,Orion Club Gold members low activity,38,31-45 years,F,2,1236103609,16601,16606,2,,2,133.6,2202002,2202,22,220200200010,Cruise Men's Road Chunk Street Shoes
19377,Ahal Beaton,GB,Orion Club Gold members low activity,73,61-75 years,M,2,1236171021,16608,16609,2,,5,362.5,2201007,2201,22,220100700013,Rugged Men's Walking Shoes
10724,Rhenae Horwtz,US,Orion Club Gold members low activity,63,61-75 years,F,2,1236224418,16613,16617,1,,2,208.2,2202002,2202,22,220200200071,Twain Men's Exit Low 2000 Street Shoes
10654,A.C. Van Raamsdonk,NL,Orion Club Gold members low activity,38,31-45 years,M,3,1236276629,16618,16621,2,,2,128,2202002,2202,22,220200200021,Pro Fit  Gel Ds Trainer Iv Men's Running Shoe
17686,Georges Mechri,FR,Orion Club Gold members low activity,58,46-60 years,M,2,1236321411,16623,16625,1,,2,9.2,2401001,2401,24,240100100429,"Shoelace 140 Cm, Assorted Colours"
14188,Leone Terrevazzi,IT,Orion Club Gold members low activity,58,46-60 years,M,2,1236334948,16624,16628,1,,2,198,2202001,2202,22,220200100077,Big Guy Men's Air Span Triax Shoes
26920,Lamon Edgerton-Lewis,US,Orion Club Gold members low activity,33,31-45 years,M,2,1236367499,16627,16628,2,,2,180,2202002,2202,22,220200200014,Dubby Low Men's Street Shoes
26920,Lamon Edgerton-Lewis,US,Orion Club Gold members low activity,33,31-45 years,M,2,1236367499,16627,16628,1,,2,374.6,2202001,2202,22,220200100053,Big Guy Men's Air Mickey Shoes
4621,Phil Yagi,GB,Orion Club Gold members low activity,28,15-30 years,F,3,1236405312,16631,16632,2,,3,178.5,2201007,2201,22,220100700027,Duration Women's Trainer Aerobic Shoes
24259,Attilia Corsi,IT,Orion Club Gold members low activity,53,46-60 years,F,2,1236406704,16631,16632,1,,2,231,2202001,2202,22,220200100147,Big Guy Men's Terra Humara Shoes
5300,Stefania Iacovoni,IT,Orion Club Gold members low activity,48,46-60 years,F,2,1236454871,16636,16639,2,,3,186.9,2202002,2202,22,220200200057,Soft Modesto Women's Indoor Shoes
886,Jamesanna Desloge,US,Orion Club Gold members low activity,21,15-30 years,F,2,1236528828,16643,16648,1,,2,122,2202001,2202,22,220200100101,Big Guy Men's Air Turbulence Shoes
4231,Michele Cantu',IT,Orion Club Gold members low activity,48,46-60 years,M,2,1236575688,16648,16649,1,,2,172.4,2202002,2202,22,220200200011,Cruise Platypus Men's Street Shoes
4054,Marion Malone,GB,Orion Club Gold members low activity,68,61-75 years,F,2,1236787017,16669,16672,1,,2,210.4,2201007,2201,22,220100700038,Power Dmx Wide Shoes
15974,Maria Lidia Graziaplena,IT,Orion Club Gold members low activity,63,61-75 years,F,2,1236829535,16673,16674,1,,2,192.8,2201007,2201,22,220100700016,Shoes Sphinx
12284,Neil Postolovski,US,Orion Club Gold members low activity,33,31-45 years,M,2,1236859711,16676,16680,1,,2,67.6,2102010,2102,21,210201000167,Children's Shoes Stratosphere
18488,Praticia Phee,GB,Orion Club Gold members low activity,73,61-75 years,F,2,1236938434,16684,16687,1,,1,59.5,2201007,2201,22,220100700027,Duration Women's Trainer Aerobic Shoes
15451,Carrie Beckert,DE,Orion Club Gold members low activity,23,15-30 years,F,2,1237219873,16712,16717,1,,1,68.6,2202001,2202,22,220200100014,Atmosphere Terra Grande Shoes
6941,Ioana Gilles,DE,Orion Club Gold members low activity,48,46-60 years,F,3,1237239755,16714,16716,1,,1,120.7,2202001,2202,22,220200100098,Big Guy Men's Air Tuned Max Shoes
6923,David Pensel,US,Orion Club Gold members low activity,21,15-30 years,M,2,1237327939,16722,16724,1,,1,103.8,2202003,2202,22,220200300071,Hgf  Low Women's Indoor Shoes
21000,María José Ribes Koninckx,ES,Orion Club Gold members low activity,73,61-75 years,F,2,1237362055,16726,16729,1,,2,225.4,2202001,2202,22,220200100156,Big Guy Men'sAir Duration Shoes
21646,Isabel Conde,ES,Orion Club Gold members low activity,68,61-75 years,F,2,1237432651,16733,16735,1,,1,112.5,2201007,2201,22,220100700009,Mc Shoes
1343,Donny Rigby-Hall,GB,Orion Club Gold members low activity,48,46-60 years,M,2,1237493601,16739,16741,1,,1,96.4,2201007,2201,22,220100700016,Shoes Sphinx
10858,Paula Elliott,GB,Orion Club Gold members low activity,43,31-45 years,F,2,1237535797,16743,16745,1,,1,130.3,2201007,2201,22,220100700031,Jog Dmx 6 Iii Shoes
22439,Adriano Rumazza,IT,Orion Club Gold members low activity,58,46-60 years,M,2,1237536784,16743,16745,1,,2,148.8,2201007,2201,22,220100700001,Classic Men's Leisure Shoes
19650,Álvaro Martínez Cárdenas,ES,Orion Club Gold members low activity,28,15-30 years,M,2,1237573766,16747,16750,1,,1,106.5,2202001,2202,22,220200100084,Big Guy Men's Air Tailwind Shoes
21719,Scott Horswell,GB,Orion Club Gold members low activity,28,15-30 years,M,2,1237607809,16750,16755,2,,3,289.2,2201007,2201,22,220100700016,Shoes Sphinx
11393,Maria Rita Nannini,IT,Orion Club Gold members low activity,58,46-60 years,F,2,1237797417,16769,16774,1,,1,56.9,2202001,2202,22,220200100128,Big Guy Men's Hermosa Shoes
17352,Viviane Slogrove,GB,Orion Club Gold members low activity,33,31-45 years,F,2,1237818134,16771,16774,1,,2,110.2,2201001,2201,22,220100100123,Big Guy Men's Dome Shorts Shoes
13862,Pier Gino Nuvoli,IT,Orion Club Gold members low activity,53,46-60 years,M,2,1237819118,16771,16772,1,,3,100.2,2202001,2202,22,220200100126,Big Guy Men's Gts Canvas Plus Shoes
19584,Sandrine Fieldes,FR,Orion Club Gold members low activity,53,46-60 years,F,3,1237846666,16774,16775,2,,2,75.8,2102006,2102,21,210200600064,Children's Canvas Shoes
2703,Thomas Riedel,DE,Orion Club Gold members low activity,21,15-30 years,M,3,1237884119,16778,16780,1,,2,171.6,2202003,2202,22,220200300012,Men's Mountain Shoes
25495,Francis Kornitzer,GB,Orion Club Gold members low activity,68,61-75 years,M,2,1237888553,16778,16779,1,,2,197.8,2201004,2201,22,220100400022,Ultra M803 Ng Men's Street Shoes
5097,Segun Mccorville,GB,Orion Club Gold members low activity,48,46-60 years,M,3,1237898900,16779,16781,1,,4,420.8,2201007,2201,22,220100700038,Power Dmx Wide Shoes
23081,Harald Vandenberghe,DE,Orion Club Gold members low activity,58,46-60 years,M,2,1237993861,16789,16792,1,,2,122,2202001,2202,22,220200100101,Big Guy Men's Air Turbulence Shoes
23081,Harald Vandenberghe,DE,Orion Club Gold members low activity,58,46-60 years,M,2,1237993861,16789,16792,2,,2,96.4,2202001,2202,22,220200100153,Big Guy Men's Understudy Cross Train. Shoes
8466,K.T.l Ruwette,NL,Orion Club Gold members low activity,38,31-45 years,F,3,1237999054,16789,16794,1,,4,418.8,2202003,2202,22,220200300062,Damaskus Women's Running Shoes
8466,K.T.l Ruwette,NL,Orion Club Gold members low activity,38,31-45 years,F,3,1238009166,16790,16795,3,,4,374,2202002,2202,22,220200200066,Twain Inco Men's Street Shoes
14429,K.R. Van Aken,NL,Orion Club Gold members low activity,58,46-60 years,M,2,1238041318,16793,16795,1,,2,142,2202003,2202,22,220200300082,Indoor Handbold Special Shoes
17686,Georges Mechri,FR,Orion Club Gold members low activity,58,46-60 years,M,2,1238065667,16796,16798,1,0.5,4,59.96,2102010,2102,21,210201000169,Children's Street Shoes
2135,R.N. Roijen,NL,Orion Club Gold members low activity,21,15-30 years,M,2,1238158839,16806,16811,2,,1,195.7,2202002,2202,22,220200200054,Soft Kayano Men's Running Shoes
2135,R.N. Roijen,NL,Orion Club Gold members low activity,21,15-30 years,M,2,1238158839,16806,16811,3,,2,168.4,2202003,2202,22,220200300014,Men's Running Shoes Ozweego
6551,Martín Goti Elejalde,ES,Orion Club Gold members low activity,28,15-30 years,M,3,1238194503,16811,16815,1,,2,66.8,2202001,2202,22,220200100126,Big Guy Men's Gts Canvas Plus Shoes
15451,Carrie Beckert,DE,Orion Club Gold members low activity,23,15-30 years,F,3,1238210329,16813,16817,1,,2,198,2202001,2202,22,220200100077,Big Guy Men's Air Span Triax Shoes
1614,Alessandro Patron,IT,Orion Club Gold members low activity,53,46-60 years,M,3,1238214189,16813,16817,2,,1,136.6,2202003,2202,22,220200300102,Mns.xzs Women's Aerobic Shoes
1614,Alessandro Patron,IT,Orion Club Gold members low activity,53,46-60 years,M,3,1238214189,16813,16817,1,,2,210.2,2202002,2202,22,220200200015,Dubby Low Men's Street Shoes Large
5768,Dieter Fabricius,DE,Orion Club Gold members low activity,21,15-30 years,M,3,1238219190,16814,16820,1,,2,241.4,2202001,2202,22,220200100098,Big Guy Men's Air Tuned Max Shoes
26317,Alessandro Dalla Grisa,IT,Orion Club Gold members low activity,58,46-60 years,M,2,1238237431,16816,16817,3,,2,209.4,2202003,2202,22,220200300062,Damaskus Women's Running Shoes
26317,Alessandro Dalla Grisa,IT,Orion Club Gold members low activity,58,46-60 years,M,2,1238237431,16816,16817,2,,1,50.2,2202001,2202,22,220200100146,Big Guy Men's Tennis Classic Shoes
11107,W.J. Romano,NL,Orion Club Gold members low activity,33,31-45 years,M,2,1238254565,16818,16822,1,,2,69.8,2202001,2202,22,220200100160,Eclipse Mens Off Court Tennis Shoes
20052,Laavanya Latz,US,Orion Club Gold members low activity,21,15-30 years,M,2,1238255666,16818,16822,1,,1,47.9,2202002,2202,22,220200200031,Soft 1040 Women's Running Shoes
12928,Tazeen Hayhow,GB,Orion Club Gold members low activity,19,15-30 years,F,3,1238300640,16824,16826,2,,1,105.2,2201007,2201,22,220100700038,Power Dmx Wide Shoes
4360,Miguel Ángel Segura,ES,Orion Club Gold members low activity,73,61-75 years,M,2,1238306747,16825,16828,2,,1,70.5,2202003,2202,22,220200300100,Mns.super Women's Shoes
14251,Johanna Schwald,DE,Orion Club Gold members low activity,38,31-45 years,F,3,1238314172,16826,16832,1,,1,86.1,2202001,2202,22,220200100039,Big Guy Men's Air Famished Shoes
14279,J.A. Jonckers,NL,Orion Club Gold members low activity,38,31-45 years,M,2,1238449479,16842,16843,1,,1,179,2202001,2202,22,220200100107,Big Guy Men's Air Zoom Citizen Shoes
15698,Michael Walker,US,Orion Club Gold members low activity,58,46-60 years,M,2,1238526272,16852,16856,2,,1,115,2202003,2202,22,220200300015,Men's Running Shoes Piedmmont
1614,Alessandro Patron,IT,Orion Club Gold members low activity,53,46-60 years,M,3,1238604583,16862,16866,1,,1,83,2202001,2202,22,220200100092,Big Guy Men's Air Terra Sebec Shoes
25959,María Milagros Fons Gómez,ES,Orion Club Gold members low activity,28,15-30 years,F,2,1238641864,16867,16869,1,,1,80.4,2202003,2202,22,220200300060,Cross Ripple Women's Street Shoes
22363,Marina Navasotti,IT,Orion Club Gold members low activity,68,61-75 years,F,2,1238653125,16868,16871,1,,1,61.6,2202003,2202,22,220200300018,Men's Shoes Tegern
16072,Jonathan Soutiere-Burud,US,Orion Club Gold members low activity,68,61-75 years,M,2,1238673350,16870,16874,1,,1,97.3,2202002,2202,22,220200200032,Soft 140 Men's Running Shoes
11386,Marioa Camangi,IT,Orion Club Gold members low activity,58,46-60 years,M,2,1238692923,16873,16876,1,,1,107.5,2202002,2202,22,220200200050,Soft Integral Men's Running Shoes
21273,Javier Alfonso Gerónimo,ES,Orion Club Gold members low activity,68,61-75 years,M,2,1238746048,16880,16883,1,,1,66.4,2202002,2202,22,220200200018,Lulu Men's Street Shoes
5743,Daphne Amaechi,US,Orion Club Gold members low activity,23,15-30 years,F,2,1238813956,16888,16892,1,,2,315.6,2202001,2202,22,220200100099,Big Guy Men's Air Tuned Sirocco Shoes
23422,Mario Ugo Fugaro,IT,Orion Club Gold members low activity,63,61-75 years,M,2,1238820765,16889,16891,1,,1,59.1,2202001,2202,22,220200100042,Big Guy Men's Air Flyer Plus Shoes
8308,Jean Andre Isabet,FR,Orion Club Gold members low activity,73,61-75 years,M,2,1238827431,16890,16894,2,,1,39.7,2102010,2102,21,210201000175,Freestyle Children's Velcro Shoes
8308,Jean Andre Isabet,FR,Orion Club Gold members low activity,73,61-75 years,M,2,1238827431,16890,16894,1,,1,41.8,2102004,2102,21,210200400002,Deschutes Boys Outdoors Training Shoes
12281,Ivona Ledingham,US,Orion Club Gold members low activity,23,15-30 years,F,3,1238840790,16891,16895,1,,1,89.5,2202001,2202,22,220200100132,Big Guy Men's Klickitat Mid Shoes
434,Valentín Álvarez Sanz,ES,Orion Club Gold members low activity,53,46-60 years,M,2,1238858066,16894,16897,1,,2,362.6,2201007,2201,22,220100700051,Trailblaze Dmx Lite Women's Running Shoes
4051,Francine English,US,Orion Club Gold members low activity,53,46-60 years,F,2,1238896841,16898,16899,1,,1,2.9,2401001,2401,24,240100100430,Shoelace Black 100 Cm
5259,J.T.F. Limpens,NL,Orion Club Gold members low activity,58,46-60 years,M,2,1238909570,16900,16904,1,,1,135.2,2202001,2202,22,220200100108,Big Guy Men's Air Zoom Drive Shoes
2146,Gothe Gihan,FR,Orion Club Gold members low activity,38,31-45 years,F,3,1238931156,16903,16905,1,,1,38,2102004,2102,21,210200400020,Kids Baby Edge Max Shoes
21719,Scott Horswell,GB,Orion Club Gold members low activity,28,15-30 years,M,2,1238949907,16905,16909,1,,1,106.2,2201007,2201,22,220100700038,Power Dmx Wide Shoes
12478,Jessica Lilly,US,Orion Club Gold members low activity,68,61-75 years,F,2,1238966877,16907,16910,1,,1,95.5,2202002,2202,22,220200200039,Soft Cumulus Men's Running Shoes
14558,Marius Lippert,DE,Orion Club Gold members low activity,43,31-45 years,M,3,1238977939,16909,16915,2,,3,156.3,2202003,2202,22,220200300078,Hilly Women's Crosstrainer Shoes Large
9752,Jean-Charles Ehlenbeck,DE,Orion Club Gold members low activity,21,15-30 years,M,3,1239026713,16915,16916,1,,1,58.6,2202003,2202,22,220200300051,Armadillo Men's Running Shoes
11386,Marioa Camangi,IT,Orion Club Gold members low activity,58,46-60 years,M,2,1239103254,16924,16927,1,,1,88.6,2202001,2202,22,220200100090,Big Guy Men's Air Terra Reach Shoes
7485,Klaus-Peter Antony,DE,Orion Club Gold members low activity,21,15-30 years,M,3,1239267204,16945,16951,1,,1,32.8,2202001,2202,22,220200100123,Big Guy Men's Deschutz Slide Shoes
26432,Gernot Schmälzle,DE,Orion Club Gold members low activity,58,46-60 years,M,2,1239267467,16945,16947,1,,1,56.3,2202001,2202,22,220200100034,Big Guy Men's Air Deschutz Shoes
5747,Shiyo Behrle,US,Orion Club Gold members low activity,19,15-30 years,F,3,1239394430,16960,16964,1,,3,100.2,2202001,2202,22,220200100126,Big Guy Men's Gts Canvas Plus Shoes
2703,Thomas Riedel,DE,Orion Club Gold members low activity,21,15-30 years,M,2,1239452002,16968,16974,1,,2,137.2,2202001,2202,22,220200100014,Atmosphere Terra Grande Shoes
19934,Rafael González Peña,ES,Orion Club Gold members low activity,38,31-45 years,M,3,1239453619,16968,16969,1,,2,113.8,2201007,2201,22,220100700022,Alexis Women's Classic Shoes
21522,Justin Puddicombe,GB,Orion Club Gold members low activity,58,46-60 years,M,3,1239501939,16974,16975,1,0.3,2,137.98,2201007,2201,22,220100700016,Shoes Sphinx
8615,Werner Urs,DE,Orion Club Gold members low activity,48,46-60 years,M,3,1239507496,16975,16977,2,,2,160.8,2202003,2202,22,220200300060,Cross Ripple Women's Street Shoes
12694,Petra Liedermann,DE,Orion Club Gold members low activity,38,31-45 years,F,2,1239507567,16975,16980,1,,2,66.8,2202001,2202,22,220200100126,Big Guy Men's Gts Canvas Plus Shoes
8590,Todd Traxler,US,Orion Club Gold members low activity,21,15-30 years,M,3,1239560115,16981,16985,2,,2,194.6,2202002,2202,22,220200200032,Soft 140 Men's Running Shoes
8590,Todd Traxler,US,Orion Club Gold members low activity,21,15-30 years,M,3,1239560115,16981,16985,1,,2,213,2202001,2202,22,220200100084,Big Guy Men's Air Tailwind Shoes
7666,Macarena de Paz López,ES,Orion Club Gold members low activity,68,61-75 years,F,2,1239578223,16984,16988,1,,2,306.2,2402001,2402,24,240200100228,Rubby Women's Golf Shoes w/Goretex S
12212,Nicole Thienenkamp,DE,Orion Club Gold members low activity,21,15-30 years,F,2,1239697506,16999,17004,1,,2,205.2,2202001,2202,22,220200100037,Big Guy Men's Air Escape Mid Shoes
26546,Jeremy Evans,US,Orion Club Gold members low activity,43,31-45 years,M,2,1239711203,17000,17005,2,,2,122,2202001,2202,22,220200100101,Big Guy Men's Air Turbulence Shoes
7339,Anne Beinlich,GB,Orion Club Gold members low activity,33,31-45 years,F,2,1239724277,17002,17003,1,,2,119,2201007,2201,22,220100700027,Duration Women's Trainer Aerobic Shoes
11377,Franca Rita Ceserato,IT,Orion Club Gold members low activity,58,46-60 years,F,2,1239725191,17002,17004,2,,3,190.5,2202002,2202,22,220200200004,Allinall Star 2000 Women's Canvas Shoes
14721,Corinne Duxin,FR,Orion Club Gold members low activity,23,15-30 years,F,3,1239732426,17003,17006,3,,2,108.4,2102010,2102,21,210201000209,Universe 4 Children's Running Shoes
21206,J.C.G. Kish,NL,Orion Club Gold members low activity,38,31-45 years,M,3,1239735308,17003,17008,1,,2,132.8,2202002,2202,22,220200200018,Lulu Men's Street Shoes
3240,Guia Brunati,IT,Orion Club Gold members low activity,73,61-75 years,F,2,1239763841,17007,17009,1,,2,242.6,2202001,2202,22,220200100051,Big Guy Men's Air Masai Shoes
4054,Marion Malone,GB,Orion Club Gold members low activity,68,61-75 years,F,2,1239780069,17009,17012,3,,2,148.8,2201007,2201,22,220100700001,Classic Men's Leisure Shoes
16421,Niels-Peter Klußmann,DE,Orion Club Gold members low activity,38,31-45 years,M,3,1239885523,17023,17028,2,,3,322.5,2202002,2202,22,220200200050,Soft Integral Men's Running Shoes
16421,Niels-Peter Klußmann,DE,Orion Club Gold members low activity,38,31-45 years,M,3,1239885523,17023,17028,1,,2,226,2202002,2202,22,220200200045,Soft Gt 2040 Women's Running Shoes
2090,Sue Flowerdew,GB,Orion Club Gold members low activity,63,61-75 years,F,2,1239896928,17024,17029,1,,2,119,2201007,2201,22,220100700027,Duration Women's Trainer Aerobic Shoes
22655,Uneada Koutsoukos,US,Orion Club Gold members low activity,33,31-45 years,F,3,1239906173,17025,17027,1,,2,132.8,2202002,2202,22,220200200018,Lulu Men's Street Shoes
24240,Werner-Ludwig Weithofer,DE,Orion Club Gold members low activity,58,46-60 years,M,2,1239916810,17027,17031,1,,2,134,2202001,2202,22,220200100026,Big Guy Men's Air Align Shoes
19934,Rafael González Peña,ES,Orion Club Gold members low activity,38,31-45 years,M,3,1239925735,17028,17029,2,,2,20.2,2102007,2102,21,210200700013,Slomo Balance Children's Shoes
15324,Begoña García Greciano,ES,Orion Club Gold members low activity,19,15-30 years,F,2,1239934085,17029,17034,1,,2,248.6,2202001,2202,22,220200100079,Big Guy Men's Air Structure Triax Shoes
5012,Carolyn Kaasa,US,Orion Club Gold members low activity,68,61-75 years,F,2,1240012532,17038,17043,1,,3,587.1,2202002,2202,22,220200200054,Soft Kayano Men's Running Shoes
3629,Enrico Cecinelli,IT,Orion Club Gold members low activity,58,46-60 years,M,2,1240160015,17057,17060,1,,2,201.2,2402001,2402,24,240200100052,Bretagne Stabilities Tg Men's Golf Shoes
14251,Johanna Schwald,DE,Orion Club Gold members low activity,38,31-45 years,F,3,1240173703,17059,17065,1,,2,202,2202003,2202,22,220200300016,Men's Running Shoes Supernova
15827,Cristina Tremolada,IT,Orion Club Gold members low activity,73,61-75 years,F,2,1240281758,17072,17073,1,,1,62.2,2202003,2202,22,220200300007,Low Women's Aerobic Shoes
22497,Michael Dobrofsky,DE,Orion Club Gold members low activity,21,15-30 years,M,3,1240310120,17076,17079,1,,1,139.9,2202003,2202,22,220200300086,Mns Gazelle Men's Running Shoes
21142,Ignacio Villarrubia,ES,Orion Club Gold members low activity,53,46-60 years,M,2,1240448939,17093,17096,1,,1,135.2,2202001,2202,22,220200100108,Big Guy Men's Air Zoom Drive Shoes
4637,Rosa Izquierdo,ES,Orion Club Gold members low activity,21,15-30 years,F,2,1240457174,17094,17097,1,,1,125.8,2202001,2202,22,220200100057,Big Guy Men's Air Mickey Willy Shoes
27517,C.A.J. Bausch-Goldbohm Ra,NL,Orion Club Gold members low activity,23,15-30 years,F,3,1240483278,17097,17098,1,,1,85.8,2202003,2202,22,220200300076,Hi Response Women's Aerobic Shoes Large
18083,Jens Huan,DE,Orion Club Gold members low activity,43,31-45 years,M,2,1240513193,17101,17106,1,,1,124.3,2202001,2202,22,220200100079,Big Guy Men's Air Structure Triax Shoes
23197,Marni Lundstrom,GB,Orion Club Gold members low activity,28,15-30 years,F,3,1240546577,17105,17106,1,,1,90.6,2201004,2201,22,220100400020,Ultra M802 All Terrain Men's Shoes
8374,Anne Baker,US,Orion Club Gold members low activity,19,15-30 years,F,2,1240613720,17113,17116,1,,2,130.4,2202003,2202,22,220200300027,Smith Men's Street Shoes
6769,Eleanor Pala,US,Orion Club Gold members low activity,21,15-30 years,F,2,1240735654,17128,17131,1,,1,86.6,2202001,2202,22,220200100066,Big Guy Men's Air Quest Shoes
26187,Hain Amsler,DE,Orion Club Gold members low activity,23,15-30 years,M,3,1240794398,17136,17138,1,,2,69.8,2202001,2202,22,220200100160,Eclipse Mens Off Court Tennis Shoes
14558,Marius Lippert,DE,Orion Club Gold members low activity,43,31-45 years,M,3,1240881764,17147,17153,2,,2,112.6,2202003,2202,22,220200300103,Multi L Women's Running Shoes
14558,Marius Lippert,DE,Orion Club Gold members low activity,43,31-45 years,M,3,1240881764,17147,17153,1,0.5,2,89.98,2202002,2202,22,220200200067,Twain Inco Women's Street Shoes
24385,Loi Mcammond,US,Orion Club Gold members low activity,58,46-60 years,M,2,1240981648,17159,17160,1,,2,214.8,2202003,2202,22,220200300061,Damaskus Men's Running Shoes
25361,T.d. Fisher,NL,Orion Club Gold members low activity,38,31-45 years,M,3,1241004208,17162,17164,1,,2,71.6,2202003,2202,22,220200300136,Trainer Women's Crosstrainer Shoes
17243,Jo Beth Poll,US,Orion Club Gold members low activity,68,61-75 years,F,2,1241005390,17162,17164,1,,2,98.8,2102004,2102,21,210200400031,Toddle Children's Air Tuco(Bg) Shoes
16274,Herman Jermain,US,Orion Club Gold members low activity,48,46-60 years,M,3,1241135108,17177,17181,1,,1,66.5,2202001,2202,22,220200100063,Big Guy Men's Air Perish Nb Shoes
12087,Wendilyn Thaxton,US,Orion Club Gold members low activity,63,61-75 years,F,2,1241162011,17180,17185,1,,2,109.6,2202003,2202,22,220200300077,Hilly Men's Crosstrainer Shoes
24128,Beatrice Vieth,DE,Orion Club Gold members low activity,43,31-45 years,F,2,1241164963,17181,17184,1,,2,118,2202002,2202,22,220200200009,Cruise 1984 Men's Street Shoes
11942,Anita Gerday,FR,Orion Club Gold members low activity,19,15-30 years,F,3,1241203811,17185,17190,1,,1,10.1,2102007,2102,21,210200700013,Slomo Balance Children's Shoes
4498,Scott Reckert,US,Orion Club Gold members low activity,58,46-60 years,M,3,1241242175,17189,17194,1,,1,16.4,2401001,2401,24,240100100434,Shoeshine Black
21719,Scott Horswell,GB,Orion Club Gold members low activity,28,15-30 years,M,2,1241321902,17198,17200,1,,1,140.3,2201007,2201,22,220100700047,Tcp 6 Women's Running Shoes
2238,Walter Facco,IT,Orion Club Gold members low activity,48,46-60 years,M,3,1241332757,17199,17201,1,,1,59.8,2201007,2201,22,220100700010,Men's Running Shoes Burn
22089,Julio Vizcarro,ES,Orion Club Gold members low activity,38,31-45 years,M,3,1241426584,17210,17215,1,,1,38.2,2202002,2202,22,220200200038,Soft Court Women's Indoor Shoes
18485,Mireille Boyer,FR,Orion Club Gold members low activity,21,15-30 years,F,3,1241457453,17213,17214,2,,1,33.9,2102010,2102,21,210201000205,Torino 2000 K Street Shoes
18485,Mireille Boyer,FR,Orion Club Gold members low activity,21,15-30 years,F,3,1241457453,17213,17214,1,,1,42.5,2102010,2102,21,210201000197,South Peak Infant Training Shoes
19073,Ignacio Machín,ES,Orion Club Gold members low activity,58,46-60 years,M,2,1241490747,17217,17223,1,,1,80.8,2202003,2202,22,220200300073,Hi Resolution Men's Tennis Shoes
20219,Debbie Norgrove,GB,Orion Club Gold members low activity,21,15-30 years,F,2,1241537731,17222,17223,1,,1,56.9,2201007,2201,22,220100700022,Alexis Women's Classic Shoes
7666,Macarena de Paz López,ES,Orion Club Gold members low activity,68,61-75 years,F,2,1241599278,17229,17234,1,,1,80,2202001,2202,22,220200100129,Big Guy Men's International Triax Shoes
11393,Maria Rita Nannini,IT,Orion Club Gold members low activity,58,46-60 years,F,3,1241602162,17229,17235,1,,1,66.5,2202001,2202,22,220200100063,Big Guy Men's Air Perish Nb Shoes
14393,Larry Douglas,US,Orion Club Gold members low activity,33,31-45 years,M,3,1241623870,17231,17232,1,,1,135.2,2202001,2202,22,220200100108,Big Guy Men's Air Zoom Drive Shoes
14393,Larry Douglas,US,Orion Club Gold members low activity,33,31-45 years,M,3,1241623870,17231,17232,2,,1,52,2202003,2202,22,220200300009,Men's Indoor Shoes Uproar
2135,R.N. Roijen,NL,Orion Club Gold members low activity,21,15-30 years,M,3,1241658781,17235,17238,1,,1,77,2202003,2202,22,220200300155,Hardcore Men's Street Shoes
21617,Tina Kamp,NL,Orion Club Gold members low activity,68,61-75 years,F,2,1241676181,17237,17240,1,,1,70.1,2202002,2202,22,220200200037,Soft Astro Women's Running Shoes
21722,Antonio Clement,IT,Orion Club Gold members low activity,48,46-60 years,F,3,1241684610,17238,17244,1,,2,216,2202002,2202,22,220200200068,Twain Men's Exentric Ii X-Hiking Shoes
4779,Karl Mühlberg,DE,Orion Club Gold members low activity,58,46-60 years,M,2,1241708405,17241,17246,1,,2,121.2,2202003,2202,22,220200300110,Qrs Men's Street Shoes
11677,Jean-Philippe Brischke,DE,Orion Club Gold members low activity,43,31-45 years,M,3,1241725858,17243,17246,3,,2,142,2202003,2202,22,220200300082,Indoor Handbold Special Shoes
11677,Jean-Philippe Brischke,DE,Orion Club Gold members low activity,43,31-45 years,M,3,1241725858,17243,17246,1,,1,32.8,2202001,2202,22,220200100123,Big Guy Men's Deschutz Slide Shoes
11677,Jean-Philippe Brischke,DE,Orion Club Gold members low activity,43,31-45 years,M,3,1241725858,17243,17246,2,,1,70.1,2202002,2202,22,220200200037,Soft Astro Women's Running Shoes
18376,Anne Marie Boersma,NL,Orion Club Gold members low activity,21,15-30 years,F,3,1241813062,17252,17258,2,,1,100.2,2202003,2202,22,220200300070,Hgf Low Men's Indoor Shoes
18376,Anne Marie Boersma,NL,Orion Club Gold members low activity,21,15-30 years,F,3,1241813062,17252,17258,1,,3,199.5,2202002,2202,22,220200200002,Men's Nubuck-Retro Running Shoes Roadster
26044,Christina Alvery,US,Orion Club Gold members low activity,58,46-60 years,F,3,1241896501,17261,17265,1,,1,34.8,2102004,2102,21,210200400077,Tony's Children's Terra Sebec(Bg) Shoes
17606,Sudarshan Beresh,US,Orion Club Gold members low activity,48,46-60 years,M,3,1241922385,17264,17269,1,,1,108.2,2202002,2202,22,220200200071,Twain Men's Exit Low 2000 Street Shoes
17887,Gloria Sanz Madariaga,ES,Orion Club Gold members low activity,58,46-60 years,F,2,1241963561,17269,17274,1,,1,111.3,2202001,2202,22,220200100145,Big Guy Men's Structure Triax Shoes
27211,Patricia Fernández,ES,Orion Club Gold members low activity,43,31-45 years,F,2,1241979544,17271,17276,2,,3,181.8,2202003,2202,22,220200300110,Qrs Men's Street Shoes
27211,Patricia Fernández,ES,Orion Club Gold members low activity,43,31-45 years,F,2,1241979544,17271,17276,1,,1,117,2202003,2202,22,220200300095,Mns.light 4 Low Men's Indoor Shoes
18471,Charles Padgett,GB,Orion Club Gold members low activity,73,61-75 years,M,2,1242019675,17275,17276,1,,1,56.5,2201007,2201,22,220100700037,Original Women's Nylon Street Shoes
25021,Sukhpal Phee,GB,Orion Club Gold members low activity,58,46-60 years,M,3,1242093925,17283,17287,3,,1,140.3,2201007,2201,22,220100700047,Tcp 6 Women's Running Shoes
25021,Sukhpal Phee,GB,Orion Club Gold members low activity,58,46-60 years,M,3,1242093925,17283,17287,2,,1,93,2201007,2201,22,220100700023,Armadillo Road Dmx Men's Running Shoes
26866,R.N. Gruijs-Vodde,NL,Orion Club Gold members low activity,63,61-75 years,M,2,1242158487,17290,17293,1,,1,55.4,2202001,2202,22,220200100060,Big Guy Men's Air One Eighty  Shoes
20079,Pierre Jousse,FR,Orion Club Gold members low activity,53,46-60 years,M,2,1242197466,17295,17296,1,,3,102.6,2102010,2102,21,210201000174,Freestyle Children's Leather Street Shoes
3032,Nelson Brunel,FR,Orion Club Gold members low activity,28,15-30 years,M,3,1242206958,17296,17302,2,,1,34.2,2102010,2102,21,210201000174,Freestyle Children's Leather Street Shoes
14226,Richard Brown,GB,Orion Club Gold members low activity,58,46-60 years,M,2,1242208540,17296,17298,1,,1,59.5,2201007,2201,22,220100700027,Duration Women's Trainer Aerobic Shoes
4231,Michele Cantu',IT,Orion Club Gold members low activity,48,46-60 years,M,2,1242209267,17296,17298,1,,1,92.5,2202002,2202,22,220200200067,Twain Inco Women's Street Shoes
15424,Marina Beerahlee,GB,Orion Club Gold members low activity,28,15-30 years,F,3,1242282604,17304,17310,2,,1,140.3,2201007,2201,22,220100700047,Tcp 6 Women's Running Shoes
8377,Andreas Schippl,DE,Orion Club Gold members low activity,53,46-60 years,M,2,1242295748,17306,17311,1,,1,52.1,2202003,2202,22,220200300078,Hilly Women's Crosstrainer Shoes Large
24702,Zerlina Koga,US,Orion Club Gold members low activity,19,15-30 years,F,3,1242351330,17311,17314,1,,1,42.5,2102010,2102,21,210201000197,South Peak Infant Training Shoes
11216,Manfred Pferr,DE,Orion Club Gold members low activity,53,46-60 years,M,3,1242470946,17325,17326,2,,2,140.2,2202002,2202,22,220200200037,Soft Astro Women's Running Shoes
10366,Blanca Manzano Romero,ES,Orion Club Gold members low activity,33,31-45 years,F,3,1242536500,17332,17337,2,,2,20.2,2102007,2102,21,210200700013,Slomo Balance Children's Shoes
7375,Francoise Waksman,FR,Orion Club Gold members low activity,23,15-30 years,F,2,1242572143,17336,17339,1,,3,170.1,2102010,2102,21,210201000166,Children's Shoes Pleva
16778,Thomas Kearney-Glenn,US,Orion Club Gold members low activity,43,31-45 years,M,2,1242605277,17339,17342,1,,2,180,2202002,2202,22,220200200014,Dubby Low Men's Street Shoes
10664,C.M. Van Keulen,NL,Orion Club Gold members low activity,33,31-45 years,F,3,1242610430,17340,17342,1,,2,210.2,2202002,2202,22,220200200015,Dubby Low Men's Street Shoes Large
2564,Stanislaw Müller,DE,Orion Club Gold members low activity,58,46-60 years,M,3,1242623433,17342,17344,2,,2,177.6,2202002,2202,22,220200200062,Top C-Tech 6000 Tennis Shoes
7666,Macarena de Paz López,ES,Orion Club Gold members low activity,68,61-75 years,F,2,1242624570,17342,17347,1,,2,191,2202002,2202,22,220200200039,Soft Cumulus Men's Running Shoes
21689,Erika Della Libera,IT,Orion Club Gold members low activity,73,61-75 years,F,2,1242655455,17345,17350,1,,2,209.2,2201007,2201,22,220100700024,Armadillo Road Dmx Women's Running Shoes
2333,I.P.A. Van Den Berg,NL,Orion Club Gold members low activity,33,31-45 years,F,3,1242665964,17346,17352,1,,2,398.4,2202002,2202,22,220200200052,Soft Kayano Men's Running Shoes VI
1016,Deborah Prue,US,Orion Club Gold members low activity,48,46-60 years,F,3,1242710440,17351,17352,2,,3,377.4,2202001,2202,22,220200100057,Big Guy Men's Air Mickey Willy Shoes
1016,Deborah Prue,US,Orion Club Gold members low activity,48,46-60 years,F,3,1242710440,17351,17352,1,,2,112.6,2202001,2202,22,220200100034,Big Guy Men's Air Deschutz Shoes
24117,B.J. Van Putten,NL,Orion Club Gold members low activity,73,61-75 years,M,2,1242729571,17353,17358,2,,3,296.1,2202003,2202,22,220200300072,Hgf Tarantula Men's Indoor Shoes
6679,Luigino Caropreso,IT,Orion Club Gold members low activity,63,61-75 years,M,2,1242762232,17357,17360,2,,3,294.3,2202003,2202,22,220200300158,Hardcore Shoes
21617,Tina Kamp,NL,Orion Club Gold members low activity,68,61-75 years,F,2,1242827166,17364,17367,2,,2,196.2,2202003,2202,22,220200300158,Hardcore Shoes
21617,Tina Kamp,NL,Orion Club Gold members low activity,68,61-75 years,F,2,1242827166,17364,17367,1,0.4,2,75.98,2202003,2202,22,220200300110,Qrs Men's Street Shoes
19650,Álvaro Martínez Cárdenas,ES,Orion Club Gold members low activity,28,15-30 years,M,2,1242832192,17365,17366,1,,2,103.6,2202003,2202,22,220200300127,The Wish M Men's Running Shoes
22673,John Olij,NL,Orion Club Gold members low activity,33,31-45 years,M,3,1242856379,17367,17371,2,0.4,2,75.98,2202003,2202,22,220200300110,Qrs Men's Street Shoes
22673,John Olij,NL,Orion Club Gold members low activity,33,31-45 years,M,3,1242856379,17367,17371,1,,2,340,2202001,2202,22,220200100165,Sire Air Max-Running Shoes
11107,W.J. Romano,NL,Orion Club Gold members low activity,33,31-45 years,M,3,1242863253,17368,17374,2,,5,260.5,2202003,2202,22,220200300078,Hilly Women's Crosstrainer Shoes Large
11107,W.J. Romano,NL,Orion Club Gold members low activity,33,31-45 years,M,3,1242863253,17368,17374,1,,5,293,2202003,2202,22,220200300051,Armadillo Men's Running Shoes
12340,Julian Loughran,GB,Orion Club Gold members low activity,53,46-60 years,M,3,1242942210,17377,17380,2,,3,178.5,2201007,2201,22,220100700027,Duration Women's Trainer Aerobic Shoes
12340,Julian Loughran,GB,Orion Club Gold members low activity,53,46-60 years,M,3,1242942210,17377,17380,1,,5,384.5,2201004,2201,22,220100400012,Bill V-3-London Calling Shoes
17941,Gabriel Cressi,ES,Orion Club Gold members low activity,19,15-30 years,M,2,1242995858,17383,17387,1,,2,144.6,2202003,2202,22,220200300022,Men's Street Shoes Gazelle
25408,Melanie Knappe,DE,Orion Club Gold members low activity,43,31-45 years,F,3,1243013308,17385,17391,1,,2,180,2202002,2202,22,220200200014,Dubby Low Men's Street Shoes
2797,Pascal Ente,FR,Orion Club Gold members low activity,38,31-45 years,M,3,1243032817,17387,17392,2,,2,20.2,2102007,2102,21,210200700013,Slomo Balance Children's Shoes
21659,Nash Candedo,US,Orion Club Gold members low activity,21,15-30 years,M,3,1243048464,17388,17390,1,,2,162.2,2202001,2202,22,220200100027,Big Guy Men's Air Aragon Shoes
4798,Laurence Breton,FR,Orion Club Gold members low activity,53,46-60 years,F,3,1243058848,17390,17392,2,,3,122.1,2102004,2102,21,210200400032,Toddle Children's Align(Bp) Shoes
20846,Francoise Hellen,DE,Orion Club Gold members low activity,58,46-60 years,F,2,1243074749,17392,17393,1,,3,354.9,2202001,2202,22,220200100086,Big Guy Men's Air Terra Central Shoes
6343,John Mitchell,US,Orion Club Gold members low activity,21,15-30 years,M,3,1243188539,17404,17408,1,,2,197.4,2202003,2202,22,220200300072,Hgf Tarantula Men's Indoor Shoes
15026,Maddalena Premazzi,IT,Orion Club Gold members low activity,68,61-75 years,F,2,1243233813,17409,17413,2,,2,207.6,2202003,2202,22,220200300071,Hgf  Low Women's Indoor Shoes
8308,Jean Andre Isabet,FR,Orion Club Gold members low activity,73,61-75 years,M,2,1243247305,17411,17419,1,,1,42.5,2102010,2102,21,210201000197,South Peak Infant Training Shoes
24080,Klaus-d. Molenda,DE,Orion Club Gold members low activity,48,46-60 years,M,3,1243347737,17422,17427,1,,2,151.4,2202001,2202,22,220200100050,Big Guy Men's Air Mantra Shoes
26406,Enrique Roset Gamisans,ES,Orion Club Gold members low activity,19,15-30 years,M,3,1243367799,17424,17429,1,,1,120.7,2202001,2202,22,220200100098,Big Guy Men's Air Tuned Max Shoes
26406,Enrique Roset Gamisans,ES,Orion Club Gold members low activity,19,15-30 years,M,3,1243367799,17424,17429,2,,1,135.8,2202002,2202,22,220200200047,Soft Gt 2050 Women's Running Shoes
5303,Odette Gally,FR,Orion Club Gold members low activity,43,31-45 years,F,2,1243413421,17429,17430,1,,2,68.4,2102010,2102,21,210201000174,Freestyle Children's Leather Street Shoes
1296,Bykim Corsi,US,Orion Club Gold members low activity,68,61-75 years,M,2,1243453341,17433,17434,1,,1,55.8,2202001,2202,22,220200100149,Big Guy Men's Ultraccel 2 F.G. Soccer Shoes
18485,Mireille Boyer,FR,Orion Club Gold members low activity,21,15-30 years,F,3,1243487492,17437,17438,2,,1,46.2,2102010,2102,21,210201000187,Mona  C- Children's Street Shoes
3733,Elly Kiedaisch,GB,Orion Club Gold members low activity,43,31-45 years,M,2,1243593895,17449,17450,1,,1,86.5,2201007,2201,22,220100700026,Del Sol Women's  Aerobic Shoes
11594,Ailse Wood,GB,Orion Club Gold members low activity,33,31-45 years,F,3,1243602940,17450,17454,2,,1,97.3,2201007,2201,22,220100700016,Shoes Sphinx
25491,Robert Wylie,US,Orion Club Gold members low activity,21,15-30 years,M,2,1243607080,17450,17451,1,,1,180.7,2202001,2202,22,220200100105,Big Guy Men's Air Zoom Beyond-Tennis Shoes
15990,Albert Elshenawy,US,Orion Club Gold members low activity,68,61-75 years,M,2,1243798003,17471,17480,1,,2,37.4,2401001,2401,24,240100100229,Cruise First Star Baby Shoes
24034,Carvel Kolu,US,Orion Club Gold members low activity,19,15-30 years,M,2,1243809230,17472,17473,3,,2,65.2,2102010,2102,21,210201000168,Children's Shoes Wilcox
25526,Daniel Gigot,FR,Orion Club Gold members low activity,28,15-30 years,M,3,1243892869,17482,17486,2,,2,67.6,2102010,2102,21,210201000167,Children's Shoes Stratosphere
22201,Leandro Lozano García,ES,Orion Club Gold members low activity,19,15-30 years,M,3,1243900784,17483,17488,1,,1,140.3,2402001,2402,24,240200100051,Bretagne Stabilites 2000 Goretex Shoes
17621,Eric Briday,FR,Orion Club Gold members low activity,21,15-30 years,M,3,1243901841,17483,17487,1,,1,61.4,2102010,2102,21,210201000193,South Peak Children's Shoes J
9160,Reiner Klose,DE,Orion Club Gold members low activity,73,61-75 years,M,2,1243909119,17484,17487,2,,1,73.4,2202003,2202,22,220200300157,Hardcore Men's Street Shoes Large
11136,Bärbel Wacholder,DE,Orion Club Gold members low activity,21,15-30 years,F,2,1244018936,17496,17497,1,,1,56.3,2202003,2202,22,220200300103,Multi L Women's Running Shoes
21689,Erika Della Libera,IT,Orion Club Gold members low activity,73,61-75 years,F,2,1244105989,17505,17510,1,,2,149.6,2202001,2202,22,220200100047,Big Guy Men's Air International Shoes
18914,Francesco Pattaro,IT,Orion Club Gold members low activity,53,46-60 years,M,3,1244125863,17507,17512,2,,2,194.6,2202002,2202,22,220200200032,Soft 140 Men's Running Shoes
18914,Francesco Pattaro,IT,Orion Club Gold members low activity,53,46-60 years,M,3,1244125863,17507,17512,1,,2,270.4,2202001,2202,22,220200100108,Big Guy Men's Air Zoom Drive Shoes
9478,Marie-Pierre Dulong,FR,Orion Club Gold members low activity,19,15-30 years,F,3,1244148377,17510,17513,2,,2,77.2,2102006,2102,21,210200600064,Children's Canvas Shoes
48775,John Nugent,US,Orion Club Gold members low activity,33,31-45 years,M,2,1230010698,15707,15711,1,,1,33.5,2102010,2102,21,210201000179,K Street Shoes
53401,Sandra Beene,US,Orion Club Gold members low activity,28,15-30 years,F,2,1230043349,15713,15716,1,,2,6,2401001,2401,24,240100100431,Shoelace Black 150 Cm
41421,Monika Wobig,DE,Orion Club Gold members low activity,58,46-60 years,F,2,1230121062,15728,15730,2,,1,105.1,2202002,2202,22,220200200015,Dubby Low Men's Street Shoes Large
41421,Monika Wobig,DE,Orion Club Gold members low activity,58,46-60 years,F,2,1230121062,15728,15730,1,,1,89.5,2202001,2202,22,220200100132,Big Guy Men's Klickitat Mid Shoes
37618,Bhavna Drolet,GB,Orion Club Gold members low activity,63,61-75 years,F,2,1230161642,15735,15740,2,,1,57.9,2201007,2201,22,220100700027,Duration Women's Trainer Aerobic Shoes
30308,Lisa Moules,GB,Orion Club Gold members low activity,23,15-30 years,F,2,1230168141,15736,15741,1,,1,88.1,2201004,2201,22,220100400027,Wa.lbc Street Shoes
47797,Agnes Scott,US,Orion Club Gold members low activity,53,46-60 years,F,3,1230309023,15761,15765,1,,1,99.6,2202003,2202,22,220200300117,South Peak Women's Light Indoor Shoes
30996,Theresa Moskala,US,Orion Club Gold members low activity,28,15-30 years,F,3,1230319426,15763,15766,1,,1,112.6,2202002,2202,22,220200200041,Soft Ds Trainer Men's Running Shoes
46996,Gennaro Vello,IT,Orion Club Gold members low activity,48,46-60 years,F,3,1230365204,15772,15776,1,,1,66.4,2202002,2202,22,220200200018,Lulu Men's Street Shoes
29527,Lewis Britt,US,Orion Club Gold members low activity,43,31-45 years,M,3,1230404971,15779,15781,1,,1,99.6,2202003,2202,22,220200300117,South Peak Women's Light Indoor Shoes
52669,Paola Carelli,IT,Orion Club Gold members low activity,48,46-60 years,F,2,1230425787,15783,15786,1,,2,156.6,2202003,2202,22,220200300106,Multi Women's Running Shoes
38552,Colleen Fisanich,US,Orion Club Gold members low activity,43,31-45 years,F,2,1230427541,15783,15788,1,,2,264.4,2202001,2202,22,220200100089,Big Guy Men's Air Terra Humara Nb Shoes
45808,Astrid Arnreich,DE,Orion Club Gold members low activity,48,46-60 years,F,2,1230435358,15785,15788,1,,1,100.9,2202002,2202,22,220200200068,Twain Men's Exentric Ii X-Hiking Shoes
53340,Finlay Prideaux,GB,Orion Club Gold members low activity,19,15-30 years,M,3,1230553253,15806,15812,1,,3,154.2,2201007,2201,22,220100700037,Original Women's Nylon Street Shoes
38995,Umberto Trivisonno,IT,Orion Club Gold members low activity,48,46-60 years,M,2,1230591054,15813,15815,2,,1,132.1,2202002,2202,22,220200200072,Twain Men's Expresso X-Hiking Shoes
38995,Umberto Trivisonno,IT,Orion Club Gold members low activity,48,46-60 years,M,2,1230591054,15813,15815,1,,1,34.9,2202001,2202,22,220200100160,Eclipse Mens Off Court Tennis Shoes
42039,Katja Schub,DE,Orion Club Gold members low activity,23,15-30 years,F,2,1230614452,15818,15820,1,,1,89.8,2202001,2202,22,220200100097,Big Guy  Men's Air Trainer Structure Plu Shoe
29960,Marie-Annick Gremont,FR,Orion Club Gold members low activity,21,15-30 years,F,2,1230621381,15819,15821,3,,1,10.1,2102007,2102,21,210200700013,Slomo Balance Children's Shoes
41978,Fronke Bayer,DE,Orion Club Gold members low activity,21,15-30 years,F,2,1230637250,15822,15824,1,,1,100.2,2202003,2202,22,220200300070,Hgf Low Men's Indoor Shoes
37484,Roger Woolham,GB,Orion Club Gold members low activity,48,46-60 years,M,3,1230654970,15825,15827,1,,1,51.4,2201007,2201,22,220100700037,Original Women's Nylon Street Shoes
43618,Colin Dermody,GB,Orion Club Gold members low activity,28,15-30 years,M,3,1230667629,15827,15832,2,,1,100.2,2201007,2201,22,220100700038,Power Dmx Wide Shoes
33303,Amey Bhe,US,Orion Club Gold members low activity,23,15-30 years,F,2,1230669528,15827,15831,1,,1,139.9,2202001,2202,22,220200100113,Big Guy Men's Air Zoom Pivot Mid Ii Shoes
54171,Gianni Liaci,IT,Orion Club Gold members low activity,48,46-60 years,M,2,1230744752,15841,15843,1,,1,112.6,2202002,2202,22,220200200041,Soft Ds Trainer Men's Running Shoes
35762,Anja Leib,DE,Orion Club Gold members low activity,68,61-75 years,F,2,1230762570,15845,15849,1,,1,101,2202003,2202,22,220200300016,Men's Running Shoes Supernova
51595,Toni Harvey,GB,Orion Club Gold members low activity,68,61-75 years,F,2,1230792272,15850,15851,2,,1,100.2,2201007,2201,22,220100700038,Power Dmx Wide Shoes
35136,Edward Mcleod,GB,Orion Club Gold members low activity,33,31-45 years,F,3,1230797746,15851,15861,1,,3,201,2201007,2201,22,220100700001,Classic Men's Leisure Shoes
36371,Chris Graindorge,GB,Orion Club Gold members low activity,53,46-60 years,M,3,1230803194,15852,15857,1,,1,80.9,2201007,2201,22,220100700026,Del Sol Women's  Aerobic Shoes
36371,Chris Graindorge,GB,Orion Club Gold members low activity,53,46-60 years,M,3,1230852183,15861,15866,1,,2,200.4,2201007,2201,22,220100700038,Power Dmx Wide Shoes
36919,Gema Gómez Medina,ES,Orion Club Gold members low activity,28,15-30 years,F,3,1230872215,15865,15867,2,,2,124.4,2201007,2201,22,220100700014,Rugged Women's Walking Shoes
43244,Irma Zambelli,IT,Orion Club Gold members low activity,73,61-75 years,F,2,1230928682,15875,15882,1,,2,162.2,2202001,2202,22,220200100027,Big Guy Men's Air Aragon Shoes
53639,Timothy Gies,US,Orion Club Gold members low activity,43,31-45 years,M,2,1230936756,15876,15881,1,,3,56.1,2401001,2401,24,240100100229,Cruise First Star Baby Shoes
36342,Brian Misgrave,GB,Orion Club Gold members low activity,43,31-45 years,M,2,1230943316,15878,15882,3,,3,161.7,2201007,2201,22,220100700010,Men's Running Shoes Burn
28238,Stephen Weller,US,Orion Club Gold members low activity,73,61-75 years,M,2,1230962160,15881,15882,1,,3,141,2202002,2202,22,220200200005,Allinall Star Men's Canvas Shoes
39033,Samara Rubagotti,IT,Orion Club Gold members low activity,48,46-60 years,F,2,1230973607,15883,15885,1,,3,337.8,2202002,2202,22,220200200041,Soft Ds Trainer Men's Running Shoes
48932,Brian Keith,US,Orion Club Gold members low activity,19,15-30 years,M,3,1230996038,15887,15889,2,,5,76.5,2401001,2401,24,240100100434,Shoeshine Black
28081,Navid Farrington,GB,Orion Club Gold members low activity,23,15-30 years,M,2,1230999464,15888,15892,1,,2,107.8,2201007,2201,22,220100700010,Men's Running Shoes Burn
51053,Pedro Parra de Haro,ES,Orion Club Gold members low activity,58,46-60 years,M,3,1231019821,15892,15900,1,,2,134.2,2202003,2202,22,220200300052,Armadillo Women's Running Shoes
36342,Brian Misgrave,GB,Orion Club Gold members low activity,43,31-45 years,M,2,1231043587,15896,15900,1,,2,182,2201004,2201,22,220100400018,Osprey Men's Street Cat Nubuck Street Shoes
48012,Scott Armbuster,US,Orion Club Gold members low activity,58,46-60 years,M,3,1231137087,15913,15916,1,,2,117.2,2202003,2202,22,220200300051,Armadillo Men's Running Shoes
53465,Volker Maier-Küderli,DE,Orion Club Gold members low activity,68,61-75 years,M,2,1231144486,15915,15916,2,,2,212.8,2202003,2202,22,220200300061,Damaskus Men's Running Shoes
53465,Volker Maier-Küderli,DE,Orion Club Gold members low activity,68,61-75 years,M,2,1231144486,15915,15916,1,,3,473.4,2202001,2202,22,220200100099,Big Guy Men's Air Tuned Sirocco Shoes
54935,Alain d'Agrain,FR,Orion Club Gold members low activity,53,46-60 years,M,3,1231168090,15919,15921,1,,2,5.6,2401001,2401,24,240100100430,Shoelace Black 100 Cm
46996,Gennaro Vello,IT,Orion Club Gold members low activity,48,46-60 years,F,3,1231173819,15920,15926,1,,2,391.4,2202002,2202,22,220200200054,Soft Kayano Men's Running Shoes
33131,Cettina Vannucchi,IT,Orion Club Gold members low activity,63,61-75 years,F,2,1231179637,15921,15924,1,,2,169.8,2202003,2202,22,220200300115,South Peak Men's Light Low Indoor Shoes
53072,Claudia Pennelli,IT,Orion Club Gold members low activity,48,46-60 years,F,3,1231204080,15925,15926,2,,2,200.4,2202003,2202,22,220200300070,Hgf Low Men's Indoor Shoes
53072,Claudia Pennelli,IT,Orion Club Gold members low activity,48,46-60 years,F,3,1231204080,15925,15926,1,,3,242.4,2202002,2202,22,220200200067,Twain Inco Women's Street Shoes
28767,Guillermo García Tenorio,ES,Orion Club Gold members low activity,73,61-75 years,M,2,1231234877,15931,15934,1,,3,362.1,2202001,2202,22,220200100098,Big Guy Men's Air Tuned Max Shoes
29134,Susan Kyriacou,GB,Orion Club Gold members low activity,38,31-45 years,F,3,1231253054,15934,15935,1,,2,217.4,2201007,2201,22,220100700003,Dmx 6 Shoes
38318,Shakira Wood,US,Orion Club Gold members low activity,21,15-30 years,F,2,1231283740,15939,15941,1,,2,20.2,2102007,2102,21,210200700013,Slomo Balance Children's Shoes
46504,Jean Valery Paternault,FR,Orion Club Gold members low activity,21,15-30 years,M,3,1231286070,15940,15943,1,,2,122.8,2102010,2102,21,210201000193,South Peak Children's Shoes J
29370,Bladen Moore,US,Orion Club Gold members low activity,38,31-45 years,F,3,1231287495,15940,15941,1,,2,134,2202001,2202,22,220200100026,Big Guy Men's Air Align Shoes
39308,Herbert Dignaß,DE,Orion Club Gold members low activity,38,31-45 years,M,2,1231327861,15948,15951,1,,2,227.4,2202001,2202,22,220200100087,Big Guy Men's Air Terra Clay-Tennis Shoes
47561,Maria Luisa Cominato,IT,Orion Club Gold members low activity,48,46-60 years,F,2,1231351839,15952,15953,2,,1,89.5,2202001,2202,22,220200100132,Big Guy Men's Klickitat Mid Shoes
47561,Maria Luisa Cominato,IT,Orion Club Gold members low activity,48,46-60 years,F,2,1231351839,15952,15953,1,,2,213.2,2202001,2202,22,220200100038,Big Guy Men's Air Exploraid Shoes
27850,Leyla Weber-Gottberg,US,Orion Club Gold members low activity,48,46-60 years,F,2,1231359826,15953,15956,1,,1,95.4,2202002,2202,22,220200200071,Twain Men's Exit Low 2000 Street Shoes
29597,Helge Luettig,DE,Orion Club Gold members low activity,38,31-45 years,M,3,1231371519,15956,15957,1,,1,70.9,2202003,2202,22,220200300022,Men's Street Shoes Gazelle
32533,Luann Calandra,US,Orion Club Gold members low activity,21,15-30 years,F,3,1231496679,15978,15980,2,,2,104.2,2202003,2202,22,220200300078,Hilly Women's Crosstrainer Shoes Large
32533,Luann Calandra,US,Orion Club Gold members low activity,21,15-30 years,F,3,1231496679,15978,15980,1,,1,108.9,2202001,2202,22,220200100173,Woman's Air Athena Triax-Running Shoes
45938,Gertraud Sincic,DE,Orion Club Gold members low activity,58,46-60 years,F,2,1231504148,15980,15985,1,,1,87.3,2202003,2202,22,220200300158,Hardcore Shoes
43618,Colin Dermody,GB,Orion Club Gold members low activity,28,15-30 years,M,3,1231506268,15980,15985,1,,1,103,2201007,2201,22,220100700020,Women's Trainer Aerobic Shoes
28354,Corinna Heinen,DE,Orion Club Gold members low activity,21,15-30 years,F,3,1231519452,15983,15985,1,,1,64,2202002,2202,22,220200200021,Pro Fit  Gel Ds Trainer Iv Men's Running Shoe
31165,Mario Giummole',IT,Orion Club Gold members low activity,48,46-60 years,M,3,1231521726,15983,15985,1,,2,114.6,2202001,2202,22,220200100139,Big Guy Men's Payoff Trainer Shoes
54171,Gianni Liaci,IT,Orion Club Gold members low activity,48,46-60 years,M,2,1231539275,15986,15988,1,,1,86.2,2202002,2202,22,220200200011,Cruise Platypus Men's Street Shoes
38722,Daniel Pflugrath,US,Orion Club Gold members low activity,48,46-60 years,M,3,1231540806,15986,15988,1,,2,103.4,2202003,2202,22,220200300035,Women's Aerobic Shoes Speedster
46977,Isabel Ranz Abad,ES,Orion Club Gold members low activity,33,31-45 years,F,2,1231549741,15988,15992,1,,1,36.7,2102010,2102,21,210201000183,Kola Children's Shoes
54165,Bárbara Becerra,ES,Orion Club Gold members low activity,73,61-75 years,F,2,1231565294,15991,15993,2,,1,73.4,2202003,2202,22,220200300157,Hardcore Men's Street Shoes Large
52026,Irmingard Ament,DE,Orion Club Gold members low activity,23,15-30 years,F,2,1231614779,16000,16001,1,,1,35.8,2202003,2202,22,220200300136,Trainer Women's Crosstrainer Shoes
50864,Jessie Morgan,US,Orion Club Gold members low activity,43,31-45 years,M,2,1231703017,16015,16016,1,,1,105.1,2202002,2202,22,220200200015,Dubby Low Men's Street Shoes Large
44911,Vincent Decousus,FR,Orion Club Gold members low activity,53,46-60 years,M,2,1231732819,16021,16023,1,,1,41.7,2102010,2102,21,210201000197,South Peak Infant Training Shoes
32110,Delle Lobur,US,Orion Club Gold members low activity,21,15-30 years,F,2,1231788228,16030,16034,1,,1,4.6,2401001,2401,24,240100100429,"Shoelace 140 Cm, Assorted Colours"
28633,Vicki Gerou,US,Orion Club Gold members low activity,33,31-45 years,F,3,1231831396,16038,16043,2,,1,60.1,2102004,2102,21,210200400076,Tony's Children's Terra Reach(Bg) Shoes
50888,Susanne Hobbeling,DE,Orion Club Gold members low activity,48,46-60 years,F,3,1231845111,16041,16043,2,,2,391.4,2202002,2202,22,220200200054,Soft Kayano Men's Running Shoes
49635,Manfred Komor,DE,Orion Club Gold members low activity,58,46-60 years,M,3,1231883512,16048,16052,1,,2,168,2202002,2202,22,220200200067,Twain Inco Women's Street Shoes
43424,Natarsha Caccamise,US,Orion Club Gold members low activity,23,15-30 years,F,2,1231904042,16051,16056,2,,2,118,2202002,2202,22,220200200009,Cruise 1984 Men's Street Shoes
31845,Toni Von Spreckelsen,US,Orion Club Gold members low activity,23,15-30 years,F,2,1231951804,16060,16065,1,,2,172.4,2202002,2202,22,220200200011,Cruise Platypus Men's Street Shoes
49963,Mercedes Pizarro Urbina,ES,Orion Club Gold members low activity,19,15-30 years,F,3,1231993289,16068,16074,2,,2,74.4,2202002,2202,22,220200200043,Soft Gel Court Men's Indoor Shoes
49802,José Encina,ES,Orion Club Gold members low activity,68,61-75 years,M,2,1232019253,16072,16075,2,,1,86.2,2202002,2202,22,220200200011,Cruise Platypus Men's Street Shoes
35380,Catharine Radford,US,Orion Club Gold members low activity,73,61-75 years,F,2,1232023302,16072,16073,1,,2,230,2202003,2202,22,220200300015,Men's Running Shoes Piedmmont
39841,Vincent Leclerc,FR,Orion Club Gold members low activity,73,61-75 years,M,2,1232031359,16074,16075,1,,1,38,2102004,2102,21,210200400020,Kids Baby Edge Max Shoes
53349,Jennifer Rubinson,GB,Orion Club Gold members low activity,23,15-30 years,F,2,1232032405,16074,16076,1,,1,53.7,2201007,2201,22,220100700022,Alexis Women's Classic Shoes
41811,Claus W. Eichler,DE,Orion Club Gold members low activity,21,15-30 years,M,2,1232064808,16079,16084,1,,1,98.8,2202002,2202,22,220200200027,Salida Low Men's Outdoor Shoes
47721,Alessandro Castelli,IT,Orion Club Gold members low activity,48,46-60 years,M,2,1232152668,16092,16096,1,,1,181.3,2201007,2201,22,220100700051,Trailblaze Dmx Lite Women's Running Shoes
38452,Gerald Smith,US,Orion Club Gold members low activity,21,15-30 years,M,2,1232162555,16093,16096,2,,1,79.7,2202003,2202,22,220200300060,Cross Ripple Women's Street Shoes
38452,Gerald Smith,US,Orion Club Gold members low activity,21,15-30 years,M,2,1232162555,16093,16096,1,,2,315.6,2202001,2202,22,220200100099,Big Guy Men's Air Tuned Sirocco Shoes
40964,Carla Tullio,IT,Orion Club Gold members low activity,68,61-75 years,F,2,1232191236,16098,16103,1,,1,73.4,2202003,2202,22,220200300157,Hardcore Men's Street Shoes Large
46113,Elise Ramanantoandro,FR,Orion Club Gold members low activity,23,15-30 years,F,3,1232229416,16104,16106,2,,1,41.4,2102010,2102,21,210201000199,Starlite Baby Shoes
47561,Maria Luisa Cominato,IT,Orion Club Gold members low activity,48,46-60 years,F,2,1232264270,16109,16113,1,,1,125.8,2202001,2202,22,220200100057,Big Guy Men's Air Mickey Willy Shoes
45663,Jürgen Vomhoff,DE,Orion Club Gold members low activity,48,46-60 years,M,3,1232353845,16123,16127,1,,1,70.7,2202003,2202,22,220200300033,Women's Aerobic Shoes Psych
39388,Corinna Manlik,DE,Orion Club Gold members low activity,23,15-30 years,F,2,1232374140,16126,16128,1,,1,90,2202002,2202,22,220200200014,Dubby Low Men's Street Shoes
34386,Jens Sinitski,DE,Orion Club Gold members low activity,68,61-75 years,M,2,1232381284,16127,16128,1,,1,73.4,2202003,2202,22,220200300157,Hardcore Men's Street Shoes Large
44694,Massimo Leipold,IT,Orion Club Gold members low activity,73,61-75 years,M,2,1232392012,16128,16129,1,,1,101,2202003,2202,22,220200300016,Men's Running Shoes Supernova
44057,Lisa Khadye,US,Orion Club Gold members low activity,53,46-60 years,F,2,1232418436,16133,16136,2,,1,4.6,2401001,2401,24,240100100429,"Shoelace 140 Cm, Assorted Colours"
54545,Enrique Cabo Caro,ES,Orion Club Gold members low activity,48,46-60 years,M,2,1232505928,16147,16151,1,,1,59,2202002,2202,22,220200200009,Cruise 1984 Men's Street Shoes
50888,Susanne Hobbeling,DE,Orion Club Gold members low activity,48,46-60 years,F,3,1232526483,16150,16155,2,,2,243,2202002,2202,22,220200200070,Twain Men's Exit Iii Mid Cd X-Hiking Shoes
50888,Susanne Hobbeling,DE,Orion Club Gold members low activity,48,46-60 years,F,3,1232526483,16150,16155,1,,1,66.5,2202002,2202,22,220200200002,Men's Nubuck-Retro Running Shoes Roadster
51180,Manfred Wodny,DE,Orion Club Gold members low activity,43,31-45 years,M,3,1232544564,16153,16158,2,,1,55.4,2202001,2202,22,220200100060,Big Guy Men's Air One Eighty  Shoes
42070,Karina Schytt,DE,Orion Club Gold members low activity,48,46-60 years,F,3,1232550865,16154,16159,1,,1,89.8,2202001,2202,22,220200100097,Big Guy  Men's Air Trainer Structure Plu Shoe
39388,Corinna Manlik,DE,Orion Club Gold members low activity,23,15-30 years,F,2,1232557781,16155,16157,1,,1,102.2,2202001,2202,22,220200100044,Big Guy Men's Air Force Strong Shoes
49342,José Arozamena,ES,Orion Club Gold members low activity,33,31-45 years,M,3,1232591916,16160,16164,2,,1,97.3,2202002,2202,22,220200200032,Soft 140 Men's Running Shoes
40964,Carla Tullio,IT,Orion Club Gold members low activity,68,61-75 years,F,2,1232614499,16163,16168,1,,2,183.2,2201004,2201,22,220100400027,Wa.lbc Street Shoes
40520,Alessandro Stanford,IT,Orion Club Gold members low activity,53,46-60 years,M,2,1232669179,16171,16176,2,,1,65.8,2202003,2202,22,220200300080,Hilo Mid Iii Women's Aerobic Shoes
40520,Alessandro Stanford,IT,Orion Club Gold members low activity,53,46-60 years,M,2,1232669179,16171,16176,1,,4,443.2,2202001,2202,22,220200100078,Big Guy Men's Air Stormy Skylon Shoes
35380,Catharine Radford,US,Orion Club Gold members low activity,73,61-75 years,F,2,1232690101,16174,16175,2,,1,109.4,2202003,2202,22,220200300069,Hgf Incentive Men's Tennis Shoes
36853,Mesut Jivoff,US,Orion Club Gold members low activity,38,31-45 years,M,3,1232723252,16179,16185,1,,1,64.9,2202003,2202,22,220200300079,Hilly Women's Crosstrainer Shoes
27929,Thomas Fehrentz,DE,Orion Club Gold members low activity,53,46-60 years,M,3,1232778117,16188,16189,1,,1,84.2,2202003,2202,22,220200300014,Men's Running Shoes Ozweego
47750,M.E. Nije Banning,NL,Orion Club Gold members low activity,38,31-45 years,F,3,1232795132,16190,16196,1,,1,84.2,2202003,2202,22,220200300014,Men's Running Shoes Ozweego
44490,Fabrizio de Serventi,IT,Orion Club Gold members low activity,53,46-60 years,M,3,1232904071,16206,16212,1,,3,431.1,2202001,2202,22,220200100056,Big Guy Men's Air MickeyTailwind Shoes
34661,Richard Firman,GB,Orion Club Gold members low activity,28,15-30 years,M,2,1232929168,16210,16212,1,,1,103.2,2201007,2201,22,220100700038,Power Dmx Wide Shoes
46807,Hansjoachim Völker,DE,Orion Club Gold members low activity,38,31-45 years,M,2,1232966244,16216,16219,1,,1,84.9,2202003,2202,22,220200300115,South Peak Men's Light Low Indoor Shoes
44694,Massimo Leipold,IT,Orion Club Gold members low activity,73,61-75 years,M,2,1232976305,16217,16218,1,,1,65.8,2202003,2202,22,220200300080,Hilo Mid Iii Women's Aerobic Shoes
49102,Helenor Ballantine,GB,Orion Club Gold members low activity,33,31-45 years,F,3,1232982690,16218,16223,1,,1,85.6,2201007,2201,22,220100700042,"Power Women's Dmx Wide, Walking Shoes"
43714,C.J. Havermans,NL,Orion Club Gold members low activity,21,15-30 years,M,3,1232998356,16220,16223,1,,1,110.3,2202003,2202,22,220200300142,Vishnu Women's Running Shoes
45343,Regine Franceschi,IT,Orion Club Gold members low activity,48,46-60 years,F,3,1233009416,16222,16225,1,,1,131.7,2202003,2202,22,220200300101,Mns.winner Men's Running Shoes
39827,R.P. Van Egmond,NL,Orion Club Gold members low activity,58,46-60 years,M,3,1233045337,16227,16229,1,,5,354,2202003,2202,22,220200300143,W.a..trainer Leather Shoes
54634,Rayma Smolik,DE,Orion Club Gold members low activity,43,31-45 years,F,2,1233074970,16232,16234,1,,2,215,2202002,2202,22,220200200050,Soft Integral Men's Running Shoes
47170,Aranzazu López García,ES,Orion Club Gold members low activity,21,15-30 years,F,3,1233075472,16232,16237,1,,2,33.6,2102007,2102,21,210200700014,Slomo Children's Hop Shoes
31446,Elaine Withers,GB,Orion Club Gold members low activity,58,46-60 years,F,3,1233076970,16232,16238,2,,2,107.4,2201007,2201,22,220100700022,Alexis Women's Classic Shoes
42039,Katja Schub,DE,Orion Club Gold members low activity,23,15-30 years,F,2,1233100790,16236,16237,1,,2,120.4,2202002,2202,22,220200200036,Soft Astro Men's Running Shoes
42498,Brigitte Chevalier,FR,Orion Club Gold members low activity,21,15-30 years,F,2,1233115534,16238,16242,1,,2,108.2,2102004,2102,21,210200400025,Toddle Children's Air Align(Bg) Shoes
43175,Ronald Earhart,US,Orion Club Gold members low activity,21,15-30 years,M,2,1233125489,16239,16245,1,,2,202,2202003,2202,22,220200300016,Men's Running Shoes Supernova
35225,Heeger Jansen,DE,Orion Club Gold members low activity,38,31-45 years,M,3,1233154201,16244,16248,1,,2,254.6,2202002,2202,22,220200200042,Soft Ds Trainer Women's Running Shoes
40379,J.T. Dashorst,NL,Orion Club Gold members low activity,73,61-75 years,F,2,1233164146,16245,16248,1,,2,114.6,2202001,2202,22,220200100139,Big Guy Men's Payoff Trainer Shoes
28147,Jürgen Messinger,DE,Orion Club Gold members low activity,43,31-45 years,M,2,1233200437,16251,16256,3,,2,171.6,2202003,2202,22,220200300076,Hi Response Women's Aerobic Shoes Large
28147,Jürgen Messinger,DE,Orion Club Gold members low activity,43,31-45 years,M,2,1233200437,16251,16256,2,,2,118,2202002,2202,22,220200200009,Cruise 1984 Men's Street Shoes
35966,Willy Prosper Dörr,DE,Orion Club Gold members low activity,38,31-45 years,M,2,1233207322,16252,16256,1,,2,186,2202003,2202,22,220200300159,Hispeed Shoes
53754,María Isabel Mistral Salas,ES,Orion Club Gold members low activity,68,61-75 years,F,2,1233207955,16252,16255,2,,3,50.4,2102007,2102,21,210200700014,Slomo Children's Hop Shoes
53754,María Isabel Mistral Salas,ES,Orion Club Gold members low activity,68,61-75 years,F,2,1233207955,16252,16255,1,,2,73.6,2102004,2102,21,210200400039,Toddle Children's Quokka V (Bp) Shoes
35471,Koron Jeyarajah,US,Orion Club Gold members low activity,48,46-60 years,M,2,1233225318,16254,16259,1,,3,100.2,2202001,2202,22,220200100126,Big Guy Men's Gts Canvas Plus Shoes
27952,Jan Reinhart,DE,Orion Club Gold members low activity,43,31-45 years,M,2,1233239833,16257,16262,2,,3,395.1,2202003,2202,22,220200300101,Mns.winner Men's Running Shoes
28663,Tony Papegaay,US,Orion Club Gold members low activity,28,15-30 years,M,3,1233244504,16257,16260,2,,3,156.3,2202003,2202,22,220200300078,Hilly Women's Crosstrainer Shoes Large
29910,C.H. Gerritsen,NL,Orion Club Gold members low activity,73,61-75 years,M,2,1233249396,16258,16259,1,,3,363.9,2202001,2202,22,220200100051,Big Guy Men's Air Masai Shoes
52271,Petra Sill,DE,Orion Club Gold members low activity,21,15-30 years,F,2,1233259847,16260,16264,2,,2,271.6,2202002,2202,22,220200200047,Soft Gt 2050 Women's Running Shoes
52271,Petra Sill,DE,Orion Club Gold members low activity,21,15-30 years,F,2,1233259847,16260,16264,1,,3,362.1,2202001,2202,22,220200100098,Big Guy Men's Air Tuned Max Shoes
40137,Selvi Drogos,US,Orion Club Gold members low activity,21,15-30 years,F,2,1233310037,16267,16269,2,,3,143.7,2102010,2102,21,210201000178,Infant Children's Shoes
47721,Alessandro Castelli,IT,Orion Club Gold members low activity,48,46-60 years,M,2,1233333845,16271,16275,1,,2,124.2,2202001,2202,22,220200100124,Big Guy Men's First Set-Tennis Shoes
42831,Roderick Makowski,GB,Orion Club Gold members low activity,28,15-30 years,M,2,1233428322,16285,16289,1,,2,73.4,2102010,2102,21,210201000183,Kola Children's Shoes
33342,Lisa Karamanian,US,Orion Club Gold members low activity,53,46-60 years,F,3,1233430346,16285,16288,1,,2,31.4,2401001,2401,24,240100100434,Shoeshine Black
28170,R.F. Flikkema,NL,Orion Club Gold members low activity,58,46-60 years,M,2,1233435278,16286,16288,1,,2,179.6,2202001,2202,22,220200100097,Big Guy  Men's Air Trainer Structure Plu Shoe
38783,Valerie Pontvieux,FR,Orion Club Gold members low activity,68,61-75 years,F,2,1233447133,16288,16291,1,,3,104.4,2102004,2102,21,210200400077,Tony's Children's Terra Sebec(Bg) Shoes
50953,Carlyton Hammermester,US,Orion Club Gold members low activity,68,61-75 years,M,2,1233476872,16292,16296,1,,2,151.4,2202001,2202,22,220200100050,Big Guy Men's Air Mantra Shoes
37065,Marie Bonnenfant,FR,Orion Club Gold members low activity,58,46-60 years,F,2,1233494399,16295,16297,1,,2,106.8,2102010,2102,21,210201000195,South Peak Children's Shoes C
44694,Massimo Leipold,IT,Orion Club Gold members low activity,73,61-75 years,M,2,1233495687,16295,16296,3,,2,181.4,2202003,2202,22,220200300158,Hardcore Shoes
49342,José Arozamena,ES,Orion Club Gold members low activity,33,31-45 years,M,3,1233508610,16297,16301,1,,2,73.4,2102010,2102,21,210201000183,Kola Children's Shoes
33854,Cluster Krempl,US,Orion Club Gold members low activity,58,46-60 years,M,2,1233584611,16308,16310,1,,3,405.6,2202001,2202,22,220200100108,Big Guy Men's Air Zoom Drive Shoes
34076,Hamp Sheffield,US,Orion Club Gold members low activity,28,15-30 years,M,2,1233584620,16308,16310,2,,2,168.4,2202003,2202,22,220200300014,Men's Running Shoes Ozweego
35398,Luis Rodríguez Castro,ES,Orion Club Gold members low activity,43,31-45 years,M,3,1233679325,16323,16324,1,,1,84.2,2202003,2202,22,220200300014,Men's Running Shoes Ozweego
43714,C.J. Havermans,NL,Orion Club Gold members low activity,21,15-30 years,M,3,1233735866,16331,16334,1,,2,112.6,2202001,2202,22,220200100034,Big Guy Men's Air Deschutz Shoes
53285,Suzanne Federowicz,US,Orion Club Gold members low activity,28,15-30 years,F,3,1233770165,16336,16340,1,,2,227.4,2202001,2202,22,220200100087,Big Guy Men's Air Terra Clay-Tennis Shoes
34583,Luigi Cicchinelli,IT,Orion Club Gold members low activity,48,46-60 years,M,2,1233806751,16342,16346,1,,2,171.6,2202003,2202,22,220200300076,Hi Response Women's Aerobic Shoes Large
44251,I.H. Tanghe,NL,Orion Club Gold members low activity,33,31-45 years,F,2,1233820996,16344,16347,1,,1,110.3,2202003,2202,22,220200300142,Vishnu Women's Running Shoes
48930,Marv Hasselmann,DE,Orion Club Gold members low activity,43,31-45 years,M,3,1233843064,16348,16352,1,,1,71,2202003,2202,22,220200300082,Indoor Handbold Special Shoes
54780,Kim Battaglia,US,Orion Club Gold members low activity,33,31-45 years,F,2,1233861993,16350,16354,1,,1,88.8,2202002,2202,22,220200200062,Top C-Tech 6000 Tennis Shoes
45021,Diane Vissac,FR,Orion Club Gold members low activity,33,31-45 years,F,3,1233885321,16354,16358,1,,1,33.4,2102004,2102,21,210200400012,Kid Trainer Lite V(Bp) Street Shoes
44251,I.H. Tanghe,NL,Orion Club Gold members low activity,33,31-45 years,F,2,1233892853,16355,16358,1,,1,128.4,2202002,2202,22,220200200079,Twain Women's Expresso X-Hiking Shoes
44781,Andreas Wipke,DE,Orion Club Gold members low activity,43,31-45 years,M,2,1233936351,16362,16363,1,,1,55.4,2202001,2202,22,220200100060,Big Guy Men's Air One Eighty  Shoes
38525,Silvia Warth,DE,Orion Club Gold members low activity,73,61-75 years,F,2,1234010039,16373,16378,2,,1,55,2202003,2202,22,220200300126,The Wish L Women's Running Shoes
38525,Silvia Warth,DE,Orion Club Gold members low activity,73,61-75 years,F,2,1234010039,16373,16378,1,,1,108.9,2202001,2202,22,220200100173,Woman's Air Athena Triax-Running Shoes
45526,Peter Stamm-Wilbrand,DE,Orion Club Gold members low activity,73,61-75 years,M,2,1234010184,16373,16377,1,,1,81.1,2202001,2202,22,220200100027,Big Guy Men's Air Aragon Shoes
35432,Aurelie Savioz,FR,Orion Club Gold members low activity,43,31-45 years,F,3,1234025068,16375,16379,2,,1,33.4,2102010,2102,21,210201000202,T&l Children's Shoes
29774,Sandra Sahuc,FR,Orion Club Gold members low activity,58,46-60 years,F,2,1234096170,16386,16390,1,,1,41.6,2102004,2102,21,210200400070,Tony's Children's Deschutz (Bg) Shoes
45387,Cynthia Schimeneck,US,Orion Club Gold members low activity,73,61-75 years,F,2,1234106711,16387,16391,1,,2,20.2,2102007,2102,21,210200700013,Slomo Balance Children's Shoes
39337,Rob Drabble,GB,Orion Club Gold members low activity,28,15-30 years,M,3,1234151325,16394,16395,1,,1,103.2,2201007,2201,22,220100700038,Power Dmx Wide Shoes
28227,Reid Rivera,US,Orion Club Gold members low activity,43,31-45 years,M,3,1234178796,16398,16404,1,,1,107.5,2202002,2202,22,220200200050,Soft Integral Men's Running Shoes
28073,Dietmar Korosek,FR,Orion Club Gold members low activity,43,31-45 years,M,2,1234182199,16399,16404,1,,2,21.4,2102007,2102,21,210200700020,Upright Shoe Balance Shoes
31012,Lesli Grate,US,Orion Club Gold members low activity,28,15-30 years,F,2,1234294736,16415,16420,2,,2,227.4,2202003,2202,22,220200300087,Mns Light 4 Low  Women's Volley Shoes
45868,C.M. Van de Riet,NL,Orion Club Gold members low activity,23,15-30 years,F,2,1234300955,16416,16421,1,,3,482.1,2202001,2202,22,220200100082,Big Guy Men's Air Tailwind Iv Shoes
30418,Chegcheng Pernicka,DE,Orion Club Gold members low activity,23,15-30 years,F,3,1234330238,16421,16422,1,,2,198,2202001,2202,22,220200100077,Big Guy Men's Air Span Triax Shoes
37339,Chris Plumpton,GB,Orion Club Gold members low activity,58,46-60 years,M,3,1234332871,16421,16423,1,,2,366.4,2201007,2201,22,220100700002,Dmx 10 Women's Aerobic Shoes
27929,Thomas Fehrentz,DE,Orion Club Gold members low activity,53,46-60 years,M,3,1234337217,16422,16423,1,,2,177.6,2202002,2202,22,220200200062,Top C-Tech 6000 Tennis Shoes
43638,Dean Schaffner,US,Orion Club Gold members low activity,53,46-60 years,M,3,1234350093,16423,16424,1,,2,222.6,2202001,2202,22,220200100145,Big Guy Men's Structure Triax Shoes
46319,Lawrence Tirone,GB,Orion Club Gold members low activity,73,61-75 years,M,2,1234359230,16425,16426,2,,4,456.4,2201007,2201,22,220100700003,Dmx 6 Shoes
34327,Alexia Vanepps,US,Orion Club Gold members low activity,28,15-30 years,F,3,1234368112,16426,16432,1,,2,122,2202001,2202,22,220200100101,Big Guy Men's Air Turbulence Shoes
34327,Alexia Vanepps,US,Orion Club Gold members low activity,28,15-30 years,F,3,1234368112,16426,16432,2,,2,197.4,2202003,2202,22,220200300072,Hgf Tarantula Men's Indoor Shoes
30867,Alexander Mescher,DE,Orion Club Gold members low activity,38,31-45 years,M,3,1234384165,16429,16432,1,,4,355.2,2202002,2202,22,220200200062,Top C-Tech 6000 Tennis Shoes
31079,Tommaso Tonato,IT,Orion Club Gold members low activity,58,46-60 years,M,3,1234481061,16442,16444,1,,1,66.5,2202001,2202,22,220200100063,Big Guy Men's Air Perish Nb Shoes
36667,Vivian Mcclenningham,US,Orion Club Gold members low activity,43,31-45 years,F,3,1234484605,16442,16443,1,,1,57.3,2202001,2202,22,220200100139,Big Guy Men's Payoff Trainer Shoes
29597,Helge Luettig,DE,Orion Club Gold members low activity,38,31-45 years,M,3,1234538967,16448,16452,2,,1,131,2202002,2202,22,220200200077,Twain Women's Exit Iii Mid Cd X-Hiking Shoes
29597,Helge Luettig,DE,Orion Club Gold members low activity,38,31-45 years,M,3,1234538967,16448,16452,1,,1,54.4,2202001,2202,22,220200100134,Big Guy Men's Maniacal Shoes
51912,Dieter Eue,DE,Orion Club Gold members low activity,58,46-60 years,M,3,1234549592,16449,16453,2,,2,162.4,2202003,2202,22,220200300129,Torino Men's Leather Adventure Shoes
37558,Luano Mannelli,IT,Orion Club Gold members low activity,73,61-75 years,M,2,1234553067,16449,16451,1,,1,32.8,2202001,2202,22,220200100123,Big Guy Men's Deschutz Slide Shoes
45818,Michael Buchanan,US,Orion Club Gold members low activity,73,61-75 years,M,2,1234556366,16449,16451,2,,1,85.8,2202003,2202,22,220200300012,Men's Mountain Shoes
43442,Nicole Urzua,US,Orion Club Gold members low activity,73,61-75 years,F,2,1234567837,16450,16451,1,,1,16.1,2401001,2401,24,240100100434,Shoeshine Black
34583,Luigi Cicchinelli,IT,Orion Club Gold members low activity,48,46-60 years,M,2,1234592817,16453,16455,1,,1,83,2202003,2202,22,220200300025,Mid Women's Aerobic Shoes X
44766,Brigitte Cauchard,FR,Orion Club Gold members low activity,28,15-30 years,F,2,1234643458,16458,16462,1,,1,40.7,2102004,2102,21,210200400032,Toddle Children's Align(Bp) Shoes
53964,Laurence J Fray,GB,Orion Club Gold members low activity,43,31-45 years,F,2,1234716351,16465,16470,1,,1,129.8,2201007,2201,22,220100700028,H Ignitor Women's Aerobic Shoes
32284,Ana Isabel Díez Martínez de Morentín,ES,Orion Club Gold members low activity,58,46-60 years,F,2,1234750724,16469,16471,2,,1,38.6,2102006,2102,21,210200600015,Hardcore Kids Street Shoes
34332,Denzil Mcarn,US,Orion Club Gold members low activity,28,15-30 years,M,2,1234932529,16486,16488,1,,1,37.2,2202002,2202,22,220200200043,Soft Gel Court Men's Indoor Shoes
51612,Teresa Torres Benítez,ES,Orion Club Gold members low activity,21,15-30 years,F,2,1234984954,16492,16493,2,,1,71.7,2202003,2202,22,220200300124,The Jet Men's Running Shoes
51612,Teresa Torres Benítez,ES,Orion Club Gold members low activity,21,15-30 years,F,2,1234984954,16492,16493,1,,1,64.9,2202001,2202,22,220200100005,4men Men's Air Golden Shoes
41766,Rolf Warweg,DE,Orion Club Gold members low activity,38,31-45 years,M,3,1235013298,16495,16500,1,,1,92.6,2202002,2202,22,220200200066,Twain Inco Men's Street Shoes
43589,Mercedes Fesi,IT,Orion Club Gold members low activity,73,61-75 years,F,2,1235099457,16502,16504,1,,1,66.4,2202002,2202,22,220200200018,Lulu Men's Street Shoes
32678,Stephanie Ernst,DE,Orion Club Gold members low activity,43,31-45 years,F,2,1235116111,16504,16506,1,,1,120.7,2202001,2202,22,220200100098,Big Guy Men's Air Tuned Max Shoes
42854,Artemio Orlandini,IT,Orion Club Gold members low activity,63,61-75 years,F,2,1235120249,16504,16507,1,,1,97.3,2202002,2202,22,220200200032,Soft 140 Men's Running Shoes
50804,Carlota García Agulla,ES,Orion Club Gold members low activity,28,15-30 years,F,3,1235168258,16509,16512,1,,1,177.8,2202001,2202,22,220200100010,Atmosphere Mickey Shoes
47454,Felipe Schneider,ES,Orion Club Gold members low activity,28,15-30 years,M,2,1235178747,16510,16514,1,,1,98.7,2202003,2202,22,220200300072,Hgf Tarantula Men's Indoor Shoes
35590,Michael Stoy,US,Orion Club Gold members low activity,58,46-60 years,M,2,1235196287,16511,16512,1,,1,141.2,2202001,2202,22,220200100113,Big Guy Men's Air Zoom Pivot Mid Ii Shoes
33554,I.F. Gale,NL,Orion Club Gold members low activity,21,15-30 years,F,3,1235215830,16513,16518,1,,1,58.7,2202001,2202,22,220200100012,Atmosphere Shatter Mid Shoes
43033,Lothar Ziener,DE,Orion Club Gold members low activity,23,15-30 years,M,2,1235238463,16516,16519,1,,1,98.8,2202002,2202,22,220200200027,Salida Low Men's Outdoor Shoes
45663,Jürgen Vomhoff,DE,Orion Club Gold members low activity,48,46-60 years,M,2,1235238509,16516,16519,1,,1,135.8,2202002,2202,22,220200200047,Soft Gt 2050 Women's Running Shoes
40379,J.T. Dashorst,NL,Orion Club Gold members low activity,73,61-75 years,F,2,1235243610,16516,16521,1,,3,326.7,2202001,2202,22,220200100173,Woman's Air Athena Triax-Running Shoes
40645,Víctor Solanell Catalán,ES,Orion Club Gold members low activity,48,46-60 years,M,3,1235260151,16518,16523,1,,2,207.6,2202003,2202,22,220200300071,Hgf  Low Women's Indoor Shoes
44589,Antje Panitz,DE,Orion Club Gold members low activity,68,61-75 years,F,2,1235378475,16530,16535,1,,1,89.5,2202001,2202,22,220200100132,Big Guy Men's Klickitat Mid Shoes
31035,Petra Stuhldreier,DE,Orion Club Gold members low activity,53,46-60 years,F,2,1235389390,16531,16533,1,,3,473.4,2202001,2202,22,220200100099,Big Guy Men's Air Tuned Sirocco Shoes
36280,Jesús Llorca García,ES,Orion Club Gold members low activity,43,31-45 years,M,2,1235411368,16533,16538,1,,1,72.3,2201007,2201,22,220100700001,Classic Men's Leisure Shoes
39533,Catherine Hindson,GB,Orion Club Gold members low activity,38,31-45 years,M,3,1235413930,16533,16537,1,,1,55.8,2201007,2201,22,220100700022,Alexis Women's Classic Shoes
37798,Joel Fessenden,US,Orion Club Gold members low activity,43,31-45 years,M,2,1235418509,16533,16537,2,,1,107,2202002,2202,22,220200200068,Twain Men's Exentric Ii X-Hiking Shoes
33788,Michael E Harrison,GB,Orion Club Gold members low activity,58,46-60 years,M,3,1235463192,16538,16544,1,,1,55.8,2201007,2201,22,220100700022,Alexis Women's Classic Shoes
42499,Sabine Decates,NL,Orion Club Gold members low activity,73,61-75 years,F,2,1235498786,16541,16543,1,,1,98.8,2202002,2202,22,220200200027,Salida Low Men's Outdoor Shoes
52653,Malisa Cauldwell,US,Orion Club Gold members low activity,23,15-30 years,F,3,1235502076,16541,16547,2,,1,10.1,2102007,2102,21,210200700013,Slomo Balance Children's Shoes
54839,Hans-Christoph Rey,DE,Orion Club Gold members low activity,23,15-30 years,M,2,1235532348,16545,16549,2,,3,220.2,2202003,2202,22,220200300157,Hardcore Men's Street Shoes Large
33740,Horst Wehinger,DE,Orion Club Gold members low activity,53,46-60 years,M,2,1235553047,16547,16551,1,,1,174.1,2202001,2202,22,220200100041,Big Guy Men's Air Flight Determination Shoes
50991,Tina Van Heusden,NL,Orion Club Gold members low activity,23,15-30 years,F,2,1235558504,16547,16551,1,,1,106.5,2202001,2202,22,220200100084,Big Guy Men's Air Tailwind Shoes
47277,Marc Cunat,FR,Orion Club Gold members low activity,21,15-30 years,M,3,1235575290,16549,16551,1,,1,38.6,2102006,2102,21,210200600015,Hardcore Kids Street Shoes
40938,Leo Johnson,US,Orion Club Gold members low activity,23,15-30 years,M,2,1235589306,16550,16553,1,,3,241.2,2202003,2202,22,220200300060,Cross Ripple Women's Street Shoes
27723,Jürgen F. Trick,DE,Orion Club Gold members low activity,53,46-60 years,M,3,1235663127,16558,16563,1,,1,100.4,2202001,2202,22,220200100072,Big Guy Men's Air Skylon Triax Shoes
27643,Francisco Pizá Mut,ES,Orion Club Gold members low activity,73,61-75 years,M,2,1235694360,16561,16562,1,,1,98.9,2201004,2201,22,220100400022,Ultra M803 Ng Men's Street Shoes
31083,Mike Kellagher,GB,Orion Club Gold members low activity,48,46-60 years,M,3,1235768856,16568,16574,2,,1,86.3,2201007,2201,22,220100700017,Trainer Women's Aerobic Shoes
42534,R.H.M.M. Andersen,NL,Orion Club Gold members low activity,38,31-45 years,M,3,1235782519,16569,16575,1,,1,196.5,2202001,2202,22,220200100052,Big Guy Men's Air Mickey 95 Running Shoes
47796,Stephen Chance,GB,Orion Club Gold members low activity,48,46-60 years,M,2,1235797548,16571,16576,1,,1,59.5,2201007,2201,22,220100700027,Duration Women's Trainer Aerobic Shoes
33302,Moritz Büttinghaus,DE,Orion Club Gold members low activity,43,31-45 years,M,3,1235876387,16579,16584,1,,4,429.6,2202003,2202,22,220200300061,Damaskus Men's Running Shoes
38355,Simon Doris,GB,Orion Club Gold members low activity,63,61-75 years,M,2,1235963067,16587,16590,2,,3,167.4,2201007,2201,22,220100700022,Alexis Women's Classic Shoes
41236,Inderjit Ellott,GB,Orion Club Gold members low activity,53,46-60 years,M,2,1235994940,16590,16593,2,,2,210.4,2201007,2201,22,220100700038,Power Dmx Wide Shoes
42499,Sabine Decates,NL,Orion Club Gold members low activity,73,61-75 years,F,2,1236043982,16595,16597,2,,2,315.6,2202001,2202,22,220200100099,Big Guy Men's Air Tuned Sirocco Shoes
45107,Teresa Guinovart,ES,Orion Club Gold members low activity,28,15-30 years,F,2,1236062059,16597,16599,2,,3,167.4,2201007,2201,22,220100700022,Alexis Women's Classic Shoes
30111,Itta Lutz,DE,Orion Club Gold members low activity,48,46-60 years,F,2,1236147577,16606,16608,1,,3,319.5,2202001,2202,22,220200100084,Big Guy Men's Air Tailwind Shoes
29020,Enrico Fassio,IT,Orion Club Gold members low activity,53,46-60 years,M,3,1236161728,16607,16610,2,,2,230,2202003,2202,22,220200300015,Men's Running Shoes Piedmmont
35783,Raquel Márquez Guerrero,ES,Orion Club Gold members low activity,48,46-60 years,F,2,1236189147,16610,16612,2,,2,129.8,2202003,2202,22,220200300079,Hilly Women's Crosstrainer Shoes
49770,Nicolas Instone,GB,Orion Club Gold members low activity,21,15-30 years,M,3,1236192131,16610,16616,2,,2,153.8,2201004,2201,22,220100400012,Bill V-3-London Calling Shoes
27732,Thornie Aman,US,Orion Club Gold members low activity,58,46-60 years,M,3,1236245350,16615,16621,2,,3,330.9,2202003,2202,22,220200300142,Vishnu Women's Running Shoes
32648,Reve Michaels,US,Orion Club Gold members low activity,58,46-60 years,F,3,1236267384,16617,16618,2,,2,271.6,2202002,2202,22,220200200047,Soft Gt 2050 Women's Running Shoes
32648,Reve Michaels,US,Orion Club Gold members low activity,58,46-60 years,F,3,1236267384,16617,16618,1,,2,113.8,2202001,2202,22,220200100128,Big Guy Men's Hermosa Shoes
50418,Faith Ingram,US,Orion Club Gold members low activity,38,31-45 years,F,2,1236268310,16617,16622,2,,2,162.4,2202003,2202,22,220200300129,Torino Men's Leather Adventure Shoes
50418,Faith Ingram,US,Orion Club Gold members low activity,38,31-45 years,F,2,1236268310,16617,16622,1,,2,209.4,2202003,2202,22,220200300062,Damaskus Women's Running Shoes
41913,Antoine Caudron,FR,Orion Club Gold members low activity,23,15-30 years,M,3,1236301184,16621,16626,2,,2,37.4,2401001,2401,24,240100100229,Cruise First Star Baby Shoes
44697,Connor Biard,US,Orion Club Gold members low activity,53,46-60 years,M,2,1236317159,16622,16623,1,,2,226,2202002,2202,22,220200200045,Soft Gt 2040 Women's Running Shoes
33829,M.A.Th. Hellendoorn,NL,Orion Club Gold members low activity,58,46-60 years,M,3,1236336229,16624,16629,2,,2,161.6,2202003,2202,22,220200300073,Hi Resolution Men's Tennis Shoes
54155,J.l. Vernant,FR,Orion Club Gold members low activity,38,31-45 years,M,2,1236384283,16629,16634,2,,5,193,2102006,2102,21,210200600015,Hardcore Kids Street Shoes
51158,J.F.J. Rubingh,NL,Orion Club Gold members low activity,63,61-75 years,M,2,1236387280,16629,16639,1,,2,102.6,2202003,2202,22,220200300127,The Wish M Men's Running Shoes
31437,Eleonore Wierth,DE,Orion Club Gold members low activity,53,46-60 years,F,2,1236402229,16631,16635,1,,3,100.2,2202001,2202,22,220200100126,Big Guy Men's Gts Canvas Plus Shoes
33099,Christina Vauvillier,FR,Orion Club Gold members low activity,21,15-30 years,F,3,1236475028,16638,16641,2,,3,101.4,2102010,2102,21,210201000167,Children's Shoes Stratosphere
35063,Gabi Disser,DE,Orion Club Gold members low activity,38,31-45 years,M,3,1236484354,16639,16644,2,,6,449.4,2202003,2202,22,220200300155,Hardcore Men's Street Shoes
35063,Gabi Disser,DE,Orion Club Gold members low activity,38,31-45 years,M,3,1236484354,16639,16644,1,,2,146.4,2202001,2202,22,220200100096,Big Guy Men's Air Tiempo Pro Ic Shoes
34583,Luigi Cicchinelli,IT,Orion Club Gold members low activity,48,46-60 years,M,2,1236489296,16639,16641,3,,2,146.8,2202003,2202,22,220200300157,Hardcore Men's Street Shoes Large
34583,Luigi Cicchinelli,IT,Orion Club Gold members low activity,48,46-60 years,M,2,1236489296,16639,16641,2,,2,209.4,2202003,2202,22,220200300062,Damaskus Women's Running Shoes
34583,Luigi Cicchinelli,IT,Orion Club Gold members low activity,48,46-60 years,M,2,1236489296,16639,16641,1,,2,189.4,2202003,2202,22,220200300036,Women's Crosstraining Shoes
47012,Ascensión Redondo Casanova,ES,Orion Club Gold members low activity,48,46-60 years,F,2,1236503332,16641,16644,1,,3,297,2202001,2202,22,220200100077,Big Guy Men's Air Span Triax Shoes
52212,Rafael Rodríguez Lombardero,ES,Orion Club Gold members low activity,68,61-75 years,M,2,1236555747,16646,16650,1,,2,116.2,2202001,2202,22,220200100008,Atmosphere Deschutz Shoes
28972,Vontena Westley,US,Orion Club Gold members low activity,43,31-45 years,F,3,1236589316,16649,16655,1,,2,361.4,2202001,2202,22,220200100116,Big Guy Men's Air Zoom Total 90 F.G Shoes
51008,Jennett Van Wittekind,US,Orion Club Gold members low activity,73,61-75 years,F,2,1236590337,16649,16652,1,,2,20.2,2102007,2102,21,210200700013,Slomo Balance Children's Shoes
37558,Luano Mannelli,IT,Orion Club Gold members low activity,73,61-75 years,M,2,1236596236,16650,16652,1,,2,218.6,2201007,2201,22,220100700009,Mc Shoes
47851,J.C. Scheick,NL,Orion Club Gold members low activity,68,61-75 years,M,2,1236597466,16650,16655,2,,2,118,2202002,2202,22,220200200009,Cruise 1984 Men's Street Shoes
47851,J.C. Scheick,NL,Orion Club Gold members low activity,68,61-75 years,M,2,1236597466,16650,16655,1,,2,200.8,2202001,2202,22,220200100093,Big Guy Men's Air Terra Train Shoes
33829,M.A.Th. Hellendoorn,NL,Orion Club Gold members low activity,58,46-60 years,M,3,1236607114,16651,16656,1,,3,287.1,2202003,2202,22,220200300159,Hispeed Shoes
44791,A.J. Voskuijl,NL,Orion Club Gold members low activity,23,15-30 years,M,3,1236618349,16652,16657,1,,2,200.4,2202003,2202,22,220200300070,Hgf Low Men's Indoor Shoes
48086,Mary Pressly,US,Orion Club Gold members low activity,23,15-30 years,F,3,1236704318,16660,16666,2,,2,230,2202003,2202,22,220200300015,Men's Running Shoes Piedmmont
48086,Mary Pressly,US,Orion Club Gold members low activity,23,15-30 years,F,3,1236704318,16660,16666,1,,2,191,2202002,2202,22,220200200039,Soft Cumulus Men's Running Shoes
46139,Paula Turner,US,Orion Club Gold members low activity,43,31-45 years,F,3,1236731497,16663,16665,3,0.3,3,215.97,2202003,2202,22,220200300117,South Peak Women's Light Indoor Shoes
46139,Paula Turner,US,Orion Club Gold members low activity,43,31-45 years,F,3,1236731497,16663,16665,2,,3,201,2202001,2202,22,220200100026,Big Guy Men's Air Align Shoes
46139,Paula Turner,US,Orion Club Gold members low activity,43,31-45 years,F,3,1236731497,16663,16665,1,,2,355.6,2202001,2202,22,220200100010,Atmosphere Mickey Shoes
32678,Stephanie Ernst,DE,Orion Club Gold members low activity,43,31-45 years,F,2,1236766284,16667,16669,1,,3,257.4,2202003,2202,22,220200300076,Hi Response Women's Aerobic Shoes Large
46280,Lalitya Bay,US,Orion Club Gold members low activity,21,15-30 years,M,2,1236812454,16671,16674,1,,2,121.2,2202002,2202,22,220200200024,Pro Fit Gel Gt 2030 Women's Running Shoes
50340,Aline Laly,FR,Orion Club Gold members low activity,23,15-30 years,F,3,1236876142,16678,16684,2,,2,82.2,2102010,2102,21,210201000182,Kola Cf Velcro Children's Shoes
27952,Jan Reinhart,DE,Orion Club Gold members low activity,43,31-45 years,M,3,1237027871,16693,16699,1,,1,136.6,2202003,2202,22,220200300102,Mns.xzs Women's Aerobic Shoes
40360,Fritz R. Rohenester,DE,Orion Club Gold members low activity,68,61-75 years,M,2,1237050199,16695,16700,1,,2,198,2202001,2202,22,220200100077,Big Guy Men's Air Span Triax Shoes
39220,J.l. Okkerse,NL,Orion Club Gold members low activity,58,46-60 years,F,3,1237114124,16701,16704,1,,1,72.7,2202001,2202,22,220200100070,Big Guy Men's Air Reckoning Ii-Tennis Shoes
51158,J.F.J. Rubingh,NL,Orion Club Gold members low activity,63,61-75 years,M,2,1237245891,16714,16719,2,,1,107,2202002,2202,22,220200200068,Twain Men's Exentric Ii X-Hiking Shoes
48422,Curtis Matthews,US,Orion Club Gold members low activity,19,15-30 years,M,3,1237248879,16714,16720,2,,1,66.4,2202002,2202,22,220200200018,Lulu Men's Street Shoes
42534,R.H.M.M. Andersen,NL,Orion Club Gold members low activity,38,31-45 years,M,3,1237286638,16718,16724,1,,1,66.4,2202002,2202,22,220200200018,Lulu Men's Street Shoes
43033,Lothar Ziener,DE,Orion Club Gold members low activity,23,15-30 years,M,2,1237333188,16723,16726,1,,2,271.6,2202002,2202,22,220200200047,Soft Gt 2050 Women's Running Shoes
54238,Terrell Hollifield,US,Orion Club Gold members low activity,48,46-60 years,M,3,1237449360,16734,16736,1,,1,148.6,2202003,2202,22,220200300094,Mns.fastpace Women's Running Shoes
37591,Jörg Wilms,DE,Orion Club Gold members low activity,38,31-45 years,M,2,1237461977,16736,16738,1,,1,91.8,2202001,2202,22,220200100062,Big Guy Men's Air Outland Shoes
30648,David Raminella,GB,Orion Club Gold members low activity,38,31-45 years,M,2,1237597122,16749,16751,1,,1,132.3,2201007,2201,22,220100700028,H Ignitor Women's Aerobic Shoes
39422,Samhee Bimont,FR,Orion Club Gold members low activity,38,31-45 years,F,2,1237785733,16768,16773,2,,1,3,2401001,2401,24,240100100431,Shoelace Black 150 Cm
39422,Samhee Bimont,FR,Orion Club Gold members low activity,38,31-45 years,F,2,1237785733,16768,16773,1,,1,18.7,2401001,2401,24,240100100229,Cruise First Star Baby Shoes
52434,Dominique Brearly-Smith,FR,Orion Club Gold members low activity,58,46-60 years,F,2,1237856239,16775,16779,1,,4,164.8,2102004,2102,21,210200400018,Kiddy.summit  90 F.G.Rbr (Bg) Children's Shoe
43906,Davinder Hostler,GB,Orion Club Gold members low activity,23,15-30 years,M,2,1237867478,16776,16777,1,,4,420.8,2201007,2201,22,220100700038,Power Dmx Wide Shoes
49293,Stephanie Stamer,US,Orion Club Gold members low activity,33,31-45 years,F,3,1238061713,16795,16799,1,,2,200.4,2202003,2202,22,220200300070,Hgf Low Men's Indoor Shoes
32180,Susan Koger,US,Orion Club Gold members low activity,48,46-60 years,F,2,1238101970,16799,16801,1,,2,169.8,2202003,2202,22,220200300115,South Peak Men's Light Low Indoor Shoes
33003,Carlos Gómez Olmos,ES,Orion Club Gold members low activity,58,46-60 years,M,2,1238164334,16807,16811,1,,2,124.2,2202001,2202,22,220200100124,Big Guy Men's First Set-Tennis Shoes
31682,Ramona Gaßner,DE,Orion Club Gold members low activity,58,46-60 years,F,3,1238210586,16813,16818,1,,1,47.9,2202002,2202,22,220200200031,Soft 1040 Women's Running Shoes
53638,Frank Heitlinger,DE,Orion Club Gold members low activity,21,15-30 years,M,2,1238219993,16814,16817,3,,1,61,2202003,2202,22,220200300081,Hilo Mid Women's Aerobic Shoes
53638,Frank Heitlinger,DE,Orion Club Gold members low activity,21,15-30 years,M,2,1238219993,16814,16817,1,,1,89.8,2202001,2202,22,220200100097,Big Guy  Men's Air Trainer Structure Plu Shoe
30916,Irene Whisnant,US,Orion Club Gold members low activity,43,31-45 years,F,2,1238263947,16819,16824,1,,2,202,2202003,2202,22,220200300016,Men's Running Shoes Supernova
52934,Robin Riemer,US,Orion Club Gold members low activity,19,15-30 years,F,2,1238264545,16819,16820,1,,1,111.3,2202001,2202,22,220200100145,Big Guy Men's Structure Triax Shoes
30745,Laurent Robinet,FR,Orion Club Gold members low activity,58,46-60 years,M,2,1238291536,16823,16828,1,,1,47.9,2102010,2102,21,210201000178,Infant Children's Shoes
51289,Sudhir Garlow,US,Orion Club Gold members low activity,43,31-45 years,M,3,1238296259,16823,16824,1,,1,66.4,2202002,2202,22,220200200018,Lulu Men's Street Shoes
38355,Simon Doris,GB,Orion Club Gold members low activity,63,61-75 years,M,2,1238365095,16832,16836,1,,1,152.9,2201007,2201,22,220100700046,Tcp 6 Men's Running Shoes
29637,Rainer Askitas,DE,Orion Club Gold members low activity,58,46-60 years,M,2,1238379055,16834,16839,1,,1,86.9,2202001,2202,22,220200100100,Big Guy Men's Air Turbino F.G. Shoes
32716,Jorge Mario Semb,DE,Orion Club Gold members low activity,53,46-60 years,M,2,1238609505,16863,16865,1,,2,358.6,2202002,2202,22,220200200080,Ultra M1210 Men's Running Shoes
52066,Caroline White,GB,Orion Club Gold members low activity,53,46-60 years,F,2,1238613472,16863,16865,1,,1,74.4,2201007,2201,22,220100700001,Classic Men's Leisure Shoes
52405,Liz Estorff,DE,Orion Club Gold members low activity,68,61-75 years,F,2,1238632557,16866,16871,1,,1,90,2202002,2202,22,220200200014,Dubby Low Men's Street Shoes
54631,Erling Frankoff,US,Orion Club Gold members low activity,21,15-30 years,M,3,1238696119,16873,16879,1,,1,44.1,2102006,2102,21,210200600032,Atx 7500 Ch Children's Shoes
34496,Chandru Ferrari,US,Orion Club Gold members low activity,48,46-60 years,M,2,1238711124,16875,16880,1,,1,104.5,2202002,2202,22,220200200034,Soft Alta Plus Men's Indoor Shoes
29910,C.H. Gerritsen,NL,Orion Club Gold members low activity,73,61-75 years,M,2,1238758326,16881,16883,1,,1,58.6,2202003,2202,22,220200300051,Armadillo Men's Running Shoes
27732,Thornie Aman,US,Orion Club Gold members low activity,58,46-60 years,M,3,1238767963,16882,16888,1,,2,315.6,2202001,2202,22,220200100099,Big Guy Men's Air Tuned Sirocco Shoes
45207,Mariangela Montrasio,IT,Orion Club Gold members low activity,58,46-60 years,F,3,1238796097,16886,16891,1,,2,112.6,2202001,2202,22,220200100034,Big Guy Men's Air Deschutz Shoes
44301,Karen Mellish,US,Orion Club Gold members low activity,19,15-30 years,F,3,1238806962,16887,16888,2,,2,216,2202002,2202,22,220200200068,Twain Men's Exentric Ii X-Hiking Shoes
44301,Karen Mellish,US,Orion Club Gold members low activity,19,15-30 years,F,3,1238806962,16887,16888,1,,1,95.5,2202002,2202,22,220200200039,Soft Cumulus Men's Running Shoes
54570,Nikolaos Biagi,DE,Orion Club Gold members low activity,68,61-75 years,M,2,1238849543,16893,16897,3,,1,118.7,2202002,2202,22,220200200078,Twain Women's Exit Low 2000 Street Shoes
54570,Nikolaos Biagi,DE,Orion Club Gold members low activity,68,61-75 years,M,2,1238849543,16893,16897,1,,1,72.7,2202001,2202,22,220200100070,Big Guy Men's Air Reckoning Ii-Tennis Shoes
33740,Horst Wehinger,DE,Orion Club Gold members low activity,53,46-60 years,M,2,1238857397,16894,16898,1,,1,131.7,2202003,2202,22,220200300101,Mns.winner Men's Running Shoes
34577,Clive Napp,GB,Orion Club Gold members low activity,53,46-60 years,M,3,1238868429,16895,16899,2,,1,56.9,2201007,2201,22,220100700022,Alexis Women's Classic Shoes
29494,J.C.J.A. Meert,NL,Orion Club Gold members low activity,33,31-45 years,M,3,1238886934,16897,16898,1,,1,103.8,2202003,2202,22,220200300071,Hgf  Low Women's Indoor Shoes
31843,Kinteh Mergel,US,Orion Club Gold members low activity,33,31-45 years,M,3,1238888611,16897,16900,1,,1,115.3,2202002,2202,22,220200200081,Ultra M878 Men's Running Shoes
50051,Nick Vitty,GB,Orion Club Gold members low activity,23,15-30 years,M,2,1238908404,16900,16903,1,,1,59.5,2201007,2201,22,220100700027,Duration Women's Trainer Aerobic Shoes
43552,Gian Sibrack,US,Orion Club Gold members low activity,21,15-30 years,M,3,1238911168,16900,16903,1,,1,110.8,2202001,2202,22,220200100078,Big Guy Men's Air Stormy Skylon Shoes
48219,Michael Watermann,DE,Orion Club Gold members low activity,21,15-30 years,M,2,1238937998,16904,16907,2,,1,71,2202003,2202,22,220200300082,Indoor Handbold Special Shoes
44445,Harold Bezdin,GB,Orion Club Gold members low activity,58,46-60 years,M,3,1238941424,16904,16907,1,,1,24.9,2102010,2102,21,210201000169,Children's Street Shoes
47750,M.E. Nije Banning,NL,Orion Club Gold members low activity,38,31-45 years,F,3,1238991479,16910,16911,2,,4,332,2202003,2202,22,220200300107,Polly Millennium Men's Tennis Shoes
47750,M.E. Nije Banning,NL,Orion Club Gold members low activity,38,31-45 years,F,3,1238991479,16910,16911,1,,1,90,2202002,2202,22,220200200014,Dubby Low Men's Street Shoes
39220,J.l. Okkerse,NL,Orion Club Gold members low activity,58,46-60 years,F,3,1239000188,16911,16912,1,,1,33.4,2202001,2202,22,220200100126,Big Guy Men's Gts Canvas Plus Shoes
54988,Susanna Crescitelli,IT,Orion Club Gold members low activity,58,46-60 years,F,2,1239086431,16922,16927,1,,1,33.4,2202001,2202,22,220200100126,Big Guy Men's Gts Canvas Plus Shoes
35319,Bertram Gerhardinger,DE,Orion Club Gold members low activity,68,61-75 years,M,2,1239131323,16928,16931,3,,1,81.2,2202003,2202,22,220200300129,Torino Men's Leather Adventure Shoes
37809,Maciej Schmidt,DE,Orion Club Gold members low activity,21,15-30 years,F,3,1239174101,16933,16936,1,,1,95.5,2202002,2202,22,220200200039,Soft Cumulus Men's Running Shoes
36932,Monique Mottier,FR,Orion Club Gold members low activity,33,31-45 years,F,2,1239232032,16940,16944,1,,3,13.8,2401001,2401,24,240100100429,"Shoelace 140 Cm, Assorted Colours"
39560,Lora Orji,US,Orion Club Gold members low activity,43,31-45 years,F,3,1239236698,16940,16945,2,,1,95.5,2202002,2202,22,220200200039,Soft Cumulus Men's Running Shoes
39560,Lora Orji,US,Orion Club Gold members low activity,43,31-45 years,F,3,1239236698,16940,16945,1,,1,33.4,2202001,2202,22,220200100126,Big Guy Men's Gts Canvas Plus Shoes
54846,Rashanda Levison,US,Orion Club Gold members low activity,33,31-45 years,F,2,1239292855,16947,16949,1,,1,105.4,2202001,2202,22,220200100142,Big Guy Men's Span Triax Shoes
52066,Caroline White,GB,Orion Club Gold members low activity,53,46-60 years,F,2,1239311211,16950,16952,1,,3,279,2201007,2201,22,220100700023,Armadillo Road Dmx Men's Running Shoes
37141,Serge Gray,GB,Orion Club Gold members low activity,28,15-30 years,M,2,1239375009,16958,16963,1,,2,264.6,2201007,2201,22,220100700028,H Ignitor Women's Aerobic Shoes
54906,Anne Marie Brunschot,NL,Orion Club Gold members low activity,23,15-30 years,F,2,1239457376,16968,16972,1,,2,177.2,2202001,2202,22,220200100090,Big Guy Men's Air Terra Reach Shoes
43160,Juan Carlos Serrano Sánchez,ES,Orion Club Gold members low activity,19,15-30 years,M,3,1239475904,16971,16975,1,,2,79,2102004,2102,21,210200400072,Tony's Children's Golden (Bp) Shoes
52511,Richard Teale,GB,Orion Club Gold members low activity,21,15-30 years,M,3,1239478037,16971,16976,2,,2,264.6,2201007,2201,22,220100700028,H Ignitor Women's Aerobic Shoes
36184,Richard Mcinnis,US,Orion Club Gold members low activity,38,31-45 years,M,3,1239505786,16974,16979,1,,2,66.8,2102004,2102,21,210200400012,Kid Trainer Lite V(Bp) Street Shoes
45168,E.A.C. Godijn,NL,Orion Club Gold members low activity,58,46-60 years,M,3,1239519280,16976,16977,2,,2,172.4,2202002,2202,22,220200200011,Cruise Platypus Men's Street Shoes
45168,E.A.C. Godijn,NL,Orion Club Gold members low activity,58,46-60 years,M,3,1239519280,16976,16977,1,,2,118.2,2202001,2202,22,220200100042,Big Guy Men's Air Flyer Plus Shoes
37790,Roland Comis,US,Orion Club Gold members low activity,21,15-30 years,M,3,1239528171,16977,16982,3,,2,67,2102010,2102,21,210201000179,K Street Shoes
52343,Amanda Ritchie,GB,Orion Club Gold members low activity,53,46-60 years,F,2,1239549068,16980,16985,1,,3,179.4,2201007,2201,22,220100700010,Men's Running Shoes Burn
32402,Fernando Pérez,ES,Orion Club Gold members low activity,48,46-60 years,M,3,1239572044,16983,16986,2,,3,211.5,2202003,2202,22,220200300100,Mns.super Women's Shoes
32402,Fernando Pérez,ES,Orion Club Gold members low activity,48,46-60 years,M,3,1239572044,16983,16986,1,,2,96.4,2202001,2202,22,220200100153,Big Guy Men's Understudy Cross Train. Shoes
32165,Hedwig-Ute Foitzik,DE,Orion Club Gold members low activity,48,46-60 years,F,2,1239577663,16984,16988,1,,3,100.2,2202001,2202,22,220200100126,Big Guy Men's Gts Canvas Plus Shoes
36979,Mariarosaria Cossetto,IT,Orion Club Gold members low activity,68,61-75 years,F,2,1239589056,16985,16989,1,,3,361.2,2201007,2201,22,220100700052,Trooper Ii Dmx-2x Men's Walking Shoes
53491,P.A. Van Den Heuvel,NL,Orion Club Gold members low activity,63,61-75 years,M,2,1239598028,16986,16991,2,,2,168.2,2202003,2202,22,220200300153,Hardcore Junior/Women's Street Shoes Small
33131,Cettina Vannucchi,IT,Orion Club Gold members low activity,63,61-75 years,F,2,1239605252,16987,16990,2,,3,201.3,2202003,2202,22,220200300052,Armadillo Women's Running Shoes
33131,Cettina Vannucchi,IT,Orion Club Gold members low activity,63,61-75 years,F,2,1239605252,16987,16990,1,,2,133.6,2202002,2202,22,220200200010,Cruise Men's Road Chunk Street Shoes
36280,Jesús Llorca García,ES,Orion Club Gold members low activity,43,31-45 years,M,3,1239611010,16988,16994,1,,2,113.4,2102010,2102,21,210201000166,Children's Shoes Pleva
53366,G.J. Bolik,NL,Orion Club Gold members low activity,21,15-30 years,M,3,1239630739,16990,16994,2,,2,142,2202003,2202,22,220200300082,Indoor Handbold Special Shoes
39717,Yolanda Tellechea Carrera,ES,Orion Club Gold members low activity,43,31-45 years,F,2,1239659155,16994,16997,1,,2,197.8,2201004,2201,22,220100400022,Ultra M803 Ng Men's Street Shoes
52189,Javier Alonso del Toro,ES,Orion Club Gold members low activity,33,31-45 years,M,3,1239714387,17001,17006,1,,2,200.4,2202003,2202,22,220200300070,Hgf Low Men's Indoor Shoes
37820,Susan Skovran,US,Orion Club Gold members low activity,21,15-30 years,F,3,1239728100,17002,17003,2,,2,191,2202002,2202,22,220200200039,Soft Cumulus Men's Running Shoes
48219,Michael Watermann,DE,Orion Club Gold members low activity,21,15-30 years,M,2,1239760900,17007,17010,2,,3,199.2,2202002,2202,22,220200200018,Lulu Men's Street Shoes
47589,Denis Bocini,FR,Orion Club Gold members low activity,48,46-60 years,M,2,1239779203,17009,17011,1,,2,20.2,2102007,2102,21,210200700013,Slomo Balance Children's Shoes
31985,Antonio Hernández,ES,Orion Club Gold members low activity,53,46-60 years,M,2,1239801121,17012,17013,2,,2,358.6,2202002,2202,22,220200200080,Ultra M1210 Men's Running Shoes
31985,Antonio Hernández,ES,Orion Club Gold members low activity,53,46-60 years,M,2,1239801121,17012,17013,1,,3,111.6,2202002,2202,22,220200200043,Soft Gel Court Men's Indoor Shoes
40979,Antonio Canella,IT,Orion Club Gold members low activity,58,46-60 years,M,3,1239803711,17012,17013,1,,3,330.3,2201007,2201,22,220100700020,Women's Trainer Aerobic Shoes
46977,Isabel Ranz Abad,ES,Orion Club Gold members low activity,33,31-45 years,F,3,1239824960,17015,17018,1,,2,177.2,2202001,2202,22,220200100090,Big Guy Men's Air Terra Reach Shoes
40230,Zachary Dunn,US,Orion Club Gold members low activity,38,31-45 years,M,2,1239900897,17024,17029,1,,2,187,2202002,2202,22,220200200066,Twain Inco Men's Street Shoes
48556,Aileen Slater,GB,Orion Club Gold members low activity,63,61-75 years,F,2,1239919911,17027,17031,2,,2,194.6,2201007,2201,22,220100700016,Shoes Sphinx
35319,Bertram Gerhardinger,DE,Orion Club Gold members low activity,68,61-75 years,M,2,1239951014,17031,17034,2,,2,180,2202002,2202,22,220200200014,Dubby Low Men's Street Shoes
35319,Bertram Gerhardinger,DE,Orion Club Gold members low activity,68,61-75 years,M,2,1239951014,17031,17034,1,,5,554,2202001,2202,22,220200100078,Big Guy Men's Air Stormy Skylon Shoes
43720,Lesley Ketley,GB,Orion Club Gold members low activity,53,46-60 years,M,2,1239976918,17034,17058,1,,2,80.4,2102006,2102,21,210200600048,Big Kid Children's Shoes
45093,José Antonio de Pablo Martínez,ES,Orion Club Gold members low activity,48,46-60 years,M,2,1239991008,17036,17039,1,,2,198,2202001,2202,22,220200100077,Big Guy Men's Air Span Triax Shoes
50523,Geneva Kanner,US,Orion Club Gold members low activity,28,15-30 years,F,3,1239996417,17036,17038,1,,2,73.4,2102010,2102,21,210201000183,Kola Children's Shoes
40939,Carmen Piqueras Ysern,ES,Orion Club Gold members low activity,73,61-75 years,F,2,1240055590,17044,17047,1,,3,32.1,2102007,2102,21,210200700020,Upright Shoe Balance Shoes
51688,A.J.M. Feenstra,NL,Orion Club Gold members low activity,68,61-75 years,M,2,1240123536,17052,17053,1,,2,191,2202002,2202,22,220200200039,Soft Cumulus Men's Running Shoes
30944,Karl-Günter Claus,DE,Orion Club Gold members low activity,58,46-60 years,M,2,1240230413,17066,17068,1,,2,104.2,2202003,2202,22,220200300078,Hilly Women's Crosstrainer Shoes Large
47428,William Celis,US,Orion Club Gold members low activity,19,15-30 years,M,3,1240243068,17067,17070,1,,2,263.4,2202003,2202,22,220200300101,Mns.winner Men's Running Shoes
51650,Gillian Loxton,GB,Orion Club Gold members low activity,21,15-30 years,F,3,1240256273,17069,17070,1,,1,76.9,2201004,2201,22,220100400012,Bill V-3-London Calling Shoes
30019,Mary Mccullough,US,Orion Club Gold members low activity,33,31-45 years,F,3,1240397237,17086,17089,1,,1,174.1,2202001,2202,22,220200100041,Big Guy Men's Air Flight Determination Shoes
50095,Catherine Tomlinson,GB,Orion Club Gold members low activity,58,46-60 years,M,2,1240403030,17087,17089,1,,1,91,2201004,2201,22,220100400018,Osprey Men's Street Cat Nubuck Street Shoes
34720,Christina Hodakozli,US,Orion Club Gold members low activity,38,31-45 years,F,2,1240476668,17096,17098,1,,1,61.9,2202001,2202,22,220200100011,Atmosphere Mic Plus.Men's Running Shoe
35136,Edward Mcleod,GB,Orion Club Gold members low activity,33,31-45 years,F,2,1240481922,17097,17101,1,,1,55.1,2201007,2201,22,220100700039,"Power Men's Dmx Wide, Walking Shoes"
37610,Tobey Schley,US,Orion Club Gold members low activity,23,15-30 years,F,3,1240493368,17098,17102,1,,1,36.7,2102010,2102,21,210201000183,Kola Children's Shoes
29500,Peter Wringe,GB,Orion Club Gold members low activity,58,46-60 years,M,2,1240619994,17114,17119,1,,1,96,2201007,2201,22,220100700018,Women's Aerobic Shoes Leggera
32941,James Milidonis,US,Orion Club Gold members low activity,23,15-30 years,M,3,1240623441,17114,17120,2,,3,101.4,2102010,2102,21,210201000167,Children's Shoes Stratosphere
54839,Hans-Christoph Rey,DE,Orion Club Gold members low activity,23,15-30 years,M,3,1240658076,17119,17124,1,,1,75,2202003,2202,22,220200300020,Men's Skate Shoes Revel
31768,Barry Richbell,GB,Orion Club Gold members low activity,53,46-60 years,M,3,1240684829,17122,17123,1,,1,55.1,2201007,2201,22,220100700039,"Power Men's Dmx Wide, Walking Shoes"
37411,Micheal Livingstone,GB,Orion Club Gold members low activity,58,46-60 years,M,3,1240707914,17125,17131,1,,2,241,2201004,2201,22,220100400026,Vector Low Men's Shoes
46300,Dametre Heinlein,US,Orion Club Gold members low activity,38,31-45 years,M,2,1240736823,17128,17131,1,,1,16.4,2401001,2401,24,240100100434,Shoeshine Black
39281,Marie-Odile Boennec,FR,Orion Club Gold members low activity,58,46-60 years,F,2,1240741124,17129,17134,2,,1,36.7,2102010,2102,21,210201000183,Kola Children's Shoes
52670,Amy Davis-Williams,US,Orion Club Gold members low activity,19,15-30 years,F,2,1240801756,17136,17139,2,,2,227.2,2202003,2202,22,220200300123,The Gonzales Men's Shoes
38013,Amy Griffiths,GB,Orion Club Gold members low activity,38,31-45 years,F,2,1240828051,17140,17142,1,,6,546,2201004,2201,22,220100400018,Osprey Men's Street Cat Nubuck Street Shoes
39284,Simone Nebeling,DE,Orion Club Gold members low activity,43,31-45 years,F,2,1240842252,17142,17144,1,,2,194.6,2202002,2202,22,220200200032,Soft 140 Men's Running Shoes
37618,Bhavna Drolet,GB,Orion Club Gold members low activity,63,61-75 years,F,2,1240932045,17153,17154,1,,4,238,2201007,2201,22,220100700027,Duration Women's Trainer Aerobic Shoes
47923,James Debutts,US,Orion Club Gold members low activity,38,31-45 years,M,3,1240943185,17154,17160,1,,2,226,2202002,2202,22,220200200045,Soft Gt 2040 Women's Running Shoes
51645,Mai Ibbett,GB,Orion Club Gold members low activity,73,61-75 years,F,2,1240966003,17157,17161,1,,2,113.8,2201007,2201,22,220100700022,Alexis Women's Classic Shoes
35694,Sandra Yonce,US,Orion Club Gold members low activity,21,15-30 years,F,2,1241056006,17168,17172,1,,2,180,2202002,2202,22,220200200014,Dubby Low Men's Street Shoes
48656,Anne Last,GB,Orion Club Gold members low activity,21,15-30 years,F,2,1241071704,17170,17171,1,,1,59.5,2201007,2201,22,220100700027,Duration Women's Trainer Aerobic Shoes
35121,Cecile Faurie,FR,Orion Club Gold members low activity,19,15-30 years,F,2,1241113309,17175,17179,1,,1,36.7,2102010,2102,21,210201000183,Kola Children's Shoes
48077,Christina Rausch,DE,Orion Club Gold members low activity,48,46-60 years,F,2,1241129481,17177,17180,2,,1,53,2202001,2202,22,220200100144,Big Guy Men's Strap Runner Shoes
48077,Christina Rausch,DE,Orion Club Gold members low activity,48,46-60 years,F,2,1241129481,17177,17180,1,,2,361.4,2202001,2202,22,220200100116,Big Guy Men's Air Zoom Total 90 F.G Shoes
49989,M.P. de Ruiter,NL,Orion Club Gold members low activity,53,46-60 years,F,3,1241134047,17177,17182,1,,1,150.3,2202001,2202,22,220200100021,Big Guy Men's Air 120 Soccer Shoes
44966,Pablo Alvarado Moreno,ES,Orion Club Gold members low activity,48,46-60 years,M,3,1241193519,17184,17187,1,,1,62.2,2202003,2202,22,220200300007,Low Women's Aerobic Shoes
39130,Meltem Folge,DE,Orion Club Gold members low activity,58,46-60 years,F,3,1241236657,17189,17194,1,,1,93.5,2202002,2202,22,220200200066,Twain Inco Men's Street Shoes
51724,Jan de Pee,NL,Orion Club Gold members low activity,23,15-30 years,M,2,1241270937,17192,17196,1,,1,71,2202003,2202,22,220200300082,Indoor Handbold Special Shoes
30209,Sano Willis,US,Orion Club Gold members low activity,43,31-45 years,M,3,1241287341,17194,17197,1,,1,66.4,2202002,2202,22,220200200018,Lulu Men's Street Shoes
39471,Antonio Henne,US,Orion Club Gold members low activity,23,15-30 years,M,3,1241287604,17194,17198,1,,1,65.2,2202003,2202,22,220200300027,Smith Men's Street Shoes
31079,Tommaso Tonato,IT,Orion Club Gold members low activity,58,46-60 years,M,3,1241340375,17200,17205,1,,1,125.8,2202001,2202,22,220200100057,Big Guy Men's Air Mickey Willy Shoes
30097,Cortenna Lerell,US,Orion Club Gold members low activity,19,15-30 years,F,3,1241342500,17200,17201,1,,1,115,2202003,2202,22,220200300015,Men's Running Shoes Piedmmont
51724,Jan de Pee,NL,Orion Club Gold members low activity,23,15-30 years,M,2,1241412697,17208,17212,1,,1,75,2202003,2202,22,220200300020,Men's Skate Shoes Revel
41511,Gilles Soudan,FR,Orion Club Gold members low activity,21,15-30 years,M,2,1241473349,17215,17220,1,,2,72.2,2102004,2102,21,210200400014,Kid Trainer Lite(Bp) Street Shoes
48014,David Price,US,Orion Club Gold members low activity,58,46-60 years,M,2,1241497035,17217,17221,1,,1,41.1,2102010,2102,21,210201000206,Trainer Children's Shoes
33788,Michael E Harrison,GB,Orion Club Gold members low activity,58,46-60 years,M,2,1241611012,17230,17233,1,,1,59.8,2201007,2201,22,220100700010,Men's Running Shoes Burn
46303,Petra Bunte,DE,Orion Club Gold members low activity,23,15-30 years,F,3,1241627497,17232,17236,1,,1,33.4,2202001,2202,22,220200100126,Big Guy Men's Gts Canvas Plus Shoes
37296,Sue Humm,GB,Orion Club Gold members low activity,53,46-60 years,F,3,1241649990,17234,17239,1,,1,60.1,2102010,2102,21,210201000198,South Peak Junior Training Shoes
44621,Wolf-Albrecht Burde,DE,Orion Club Gold members low activity,58,46-60 years,M,2,1241690283,17239,17243,2,,1,132.1,2202002,2202,22,220200200072,Twain Men's Expresso X-Hiking Shoes
52405,Liz Estorff,DE,Orion Club Gold members low activity,68,61-75 years,F,2,1241699462,17240,17245,1,,2,142.8,2202001,2202,22,220200100143,Big Guy Men's Speedy Flight Plus Shoes
37722,Nicolás Sánchez-Mateos Rubio,ES,Orion Club Gold members low activity,28,15-30 years,M,3,1241764368,17247,17264,1,,1,48.2,2202001,2202,22,220200100153,Big Guy Men's Understudy Cross Train. Shoes
44720,Sherrieffia Salmi,US,Orion Club Gold members low activity,19,15-30 years,F,3,1241771032,17247,17252,1,,1,105.1,2202002,2202,22,220200200015,Dubby Low Men's Street Shoes Large
31179,Wolfgang Hayek,DE,Orion Club Gold members low activity,73,61-75 years,M,2,1241789769,17250,17252,1,,1,89.8,2202001,2202,22,220200100097,Big Guy  Men's Air Trainer Structure Plu Shoe
53198,Petra Büchner,DE,Orion Club Gold members low activity,43,31-45 years,F,2,1241790118,17250,17255,1,,2,234,2202003,2202,22,220200300095,Mns.light 4 Low Men's Indoor Shoes
30350,Martin Axtell,US,Orion Club Gold members low activity,23,15-30 years,M,3,1241805186,17251,17254,2,,1,80,2202001,2202,22,220200100129,Big Guy Men's International Triax Shoes
30350,Martin Axtell,US,Orion Club Gold members low activity,23,15-30 years,M,3,1241805186,17251,17254,1,,1,157.8,2202001,2202,22,220200100099,Big Guy Men's Air Tuned Sirocco Shoes
37722,Nicolás Sánchez-Mateos Rubio,ES,Orion Club Gold members low activity,28,15-30 years,M,3,1241853493,17257,17262,1,,3,322.5,2202002,2202,22,220200200050,Soft Integral Men's Running Shoes
28147,Jürgen Messinger,DE,Orion Club Gold members low activity,43,31-45 years,M,3,1241899081,17262,17269,1,,3,213,2202003,2202,22,220200300082,Indoor Handbold Special Shoes
47429,Inés Valbuena,ES,Orion Club Gold members low activity,48,46-60 years,F,3,1241900500,17262,17264,1,,3,100.2,2202001,2202,22,220200100126,Big Guy Men's Gts Canvas Plus Shoes
34572,l.G.W Stienen,NL,Orion Club Gold members low activity,33,31-45 years,M,2,1241921281,17264,17265,1,,3,362.1,2202001,2202,22,220200100098,Big Guy Men's Air Tuned Max Shoes
35150,Montse Romanos,ES,Orion Club Gold members low activity,21,15-30 years,F,3,1241935213,17266,17269,1,,1,60.1,2102004,2102,21,210200400076,Tony's Children's Terra Reach(Bg) Shoes
31565,Norbert Morris-Perkins,US,Orion Club Gold members low activity,23,15-30 years,M,3,1241940748,17266,17268,2,,1,70.1,2202002,2202,22,220200200037,Soft Astro Women's Running Shoes
46609,Enrique Yamilet Herrera,ES,Orion Club Gold members low activity,48,46-60 years,M,2,1241944240,17267,17268,1,,3,165,2202003,2202,22,220200300126,The Wish L Women's Running Shoes
47454,Felipe Schneider,ES,Orion Club Gold members low activity,28,15-30 years,M,2,1241963786,17269,17270,3,,1,70.8,2202003,2202,22,220200300143,W.a..trainer Leather Shoes
43160,Juan Carlos Serrano Sánchez,ES,Orion Club Gold members low activity,19,15-30 years,M,3,1241979643,17271,17275,2,,1,75.8,2201007,2201,22,220100700001,Classic Men's Leisure Shoes
39443,Andrea Atzeni,IT,Orion Club Gold members low activity,53,46-60 years,F,3,1241991716,17272,17276,3,,3,213,2202003,2202,22,220200300082,Indoor Handbold Special Shoes
39443,Andrea Atzeni,IT,Orion Club Gold members low activity,53,46-60 years,F,3,1241991716,17272,17276,2,,1,97.3,2202002,2202,22,220200200032,Soft 140 Men's Running Shoes
49989,M.P. de Ruiter,NL,Orion Club Gold members low activity,53,46-60 years,F,3,1242038927,17277,17282,1,,1,89.8,2202001,2202,22,220200100097,Big Guy  Men's Air Trainer Structure Plu Shoe
40540,Gunda Baasch,DE,Orion Club Gold members low activity,23,15-30 years,F,3,1242052406,17279,17284,1,,1,177.8,2202001,2202,22,220200100010,Atmosphere Mickey Shoes
51245,Alessia Nascinben,IT,Orion Club Gold members low activity,58,46-60 years,F,3,1242056312,17279,17285,1,,1,77,2202003,2202,22,220200300155,Hardcore Men's Street Shoes
54848,Pierre Tartar,FR,Orion Club Gold members low activity,33,31-45 years,M,2,1242064061,17280,17283,2,,1,10.7,2102007,2102,21,210200700020,Upright Shoe Balance Shoes
51631,Arnaud Blouard,FR,Orion Club Gold members low activity,21,15-30 years,F,2,1242127420,17287,17291,1,,1,49.4,2102004,2102,21,210200400031,Toddle Children's Air Tuco(Bg) Shoes
51391,Claudette Samra,GB,Orion Club Gold members low activity,21,15-30 years,F,3,1242156532,17290,17292,1,,1,123.3,2201007,2201,22,220100700003,Dmx 6 Shoes
33788,Michael E Harrison,GB,Orion Club Gold members low activity,58,46-60 years,M,2,1242180859,17293,17296,1,,3,313.8,2201007,2201,22,220100700024,Armadillo Road Dmx Women's Running Shoes
50333,Christine Sudaka,FR,Orion Club Gold members low activity,38,31-45 years,F,2,1242188511,17294,17299,3,,3,108.3,2102004,2102,21,210200400014,Kid Trainer Lite(Bp) Street Shoes
45675,Annie Stancel,US,Orion Club Gold members low activity,28,15-30 years,F,2,1242238946,17299,17303,2,,3,395.1,2202003,2202,22,220200300101,Mns.winner Men's Running Shoes
28174,Zerbaksh Da Silva,US,Orion Club Gold members low activity,63,61-75 years,M,2,1242248216,17300,17305,1,,1,16.4,2401001,2401,24,240100100434,Shoeshine Black
51158,J.F.J. Rubingh,NL,Orion Club Gold members low activity,63,61-75 years,M,2,1242256217,17301,17306,1,,3,332.1,2202003,2202,22,220200300040,Women's Running Shoes Piedmont
54111,Isabelle Guyon,FR,Orion Club Gold members low activity,23,15-30 years,F,2,1242272025,17303,17305,1,,1,33.8,2102010,2102,21,210201000167,Children's Shoes Stratosphere
36587,Helen Mclarnon,US,Orion Club Gold members low activity,19,15-30 years,F,3,1242276745,17303,17306,1,,1,92.5,2202002,2202,22,220200200067,Twain Inco Women's Street Shoes
32578,Outi Pfüller,DE,Orion Club Gold members low activity,23,15-30 years,F,3,1242360908,17313,17318,1,,4,382,2202002,2202,22,220200200039,Soft Cumulus Men's Running Shoes
48563,Renaud Radulesco,FR,Orion Club Gold members low activity,28,15-30 years,M,2,1242464032,17324,17327,1,,2,74.8,2102004,2102,21,210200400041,Toddle Children's Understudy(Bg) Shoes
43653,Adele Stankhome,GB,Orion Club Gold members low activity,53,46-60 years,M,3,1242465326,17324,17329,1,,2,220.2,2201007,2201,22,220100700020,Women's Trainer Aerobic Shoes
46873,Fulvio Palazzini,IT,Orion Club Gold members low activity,53,46-60 years,M,2,1242540605,17332,17335,2,,3,258.6,2202002,2202,22,220200200011,Cruise Platypus Men's Street Shoes
29920,Rasheena Graefenstein,US,Orion Club Gold members low activity,38,31-45 years,F,3,1242567411,17335,17341,2,,3,175.8,2202003,2202,22,220200300051,Armadillo Men's Running Shoes
29920,Rasheena Graefenstein,US,Orion Club Gold members low activity,38,31-45 years,F,3,1242567411,17335,17341,1,,2,218.6,2202001,2202,22,220200100033,Big Guy Men's Air Croos Trainer Iii Shoes
34496,Chandru Ferrari,US,Orion Club Gold members low activity,48,46-60 years,M,3,1242667993,17346,17347,2,,3,102.6,2102010,2102,21,210201000174,Freestyle Children's Leather Street Shoes
42436,Marc Rajukumar,GB,Orion Club Gold members low activity,73,61-75 years,M,2,1242680178,17348,17350,1,,2,84.2,2102004,2102,21,210200400073,Tony's Children's Payoff Trainer (Bp) Shoes
29045,Udo Mattes,DE,Orion Club Gold members low activity,38,31-45 years,M,2,1242723483,17353,17358,2,,2,200.4,2202003,2202,22,220200300070,Hgf Low Men's Indoor Shoes
33357,Roberto Martín de Valmaseda,ES,Orion Club Gold members low activity,28,15-30 years,M,2,1242724813,17353,17357,1,,3,195.3,2102004,2102,21,210200400030,Toddle Children's Air Terra Humara(Bg) Shoes
42058,Brin Hockin,GB,Orion Club Gold members low activity,53,46-60 years,M,3,1242761845,17357,17363,1,,2,113.8,2201007,2201,22,220100700022,Alexis Women's Classic Shoes
28170,R.F. Flikkema,NL,Orion Club Gold members low activity,58,46-60 years,M,3,1242836211,17365,17368,2,,2,191,2202002,2202,22,220200200039,Soft Cumulus Men's Running Shoes
28170,R.F. Flikkema,NL,Orion Club Gold members low activity,58,46-60 years,M,3,1242836211,17365,17368,1,,2,160,2202001,2202,22,220200100129,Big Guy Men's International Triax Shoes
49544,Matyas Toepfer,DE,Orion Club Gold members low activity,23,15-30 years,M,2,1243004599,17384,17386,3,,2,162.4,2202003,2202,22,220200300129,Torino Men's Leather Adventure Shoes
49544,Matyas Toepfer,DE,Orion Club Gold members low activity,23,15-30 years,M,2,1243004599,17384,17386,2,,2,199,2202003,2202,22,220200300017,Men's Shoes Solace
49544,Matyas Toepfer,DE,Orion Club Gold members low activity,23,15-30 years,M,2,1243004599,17384,17386,1,,2,216.4,2202002,2202,22,220200200071,Twain Men's Exit Low 2000 Street Shoes
38962,Thierry Marion-Gallois,FR,Orion Club Gold members low activity,21,15-30 years,M,2,1243033222,17387,17391,1,,3,119.4,2102004,2102,21,210200400042,Toddle Children's Understudy(Bp) Shoes
48838,Christopher Ward,US,Orion Club Gold members low activity,38,31-45 years,M,3,1243063870,17390,17393,1,,3,30.3,2102007,2102,21,210200700013,Slomo Balance Children's Shoes
50669,Yontz Gartenberg,US,Orion Club Gold members low activity,33,31-45 years,M,3,1243216827,17407,17411,1,0.3,3,218.97,2202003,2202,22,220200300117,South Peak Women's Light Indoor Shoes
51126,Cindy Barratt,GB,Orion Club Gold members low activity,21,15-30 years,F,2,1243287708,17415,17419,1,,1,93.6,2201004,2201,22,220100400023,Ultra W802 All Terrain Women's Shoes
31984,Nazih Filippi,FR,Orion Club Gold members low activity,68,61-75 years,M,2,1243440666,17432,17433,1,,1,48.7,2102004,2102,21,210200400029,Toddle Children's Air Terra Grande Shoes
28170,R.F. Flikkema,NL,Orion Club Gold members low activity,58,46-60 years,M,3,1243443571,17432,17435,1,,2,197.4,2202003,2202,22,220200300072,Hgf Tarantula Men's Indoor Shoes
45240,Shirlita Brookins,US,Orion Club Gold members low activity,19,15-30 years,F,3,1243508272,17439,17441,1,,2,172.4,2202002,2202,22,220200200011,Cruise Platypus Men's Street Shoes
39422,Samhee Bimont,FR,Orion Club Gold members low activity,38,31-45 years,F,2,1243512254,17440,17457,1,,1,42.1,2102004,2102,21,210200400078,Tony's Children's Trainer Lite (Bg) Shoes
49481,Bob Whiteley,GB,Orion Club Gold members low activity,53,46-60 years,M,2,1243532069,17442,17447,1,,1,33.8,2102010,2102,21,210201000167,Children's Shoes Stratosphere
50197,Josef Poidatz,IT,Orion Club Gold members low activity,58,46-60 years,M,2,1243552203,17444,17448,1,,1,55,2202003,2202,22,220200300126,The Wish L Women's Running Shoes
48930,Marv Hasselmann,DE,Orion Club Gold members low activity,43,31-45 years,M,3,1243610363,17451,17457,1,,1,64,2202002,2202,22,220200200021,Pro Fit  Gel Ds Trainer Iv Men's Running Shoe
40379,J.T. Dashorst,NL,Orion Club Gold members low activity,73,61-75 years,F,2,1243659303,17456,17460,1,,1,33.4,2202001,2202,22,220200100126,Big Guy Men's Gts Canvas Plus Shoes
38328,Ibrahim Stoute,US,Orion Club Gold members low activity,73,61-75 years,M,2,1243724732,17463,17466,1,,1,16.4,2401001,2401,24,240100100434,Shoeshine Black
54333,Michelle Benelhadj,FR,Orion Club Gold members low activity,28,15-30 years,F,3,1243748213,17466,17467,1,,1,36.8,2102004,2102,21,210200400039,Toddle Children's Quokka V (Bp) Shoes
40379,J.T. Dashorst,NL,Orion Club Gold members low activity,73,61-75 years,F,2,1243786538,17470,17474,1,,1,136.7,2202002,2202,22,220200200059,Soft Nimbus Men's Running Shoes
52344,Gaz Byford,GB,Orion Club Gold members low activity,53,46-60 years,M,2,1243869547,17479,17481,1,,1,36.7,2102010,2102,21,210201000183,Kola Children's Shoes
50597,Mickael Jennings,US,Orion Club Gold members low activity,28,15-30 years,M,3,1243907450,17483,17487,1,,1,53.4,2102010,2102,21,210201000195,South Peak Children's Shoes C
49156,Mirian Hoppe,DE,Orion Club Gold members low activity,68,61-75 years,F,2,1243993745,17493,17497,2,,1,66.4,2202002,2202,22,220200200018,Lulu Men's Street Shoes
35247,Corinna Rohlfing,DE,Orion Club Gold members low activity,21,15-30 years,F,2,1244057223,17500,17502,1,,1,106.5,2202001,2202,22,220200100084,Big Guy Men's Air Tailwind Shoes
45675,Annie Stancel,US,Orion Club Gold members low activity,28,15-30 years,F,2,1244065244,17500,17504,1,,1,88.9,2202003,2202,22,220200300152,Hardcore Junior/Women's Street Shoes
47416,Trak Rowland,GB,Orion Club Gold members low activity,33,31-45 years,F,2,1244077139,17502,17504,1,,2,185.8,2201004,2201,22,220100400024,Ultra W803 At Women's Street Shoes
49963,Mercedes Pizarro Urbina,ES,Orion Club Gold members low activity,19,15-30 years,F,2,1244166512,17512,17513,1,,2,67.6,2102010,2102,21,210201000167,Children's Shoes Stratosphere
46873,Fulvio Palazzini,IT,Orion Club Gold members low activity,53,46-60 years,M,2,1244204433,17516,17519,2,,6,517.2,2202002,2202,22,220200200011,Cruise Platypus Men's Street Shoes
39388,Corinna Manlik,DE,Orion Club Gold members low activity,23,15-30 years,F,2,1244236998,17520,17525,1,,2,140.2,2202002,2202,22,220200200037,Soft Astro Women's Running Shoes
36344,Michael Falciani,US,Orion Club Gold members low activity,53,46-60 years,M,3,1244254762,17521,17524,1,,2,266.6,2202003,2202,22,220200300098,Mns.riding Women's Running Shoes
50991,Tina Van Heusden,NL,Orion Club Gold members low activity,23,15-30 years,F,2,1244330579,17530,17537,1,,4,432.8,2202002,2202,22,220200200071,Twain Men's Exit Low 2000 Street Shoes
40520,Alessandro Stanford,IT,Orion Club Gold members low activity,53,46-60 years,M,2,1244335663,17531,17534,2,,4,266,2202002,2202,22,220200200002,Men's Nubuck-Retro Running Shoes Roadster
71432,Paola Lusetti,IT,Orion Club Gold members low activity,73,61-75 years,F,2,1230041227,15713,15715,1,,1,73.2,2202001,2202,22,220200100096,Big Guy Men's Air Tiempo Pro Ic Shoes
62274,James Le-Belcea,US,Orion Club Gold members low activity,19,15-30 years,M,2,1230049633,15714,15717,1,,1,3,2401001,2401,24,240100100431,Shoelace Black 150 Cm
79562,Pierre-Gatien Carbillet,FR,Orion Club Gold members low activity,58,46-60 years,M,3,1230078832,15720,15721,2,,2,30.6,2401001,2401,24,240100100434,Shoeshine Black
78194,J-l Stolin,FR,Orion Club Gold members low activity,68,61-75 years,M,2,1230090474,15722,15725,1,,1,10.1,2102007,2102,21,210200700013,Slomo Balance Children's Shoes
84570,Orazio Carlo Marcato,IT,Orion Club Gold members low activity,63,61-75 years,M,2,1230117687,15727,15730,1,,1,106.1,2201007,2201,22,220100700052,Trooper Ii Dmx-2x Men's Walking Shoes
85000,Javier Bonmati,ES,Orion Club Gold members low activity,38,31-45 years,M,2,1230122005,15728,15731,1,,2,315.6,2202001,2202,22,220200100099,Big Guy Men's Air Tuned Sirocco Shoes
70915,Sara Simons,ES,Orion Club Gold members low activity,28,15-30 years,F,3,1230137467,15731,15735,1,,2,157.2,2202001,2202,22,220200100129,Big Guy Men's International Triax Shoes
70085,Canio Toderi,IT,Orion Club Gold members low activity,58,46-60 years,M,2,1230195734,15741,15745,1,,1,66.4,2202002,2202,22,220200200018,Lulu Men's Street Shoes
60002,Renata O'Docherty,GB,Orion Club Gold members low activity,23,15-30 years,F,2,1230223227,15746,15748,1,,1,83.2,2201007,2201,22,220100700042,"Power Women's Dmx Wide, Walking Shoes"
87954,Virginie Berggren,FR,Orion Club Gold members low activity,33,31-45 years,F,3,1230267898,15754,15757,1,,1,10.1,2102007,2102,21,210200700013,Slomo Balance Children's Shoes
59308,Safiullah Nappo,US,Orion Club Gold members low activity,58,46-60 years,M,3,1230372834,15773,15779,1,,2,315.6,2202001,2202,22,220200100099,Big Guy Men's Air Tuned Sirocco Shoes
56960,Diane Woodbury,US,Orion Club Gold members low activity,58,46-60 years,F,2,1230411257,15780,15782,1,,2,66.8,2202001,2202,22,220200100126,Big Guy Men's Gts Canvas Plus Shoes
56779,Silvano Rimbano,IT,Orion Club Gold members low activity,58,46-60 years,M,2,1230425822,15783,15788,3,,2,200.4,2202003,2202,22,220200300070,Hgf Low Men's Indoor Shoes
56779,Silvano Rimbano,IT,Orion Club Gold members low activity,58,46-60 years,M,2,1230425822,15783,15788,2,,1,61,2202003,2202,22,220200300013,Men's Running Shoes Estes
92569,María Victoria Velázquez Fernández,ES,Orion Club Gold members low activity,68,61-75 years,F,2,1230496502,15796,15800,1,,1,90,2201007,2201,22,220100700016,Shoes Sphinx
64268,Ivia Standfield,US,Orion Club Gold members low activity,21,15-30 years,F,2,1230505426,15797,15802,2,,1,81.4,2202003,2202,22,220200300025,Mid Women's Aerobic Shoes X
64268,Ivia Standfield,US,Orion Club Gold members low activity,21,15-30 years,F,2,1230505426,15797,15802,1,,3,205.8,2202001,2202,22,220200100014,Atmosphere Terra Grande Shoes
80153,Philippe Feur,FR,Orion Club Gold members low activity,73,61-75 years,M,2,1230529360,15802,15806,2,,1,10.7,2102007,2102,21,210200700020,Upright Shoe Balance Shoes
70715,Renzo Fraire,IT,Orion Club Gold members low activity,73,61-75 years,M,2,1230535851,15803,15806,1,,1,177.8,2202001,2202,22,220200100010,Atmosphere Mickey Shoes
82063,Margarita Galán de la Fuente,ES,Orion Club Gold members low activity,53,46-60 years,F,2,1230552271,15806,15815,2,,1,33.5,2102010,2102,21,210201000179,K Street Shoes
86069,Antonio Dogliotti,IT,Orion Club Gold members low activity,48,46-60 years,M,3,1230573697,15810,15816,1,,4,680,2202001,2202,22,220200100165,Sire Air Max-Running Shoes
79827,Donatello Lapietra,IT,Orion Club Gold members low activity,73,61-75 years,M,2,1230585221,15812,15816,1,,3,286.5,2202002,2202,22,220200200039,Soft Cumulus Men's Running Shoes
78590,Andre Aegerter,FR,Orion Club Gold members low activity,28,15-30 years,M,3,1230644050,15823,15829,1,,1,32.3,2102010,2102,21,210201000168,Children's Shoes Wilcox
83177,Inés Elexpe,ES,Orion Club Gold members low activity,33,31-45 years,F,2,1230666461,15827,15832,1,,4,336.8,2202003,2202,22,220200300116,South Peak Men's Running Shoes
56252,Bernard Perlasco,FR,Orion Club Gold members low activity,38,31-45 years,M,2,1230687227,15831,15832,2,,1,53.4,2102010,2102,21,210201000195,South Peak Children's Shoes C
88630,Suzel Vandenbilcke,FR,Orion Club Gold members low activity,43,31-45 years,F,2,1230705097,15834,15838,3,,1,41.1,2102010,2102,21,210201000206,Trainer Children's Shoes
57789,Daniel Abelleira Méndez,ES,Orion Club Gold members low activity,19,15-30 years,M,3,1230781171,15848,15853,1,,1,78.3,2201007,2201,22,220100700017,Trainer Women's Aerobic Shoes
88805,Carla Pizarro,ES,Orion Club Gold members low activity,53,46-60 years,F,2,1230781612,15848,15849,1,,3,319.2,2202003,2202,22,220200300061,Damaskus Men's Running Shoes
76906,Pierre Mira,FR,Orion Club Gold members low activity,33,31-45 years,M,3,1230791720,15850,15855,1,,1,32.3,2102010,2102,21,210201000168,Children's Shoes Wilcox
74659,Aldo Adriano,IT,Orion Club Gold members low activity,58,46-60 years,M,3,1230792749,15850,15852,1,,3,183,2202003,2202,22,220200300013,Men's Running Shoes Estes
79753,Francisco Pena,ES,Orion Club Gold members low activity,48,46-60 years,M,2,1230819479,15855,15858,1,,1,78.3,2202003,2202,22,220200300106,Multi Women's Running Shoes
56510,Josephine Brick,US,Orion Club Gold members low activity,23,15-30 years,F,2,1230837525,15858,15862,1,,2,361.4,2202001,2202,22,220200100116,Big Guy Men's Air Zoom Total 90 F.G Shoes
76865,Jordi García Álvarez,ES,Orion Club Gold members low activity,58,46-60 years,M,2,1230839534,15859,15864,1,,2,173.2,2202001,2202,22,220200100066,Big Guy Men's Air Quest Shoes
55252,Marita Kaatz,DE,Orion Club Gold members low activity,43,31-45 years,F,3,1230844465,15860,15863,1,,2,315.6,2202001,2202,22,220200100099,Big Guy Men's Air Tuned Sirocco Shoes
90581,Humbert Castro Barroso,ES,Orion Club Gold members low activity,28,15-30 years,M,2,1230845327,15860,15864,1,,2,162.4,2202003,2202,22,220200300129,Torino Men's Leather Adventure Shoes
84001,Luis Franch-Arcas,ES,Orion Club Gold members low activity,53,46-60 years,M,3,1230862148,15863,15868,2,,2,110.8,2202001,2202,22,220200100060,Big Guy Men's Air One Eighty  Shoes
85478,Lorenzo Cappuccio,IT,Orion Club Gold members low activity,73,61-75 years,M,2,1230906784,15871,15874,1,,2,134,2202001,2202,22,220200100026,Big Guy Men's Air Align Shoes
59918,Gurpreet Bullard,US,Orion Club Gold members low activity,33,31-45 years,M,2,1230936954,15876,15881,1,,2,170.8,2202001,2202,22,220200100025,Big Guy  Men's Air Ace 4 Plus Low-Tennis Shoe
84148,José María de Miguel Colom,ES,Orion Club Gold members low activity,43,31-45 years,M,3,1230954028,15880,15884,1,,2,315.6,2202001,2202,22,220200100099,Big Guy Men's Air Tuned Sirocco Shoes
63202,David Burleson,US,Orion Club Gold members low activity,21,15-30 years,M,2,1230963281,15881,15885,1,,2,71.6,2401001,2401,24,240100100437,Shoeshine Olive
81271,Delphine Richard,FR,Orion Club Gold members low activity,33,31-45 years,F,3,1230977849,15884,15886,1,,2,9.2,2401001,2401,24,240100100429,"Shoelace 140 Cm, Assorted Colours"
70286,Sara Salasco,IT,Orion Club Gold members low activity,73,61-75 years,F,2,1230994109,15887,15892,1,,2,210.8,2202001,2202,22,220200100142,Big Guy Men's Span Triax Shoes
65484,Alexandra Reichstein,DE,Orion Club Gold members low activity,68,61-75 years,F,2,1231036035,15895,15900,2,,3,141,2202002,2202,22,220200200005,Allinall Star Men's Canvas Shoes
65484,Alexandra Reichstein,DE,Orion Club Gold members low activity,68,61-75 years,F,2,1231036035,15895,15900,1,,2,65.6,2202001,2202,22,220200100123,Big Guy Men's Deschutz Slide Shoes
78006,Elena Tous,ES,Orion Club Gold members low activity,73,61-75 years,F,2,1231036582,15895,15900,1,,2,53.8,2102009,2102,21,210200900027,Osprey Cuda Lo Jr. Shoes Synthetic
77103,Pierre Pennavayre,FR,Orion Club Gold members low activity,53,46-60 years,M,3,1231065083,15900,15906,1,,2,20.2,2102007,2102,21,210200700013,Slomo Balance Children's Shoes
76486,Encarnación González,ES,Orion Club Gold members low activity,63,61-75 years,F,2,1231074629,15902,15907,1,,3,143.7,2102010,2102,21,210201000178,Infant Children's Shoes
60944,Susanne Rothmaier,DE,Orion Club Gold members low activity,21,15-30 years,F,2,1231100715,15907,15912,1,,2,180,2202002,2202,22,220200200014,Dubby Low Men's Street Shoes
61948,Ursula Rodenstock,DE,Orion Club Gold members low activity,43,31-45 years,F,3,1231133110,15913,15919,1,,2,94,2202002,2202,22,220200200005,Allinall Star Men's Canvas Shoes
88399,Giorgio Tauriello,IT,Orion Club Gold members low activity,63,61-75 years,M,2,1231151808,15916,15921,2,,2,240.2,2201007,2201,22,220100700047,Tcp 6 Women's Running Shoes
88161,Javier Delgado,ES,Orion Club Gold members low activity,43,31-45 years,M,3,1231178318,15921,15923,2,,2,20.2,2102007,2102,21,210200700013,Slomo Balance Children's Shoes
88334,Enrique Serra,ES,Orion Club Gold members low activity,58,46-60 years,M,2,1231218487,15928,15930,1,,2,67.2,2102010,2102,21,210201000205,Torino 2000 K Street Shoes
88161,Javier Delgado,ES,Orion Club Gold members low activity,43,31-45 years,M,3,1231242144,15932,15934,1,,2,212.2,2201007,2201,22,220100700052,Trooper Ii Dmx-2x Men's Walking Shoes
79091,Susana Mendizábal Aizpuru,ES,Orion Club Gold members low activity,53,46-60 years,F,2,1231252069,15934,15937,1,,3,123.6,2102004,2102,21,210200400018,Kiddy.summit  90 F.G.Rbr (Bg) Children's Shoe
56213,Pavla Couchat,FR,Orion Club Gold members low activity,63,61-75 years,F,2,1231258090,15935,15940,1,,2,69.6,2102006,2102,21,210200600064,Children's Canvas Shoes
63977,Juan Alberto Rowenczyk,FR,Orion Club Gold members low activity,38,31-45 years,M,3,1231280926,15939,15940,2,,2,82.2,2102010,2102,21,210201000206,Trainer Children's Shoes
56231,Heide Malone,GB,Orion Club Gold members low activity,48,46-60 years,F,2,1231281876,15939,15942,1,,2,199.4,2201007,2201,22,220100700024,Armadillo Road Dmx Women's Running Shoes
84167,Faustino Borges,ES,Orion Club Gold members low activity,19,15-30 years,M,3,1231296103,15942,15943,2,,2,190.8,2202002,2202,22,220200200071,Twain Men's Exit Low 2000 Street Shoes
61005,Bev Bhagat,US,Orion Club Gold members low activity,33,31-45 years,M,2,1231323331,15946,15951,1,,2,142,2202003,2202,22,220200300082,Indoor Handbold Special Shoes
80390,Ondina Ziccardi,IT,Orion Club Gold members low activity,68,61-75 years,F,2,1231495319,15978,15981,1,,2,273.2,2202003,2202,22,220200300102,Mns.xzs Women's Aerobic Shoes
74920,Riccardo Piazzola,IT,Orion Club Gold members low activity,48,46-60 years,M,2,1231561194,15990,15994,1,,1,82,2202003,2202,22,220200300164,Traverse Shoes
74365,Francesco Gaetano Battegazzorre,IT,Orion Club Gold members low activity,53,46-60 years,M,2,1231600328,15997,16002,1,,2,177.6,2202002,2202,22,220200200062,Top C-Tech 6000 Tennis Shoes
55280,Oswald Altrichter,DE,Orion Club Gold members low activity,43,31-45 years,M,3,1231603838,15998,16004,1,,1,69,2202003,2202,22,220200300124,The Jet Men's Running Shoes
60452,John Apostol,US,Orion Club Gold members low activity,33,31-45 years,M,3,1231608221,15998,16002,1,,1,157.8,2202001,2202,22,220200100099,Big Guy Men's Air Tuned Sirocco Shoes
85113,Marco Aguado Sánchez,ES,Orion Club Gold members low activity,19,15-30 years,M,3,1231628002,16002,16003,1,,1,53.4,2102010,2102,21,210201000195,South Peak Children's Shoes C
85126,Paolo Bigarelli,IT,Orion Club Gold members low activity,48,46-60 years,M,2,1231678124,16011,16014,1,,1,196.5,2202001,2202,22,220200100052,Big Guy Men's Air Mickey 95 Running Shoes
77056,Pietropaolo Bizzaga,IT,Orion Club Gold members low activity,53,46-60 years,M,3,1231689440,16013,16018,1,,1,132.1,2202002,2202,22,220200200072,Twain Men's Expresso X-Hiking Shoes
75272,Tiziana Fuganti,IT,Orion Club Gold members low activity,53,46-60 years,F,2,1231722560,16019,16023,1,,2,241.4,2202001,2202,22,220200100098,Big Guy Men's Air Tuned Max Shoes
79331,Beatriz Rivero Ximenes,ES,Orion Club Gold members low activity,63,61-75 years,F,2,1231726911,16020,16031,1,,1,55.1,2201001,2201,22,220100100123,Big Guy Men's Dome Shorts Shoes
74659,Aldo Adriano,IT,Orion Club Gold members low activity,58,46-60 years,M,3,1231747284,16023,16025,1,,1,78.6,2202001,2202,22,220200100129,Big Guy Men's International Triax Shoes
75423,Anna Vangelisti,IT,Orion Club Gold members low activity,48,46-60 years,F,2,1231767997,16027,16043,2,,2,187.2,2201004,2201,22,220100400023,Ultra W802 All Terrain Women's Shoes
82647,Gianfranco Galvano,IT,Orion Club Gold members low activity,68,61-75 years,M,2,1231802128,16033,16038,2,,1,98.9,2201004,2201,22,220100400022,Ultra M803 Ng Men's Street Shoes
63769,Raj Horbury,GB,Orion Club Gold members low activity,23,15-30 years,M,3,1231807481,16034,16036,1,,2,180,2201007,2201,22,220100700016,Shoes Sphinx
85268,Ángeles Medel Carceles,ES,Orion Club Gold members low activity,53,46-60 years,F,2,1231818334,16036,16040,1,,1,72.5,2201004,2201,22,220100400019,Osprey Men's Streetcat Leather Street Shoes
74932,Ana Armiseng,ES,Orion Club Gold members low activity,73,61-75 years,F,2,1231872445,16046,16048,1,,2,226,2202002,2202,22,220200200045,Soft Gt 2040 Women's Running Shoes
84714,Jean Dutilleul,FR,Orion Club Gold members low activity,73,61-75 years,M,2,1231879302,16047,16051,1,,2,85.6,2102010,2102,21,210201000201,Suède Kid Allround Shoes
59820,Karl-Josef Beckerle,DE,Orion Club Gold members low activity,53,46-60 years,M,3,1231888734,16049,16050,1,,2,116.2,2202001,2202,22,220200100008,Atmosphere Deschutz Shoes
63058,Solomon Breault,US,Orion Club Gold members low activity,53,46-60 years,M,2,1231924828,16055,16056,1,,2,367.8,2202001,2202,22,220200100110,Big Guy Men's Air Zoom Italia F.G Shoes
91092,Luis Bengoa,ES,Orion Club Gold members low activity,48,46-60 years,M,3,1231926727,16056,16057,2,,2,271.6,2202002,2202,22,220200200047,Soft Gt 2050 Women's Running Shoes
76865,Jordi García Álvarez,ES,Orion Club Gold members low activity,58,46-60 years,M,2,1231938645,16058,16063,1,,2,157.2,2202001,2202,22,220200100129,Big Guy Men's International Triax Shoes
59706,Frank Fante,DE,Orion Club Gold members low activity,23,15-30 years,M,3,1231965506,16063,16069,1,,3,473.4,2202001,2202,22,220200100099,Big Guy Men's Air Tuned Sirocco Shoes
57406,William Mueller-Brady,US,Orion Club Gold members low activity,28,15-30 years,M,3,1232003067,16069,16071,1,,2,66.8,2202001,2202,22,220200100126,Big Guy Men's Gts Canvas Plus Shoes
91325,Marie-Helene Nicollet,FR,Orion Club Gold members low activity,58,46-60 years,F,2,1232006269,16070,16073,1,,4,62.8,2401001,2401,24,240100100434,Shoeshine Black
77884,Manfred Silingardi,IT,Orion Club Gold members low activity,48,46-60 years,M,2,1232068244,16079,16084,1,,2,118.2,2202001,2202,22,220200100042,Big Guy Men's Air Flyer Plus Shoes
62491,Martine Grisendi,FR,Orion Club Gold members low activity,23,15-30 years,F,3,1232090537,16083,16084,1,,1,47.1,2102010,2102,21,210201000196,South Peak Children's Training Shoes
61542,Oliver Wolter,DE,Orion Club Gold members low activity,38,31-45 years,M,3,1232103063,16085,16088,1,,1,37.2,2202002,2202,22,220200200043,Soft Gel Court Men's Indoor Shoes
74214,E.F. Koekkoek,NL,Orion Club Gold members low activity,53,46-60 years,F,3,1232118815,16087,16091,1,,1,183.2,2202002,2202,22,220200200055,Soft Kayano Women's Running Shoes
61197,Rainer Garbe,DE,Orion Club Gold members low activity,23,15-30 years,M,3,1232135878,16090,16094,1,,1,57.3,2202002,2202,22,220200200022,Pro Fit Gel Ds Trainer Women's Running Shoes
72194,Domenico Maurizio Ligasacchi,IT,Orion Club Gold members low activity,73,61-75 years,M,2,1232184525,16097,16099,2,,1,135.8,2202002,2202,22,220200200047,Soft Gt 2050 Women's Running Shoes
74630,Davyd Guzmán Lillo,ES,Orion Club Gold members low activity,43,31-45 years,M,2,1232189340,16098,16103,2,,2,199.2,2202003,2202,22,220200300117,South Peak Women's Light Indoor Shoes
76018,Melinda Vos,NL,Orion Club Gold members low activity,33,31-45 years,F,3,1232198411,16099,16101,2,,2,248.6,2202001,2202,22,220200100079,Big Guy Men's Air Structure Triax Shoes
91573,Murielle Zeeraerd,FR,Orion Club Gold members low activity,21,15-30 years,F,3,1232210337,16101,16104,2,,1,16.8,2102007,2102,21,210200700014,Slomo Children's Hop Shoes
78968,I.B. Naipal,NL,Orion Club Gold members low activity,38,31-45 years,F,3,1232245645,16106,16110,1,,1,64,2202002,2202,22,220200200021,Pro Fit  Gel Ds Trainer Iv Men's Running Shoe
65281,Tracy French,GB,Orion Club Gold members low activity,28,15-30 years,F,2,1232270764,16110,16113,1,,1,69.6,2201007,2201,22,220100700001,Classic Men's Leisure Shoes
81865,G.O. Buffing Re Ra,NL,Orion Club Gold members low activity,21,15-30 years,M,2,1232462394,16140,16141,1,,1,55,2202003,2202,22,220200300126,The Wish L Women's Running Shoes
63469,A.J. Van Twuijver,NL,Orion Club Gold members low activity,23,15-30 years,M,3,1232554405,16154,16155,1,,1,50.3,2202003,2202,22,220200300127,The Wish M Men's Running Shoes
90820,M.P. Alves,NL,Orion Club Gold members low activity,68,61-75 years,F,2,1232554671,16154,16158,1,,3,166.2,2202001,2202,22,220200100060,Big Guy Men's Air One Eighty  Shoes
86069,Antonio Dogliotti,IT,Orion Club Gold members low activity,48,46-60 years,M,2,1232561025,16155,16160,1,,1,135.8,2202002,2202,22,220200200047,Soft Gt 2050 Women's Running Shoes
56552,Manuel Martínez Blasco,ES,Orion Club Gold members low activity,28,15-30 years,M,2,1232585042,16159,16163,1,,1,61,2202001,2202,22,220200100101,Big Guy Men's Air Turbulence Shoes
61544,Heike Habicht,DE,Orion Club Gold members low activity,21,15-30 years,F,3,1232637761,16167,16169,1,,1,97.3,2202002,2202,22,220200200032,Soft 140 Men's Running Shoes
75412,Ma. Belén García López,ES,Orion Club Gold members low activity,33,31-45 years,F,2,1232652402,16169,16171,1,,4,345.6,2402001,2402,24,240200100053,Bretagne Stabilities Women's Golf Shoes
81865,G.O. Buffing Re Ra,NL,Orion Club Gold members low activity,21,15-30 years,M,2,1232662776,16170,16171,1,,1,33.4,2202001,2202,22,220200100126,Big Guy Men's Gts Canvas Plus Shoes
62690,Minnie Nam,GB,Orion Club Gold members low activity,38,31-45 years,F,2,1232701122,16176,16179,1,,1,91,2201004,2201,22,220100400018,Osprey Men's Street Cat Nubuck Street Shoes
87107,Elena Palomar,ES,Orion Club Gold members low activity,53,46-60 years,F,3,1232713998,16178,16180,2,,1,85.6,2201007,2201,22,220100700042,"Power Women's Dmx Wide, Walking Shoes"
58327,Gerd Grünebaum,DE,Orion Club Gold members low activity,48,46-60 years,M,2,1232785496,16189,16193,1,,1,99.6,2202003,2202,22,220200300117,South Peak Women's Light Indoor Shoes
84814,José Miguel Gracia Montes,ES,Orion Club Gold members low activity,53,46-60 years,M,2,1232786201,16189,16191,1,,1,55.1,2201007,2201,22,220100700039,"Power Men's Dmx Wide, Walking Shoes"
78877,M.A. Ter Laak,NL,Orion Club Gold members low activity,38,31-45 years,M,2,1232788585,16189,16193,3,,1,73.4,2202003,2202,22,220200300157,Hardcore Men's Street Shoes Large
89933,Consuelo Álvarez,ES,Orion Club Gold members low activity,33,31-45 years,F,2,1232799901,16191,16192,1,,3,213,2202003,2202,22,220200300082,Indoor Handbold Special Shoes
70994,C.J. Klaver,NL,Orion Club Gold members low activity,58,46-60 years,M,3,1232810276,16192,16194,1,,1,60.6,2202003,2202,22,220200300110,Qrs Men's Street Shoes
91693,P.J.M. Willemsens,NL,Orion Club Gold members low activity,53,46-60 years,M,3,1232810452,16192,16195,1,,1,55,2202003,2202,22,220200300126,The Wish L Women's Running Shoes
83374,Milena Caterino,IT,Orion Club Gold members low activity,58,46-60 years,F,2,1232828179,16195,16199,1,,1,91,2201004,2201,22,220100400018,Osprey Men's Street Cat Nubuck Street Shoes
73251,Virginia Arqués Antón,ES,Orion Club Gold members low activity,73,61-75 years,F,2,1232832807,16196,16198,1,,1,86.2,2202002,2202,22,220200200011,Cruise Platypus Men's Street Shoes
72172,Philippe Beaujot,FR,Orion Club Gold members low activity,68,61-75 years,M,2,1232840374,16197,16199,3,,1,2.9,2401001,2401,24,240100100430,Shoelace Black 100 Cm
63069,H.Th.A. Jooya,NL,Orion Club Gold members low activity,58,46-60 years,M,2,1232841923,16197,16198,1,,1,101,2202003,2202,22,220200300016,Men's Running Shoes Supernova
84928,Jacques Zubar,FR,Orion Club Gold members low activity,21,15-30 years,M,2,1232847170,16198,16200,2,,3,119.4,2102004,2102,21,210200400042,Toddle Children's Understudy(Bp) Shoes
82647,Gianfranco Galvano,IT,Orion Club Gold members low activity,68,61-75 years,M,2,1232951061,16213,16214,1,,1,100.4,2202001,2202,22,220200100072,Big Guy Men's Air Skylon Triax Shoes
81271,Delphine Richard,FR,Orion Club Gold members low activity,33,31-45 years,F,3,1232961078,16215,16216,2,,3,56.1,2401001,2401,24,240100100229,Cruise First Star Baby Shoes
64645,Susan Rietvelt,US,Orion Club Gold members low activity,43,31-45 years,F,2,1232992985,16219,16222,1,,1,86.6,2202001,2202,22,220200100066,Big Guy Men's Air Quest Shoes
81527,Marc Ruíz de Eguino,ES,Orion Club Gold members low activity,53,46-60 years,M,2,1233035560,16226,16229,1,,3,197.4,2202003,2202,22,220200300080,Hilo Mid Iii Women's Aerobic Shoes
64106,Frank Banks,US,Orion Club Gold members low activity,38,31-45 years,M,3,1233040363,16226,16228,2,,2,131.6,2202003,2202,22,220200300080,Hilo Mid Iii Women's Aerobic Shoes
75040,Joaquín García Pérez-Cuadrado,ES,Orion Club Gold members low activity,33,31-45 years,M,2,1233054432,16229,16231,2,,2,164.4,2202003,2202,22,220200300025,Mid Women's Aerobic Shoes X
75040,Joaquín García Pérez-Cuadrado,ES,Orion Club Gold members low activity,33,31-45 years,M,2,1233054432,16229,16231,1,,2,225.4,2202001,2202,22,220200100156,Big Guy Men'sAir Duration Shoes
62911,Annette Bahmüller,DE,Orion Club Gold members low activity,38,31-45 years,F,2,1233068300,16231,16232,1,,2,207.8,2202002,2202,22,220200200068,Twain Men's Exentric Ii X-Hiking Shoes
81157,Aurelio Pietropaoli,IT,Orion Club Gold members low activity,68,61-75 years,M,2,1233077592,16232,16234,1,,2,222.6,2202001,2202,22,220200100145,Big Guy Men's Structure Triax Shoes
74365,Francesco Gaetano Battegazzorre,IT,Orion Club Gold members low activity,53,46-60 years,M,3,1233138679,16241,16246,1,,6,675.6,2202002,2202,22,220200200041,Soft Ds Trainer Men's Running Shoes
70742,Peter Kuipers,NL,Orion Club Gold members low activity,53,46-60 years,M,2,1233139171,16241,16244,2,,2,168,2202002,2202,22,220200200067,Twain Inco Women's Street Shoes
70742,Peter Kuipers,NL,Orion Club Gold members low activity,53,46-60 years,M,2,1233139171,16241,16244,1,,2,132.8,2202002,2202,22,220200200018,Lulu Men's Street Shoes
61527,Sigifredo Knapp,US,Orion Club Gold members low activity,68,61-75 years,M,2,1233159258,16244,16248,2,,2,146.8,2202003,2202,22,220200300157,Hardcore Men's Street Shoes Large
85834,N.U. Van Gils,NL,Orion Club Gold members low activity,23,15-30 years,M,2,1233185983,16248,16253,1,,2,215,2202002,2202,22,220200200050,Soft Integral Men's Running Shoes
75449,Francesc Jevenois Acillona,ES,Orion Club Gold members low activity,43,31-45 years,M,3,1233194361,16250,16253,2,,2,168.4,2202003,2202,22,220200300116,South Peak Men's Running Shoes
75449,Francesc Jevenois Acillona,ES,Orion Club Gold members low activity,43,31-45 years,M,3,1233194361,16250,16253,1,,2,221.6,2202001,2202,22,220200100078,Big Guy Men's Air Stormy Skylon Shoes
73066,J.l. Durnad-Stocco,FR,Orion Club Gold members low activity,23,15-30 years,M,2,1233202235,16251,16253,2,,2,37.4,2401001,2401,24,240100100229,Cruise First Star Baby Shoes
59323,Werner Dörre,DE,Orion Club Gold members low activity,23,15-30 years,M,2,1233259941,16260,16263,1,,3,415.8,2202003,2202,22,220200300086,Mns Gazelle Men's Running Shoes
81157,Aurelio Pietropaoli,IT,Orion Club Gold members low activity,68,61-75 years,M,2,1233269964,16261,16263,2,,2,171.6,2202003,2202,22,220200300076,Hi Response Women's Aerobic Shoes Large
81157,Aurelio Pietropaoli,IT,Orion Club Gold members low activity,68,61-75 years,M,2,1233269964,16261,16263,1,,3,393,2202002,2202,22,220200200077,Twain Women's Exit Iii Mid Cd X-Hiking Shoes
76018,Melinda Vos,NL,Orion Club Gold members low activity,33,31-45 years,F,3,1233270445,16261,16263,1,,2,129.8,2202001,2202,22,220200100005,4men Men's Air Golden Shoes
65222,Sabine Stam,NL,Orion Club Gold members low activity,38,31-45 years,F,3,1233277815,16262,16265,1,,2,213,2202001,2202,22,220200100084,Big Guy Men's Air Tailwind Shoes
74051,Carlos Segarra Segarra,ES,Orion Club Gold members low activity,48,46-60 years,M,2,1233320317,16269,16270,1,,2,104,2202003,2202,22,220200300009,Men's Indoor Shoes Uproar
82647,Gianfranco Galvano,IT,Orion Club Gold members low activity,68,61-75 years,M,2,1233322581,16269,16270,1,,2,177.2,2202001,2202,22,220200100090,Big Guy Men's Air Terra Reach Shoes
88962,Ignacio Badiola Gómez,ES,Orion Club Gold members low activity,48,46-60 years,M,2,1233338812,16272,16275,1,,2,98.2,2102004,2102,21,210200400027,Toddle Children's Air Mantra (3) (Bg) Shoes
55519,Norbert Kast,DE,Orion Club Gold members low activity,53,46-60 years,M,2,1233379420,16278,16281,3,0.4,2,101.98,2202003,2202,22,220200300164,Traverse Shoes
55519,Norbert Kast,DE,Orion Club Gold members low activity,53,46-60 years,M,2,1233379420,16278,16281,2,,2,340,2202001,2202,22,220200100165,Sire Air Max-Running Shoes
55519,Norbert Kast,DE,Orion Club Gold members low activity,53,46-60 years,M,2,1233379420,16278,16281,1,,2,218.6,2202001,2202,22,220200100033,Big Guy Men's Air Croos Trainer Iii Shoes
62713,Jürgen Fehren-Rohling,DE,Orion Club Gold members low activity,23,15-30 years,M,2,1233379568,16278,16282,1,,2,198,2202001,2202,22,220200100077,Big Guy Men's Air Span Triax Shoes
85822,F.C.A.J. Smits Aag,NL,Orion Club Gold members low activity,33,31-45 years,M,3,1233382749,16278,16281,1,,2,152.2,2202003,2202,22,220200300154,Hardcore Junior/Women's Street Shoes Large
55241,Alberto Tiburtini,IT,Orion Club Gold members low activity,48,46-60 years,M,3,1233388428,16279,16284,1,,2,132.8,2202002,2202,22,220200200018,Lulu Men's Street Shoes
89720,María Clastre,ES,Orion Club Gold members low activity,33,31-45 years,F,2,1233406977,16282,16284,2,,2,118,2202002,2202,22,220200200009,Cruise 1984 Men's Street Shoes
62735,Christelle Meyer,FR,Orion Club Gold members low activity,23,15-30 years,F,2,1233473460,16292,16296,1,,2,67.6,2102010,2102,21,210201000167,Children's Shoes Stratosphere
92560,Christine Schmidt,FR,Orion Club Gold members low activity,63,61-75 years,F,2,1233495065,16295,16296,1,,3,159.6,2102004,2102,21,210200400019,Kiddy.turbo Premier F.G Children's Shoes
88729,Aldivano Berti,IT,Orion Club Gold members low activity,53,46-60 years,M,2,1233511331,16297,16300,2,,2,220.6,2202003,2202,22,220200300142,Vishnu Women's Running Shoes
81271,Delphine Richard,FR,Orion Club Gold members low activity,33,31-45 years,F,3,1233515737,16298,16299,2,,2,65.2,2102010,2102,21,210201000168,Children's Shoes Wilcox
88729,Aldivano Berti,IT,Orion Club Gold members low activity,53,46-60 years,M,2,1233529498,16300,16303,1,,3,393,2202002,2202,22,220200200077,Twain Women's Exit Iii Mid Cd X-Hiking Shoes
63069,H.Th.A. Jooya,NL,Orion Club Gold members low activity,58,46-60 years,M,2,1233529738,16300,16301,1,,3,300.3,2202002,2202,22,220200200071,Twain Men's Exit Low 2000 Street Shoes
86048,Massimo Fugazzotto,IT,Orion Club Gold members low activity,48,46-60 years,M,2,1233536303,16301,16304,2,,2,65.6,2202001,2202,22,220200100123,Big Guy Men's Deschutz Slide Shoes
86048,Massimo Fugazzotto,IT,Orion Club Gold members low activity,48,46-60 years,M,2,1233536303,16301,16304,1,,2,145.4,2202001,2202,22,220200100070,Big Guy Men's Air Reckoning Ii-Tennis Shoes
60187,Stephan Lückert,DE,Orion Club Gold members low activity,58,46-60 years,M,2,1233547344,16303,16306,3,,2,124.4,2202003,2202,22,220200300007,Low Women's Aerobic Shoes
60187,Stephan Lückert,DE,Orion Club Gold members low activity,58,46-60 years,M,2,1233547344,16303,16306,2,,2,213.2,2202001,2202,22,220200100038,Big Guy Men's Air Exploraid Shoes
60187,Stephan Lückert,DE,Orion Club Gold members low activity,58,46-60 years,M,2,1233547344,16303,16306,1,,2,355.6,2202001,2202,22,220200100010,Atmosphere Mickey Shoes
63878,Andreas Diemler,DE,Orion Club Gold members low activity,58,46-60 years,M,3,1233555224,16304,16308,1,,2,113.8,2202001,2202,22,220200100128,Big Guy Men's Hermosa Shoes
59102,Ines Donleavy,GB,Orion Club Gold members low activity,68,61-75 years,F,2,1233557586,16304,16308,1,,2,187.2,2201007,2201,22,220100700016,Shoes Sphinx
58530,Franz Sharifi,DE,Orion Club Gold members low activity,21,15-30 years,M,2,1233573670,16307,16309,1,,2,126.8,2202001,2202,22,220200100009,Atmosphere Imara Women's Running Shoes
78988,Rosa Gil,ES,Orion Club Gold members low activity,63,61-75 years,F,2,1233594978,16310,16314,2,,3,192,2202002,2202,22,220200200021,Pro Fit  Gel Ds Trainer Iv Men's Running Shoe
91507,Fernando Morras Ruiz-Falco,ES,Orion Club Gold members low activity,21,15-30 years,M,3,1233595127,16310,16315,1,,2,151.2,2202001,2202,22,220200100061,Big Guy Men's Air Orchestrate Shoes
84523,Luciana Zotti,IT,Orion Club Gold members low activity,73,61-75 years,F,2,1233742793,16332,16335,1,,1,114.1,2201007,2201,22,220100700003,Dmx 6 Shoes
85764,Juani Molina Niño,ES,Orion Club Gold members low activity,43,31-45 years,F,2,1233759240,16335,16340,1,,2,121.2,2202003,2202,22,220200300110,Qrs Men's Street Shoes
90718,Danilo Zamponi,IT,Orion Club Gold members low activity,63,61-75 years,M,2,1233774685,16337,16339,1,,2,156.6,2202003,2202,22,220200300106,Multi Women's Running Shoes
63734,José Crespo,ES,Orion Club Gold members low activity,53,46-60 years,M,3,1233786801,16339,16345,1,,1,106.5,2202001,2202,22,220200100084,Big Guy Men's Air Tailwind Shoes
76584,Veronique Bocini,FR,Orion Club Gold members low activity,19,15-30 years,F,2,1233805693,16342,16345,1,,2,73.4,2102010,2102,21,210201000183,Kola Children's Shoes
84814,José Miguel Gracia Montes,ES,Orion Club Gold members low activity,53,46-60 years,M,2,1233818642,16344,16346,1,,1,37.5,2102006,2102,21,210200600015,Hardcore Kids Street Shoes
70975,Philippe Brumn,FR,Orion Club Gold members low activity,33,31-45 years,M,3,1233858596,16350,16358,2,,1,37.1,2102004,2102,21,210200400041,Toddle Children's Understudy(Bg) Shoes
64703,Margrit Hafemeister,DE,Orion Club Gold members low activity,58,46-60 years,F,3,1233870567,16352,16354,1,,1,54.8,2202003,2202,22,220200300077,Hilly Men's Crosstrainer Shoes
85634,Maria Luce Mazzantini,IT,Orion Club Gold members low activity,63,61-75 years,F,2,1233873609,16352,16357,1,,1,64,2202002,2202,22,220200200021,Pro Fit  Gel Ds Trainer Iv Men's Running Shoe
91266,G.J. Hooft,NL,Orion Club Gold members low activity,58,46-60 years,M,3,1233959813,16365,16366,1,,1,97.3,2202002,2202,22,220200200032,Soft 140 Men's Running Shoes
81295,Christine Berlie,FR,Orion Club Gold members low activity,33,31-45 years,M,3,1234072165,16382,16386,1,,1,36.8,2102006,2102,21,210200600064,Children's Canvas Shoes
81970,Bertrand Delivre,FR,Orion Club Gold members low activity,19,15-30 years,M,2,1234083961,16384,16385,1,,1,10.1,2102007,2102,21,210200700013,Slomo Balance Children's Shoes
80390,Ondina Ziccardi,IT,Orion Club Gold members low activity,68,61-75 years,F,2,1234131256,16391,16394,2,,1,53.7,2201007,2201,22,220100700022,Alexis Women's Classic Shoes
86797,Jean-Luc Burret,FR,Orion Club Gold members low activity,33,31-45 years,M,2,1234204516,16402,16406,3,,1,32.6,2102010,2102,21,210201000168,Children's Shoes Wilcox
86797,Jean-Luc Burret,FR,Orion Club Gold members low activity,33,31-45 years,M,2,1234204516,16402,16406,2,,1,10.1,2102007,2102,21,210200700013,Slomo Balance Children's Shoes
84567,Xavier de Velasco,ES,Orion Club Gold members low activity,43,31-45 years,M,2,1234215143,16404,16407,3,,1,10.1,2102007,2102,21,210200700013,Slomo Balance Children's Shoes
72040,N.A.E. Verbeek,NL,Orion Club Gold members low activity,53,46-60 years,F,2,1234232436,16406,16411,1,,2,213,2202001,2202,22,220200100084,Big Guy Men's Air Tailwind Shoes
78280,Luigi Menchi,IT,Orion Club Gold members low activity,48,46-60 years,M,3,1234265815,16411,16412,2,,2,150.4,2202003,2202,22,220200300120,Starlite Men's Street Shoes
83399,Rodolf Zabildea Álvarez,ES,Orion Club Gold members low activity,38,31-45 years,M,3,1234298184,16416,16420,1,,2,118.2,2202001,2202,22,220200100042,Big Guy Men's Air Flyer Plus Shoes
82591,Patrizia Davoli,IT,Orion Club Gold members low activity,58,46-60 years,F,3,1234300674,16416,16418,1,,2,243,2202002,2202,22,220200200070,Twain Men's Exit Iii Mid Cd X-Hiking Shoes
70994,C.J. Klaver,NL,Orion Club Gold members low activity,58,46-60 years,M,3,1234319854,16419,16421,2,,2,165.6,2202003,2202,22,220200300164,Traverse Shoes
76416,Albino Marinelli,IT,Orion Club Gold members low activity,68,61-75 years,M,2,1234387376,16429,16433,2,,2,121.2,2202003,2202,22,220200300110,Qrs Men's Street Shoes
78525,G.J.l. Van Dulken,NL,Orion Club Gold members low activity,38,31-45 years,M,2,1234406642,16432,16434,1,,2,81.6,2202001,2202,22,220200100161,Eclipse Women's Off Court Canvas Shoes
74563,R.J.F. Slager,NL,Orion Club Gold members low activity,33,31-45 years,M,3,1234412672,16433,16438,1,,2,125.2,2202001,2202,22,220200100035,Big Guy Men's Air Deschutz Viii Shoes
83374,Milena Caterino,IT,Orion Club Gold members low activity,58,46-60 years,F,2,1234430586,16436,16440,1,,4,486,2202002,2202,22,220200200070,Twain Men's Exit Iii Mid Cd X-Hiking Shoes
65184,Martín Maján,ES,Orion Club Gold members low activity,43,31-45 years,M,3,1234590206,16453,16454,1,,1,2.9,2401001,2401,24,240100100430,Shoelace Black 100 Cm
73074,Carmen Romeo Martínez,ES,Orion Club Gold members low activity,73,61-75 years,F,2,1234661162,16460,16464,1,,1,55.1,2201007,2201,22,220100700039,"Power Men's Dmx Wide, Walking Shoes"
76028,I.C. Hooft,NL,Orion Club Gold members low activity,33,31-45 years,F,2,1234685313,16462,16466,1,,1,112.7,2202001,2202,22,220200100156,Big Guy Men'sAir Duration Shoes
77682,J.A.A. Klein,NL,Orion Club Gold members low activity,53,46-60 years,M,3,1234718161,16465,16471,1,,2,104,2202003,2202,22,220200300009,Men's Indoor Shoes Uproar
65708,Darrin Zafft,US,Orion Club Gold members low activity,21,15-30 years,M,3,1234808924,16474,16477,1,,2,208.6,2202001,2202,22,220200100029,Big Guy Men's Air Baltoro Shoes
80336,N.U. Govers,NL,Orion Club Gold members low activity,33,31-45 years,M,3,1234867059,16480,16485,1,,1,84.2,2202003,2202,22,220200300014,Men's Running Shoes Ozweego
64842,Fillmer Cannady,US,Orion Club Gold members low activity,33,31-45 years,M,3,1234941044,16487,16488,1,,1,36.7,2102010,2102,21,210201000183,Kola Children's Shoes
62738,Yewoinshet Parham,US,Orion Club Gold members low activity,28,15-30 years,F,2,1234992199,16492,16493,1,,1,75.6,2202001,2202,22,220200100061,Big Guy Men's Air Orchestrate Shoes
71624,Cono Lonardoni,IT,Orion Club Gold members low activity,53,46-60 years,M,3,1235079371,16500,16503,1,,1,87.3,2202002,2202,22,220200200067,Twain Inco Women's Street Shoes
60385,Fernando Connold,ES,Orion Club Gold members low activity,43,31-45 years,M,2,1235085633,16501,16502,1,,3,298.5,2202003,2202,22,220200300017,Men's Shoes Solace
70715,Renzo Fraire,IT,Orion Club Gold members low activity,73,61-75 years,M,2,1235089036,16501,16506,2,,1,135.8,2202002,2202,22,220200200047,Soft Gt 2050 Women's Running Shoes
62000,Binh Hamilton,US,Orion Club Gold members low activity,58,46-60 years,M,3,1235165299,16508,16511,1,,2,133,2202002,2202,22,220200200002,Men's Nubuck-Retro Running Shoes Roadster
81105,C.M. Van Den Berk,NL,Orion Club Gold members low activity,21,15-30 years,F,3,1235194220,16511,16512,1,,1,109.4,2202003,2202,22,220200300069,Hgf Incentive Men's Tennis Shoes
82184,Anita Kootstra,NL,Orion Club Gold members low activity,33,31-45 years,F,2,1235194254,16511,16516,1,,1,157.8,2202001,2202,22,220200100099,Big Guy Men's Air Tuned Sirocco Shoes
61761,Robert Schönewolf,DE,Orion Club Gold members low activity,23,15-30 years,M,2,1235259564,16518,16522,1,,1,121.3,2202001,2202,22,220200100051,Big Guy Men's Air Masai Shoes
83374,Milena Caterino,IT,Orion Club Gold members low activity,58,46-60 years,F,3,1235264024,16518,16520,1,,1,57.6,2201007,2201,22,220100700010,Men's Running Shoes Burn
57372,Julie Chohan,GB,Orion Club Gold members low activity,28,15-30 years,F,2,1235284358,16520,16521,1,,1,93,2201007,2201,22,220100700023,Armadillo Road Dmx Men's Running Shoes
89882,Jean-Michel Vigneron,FR,Orion Club Gold members low activity,23,15-30 years,M,2,1235343230,16526,16528,1,,1,33.8,2102010,2102,21,210201000167,Children's Shoes Stratosphere
85330,M.H. Kromokario,NL,Orion Club Gold members low activity,63,61-75 years,M,2,1235374036,16529,16532,1,,1,38.2,2202002,2202,22,220200200038,Soft Court Women's Indoor Shoes
90402,Jesús Magro Cuadrado,ES,Orion Club Gold members low activity,28,15-30 years,M,2,1235391222,16531,16534,1,,4,482.8,2202001,2202,22,220200100098,Big Guy Men's Air Tuned Max Shoes
90311,Fernando Cotín Montero,ES,Orion Club Gold members low activity,68,61-75 years,M,2,1235441445,16536,16540,1,,1,104.6,2201007,2201,22,220100700024,Armadillo Road Dmx Women's Running Shoes
63069,H.Th.A. Jooya,NL,Orion Club Gold members low activity,58,46-60 years,M,2,1235465233,16538,16540,1,,1,104.7,2202003,2202,22,220200300062,Damaskus Women's Running Shoes
89102,J.l. Castelijns,NL,Orion Club Gold members low activity,68,61-75 years,F,2,1235476024,16539,16543,2,,3,224.7,2202003,2202,22,220200300155,Hardcore Men's Street Shoes
89102,J.l. Castelijns,NL,Orion Club Gold members low activity,68,61-75 years,F,2,1235476024,16539,16543,1,,1,120.7,2202001,2202,22,220200100098,Big Guy Men's Air Tuned Max Shoes
74948,Dr. J.B.M.M. de Heus,NL,Orion Club Gold members low activity,58,46-60 years,M,2,1235499044,16541,16545,1,,1,87.7,2202001,2202,22,220200100091,Big Guy Men's Air Terra Rise Shoes
91206,Eva Isabel Ariño Andreu,ES,Orion Club Gold members low activity,28,15-30 years,F,3,1235574859,16549,16555,1,,3,187.8,2202001,2202,22,220200100035,Big Guy Men's Air Deschutz Viii Shoes
89359,Francisco García de Polavieja,ES,Orion Club Gold members low activity,73,61-75 years,M,2,1235583559,16550,16553,1,,1,81.2,2202003,2202,22,220200300129,Torino Men's Leather Adventure Shoes
85884,Francois Blanchard,FR,Orion Club Gold members low activity,68,61-75 years,M,2,1235594509,16551,16553,1,,1,33.4,2102004,2102,21,210200400012,Kid Trainer Lite V(Bp) Street Shoes
59743,A.S. Braams,NL,Orion Club Gold members low activity,38,31-45 years,F,2,1235596874,16551,16555,2,,3,184.8,2202003,2202,22,220200300018,Men's Shoes Tegern
72333,María Milagros Morales,ES,Orion Club Gold members low activity,43,31-45 years,F,2,1235603166,16552,16554,1,,1,59,2202002,2202,22,220200200009,Cruise 1984 Men's Street Shoes
57678,Inga Kolk,DE,Orion Club Gold members low activity,38,31-45 years,F,2,1235623891,16554,16559,1,,1,133.3,2202003,2202,22,220200300098,Mns.riding Women's Running Shoes
88034,Chantal Karcher,FR,Orion Club Gold members low activity,58,46-60 years,F,2,1235637162,16555,16556,1,,2,73.4,2102010,2102,21,210201000183,Kola Children's Shoes
85296,I.H. Dullaert,NL,Orion Club Gold members low activity,58,46-60 years,F,2,1235658497,16557,16560,2,,1,125.8,2202001,2202,22,220200100057,Big Guy Men's Air Mickey Willy Shoes
65787,Sanjeev Conibear,GB,Orion Club Gold members low activity,23,15-30 years,M,2,1235667218,16558,16559,2,,1,84.9,2201007,2201,22,220100700026,Del Sol Women's  Aerobic Shoes
72666,Beatriz Centeno Silva,ES,Orion Club Gold members low activity,33,31-45 years,F,2,1235674820,16559,16564,1,,1,36.7,2102010,2102,21,210201000183,Kola Children's Shoes
78841,Christine Dorion,FR,Orion Club Gold members low activity,48,46-60 years,F,3,1235685778,16560,16566,1,,3,110.4,2102004,2102,21,210200400039,Toddle Children's Quokka V (Bp) Shoes
71719,Serena Pazzagli,IT,Orion Club Gold members low activity,53,46-60 years,F,3,1235687727,16560,16566,1,,3,589.5,2202001,2202,22,220200100052,Big Guy Men's Air Mickey 95 Running Shoes
78701,Marc Beaufrere,FR,Orion Club Gold members low activity,63,61-75 years,M,2,1235707501,16562,16566,1,,3,100.2,2102004,2102,21,210200400012,Kid Trainer Lite V(Bp) Street Shoes
86524,Maria Clelia Whincup,IT,Orion Club Gold members low activity,48,46-60 years,F,2,1235770225,16568,16570,1,,3,341.1,2202001,2202,22,220200100087,Big Guy Men's Air Terra Clay-Tennis Shoes
70994,C.J. Klaver,NL,Orion Club Gold members low activity,58,46-60 years,M,3,1235789664,16570,16573,1,,3,362.1,2202001,2202,22,220200100098,Big Guy Men's Air Tuned Max Shoes
89668,Guy Wargon,FR,Orion Club Gold members low activity,58,46-60 years,M,3,1235796632,16571,16573,2,,1,56.7,2102010,2102,21,210201000166,Children's Shoes Pleva
87586,Mimma Bellina,IT,Orion Club Gold members low activity,48,46-60 years,F,3,1235840535,16575,16580,2,,1,127.3,2202002,2202,22,220200200042,Soft Ds Trainer Women's Running Shoes
87586,Mimma Bellina,IT,Orion Club Gold members low activity,48,46-60 years,F,3,1235840535,16575,16580,1,,1,157.8,2202001,2202,22,220200100099,Big Guy Men's Air Tuned Sirocco Shoes
75778,J.J. Hiemstra,NL,Orion Club Gold members low activity,33,31-45 years,F,3,1235902664,16581,16582,1,,1,57.3,2202001,2202,22,220200100139,Big Guy Men's Payoff Trainer Shoes
89333,Victoria Vidaechea Montes,ES,Orion Club Gold members low activity,21,15-30 years,F,2,1235921442,16583,16588,1,,1,109.3,2201007,2201,22,220100700009,Mc Shoes
74920,Riccardo Piazzola,IT,Orion Club Gold members low activity,48,46-60 years,M,2,1236013386,16592,16596,1,,3,199.2,2202002,2202,22,220200200018,Lulu Men's Street Shoes
64343,Eugenio Velázquez Álvarez,ES,Orion Club Gold members low activity,58,46-60 years,M,3,1236100073,16601,16623,2,,2,77.2,2102006,2102,21,210200600015,Hardcore Kids Street Shoes
56186,Dionysos Kirby,US,Orion Club Gold members low activity,28,15-30 years,M,3,1236156073,16606,16612,1,,2,80.4,2102006,2102,21,210200600048,Big Kid Children's Shoes
72098,H.J. Von Bannisseht,NL,Orion Club Gold members low activity,63,61-75 years,M,2,1236162987,16607,16611,1,,2,132.8,2202002,2202,22,220200200018,Lulu Men's Street Shoes
74224,R.E.M. Van Zoeren,NL,Orion Club Gold members low activity,68,61-75 years,F,2,1236243878,16615,16620,1,,2,166,2202001,2202,22,220200100092,Big Guy Men's Air Terra Sebec Shoes
87583,R.H.H. Van Vliet,NL,Orion Club Gold members low activity,21,15-30 years,M,3,1236283903,16619,16625,1,,2,120.4,2202002,2202,22,220200200036,Soft Astro Men's Running Shoes
58327,Gerd Grünebaum,DE,Orion Club Gold members low activity,48,46-60 years,M,2,1236299449,16621,16623,1,,2,96.4,2202001,2202,22,220200100153,Big Guy Men's Understudy Cross Train. Shoes
91766,Angelo Grigatti,IT,Orion Club Gold members low activity,63,61-75 years,M,2,1236303820,16621,16625,1,,2,210.4,2201007,2201,22,220100700038,Power Dmx Wide Shoes
60854,John Dave,GB,Orion Club Gold members low activity,73,61-75 years,M,2,1236312969,16622,16626,1,,3,110.1,2102010,2102,21,210201000183,Kola Children's Shoes
75714,Simona Bonfa',IT,Orion Club Gold members low activity,53,46-60 years,F,3,1236348061,16625,16638,1,,2,134,2202001,2202,22,220200100026,Big Guy Men's Air Align Shoes
62984,Gianpaola Pontecorvi,IT,Orion Club Gold members low activity,48,46-60 years,F,2,1236396131,16630,16631,1,,2,218.2,2201007,2201,22,220100700020,Women's Trainer Aerobic Shoes
88432,A.A. Kylstra,NL,Orion Club Gold members low activity,68,61-75 years,M,2,1236397349,16630,16635,1,,3,321,2202002,2202,22,220200200068,Twain Men's Exentric Ii X-Hiking Shoes
77637,José Meije Cerdeira,ES,Orion Club Gold members low activity,19,15-30 years,M,2,1236403851,16631,16636,1,,2,200.8,2202001,2202,22,220200100072,Big Guy Men's Air Skylon Triax Shoes
63329,Giovanni Pittore,IT,Orion Club Gold members low activity,53,46-60 years,M,2,1236407043,16631,16635,2,,3,234,2201004,2201,22,220100400013,Cross Nubuck Women's Street Shoes
75187,Christopher Guenot,FR,Orion Club Gold members low activity,28,15-30 years,F,2,1236433961,16634,16639,1,,2,82.4,2102004,2102,21,210200400018,Kiddy.summit  90 F.G.Rbr (Bg) Children's Shoe
60179,Didier Nickson,GB,Orion Club Gold members low activity,53,46-60 years,M,2,1236434918,16634,16637,1,,2,264.6,2201007,2201,22,220100700028,H Ignitor Women's Aerobic Shoes
78011,Juan José Cabeza Luque,ES,Orion Club Gold members low activity,21,15-30 years,M,3,1236463664,16637,16639,2,,3,322.5,2202002,2202,22,220200200050,Soft Integral Men's Running Shoes
78011,Juan José Cabeza Luque,ES,Orion Club Gold members low activity,21,15-30 years,M,3,1236463664,16637,16639,1,,3,362.1,2202001,2202,22,220200100098,Big Guy Men's Air Tuned Max Shoes
81179,Guy Jallerat,FR,Orion Club Gold members low activity,53,46-60 years,M,2,1236487322,16639,16641,1,,3,97.8,2102010,2102,21,210201000168,Children's Shoes Wilcox
76013,Emilia Ghetti,IT,Orion Club Gold members low activity,73,61-75 years,M,2,1236517631,16642,16643,1,,2,239.6,2201007,2201,22,220100700003,Dmx 6 Shoes
76458,Esther de Bie,NL,Orion Club Gold members low activity,23,15-30 years,F,3,1236518404,16642,16646,1,,2,96.4,2202001,2202,22,220200100153,Big Guy Men's Understudy Cross Train. Shoes
87504,Marine de Backer,FR,Orion Club Gold members low activity,28,15-30 years,F,2,1236536005,16644,16645,1,,3,162.6,2102010,2102,21,210201000209,Universe 4 Children's Running Shoes
78877,M.A. Ter Laak,NL,Orion Club Gold members low activity,38,31-45 years,M,3,1236538619,16644,16647,1,,2,133,2202001,2202,22,220200100063,Big Guy Men's Air Perish Nb Shoes
63716,Rudolf Cordes,DE,Orion Club Gold members low activity,43,31-45 years,M,2,1236572700,16648,16653,1,,3,213,2202003,2202,22,220200300082,Indoor Handbold Special Shoes
77056,Pietropaolo Bizzaga,IT,Orion Club Gold members low activity,53,46-60 years,M,3,1236596682,16650,16653,1,,3,192,2202002,2202,22,220200200021,Pro Fit  Gel Ds Trainer Iv Men's Running Shoe
91739,A.G. Stam,NL,Orion Club Gold members low activity,53,46-60 years,M,3,1236618846,16652,16657,2,,2,104,2202003,2202,22,220200300009,Men's Indoor Shoes Uproar
83399,Rodolf Zabildea Álvarez,ES,Orion Club Gold members low activity,38,31-45 years,M,3,1236634895,16654,16659,3,,3,224.7,2202003,2202,22,220200300155,Hardcore Men's Street Shoes
72861,Jean-Pierre Guibert,FR,Orion Club Gold members low activity,21,15-30 years,M,2,1236645627,16655,16658,1,,2,83.2,2102004,2102,21,210200400070,Tony's Children's Deschutz (Bg) Shoes
87882,Sylvie Atlan,FR,Orion Club Gold members low activity,21,15-30 years,F,3,1236677008,16658,16661,1,,3,122.1,2102004,2102,21,210200400032,Toddle Children's Align(Bp) Shoes
77276,Giovanni Giuliodori,IT,Orion Club Gold members low activity,48,46-60 years,M,2,1236700669,16660,16663,1,,2,174.6,2202002,2202,22,220200200067,Twain Inco Women's Street Shoes
72252,H.l.M. Putman,NL,Orion Club Gold members low activity,53,46-60 years,M,3,1236701493,16660,16664,1,,2,166,2202001,2202,22,220200100092,Big Guy Men's Air Terra Sebec Shoes
86053,I.F. Sieverdink,NL,Orion Club Gold members low activity,23,15-30 years,F,3,1236701795,16660,16664,1,,2,186.8,2202003,2202,22,220200300158,Hardcore Shoes
83744,Daniele Muzzani,IT,Orion Club Gold members low activity,53,46-60 years,M,3,1236788928,16669,16674,1,,3,362.1,2202001,2202,22,220200100098,Big Guy Men's Air Tuned Max Shoes
81560,José Luis Sanmartín Heras,ES,Orion Club Gold members low activity,28,15-30 years,M,3,1236826794,16673,16678,1,,3,551.7,2202001,2202,22,220200100110,Big Guy Men's Air Zoom Italia F.G Shoes
78402,Ronan Huyart,FR,Orion Club Gold members low activity,19,15-30 years,M,3,1236855874,16676,16680,1,,2,20.2,2102007,2102,21,210200700013,Slomo Balance Children's Shoes
64020,Hollie Paul,US,Orion Club Gold members low activity,28,15-30 years,F,2,1236862107,16676,16681,2,,2,117.2,2202003,2202,22,220200300051,Armadillo Men's Running Shoes
64020,Hollie Paul,US,Orion Club Gold members low activity,28,15-30 years,F,2,1236862107,16676,16681,1,,2,226,2202002,2202,22,220200200045,Soft Gt 2040 Women's Running Shoes
88432,A.A. Kylstra,NL,Orion Club Gold members low activity,68,61-75 years,M,2,1237002021,16690,16692,1,,1,99.6,2202003,2202,22,220200300117,South Peak Women's Light Indoor Shoes
63672,Steven Hancock,GB,Orion Club Gold members low activity,19,15-30 years,F,3,1237042595,16694,16696,1,,2,186,2201007,2201,22,220100700023,Armadillo Road Dmx Men's Running Shoes
75668,Florence Lourme,FR,Orion Club Gold members low activity,58,46-60 years,F,2,1237222490,16712,16716,1,,1,39.8,2102004,2102,21,210200400042,Toddle Children's Understudy(Bp) Shoes
74313,H.C. Knueppel,NL,Orion Club Gold members low activity,53,46-60 years,F,2,1237235523,16713,16718,1,,1,120.7,2202001,2202,22,220200100098,Big Guy Men's Air Tuned Max Shoes
61138,Silvia Cinoffo,IT,Orion Club Gold members low activity,68,61-75 years,F,2,1237244780,16714,16716,1,,1,55.8,2201007,2201,22,220100700022,Alexis Women's Classic Shoes
83339,M P Willemsen,NL,Orion Club Gold members low activity,58,46-60 years,F,3,1237376745,16727,16728,1,,1,180.7,2202001,2202,22,220200100116,Big Guy Men's Air Zoom Total 90 F.G Shoes
55425,Cora Olague,US,Orion Club Gold members low activity,68,61-75 years,F,2,1237449425,16734,16739,1,,1,83,2202001,2202,22,220200100092,Big Guy Men's Air Terra Sebec Shoes
65760,Kashi Williams,US,Orion Club Gold members low activity,21,15-30 years,F,3,1237460294,16735,16743,1,,1,58.1,2202001,2202,22,220200100008,Atmosphere Deschutz Shoes
75778,J.J. Hiemstra,NL,Orion Club Gold members low activity,33,31-45 years,F,3,1237507166,16740,16741,1,,1,67,2202001,2202,22,220200100026,Big Guy Men's Air Align Shoes
72896,Carmelo Soler,IT,Orion Club Gold members low activity,68,61-75 years,M,2,1237577451,16747,16749,1,,1,68.6,2202001,2202,22,220200100121,Big Guy Men's Cortez Leather Street Shoes
74278,C.H.M. Klomberg,NL,Orion Club Gold members low activity,53,46-60 years,M,3,1237681021,16757,16759,1,,1,107,2202002,2202,22,220200200068,Twain Men's Exentric Ii X-Hiking Shoes
87035,Belén Borreguero,ES,Orion Club Gold members low activity,48,46-60 years,F,2,1237757931,16765,16767,1,,1,65.7,2202001,2202,22,220200100120,Big Guy Men's Cortez Iii Leather Shoes
75670,Jean-Rene Lhermite,FR,Orion Club Gold members low activity,73,61-75 years,M,2,1237758932,16765,16769,2,,1,24.9,2102010,2102,21,210201000169,Children's Street Shoes
74054,Pascal Bildet,FR,Orion Club Gold members low activity,19,15-30 years,M,3,1237806741,16770,16772,1,,1,3,2401001,2401,24,240100100433,Shoelace White 150 Cm
70454,Michel Potus,FR,Orion Club Gold members low activity,38,31-45 years,M,2,1237828517,16772,16774,1,,2,9.2,2401001,2401,24,240100100429,"Shoelace 140 Cm, Assorted Colours"
88432,A.A. Kylstra,NL,Orion Club Gold members low activity,68,61-75 years,M,2,1237901780,16779,16781,2,,2,271.6,2202002,2202,22,220200200047,Soft Gt 2050 Women's Running Shoes
59389,Francisco García Novoa,ES,Orion Club Gold members low activity,43,31-45 years,M,3,1237933883,16783,16784,1,,2,126.8,2202001,2202,22,220200100009,Atmosphere Imara Women's Running Shoes
59743,A.S. Braams,NL,Orion Club Gold members low activity,38,31-45 years,F,2,1237948135,16784,16788,1,,2,241.4,2202001,2202,22,220200100098,Big Guy Men's Air Tuned Max Shoes
65789,Annabelle Linford,GB,Orion Club Gold members low activity,73,61-75 years,F,2,1237969650,16786,16788,1,,2,343.6,2201007,2201,22,220100700005,Dmx Lite Women's Aerobic Shoes
76412,Alain Baudiment,FR,Orion Club Gold members low activity,58,46-60 years,M,2,1237996565,16789,16791,2,,2,67.8,2102010,2102,21,210201000205,Torino 2000 K Street Shoes
74224,R.E.M. Van Zoeren,NL,Orion Club Gold members low activity,68,61-75 years,F,2,1238009522,16790,16795,2,,3,150.9,2202001,2202,22,220200100137,Big Guy Men's Multicourt Ii Shoes
74224,R.E.M. Van Zoeren,NL,Orion Club Gold members low activity,68,61-75 years,F,2,1238009522,16790,16795,1,,2,137.2,2202001,2202,22,220200100014,Atmosphere Terra Grande Shoes
86717,María Paz Altaba,ES,Orion Club Gold members low activity,48,46-60 years,F,2,1238016075,16791,16794,2,,2,216.4,2202002,2202,22,220200200069,Twain Men's Exit Ii Low X-Hiking Shoes
86717,María Paz Altaba,ES,Orion Club Gold members low activity,48,46-60 years,F,2,1238016075,16791,16794,1,,2,391.4,2202002,2202,22,220200200054,Soft Kayano Men's Running Shoes
91766,Angelo Grigatti,IT,Orion Club Gold members low activity,63,61-75 years,M,2,1238078875,16797,16801,2,,2,122,2202001,2202,22,220200100101,Big Guy Men's Air Turbulence Shoes
91766,Angelo Grigatti,IT,Orion Club Gold members low activity,63,61-75 years,M,2,1238078875,16797,16801,1,,3,473.4,2202001,2202,22,220200100099,Big Guy Men's Air Tuned Sirocco Shoes
78525,G.J.l. Van Dulken,NL,Orion Club Gold members low activity,38,31-45 years,M,2,1238089496,16798,16799,1,,2,148.6,2202001,2202,22,220200100030,Big Guy Men's Air Cortez Shoes
65281,Tracy French,GB,Orion Club Gold members low activity,28,15-30 years,F,2,1238110090,16800,16801,1,,2,241,2201004,2201,22,220100400026,Vector Low Men's Shoes
65464,Bill Pyzer,GB,Orion Club Gold members low activity,21,15-30 years,M,3,1238149356,16805,16810,1,,2,186,2201007,2201,22,220100700023,Armadillo Road Dmx Men's Running Shoes
83579,Berengere Laurenceau,FR,Orion Club Gold members low activity,58,46-60 years,F,2,1238188048,16810,16812,2,,1,40.5,2102004,2102,21,210200400037,Toddle Children's Perish Nubuck Shoes
89214,José Ignacio Sáenz,ES,Orion Club Gold members low activity,28,15-30 years,M,2,1238277425,16821,16825,1,,2,109.6,2202003,2202,22,220200300077,Hilly Men's Crosstrainer Shoes
90959,Pascal Oliveira,FR,Orion Club Gold members low activity,43,31-45 years,M,3,1238334385,16828,16834,1,,1,60.1,2102004,2102,21,210200400076,Tony's Children's Terra Reach(Bg) Shoes
89749,Carlos Marcelo Antuña,ES,Orion Club Gold members low activity,58,46-60 years,M,3,1238389618,16835,16839,1,,1,113,2202002,2202,22,220200200045,Soft Gt 2040 Women's Running Shoes
84925,A.M. Kisch,NL,Orion Club Gold members low activity,58,46-60 years,F,2,1238393300,16835,16837,1,,1,90,2202002,2202,22,220200200014,Dubby Low Men's Street Shoes
75563,Arianna Ribolla,IT,Orion Club Gold members low activity,58,46-60 years,F,2,1238414416,16838,16842,1,,1,104.3,2202001,2202,22,220200100029,Big Guy Men's Air Baltoro Shoes
59436,Randy Mineheart,US,Orion Club Gold members low activity,19,15-30 years,M,3,1238452118,16842,16845,1,,1,76.3,2202003,2202,22,220200300155,Hardcore Men's Street Shoes
74980,Carlo Gallivanone,IT,Orion Club Gold members low activity,68,61-75 years,M,2,1238524680,16852,16856,1,,1,62.1,2202001,2202,22,220200100124,Big Guy Men's First Set-Tennis Shoes
74109,Santiago Dupuy,ES,Orion Club Gold members low activity,21,15-30 years,M,3,1238562765,16857,16862,1,,1,37.2,2202002,2202,22,220200200043,Soft Gel Court Men's Indoor Shoes
83583,Laetitia Somerlinck,FR,Orion Club Gold members low activity,43,31-45 years,F,3,1238586160,16860,16866,1,,1,33.8,2102010,2102,21,210201000167,Children's Shoes Stratosphere
62690,Minnie Nam,GB,Orion Club Gold members low activity,38,31-45 years,F,3,1238627636,16865,16869,1,,1,18.2,2201009,2201,22,220100900004,Osprey Bermuda Canvas Shoes
70045,Michele Gonzo,IT,Orion Club Gold members low activity,58,46-60 years,M,2,1238628192,16865,16867,2,,1,120.7,2202001,2202,22,220200100098,Big Guy Men's Air Tuned Max Shoes
70045,Michele Gonzo,IT,Orion Club Gold members low activity,58,46-60 years,M,2,1238628192,16865,16867,1,,2,227.4,2202001,2202,22,220200100087,Big Guy Men's Air Terra Clay-Tennis Shoes
73235,Maria Bruna Bonfissuto,IT,Orion Club Gold members low activity,53,46-60 years,F,3,1238653513,16868,16870,1,,1,90.7,2202002,2202,22,220200200067,Twain Inco Women's Street Shoes
72282,María Pilar Cardona Vilaplana,ES,Orion Club Gold members low activity,43,31-45 years,F,3,1238659578,16869,16874,1,,1,49.4,2102004,2102,21,210200400031,Toddle Children's Air Tuco(Bg) Shoes
72447,Arianna Gaddoni,IT,Orion Club Gold members low activity,48,46-60 years,F,3,1238693448,16873,16876,1,,1,62.6,2202001,2202,22,220200100035,Big Guy Men's Air Deschutz Viii Shoes
74662,María Teresa Arbaiza,ES,Orion Club Gold members low activity,58,46-60 years,F,3,1238706615,16875,16880,1,,1,34.8,2102004,2102,21,210200400077,Tony's Children's Terra Sebec(Bg) Shoes
91925,Reyes Sierra de la Flor,ES,Orion Club Gold members low activity,58,46-60 years,F,3,1238706894,16875,16880,1,,1,35.3,2202003,2202,22,220200300066,Hawk Logo Women's Tennis Shoes
81105,C.M. Van Den Berk,NL,Orion Club Gold members low activity,21,15-30 years,F,3,1238733731,16878,16882,1,,1,99,2202001,2202,22,220200100077,Big Guy Men's Air Span Triax Shoes
75224,Maria Rita Savarese,IT,Orion Club Gold members low activity,48,46-60 years,F,2,1238749554,16880,16885,1,,1,62.6,2202001,2202,22,220200100035,Big Guy Men's Air Deschutz Viii Shoes
86273,David Kerssens,NL,Orion Club Gold members low activity,23,15-30 years,M,3,1238758836,16881,16885,1,,2,130.4,2202003,2202,22,220200300027,Smith Men's Street Shoes
55822,Christopher Rackley,US,Orion Club Gold members low activity,48,46-60 years,M,2,1238760549,16881,16885,1,,1,2.9,2401001,2401,24,240100100430,Shoelace Black 100 Cm
85247,Armelle Gambirasio,FR,Orion Club Gold members low activity,19,15-30 years,F,2,1238828073,16890,16891,1,,2,95.8,2102010,2102,21,210201000178,Infant Children's Shoes
86660,J.J.M. Witlou,NL,Orion Club Gold members low activity,63,61-75 years,F,2,1238853934,16893,16897,2,,1,87.2,2202003,2202,22,220200300152,Hardcore Junior/Women's Street Shoes
76113,J.A.M. Matthesius,NL,Orion Club Gold members low activity,63,61-75 years,M,2,1238870214,16895,16899,1,,1,65.7,2202001,2202,22,220200100120,Big Guy Men's Cortez Iii Leather Shoes
90314,Gema Aguado Guadalix,ES,Orion Club Gold members low activity,63,61-75 years,F,2,1238875253,16896,16898,2,,1,95.5,2202002,2202,22,220200200039,Soft Cumulus Men's Running Shoes
90314,Gema Aguado Guadalix,ES,Orion Club Gold members low activity,63,61-75 years,F,2,1238875253,16896,16898,1,,1,83,2202001,2202,22,220200100092,Big Guy Men's Air Terra Sebec Shoes
85372,Saverio Parcu,IT,Orion Club Gold members low activity,73,61-75 years,M,2,1238886658,16897,16898,1,,4,221.6,2202001,2202,22,220200100060,Big Guy Men's Air One Eighty  Shoes
91340,Elio Bianco,IT,Orion Club Gold members low activity,48,46-60 years,M,3,1238909493,16900,16906,1,,1,135.8,2202002,2202,22,220200200047,Soft Gt 2050 Women's Running Shoes
91340,Elio Bianco,IT,Orion Club Gold members low activity,48,46-60 years,M,3,1238909493,16900,16906,2,,1,107.5,2202002,2202,22,220200200050,Soft Integral Men's Running Shoes
91266,G.J. Hooft,NL,Orion Club Gold members low activity,58,46-60 years,M,2,1238918246,16901,16905,2,,1,55,2202003,2202,22,220200300126,The Wish L Women's Running Shoes
70085,Canio Toderi,IT,Orion Club Gold members low activity,58,46-60 years,M,2,1238925240,16902,16903,2,,2,373.6,2201007,2201,22,220100700002,Dmx 10 Women's Aerobic Shoes
91246,Saskia Groenendijk,NL,Orion Club Gold members low activity,23,15-30 years,F,2,1238926475,16902,16905,1,,3,243.6,2202003,2202,22,220200300129,Torino Men's Leather Adventure Shoes
86274,Victor Manuel Cuadras,ES,Orion Club Gold members low activity,58,46-60 years,M,3,1238931000,16903,16914,1,,1,52.6,2201007,2201,22,220100700021,Alexis Women's Classic Shoes Large
59743,A.S. Braams,NL,Orion Club Gold members low activity,38,31-45 years,F,3,1238942957,16904,16905,1,,3,156.3,2202003,2202,22,220200300078,Hilly Women's Crosstrainer Shoes Large
87041,Istvan Basnier,FR,Orion Club Gold members low activity,28,15-30 years,M,3,1238949462,16905,16908,1,,2,76,2102004,2102,21,210200400020,Kids Baby Edge Max Shoes
71864,M.M.J. Groen,NL,Orion Club Gold members low activity,53,46-60 years,F,3,1239000316,16911,16915,1,,1,118.3,2202001,2202,22,220200100086,Big Guy Men's Air Terra Central Shoes
78525,G.J.l. Van Dulken,NL,Orion Club Gold members low activity,38,31-45 years,M,3,1239000373,16911,16916,1,,3,522.3,2202001,2202,22,220200100041,Big Guy Men's Air Flight Determination Shoes
80579,C.l. Verrips,NL,Orion Club Gold members low activity,63,61-75 years,M,2,1239000408,16911,16913,1,,3,266.4,2202002,2202,22,220200200062,Top C-Tech 6000 Tennis Shoes
91959,G.J. Groen,NL,Orion Club Gold members low activity,68,61-75 years,M,2,1239000647,16911,16915,1,,3,240,2202001,2202,22,220200100129,Big Guy Men's International Triax Shoes
91438,Félix Domínguez,ES,Orion Club Gold members low activity,33,31-45 years,M,3,1239006142,16912,16913,2,,1,100.6,2402001,2402,24,240200100052,Bretagne Stabilities Tg Men's Golf Shoes
85821,Sonia Mogollón,ES,Orion Club Gold members low activity,38,31-45 years,F,3,1239044819,16917,16918,1,,3,381.9,2202002,2202,22,220200200042,Soft Ds Trainer Women's Running Shoes
85821,Sonia Mogollón,ES,Orion Club Gold members low activity,38,31-45 years,F,3,1239044819,16917,16918,2,,1,107.5,2202002,2202,22,220200200050,Soft Integral Men's Running Shoes
87041,Istvan Basnier,FR,Orion Club Gold members low activity,28,15-30 years,M,3,1239054470,16918,16921,1,,2,77.2,2401001,2401,24,240100100437,Shoeshine Olive
62630,Autrey Slepian,US,Orion Club Gold members low activity,23,15-30 years,M,3,1239068504,16919,16924,1,,1,106.5,2202001,2202,22,220200100084,Big Guy Men's Air Tailwind Shoes
62630,Autrey Slepian,US,Orion Club Gold members low activity,23,15-30 years,M,3,1239068504,16919,16924,2,,1,100.4,2202001,2202,22,220200100093,Big Guy Men's Air Terra Train Shoes
55752,Arch Anna Shobert,US,Orion Club Gold members low activity,23,15-30 years,F,3,1239073743,16920,16932,1,,1,120.7,2202001,2202,22,220200100098,Big Guy Men's Air Tuned Max Shoes
73178,Susana Cano Giner,ES,Orion Club Gold members low activity,33,31-45 years,F,3,1239076115,16921,16923,1,,2,20.2,2102007,2102,21,210200700013,Slomo Balance Children's Shoes
92564,Giordano Reggiani,IT,Orion Club Gold members low activity,68,61-75 years,M,2,1239079008,16921,16926,3,,1,96.2,2202003,2202,22,220200300158,Hardcore Shoes
65516,Sylvie Denis,FR,Orion Club Gold members low activity,23,15-30 years,F,2,1239118626,16926,16929,1,,3,100.5,2102010,2102,21,210201000179,K Street Shoes
75853,Laura Riganti,IT,Orion Club Gold members low activity,58,46-60 years,F,2,1239151906,16930,16934,1,,1,186.8,2201007,2201,22,220100700002,Dmx 10 Women's Aerobic Shoes
85515,Paolo Tracy,IT,Orion Club Gold members low activity,73,61-75 years,M,2,1239152026,16930,16933,2,,1,107.5,2202002,2202,22,220200200050,Soft Integral Men's Running Shoes
85515,Paolo Tracy,IT,Orion Club Gold members low activity,73,61-75 years,M,2,1239152026,16930,16933,1,,1,59,2202002,2202,22,220200200009,Cruise 1984 Men's Street Shoes
60355,Luigi Baraldo,IT,Orion Club Gold members low activity,68,61-75 years,M,2,1239168769,16932,16935,1,,1,98.8,2202002,2202,22,220200200027,Salida Low Men's Outdoor Shoes
75272,Tiziana Fuganti,IT,Orion Club Gold members low activity,53,46-60 years,F,2,1239168866,16932,16935,1,,3,157.8,2201007,2201,22,220100700021,Alexis Women's Classic Shoes Large
70707,Laura Niutenen,IT,Orion Club Gold members low activity,63,61-75 years,F,2,1239178435,16933,16937,2,,3,180.6,2202002,2202,22,220200200036,Soft Astro Men's Running Shoes
70707,Laura Niutenen,IT,Orion Club Gold members low activity,63,61-75 years,F,2,1239178435,16933,16937,1,,1,110.8,2202001,2202,22,220200100078,Big Guy Men's Air Stormy Skylon Shoes
81799,Daniela Paolati,IT,Orion Club Gold members low activity,48,46-60 years,F,3,1239192960,16935,16938,1,,1,112.6,2202002,2202,22,220200200041,Soft Ds Trainer Men's Running Shoes
82647,Gianfranco Galvano,IT,Orion Club Gold members low activity,68,61-75 years,M,2,1239200839,16936,16941,1,,2,201.2,2402001,2402,24,240200100052,Bretagne Stabilities Tg Men's Golf Shoes
56868,Lular Coracini,US,Orion Club Gold members low activity,21,15-30 years,F,2,1239203299,16936,16940,1,,1,62.1,2202001,2202,22,220200100124,Big Guy Men's First Set-Tennis Shoes
65464,Bill Pyzer,GB,Orion Club Gold members low activity,21,15-30 years,M,3,1239208083,16937,16942,1,,1,74.4,2201007,2201,22,220100700001,Classic Men's Leisure Shoes
64120,Erick Poutrin,FR,Orion Club Gold members low activity,43,31-45 years,M,3,1239215373,16938,16940,2,,1,36.7,2102010,2102,21,210201000183,Kola Children's Shoes
64538,Gauttam Brown,GB,Orion Club Gold members low activity,58,46-60 years,M,2,1239225131,16939,16942,1,,3,170.7,2201007,2201,22,220100700022,Alexis Women's Classic Shoes
88077,Guy Maaouni,FR,Orion Club Gold members low activity,28,15-30 years,M,2,1239326491,16952,16953,2,,1,60.1,2102010,2102,21,210201000198,South Peak Junior Training Shoes
82420,Sergio Della Bona,IT,Orion Club Gold members low activity,48,46-60 years,M,2,1239327915,16952,16956,1,,1,97.3,2201007,2201,22,220100700016,Shoes Sphinx
78945,Philippe Leclerc,FR,Orion Club Gold members low activity,19,15-30 years,M,3,1239334311,16953,16959,1,,3,162.6,2102010,2102,21,210201000209,Universe 4 Children's Running Shoes
80579,C.l. Verrips,NL,Orion Club Gold members low activity,63,61-75 years,M,2,1239432398,16965,16967,2,,3,510,2202001,2202,22,220200100165,Sire Air Max-Running Shoes
64966,Ted Turschman,GB,Orion Club Gold members low activity,23,15-30 years,M,3,1239438714,16966,16967,1,,2,225,2201007,2201,22,220100700009,Mc Shoes
65470,Catrina Boyne,GB,Orion Club Gold members low activity,38,31-45 years,F,2,1239438717,16966,16970,2,,2,264.6,2201007,2201,22,220100700028,H Ignitor Women's Aerobic Shoes
83731,Alessandro Dalla Longa,IT,Orion Club Gold members low activity,48,46-60 years,F,3,1239448300,16967,16971,2,,2,113.8,2202001,2202,22,220200100128,Big Guy Men's Hermosa Shoes
83731,Alessandro Dalla Longa,IT,Orion Club Gold members low activity,48,46-60 years,F,3,1239448300,16967,16971,1,,2,145.4,2202001,2202,22,220200100070,Big Guy Men's Air Reckoning Ii-Tennis Shoes
72175,Salomé de Juan Saboya,ES,Orion Club Gold members low activity,48,46-60 years,F,3,1239483771,16972,16977,2,,3,473.4,2202001,2202,22,220200100099,Big Guy Men's Air Tuned Sirocco Shoes
72175,Salomé de Juan Saboya,ES,Orion Club Gold members low activity,48,46-60 years,F,3,1239483771,16972,16977,1,,3,187.8,2202001,2202,22,220200100035,Big Guy Men's Air Deschutz Viii Shoes
70405,Fiorina Ponti,IT,Orion Club Gold members low activity,58,46-60 years,F,3,1239512388,16975,16976,1,,3,220.2,2202003,2202,22,220200300157,Hardcore Men's Street Shoes Large
85089,Lucia Vacaretti,IT,Orion Club Gold members low activity,68,61-75 years,F,2,1239512744,16975,16979,2,,2,216,2202002,2202,22,220200200068,Twain Men's Exentric Ii X-Hiking Shoes
85089,Lucia Vacaretti,IT,Orion Club Gold members low activity,68,61-75 years,F,2,1239512744,16975,16979,1,,2,194.6,2202002,2202,22,220200200032,Soft 140 Men's Running Shoes
77026,María José Ortega Castillo,ES,Orion Club Gold members low activity,58,46-60 years,F,3,1239517233,16976,16978,2,,2,124.2,2202001,2202,22,220200100124,Big Guy Men's First Set-Tennis Shoes
77026,María José Ortega Castillo,ES,Orion Club Gold members low activity,58,46-60 years,F,3,1239517233,16976,16978,1,,3,190.2,2202001,2202,22,220200100009,Atmosphere Imara Women's Running Shoes
73329,Benoit Denizou-Letu,FR,Orion Club Gold members low activity,33,31-45 years,M,3,1239523949,16977,16978,1,,2,6,2401001,2401,24,240100100433,Shoelace White 150 Cm
78555,M.W. Hellevoort,NL,Orion Club Gold members low activity,21,15-30 years,F,3,1239526570,16977,16980,1,,3,345,2202003,2202,22,220200300015,Men's Running Shoes Piedmmont
90389,Marc Uzel,ES,Orion Club Gold members low activity,21,15-30 years,M,2,1239531773,16978,16981,1,,2,240.8,2201007,2201,22,220100700052,Trooper Ii Dmx-2x Men's Walking Shoes
84360,Orietta Lagrasta,IT,Orion Club Gold members low activity,73,61-75 years,F,2,1239534194,16978,16982,3,,2,152.6,2202003,2202,22,220200300155,Hardcore Men's Street Shoes
84360,Orietta Lagrasta,IT,Orion Club Gold members low activity,73,61-75 years,F,2,1239534194,16978,16982,2,,2,132.8,2202002,2202,22,220200200018,Lulu Men's Street Shoes
89244,Chantal Preau,FR,Orion Club Gold members low activity,38,31-45 years,F,2,1239541072,16979,16984,2,,2,84.2,2102004,2102,21,210200400078,Tony's Children's Trainer Lite (Bg) Shoes
58703,Steve Bolton,GB,Orion Club Gold members low activity,48,46-60 years,M,2,1239558125,16981,16983,1,,2,305.8,2201007,2201,22,220100700046,Tcp 6 Men's Running Shoes
86216,Mercedes García-Santesmases,ES,Orion Club Gold members low activity,53,46-60 years,F,3,1239578835,16984,16987,1,,2,118,2202002,2202,22,220200200009,Cruise 1984 Men's Street Shoes
83731,Alessandro Dalla Longa,IT,Orion Club Gold members low activity,48,46-60 years,F,3,1239589475,16985,16989,1,,2,69.8,2202001,2202,22,220200100160,Eclipse Mens Off Court Tennis Shoes
58944,d.F. Emond,NL,Orion Club Gold members low activity,53,46-60 years,M,2,1239589835,16985,16990,3,,3,249,2202003,2202,22,220200300107,Polly Millennium Men's Tennis Shoes
58944,d.F. Emond,NL,Orion Club Gold members low activity,53,46-60 years,M,2,1239589835,16985,16990,2,,2,263.4,2202003,2202,22,220200300101,Mns.winner Men's Running Shoes
62697,Sophia Güllich,DE,Orion Club Gold members low activity,53,46-60 years,F,2,1239593459,16986,16991,1,,3,272.1,2202002,2202,22,220200200067,Twain Inco Women's Street Shoes
60355,Luigi Baraldo,IT,Orion Club Gold members low activity,68,61-75 years,M,2,1239670823,16995,16998,1,,2,264.2,2202002,2202,22,220200200072,Twain Men's Expresso X-Hiking Shoes
72703,B.M.C. Ploeg,NL,Orion Club Gold members low activity,53,46-60 years,M,3,1239671634,16995,17001,2,,2,168.2,2202003,2202,22,220200300153,Hardcore Junior/Women's Street Shoes Small
58398,Carl-Peter Thieme,DE,Orion Club Gold members low activity,58,46-60 years,M,2,1239698188,16999,17003,2,,2,100.6,2202001,2202,22,220200100137,Big Guy Men's Multicourt Ii Shoes
58398,Carl-Peter Thieme,DE,Orion Club Gold members low activity,58,46-60 years,M,2,1239698188,16999,17003,1,,2,213,2202001,2202,22,220200100084,Big Guy Men's Air Tailwind Shoes
87829,Alain Verux,FR,Orion Club Gold members low activity,43,31-45 years,M,3,1239715863,17001,17002,1,,3,9,2401001,2401,24,240100100431,Shoelace Black 150 Cm
76755,Ana Isabel Ormaeche,ES,Orion Club Gold members low activity,28,15-30 years,F,3,1239745710,17005,17008,1,,2,108.8,2202001,2202,22,220200100134,Big Guy Men's Maniacal Shoes
60549,Herbert Lemonnier,FR,Orion Club Gold members low activity,19,15-30 years,M,3,1239770277,17008,17013,1,,2,37.4,2401001,2401,24,240100100229,Cruise First Star Baby Shoes
91959,G.J. Groen,NL,Orion Club Gold members low activity,68,61-75 years,M,2,1239773418,17008,17012,1,,2,177.2,2202001,2202,22,220200100090,Big Guy Men's Air Terra Reach Shoes
88805,Carla Pizarro,ES,Orion Club Gold members low activity,53,46-60 years,F,2,1239787743,17010,17014,2,,2,241.4,2202001,2202,22,220200100098,Big Guy Men's Air Tuned Max Shoes
85372,Saverio Parcu,IT,Orion Club Gold members low activity,73,61-75 years,M,2,1239812232,17013,17014,2,,2,263.4,2202003,2202,22,220200300101,Mns.winner Men's Running Shoes
78011,Juan José Cabeza Luque,ES,Orion Club Gold members low activity,21,15-30 years,M,2,1239817599,17014,17017,2,,2,280.2,2202002,2202,22,220200200079,Twain Women's Expresso X-Hiking Shoes
76637,Aude Blanchard,FR,Orion Club Gold members low activity,43,31-45 years,F,3,1239818542,17014,17017,1,,2,49.8,2102010,2102,21,210201000169,Children's Street Shoes
86053,I.F. Sieverdink,NL,Orion Club Gold members low activity,23,15-30 years,F,3,1239845969,17017,17019,1,,2,118,2202002,2202,22,220200200009,Cruise 1984 Men's Street Shoes
58290,Johnnie Riley,US,Orion Club Gold members low activity,43,31-45 years,M,2,1239847966,17017,17020,2,,2,77.2,2401001,2401,24,240100100437,Shoeshine Olive
90314,Gema Aguado Guadalix,ES,Orion Club Gold members low activity,63,61-75 years,F,2,1239926377,17028,17030,1,,2,201.2,2402001,2402,24,240200100052,Bretagne Stabilities Tg Men's Golf Shoes
57484,Philip Jäger,DE,Orion Club Gold members low activity,23,15-30 years,M,2,1239966279,17033,17034,1,,2,125.2,2202001,2202,22,220200100035,Big Guy Men's Air Deschutz Viii Shoes
78525,G.J.l. Van Dulken,NL,Orion Club Gold members low activity,38,31-45 years,M,3,1239970572,17033,17038,1,,3,220.2,2202003,2202,22,220200300157,Hardcore Men's Street Shoes Large
73378,Elisardo Redondo Sánchez,ES,Orion Club Gold members low activity,33,31-45 years,M,2,1239983243,17035,17036,2,,2,347,2201007,2201,22,220100700005,Dmx Lite Women's Aerobic Shoes
73378,Elisardo Redondo Sánchez,ES,Orion Club Gold members low activity,33,31-45 years,M,2,1239983243,17035,17036,1,,2,151.6,2201007,2201,22,220100700001,Classic Men's Leisure Shoes
82928,H.F.R. Hargreaves,NL,Orion Club Gold members low activity,68,61-75 years,F,2,1240026442,17040,17043,1,,2,133,2202001,2202,22,220200100063,Big Guy Men's Air Perish Nb Shoes
74980,Carlo Gallivanone,IT,Orion Club Gold members low activity,68,61-75 years,M,2,1240068031,17045,17049,1,,1,152.9,2201007,2201,22,220100700046,Tcp 6 Men's Running Shoes
86273,David Kerssens,NL,Orion Club Gold members low activity,23,15-30 years,M,3,1240249724,17068,17072,1,,1,106.5,2202001,2202,22,220200100084,Big Guy Men's Air Tailwind Shoes
79884,Mercedes Gich Saladich,ES,Orion Club Gold members low activity,63,61-75 years,F,2,1240319676,17077,17079,1,,1,160.8,2402001,2402,24,240200100229,Rubby Women's Golf Shoes w/Goretex
85432,M.H.M. Hulpiau,NL,Orion Club Gold members low activity,68,61-75 years,M,2,1240371847,17083,17087,1,,1,52.1,2202003,2202,22,220200300078,Hilly Women's Crosstrainer Shoes Large
70045,Michele Gonzo,IT,Orion Club Gold members low activity,58,46-60 years,M,2,1240386373,17085,17087,3,,1,60.6,2202003,2202,22,220200300110,Qrs Men's Street Shoes
70045,Michele Gonzo,IT,Orion Club Gold members low activity,58,46-60 years,M,2,1240386373,17085,17087,1,,1,55.4,2202001,2202,22,220200100060,Big Guy Men's Air One Eighty  Shoes
65464,Bill Pyzer,GB,Orion Club Gold members low activity,21,15-30 years,M,3,1240394418,17086,17091,1,,1,96.1,2201004,2201,22,220100400027,Wa.lbc Street Shoes
64119,Yüksel Struckmeyer,DE,Orion Club Gold members low activity,73,61-75 years,M,2,1240400192,17087,17088,1,,1,86.6,2202001,2202,22,220200100066,Big Guy Men's Air Quest Shoes
57501,Gerrit Kochta,DE,Orion Club Gold members low activity,21,15-30 years,M,3,1240415676,17089,17093,2,,1,107.4,2202003,2202,22,220200300061,Damaskus Men's Running Shoes
91340,Elio Bianco,IT,Orion Club Gold members low activity,48,46-60 years,M,3,1240419618,17089,17095,2,,1,131.7,2202003,2202,22,220200300101,Mns.winner Men's Running Shoes
91340,Elio Bianco,IT,Orion Club Gold members low activity,48,46-60 years,M,3,1240419618,17089,17095,1,,1,97.3,2202002,2202,22,220200200032,Soft 140 Men's Running Shoes
60032,Arturo Infante,ES,Orion Club Gold members low activity,33,31-45 years,M,3,1240457550,17094,17096,1,,1,73.4,2202003,2202,22,220200300157,Hardcore Men's Street Shoes Large
91246,Saskia Groenendijk,NL,Orion Club Gold members low activity,23,15-30 years,F,2,1240461910,17094,17097,1,,1,33.4,2202001,2202,22,220200100126,Big Guy Men's Gts Canvas Plus Shoes
90535,Francisco Imatz,ES,Orion Club Gold members low activity,73,61-75 years,M,2,1240488685,17098,17099,1,,1,56.9,2202001,2202,22,220200100128,Big Guy Men's Hermosa Shoes
84925,A.M. Kisch,NL,Orion Club Gold members low activity,58,46-60 years,F,2,1240596618,17111,17113,1,,1,62.6,2202001,2202,22,220200100035,Big Guy Men's Air Deschutz Viii Shoes
63374,Pam Shirly,GB,Orion Club Gold members low activity,28,15-30 years,F,2,1240685291,17122,17124,1,,1,46.2,2102010,2102,21,210201000187,Mona  C- Children's Street Shoes
76582,A.M. Bergfeld,NL,Orion Club Gold members low activity,33,31-45 years,M,3,1240758231,17131,17133,1,,1,113.6,2202003,2202,22,220200300123,The Gonzales Men's Shoes
70085,Canio Toderi,IT,Orion Club Gold members low activity,58,46-60 years,M,2,1240799265,17136,17137,1,,2,173.2,2202001,2202,22,220200100066,Big Guy Men's Air Quest Shoes
74778,Miguel Sáenz,ES,Orion Club Gold members low activity,73,61-75 years,M,2,1240826241,17140,17142,1,,2,248.6,2202001,2202,22,220200100079,Big Guy Men's Air Structure Triax Shoes
76113,J.A.M. Matthesius,NL,Orion Club Gold members low activity,63,61-75 years,M,2,1240847330,17142,17146,1,,2,168.4,2202003,2202,22,220200300014,Men's Running Shoes Ozweego
59886,Stefan Bohle,DE,Orion Club Gold members low activity,58,46-60 years,M,2,1240882375,17147,17152,2,,2,199,2202003,2202,22,220200300017,Men's Shoes Solace
59886,Stefan Bohle,DE,Orion Club Gold members low activity,58,46-60 years,M,2,1240882375,17147,17152,1,,2,216,2202002,2202,22,220200200068,Twain Men's Exentric Ii X-Hiking Shoes
91438,Félix Domínguez,ES,Orion Club Gold members low activity,33,31-45 years,M,3,1240883278,17147,17148,1,,3,100.2,2202001,2202,22,220200100126,Big Guy Men's Gts Canvas Plus Shoes
83731,Alessandro Dalla Longa,IT,Orion Club Gold members low activity,48,46-60 years,F,3,1240885604,17147,17151,1,,2,305.8,2201007,2201,22,220100700046,Tcp 6 Men's Running Shoes
55923,J.T. de Groot,NL,Orion Club Gold members low activity,21,15-30 years,F,3,1240886119,17147,17152,1,,2,200.8,2202001,2202,22,220200100072,Big Guy Men's Air Skylon Triax Shoes
61129,Kathy K. Sluzalek,DE,Orion Club Gold members low activity,23,15-30 years,F,3,1240921127,17152,17156,2,,4,343.2,2202003,2202,22,220200300076,Hi Response Women's Aerobic Shoes Large
61129,Kathy K. Sluzalek,DE,Orion Club Gold members low activity,23,15-30 years,F,3,1240921127,17152,17156,1,,3,358.2,2202001,2202,22,220200100094,Big Guy Men's Air Terra Triax Shoes
79884,Mercedes Gich Saladich,ES,Orion Club Gold members low activity,63,61-75 years,F,2,1240963710,17157,17159,1,,2,156,2201004,2201,22,220100400013,Cross Nubuck Women's Street Shoes
85513,Mario Barcena Arteagabeitia,ES,Orion Club Gold members low activity,19,15-30 years,F,3,1241019096,17164,17168,2,,2,128,2202002,2202,22,220200200021,Pro Fit  Gel Ds Trainer Iv Men's Running Shoe
63374,Pam Shirly,GB,Orion Club Gold members low activity,28,15-30 years,F,3,1241035059,17166,17171,1,,2,197.8,2201004,2201,22,220100400022,Ultra M803 Ng Men's Street Shoes
84487,R.N. Puttiger,NL,Orion Club Gold members low activity,23,15-30 years,M,2,1241116381,17175,17179,1,,1,110.3,2202003,2202,22,220200300142,Vishnu Women's Running Shoes
63540,Mike Antwine,US,Orion Club Gold members low activity,43,31-45 years,M,3,1241147551,17178,17183,1,,2,367.8,2202001,2202,22,220200100110,Big Guy Men's Air Zoom Italia F.G Shoes
72040,N.A.E. Verbeek,NL,Orion Club Gold members low activity,53,46-60 years,F,2,1241260454,17191,17192,2,,1,113,2202002,2202,22,220200200045,Soft Gt 2040 Women's Running Shoes
72040,N.A.E. Verbeek,NL,Orion Club Gold members low activity,53,46-60 years,F,2,1241260454,17191,17192,1,,2,106,2202001,2202,22,220200100144,Big Guy Men's Strap Runner Shoes
87000,Christophe Roux,FR,Orion Club Gold members low activity,23,15-30 years,M,3,1241321467,17198,17199,1,,1,41.4,2102010,2102,21,210201000199,Starlite Baby Shoes
63893,Josiane Faivre,FR,Orion Club Gold members low activity,21,15-30 years,F,2,1241446721,17212,17213,1,,1,24.9,2102010,2102,21,210201000169,Children's Street Shoes
77175,José Manuel Mota Molina,ES,Orion Club Gold members low activity,48,46-60 years,M,3,1241456929,17213,17218,1,,1,188.6,2201007,2201,22,220100700002,Dmx 10 Women's Aerobic Shoes
85515,Paolo Tracy,IT,Orion Club Gold members low activity,73,61-75 years,M,2,1241460842,17213,17217,1,,1,141.2,2202001,2202,22,220200100113,Big Guy Men's Air Zoom Pivot Mid Ii Shoes
57969,Tina Slager,NL,Orion Club Gold members low activity,58,46-60 years,F,2,1241494986,17217,17222,2,,1,61,2202001,2202,22,220200100101,Big Guy Men's Air Turbulence Shoes
57969,Tina Slager,NL,Orion Club Gold members low activity,58,46-60 years,F,2,1241494986,17217,17222,1,,2,173.8,2202001,2202,22,220200100100,Big Guy Men's Air Turbino F.G. Shoes
92231,Joseph Oules,FR,Orion Club Gold members low activity,21,15-30 years,M,3,1241537509,17222,17224,2,,1,33.4,2102010,2102,21,210201000202,T&l Children's Shoes
90415,Guilhem Essermeant,FR,Orion Club Gold members low activity,53,46-60 years,M,3,1241555611,17224,17229,1,,1,38,2102004,2102,21,210200400020,Kids Baby Edge Max Shoes
58764,Samuel Schieb,FR,Orion Club Gold members low activity,19,15-30 years,M,3,1241619969,17231,17237,1,,1,36.7,2102010,2102,21,210201000183,Kola Children's Shoes
82616,Michele Fayssard,FR,Orion Club Gold members low activity,21,15-30 years,F,3,1241712311,17241,17242,1,,1,33.8,2102010,2102,21,210201000167,Children's Shoes Stratosphere
89073,Juan Patricio Rincón,ES,Orion Club Gold members low activity,53,46-60 years,M,3,1241719757,17242,17244,1,,1,33.4,2202001,2202,22,220200100126,Big Guy Men's Gts Canvas Plus Shoes
72186,Louis Angela,IT,Orion Club Gold members low activity,58,46-60 years,M,3,1241739919,17244,17248,1,,2,315.6,2202001,2202,22,220200100099,Big Guy Men's Air Tuned Sirocco Shoes
58664,Milagros Irlan Ferrer,ES,Orion Club Gold members low activity,28,15-30 years,F,3,1241826958,17254,17260,1,,1,89.5,2202001,2202,22,220200100132,Big Guy Men's Klickitat Mid Shoes
70096,M.M.J. Hellevoort,NL,Orion Club Gold members low activity,73,61-75 years,F,2,1241841857,17255,17259,1,,1,66.5,2202001,2202,22,220200100063,Big Guy Men's Air Perish Nb Shoes
73325,Estrella Sánchez Pérez,ES,Orion Club Gold members low activity,68,61-75 years,F,2,1241872081,17259,17261,1,,1,10.1,2102007,2102,21,210200700013,Slomo Balance Children's Shoes
76962,Rocío Aller,ES,Orion Club Gold members low activity,28,15-30 years,F,2,1241872201,17259,17263,2,,1,66.8,2202002,2202,22,220200200010,Cruise Men's Road Chunk Street Shoes
76962,Rocío Aller,ES,Orion Club Gold members low activity,28,15-30 years,F,2,1241872201,17259,17263,1,,1,58.7,2202001,2202,22,220200100012,Atmosphere Shatter Mid Shoes
91476,I.C. Van Den Eertwegh,NL,Orion Club Gold members low activity,23,15-30 years,F,3,1241895552,17261,17263,1,,3,150.9,2202001,2202,22,220200100137,Big Guy Men's Multicourt Ii Shoes
91246,Saskia Groenendijk,NL,Orion Club Gold members low activity,23,15-30 years,F,3,1241969003,17269,17274,1,,3,316.2,2202001,2202,22,220200100142,Big Guy Men's Span Triax Shoes
76082,W.d. Van Der Horst,NL,Orion Club Gold members low activity,23,15-30 years,F,2,1242002268,17273,17275,3,,4,370,2202002,2202,22,220200200067,Twain Inco Women's Street Shoes
76082,W.d. Van Der Horst,NL,Orion Club Gold members low activity,23,15-30 years,F,2,1242002268,17273,17275,2,,1,80,2202001,2202,22,220200100129,Big Guy Men's International Triax Shoes
76082,W.d. Van Der Horst,NL,Orion Club Gold members low activity,23,15-30 years,F,2,1242002268,17273,17275,1,,1,61,2202001,2202,22,220200100101,Big Guy Men's Air Turbulence Shoes
70901,Susana Guigourez,FR,Orion Club Gold members low activity,23,15-30 years,F,2,1242008858,17274,17277,1,,1,3,2401001,2401,24,240100100433,Shoelace White 150 Cm
61995,H.C. Chiu,NL,Orion Club Gold members low activity,58,46-60 years,F,3,1242076128,17281,17287,1,,1,92.5,2202002,2202,22,220200200067,Twain Inco Women's Street Shoes
75222,N.A.E. Vroom,NL,Orion Club Gold members low activity,33,31-45 years,F,3,1242076183,17281,17283,1,,1,157.8,2202001,2202,22,220200100099,Big Guy Men's Air Tuned Sirocco Shoes
55307,Luca Gennarini,IT,Orion Club Gold members low activity,48,46-60 years,M,2,1242084829,17282,17285,1,,1,101,2202003,2202,22,220200300016,Men's Running Shoes Supernova
76084,María José Remiro,ES,Orion Club Gold members low activity,58,46-60 years,F,3,1242100655,17284,17286,1,,1,85.4,2202001,2202,22,220200100025,Big Guy  Men's Air Ace 4 Plus Low-Tennis Shoe
77026,María José Ortega Castillo,ES,Orion Club Gold members low activity,58,46-60 years,F,3,1242100677,17284,17286,1,,1,100.6,2402001,2402,24,240200100052,Bretagne Stabilities Tg Men's Golf Shoes
60398,Cyril Bidon,FR,Orion Club Gold members low activity,19,15-30 years,M,2,1242127459,17287,17294,1,,1,18.7,2401001,2401,24,240100100229,Cruise First Star Baby Shoes
57188,Earnie Mossberg,GB,Orion Club Gold members low activity,48,46-60 years,M,2,1242128721,17287,17289,1,,4,418.4,2201007,2201,22,220100700024,Armadillo Road Dmx Women's Running Shoes
72040,N.A.E. Verbeek,NL,Orion Club Gold members low activity,53,46-60 years,F,2,1242148787,17289,17290,1,,1,40.8,2202001,2202,22,220200100161,Eclipse Women's Off Court Canvas Shoes
86009,Willy Lecorre,FR,Orion Club Gold members low activity,58,46-60 years,M,2,1242170937,17292,17293,1,,1,56.7,2102010,2102,21,210201000166,Children's Shoes Pleva
84960,H.F.R. Zuure,NL,Orion Club Gold members low activity,73,61-75 years,F,2,1242173730,17292,17297,2,,1,92.5,2202002,2202,22,220200200067,Twain Inco Women's Street Shoes
84960,H.F.R. Zuure,NL,Orion Club Gold members low activity,73,61-75 years,F,2,1242173730,17292,17297,1,,1,179,2202001,2202,22,220200100107,Big Guy Men's Air Zoom Citizen Shoes
73997,Demetrio Cornazzani,IT,Orion Club Gold members low activity,48,46-60 years,M,2,1242181946,17293,17295,1,,1,87.7,2202001,2202,22,220200100091,Big Guy Men's Air Terra Rise Shoes
55381,Maria Lucrezi,IT,Orion Club Gold members low activity,58,46-60 years,F,3,1242227060,17298,17303,1,,1,119.8,2202002,2202,22,220200200078,Twain Women's Exit Low 2000 Street Shoes
82591,Patrizia Davoli,IT,Orion Club Gold members low activity,58,46-60 years,F,3,1242292109,17305,17307,3,,1,77,2202003,2202,22,220200300155,Hardcore Men's Street Shoes
73808,Michel Audrain,FR,Orion Club Gold members low activity,48,46-60 years,M,3,1242298281,17306,17307,2,,1,48.7,2102004,2102,21,210200400029,Toddle Children's Air Terra Grande Shoes
88287,Ana Sánchez Fernández,ES,Orion Club Gold members low activity,28,15-30 years,F,3,1242324783,17309,17315,1,,1,50.3,2202001,2202,22,220200100137,Big Guy Men's Multicourt Ii Shoes
75334,Dominique Bely,FR,Orion Club Gold members low activity,21,15-30 years,M,3,1242325717,17309,17310,1,,1,44.5,2102006,2102,21,210200600032,Atx 7500 Ch Children's Shoes
77340,Analía Ferrer García,ES,Orion Club Gold members low activity,53,46-60 years,F,2,1242345282,17311,17316,1,,1,141.2,2202001,2202,22,220200100113,Big Guy Men's Air Zoom Pivot Mid Ii Shoes
78435,César Rodríguez Bonachera,ES,Orion Club Gold members low activity,58,46-60 years,M,2,1242345299,17311,17316,1,,3,120.6,2102006,2102,21,210200600048,Big Kid Children's Shoes
70257,José María Raso,ES,Orion Club Gold members low activity,73,61-75 years,M,2,1242426051,17320,17325,1,0.4,2,185.98,2402001,2402,24,240200100227,Rubby Women's Golf Shoes w/Gore-Tex
90686,M.H. Poortman,NL,Orion Club Gold members low activity,33,31-45 years,M,2,1242439659,17321,17326,3,,3,194.7,2202003,2202,22,220200300079,Hilly Women's Crosstrainer Shoes
72194,Domenico Maurizio Ligasacchi,IT,Orion Club Gold members low activity,73,61-75 years,M,2,1242447990,17322,17325,1,,2,249,2201007,2201,22,220100700003,Dmx 6 Shoes
65336,Marianne Werthmüller,DE,Orion Club Gold members low activity,48,46-60 years,F,2,1242516266,17330,17333,1,,2,271.6,2202002,2202,22,220200200047,Soft Gt 2050 Women's Running Shoes
78435,César Rodríguez Bonachera,ES,Orion Club Gold members low activity,58,46-60 years,M,2,1242517136,17330,17335,3,,3,409.8,2202003,2202,22,220200300102,Mns.xzs Women's Aerobic Shoes
76458,Esther de Bie,NL,Orion Club Gold members low activity,23,15-30 years,F,3,1242520872,17330,17334,2,,2,199.2,2202003,2202,22,220200300117,South Peak Women's Light Indoor Shoes
76458,Esther de Bie,NL,Orion Club Gold members low activity,23,15-30 years,F,3,1242520872,17330,17334,1,,2,65.6,2202001,2202,22,220200100123,Big Guy Men's Deschutz Slide Shoes
73944,M.M.J. Gorissen,NL,Orion Club Gold members low activity,68,61-75 years,F,2,1242575491,17336,17341,1,,2,185,2202002,2202,22,220200200067,Twain Inco Women's Street Shoes
86545,Elise Gutzwiller,FR,Orion Club Gold members low activity,68,61-75 years,F,2,1242582049,17337,17338,1,,2,77.2,2401001,2401,24,240100100437,Shoeshine Olive
76082,W.d. Van Der Horst,NL,Orion Club Gold members low activity,23,15-30 years,F,2,1242584751,17337,17339,1,,2,225.4,2202001,2202,22,220200100156,Big Guy Men'sAir Duration Shoes
55627,M.E. Tenniglo,NL,Orion Club Gold members low activity,53,46-60 years,F,3,1242594176,17338,17339,1,,2,120.4,2202002,2202,22,220200200036,Soft Astro Men's Running Shoes
76993,José Luis Lodares,ES,Orion Club Gold members low activity,53,46-60 years,M,3,1242608293,17340,17346,1,,2,180.6,2202003,2202,22,220200300151,Hardcore Junior/Women's Shoes
56632,J.l. Ulicevic,NL,Orion Club Gold members low activity,21,15-30 years,F,2,1242619325,17341,17345,2,,2,216.4,2202002,2202,22,220200200069,Twain Men's Exit Ii Low X-Hiking Shoes
56632,J.l. Ulicevic,NL,Orion Club Gold members low activity,21,15-30 years,F,2,1242619325,17341,17345,1,,2,128,2202002,2202,22,220200200021,Pro Fit  Gel Ds Trainer Iv Men's Running Shoe
70131,Carlota Mazarredo Barandica,ES,Orion Club Gold members low activity,21,15-30 years,F,3,1242652758,17345,17348,1,,2,160,2202001,2202,22,220200100129,Big Guy Men's International Triax Shoes
75222,N.A.E. Vroom,NL,Orion Club Gold members low activity,33,31-45 years,F,3,1242656876,17345,17347,1,,2,144.6,2202003,2202,22,220200300022,Men's Street Shoes Gazelle
59342,Ursula Mcgeoghan,GB,Orion Club Gold members low activity,38,31-45 years,F,2,1242680335,17348,17353,3,,2,182,2201004,2201,22,220100400018,Osprey Men's Street Cat Nubuck Street Shoes
62026,Chris Manship,GB,Orion Club Gold members low activity,38,31-45 years,M,3,1242698753,17350,17353,2,,2,194,2201004,2201,22,220100400027,Wa.lbc Street Shoes
57673,Paola Geisler,US,Orion Club Gold members low activity,21,15-30 years,F,2,1242732357,17353,17356,2,,2,32.8,2401001,2401,24,240100100434,Shoeshine Black
57047,Gregory Cho,US,Orion Club Gold members low activity,53,46-60 years,M,3,1242801536,17361,17365,2,,2,77.2,2401001,2401,24,240100100437,Shoeshine Olive
85199,Arabella Capogrossi,IT,Orion Club Gold members low activity,48,46-60 years,F,3,1242817836,17363,17365,1,,2,132.8,2202002,2202,22,220200200018,Lulu Men's Street Shoes
55923,J.T. de Groot,NL,Orion Club Gold members low activity,21,15-30 years,F,3,1242818298,17363,17367,1,,2,142,2202003,2202,22,220200300082,Indoor Handbold Special Shoes
78011,Juan José Cabeza Luque,ES,Orion Club Gold members low activity,21,15-30 years,M,3,1242841846,17366,17368,1,,3,259.8,2202001,2202,22,220200100066,Big Guy Men's Air Quest Shoes
59743,A.S. Braams,NL,Orion Club Gold members low activity,38,31-45 years,F,3,1242881314,17370,17375,3,,2,398.4,2202002,2202,22,220200200052,Soft Kayano Men's Running Shoes VI
59743,A.S. Braams,NL,Orion Club Gold members low activity,38,31-45 years,F,3,1242881314,17370,17375,2,,5,537.5,2202002,2202,22,220200200050,Soft Integral Men's Running Shoes
80706,J.P.M. Hollebrandse,NL,Orion Club Gold members low activity,23,15-30 years,M,3,1242909228,17373,17379,2,,3,114.6,2202002,2202,22,220200200038,Soft Court Women's Indoor Shoes
80706,J.P.M. Hollebrandse,NL,Orion Club Gold members low activity,23,15-30 years,M,3,1242909228,17373,17379,1,,2,127,2202002,2202,22,220200200004,Allinall Star 2000 Women's Canvas Shoes
89720,María Clastre,ES,Orion Club Gold members low activity,33,31-45 years,F,2,1242940869,17377,17378,2,,2,214.8,2202003,2202,22,220200300061,Damaskus Men's Running Shoes
89720,María Clastre,ES,Orion Club Gold members low activity,33,31-45 years,F,2,1242940869,17377,17378,1,,3,537.9,2202002,2202,22,220200200080,Ultra M1210 Men's Running Shoes
72186,Louis Angela,IT,Orion Club Gold members low activity,58,46-60 years,M,3,1242943654,17377,17381,2,,2,391.4,2202002,2202,22,220200200054,Soft Kayano Men's Running Shoes
84363,Pierre Niedzwiedz,FR,Orion Club Gold members low activity,38,31-45 years,M,3,1242950611,17378,17380,1,,3,170.1,2102010,2102,21,210201000166,Children's Shoes Pleva
88180,Alessandro Mugnaini,IT,Orion Club Gold members low activity,48,46-60 years,M,2,1242952719,17378,17380,1,,2,216.4,2202002,2202,22,220200200069,Twain Men's Exit Ii Low X-Hiking Shoes
78997,Milco Checcacci,IT,Orion Club Gold members low activity,58,46-60 years,M,3,1242973013,17380,17386,1,,3,520.5,2201007,2201,22,220100700005,Dmx Lite Women's Aerobic Shoes
64683,Felix Murphey,US,Orion Club Gold members low activity,19,15-30 years,M,2,1242976690,17380,17381,1,,2,196.2,2202003,2202,22,220200300158,Hardcore Shoes
60702,J.P. Bohnenn,NL,Orion Club Gold members low activity,21,15-30 years,M,2,1243009577,17384,17385,2,,2,96.4,2202001,2202,22,220200100153,Big Guy Men's Understudy Cross Train. Shoes
89279,Mercedes Brazzolotto,IT,Orion Club Gold members low activity,53,46-60 years,F,3,1243026201,17386,17389,1,,5,234.5,2202003,2202,22,220200300162,N.d.gear Men's Galileo Shoes
87976,F.M. Hessels,NL,Orion Club Gold members low activity,21,15-30 years,M,2,1243026814,17386,17391,1,,2,95.8,2202002,2202,22,220200200031,Soft 1040 Women's Running Shoes
84725,Alain Riche,FR,Orion Club Gold members low activity,48,46-60 years,M,2,1243068834,17391,17395,2,,2,49.8,2102010,2102,21,210201000169,Children's Street Shoes
65324,Germano Girone,IT,Orion Club Gold members low activity,48,46-60 years,M,2,1243133041,17398,17401,1,,3,177,2202002,2202,22,220200200009,Cruise 1984 Men's Street Shoes
62417,Tingmei Koeller-Anna,US,Orion Club Gold members low activity,68,61-75 years,F,2,1243136841,17398,17403,2,,2,214.8,2202003,2202,22,220200300061,Damaskus Men's Running Shoes
62417,Tingmei Koeller-Anna,US,Orion Club Gold members low activity,68,61-75 years,F,2,1243136841,17398,17403,1,,2,142.8,2202001,2202,22,220200100143,Big Guy Men's Speedy Flight Plus Shoes
72040,N.A.E. Verbeek,NL,Orion Club Gold members low activity,53,46-60 years,F,2,1243214714,17407,17408,1,,2,110.8,2202001,2202,22,220200100060,Big Guy Men's Air One Eighty  Shoes
80030,Piero Moroni,IT,Orion Club Gold members low activity,53,46-60 years,M,3,1243223991,17408,17410,1,,3,183,2202001,2202,22,220200100101,Big Guy Men's Air Turbulence Shoes
57969,Tina Slager,NL,Orion Club Gold members low activity,58,46-60 years,F,2,1243224909,17408,17413,1,,2,393,2202001,2202,22,220200100052,Big Guy Men's Air Mickey 95 Running Shoes
74950,Ángela Ballesteros Villapalos,ES,Orion Club Gold members low activity,53,46-60 years,F,2,1243339524,17421,17425,1,,2,315.6,2202001,2202,22,220200100099,Big Guy Men's Air Tuned Sirocco Shoes
71296,Raquel Gómez Ramos,ES,Orion Club Gold members low activity,63,61-75 years,F,2,1243403524,17428,17430,1,,2,69.6,2102004,2102,21,210200400077,Tony's Children's Terra Sebec(Bg) Shoes
70915,Sara Simons,ES,Orion Club Gold members low activity,28,15-30 years,F,2,1243412878,17429,17433,1,,1,36.1,2102004,2102,21,210200400014,Kid Trainer Lite(Bp) Street Shoes
57645,Ambrogina Antoniol,IT,Orion Club Gold members low activity,73,61-75 years,F,2,1243451589,17433,17442,1,,2,242.6,2202001,2202,22,220200100051,Big Guy Men's Air Masai Shoes
92275,Nathalie Guion,FR,Orion Club Gold members low activity,19,15-30 years,F,3,1243496059,17438,17439,1,,1,39.8,2102004,2102,21,210200400042,Toddle Children's Understudy(Bp) Shoes
75303,Lola Jiménez,ES,Orion Club Gold members low activity,19,15-30 years,F,2,1243511620,17440,17445,1,,1,110.8,2202001,2202,22,220200100078,Big Guy Men's Air Stormy Skylon Shoes
86069,Antonio Dogliotti,IT,Orion Club Gold members low activity,48,46-60 years,M,3,1243514737,17440,17446,1,,1,136.6,2202003,2202,22,220200300102,Mns.xzs Women's Aerobic Shoes
74214,E.F. Koekkoek,NL,Orion Club Gold members low activity,53,46-60 years,F,3,1243524253,17441,17447,1,,1,93.5,2202002,2202,22,220200200066,Twain Inco Men's Street Shoes
83078,Francisco Boto,ES,Orion Club Gold members low activity,28,15-30 years,M,2,1243611746,17451,17454,1,,1,38.6,2401001,2401,24,240100100437,Shoeshine Olive
78997,Milco Checcacci,IT,Orion Club Gold members low activity,58,46-60 years,M,3,1243630982,17453,17459,1,,1,89.5,2202001,2202,22,220200100132,Big Guy Men's Klickitat Mid Shoes
71298,Annalisa Schettino,IT,Orion Club Gold members low activity,58,46-60 years,F,2,1243679038,17458,17461,1,,1,66.5,2202002,2202,22,220200200002,Men's Nubuck-Retro Running Shoes Roadster
61995,H.C. Chiu,NL,Orion Club Gold members low activity,58,46-60 years,F,3,1243679934,17458,17464,1,,2,282.4,2202001,2202,22,220200100113,Big Guy Men's Air Zoom Pivot Mid Ii Shoes
58398,Carl-Peter Thieme,DE,Orion Club Gold members low activity,58,46-60 years,M,2,1243699715,17461,17466,2,,1,64,2202002,2202,22,220200200021,Pro Fit  Gel Ds Trainer Iv Men's Running Shoe
58398,Carl-Peter Thieme,DE,Orion Club Gold members low activity,58,46-60 years,M,2,1243699715,17461,17466,1,,1,62.6,2202001,2202,22,220200100035,Big Guy Men's Air Deschutz Viii Shoes
63362,Pierre-Gatien Piquet,FR,Orion Club Gold members low activity,48,46-60 years,M,2,1243755936,17467,17470,2,,1,3,2401001,2401,24,240100100433,Shoelace White 150 Cm
76082,W.d. Van Der Horst,NL,Orion Club Gold members low activity,23,15-30 years,F,2,1243758886,17467,17469,1,,1,70.1,2202003,2202,22,220200300131,Torino Women's Leather Shoes
60187,Stephan Lückert,DE,Orion Club Gold members low activity,58,46-60 years,M,3,1243882284,17481,17486,2,,1,93.1,2202003,2202,22,220200300056,Banto Light Men's Shoes
75399,Marie-Pierre Lemercier,FR,Orion Club Gold members low activity,43,31-45 years,F,3,1243967393,17490,17495,1,,1,30.6,2102004,2102,21,210200400047,Toddler Fit Shoes
59763,Jack Staniland,GB,Orion Club Gold members low activity,28,15-30 years,M,3,1244095852,17504,17510,1,,4,725.2,2201007,2201,22,220100700051,Trailblaze Dmx Lite Women's Running Shoes
80706,J.P.M. Hollebrandse,NL,Orion Club Gold members low activity,23,15-30 years,M,3,1244098132,17504,17510,1,,3,473.4,2202001,2202,22,220200100099,Big Guy Men's Air Tuned Sirocco Shoes
89073,Juan Patricio Rincón,ES,Orion Club Gold members low activity,53,46-60 years,M,3,1244148122,17510,17512,1,,3,459.3,2402001,2402,24,240200100225,Rubby Men's Golf Shoes w/Goretex
76874,Andrea Nascinben,IT,Orion Club Gold members low activity,73,61-75 years,M,2,1244160678,17511,17514,1,,2,323.8,2402001,2402,24,240200100227,Rubby Women's Golf Shoes w/Gore-Tex
90497,Ana Iglesias Vidal,ES,Orion Club Gold members low activity,43,31-45 years,F,2,1244229160,17519,17523,1,,2,82.4,2102004,2102,21,210200400018,Kiddy.summit  90 F.G.Rbr (Bg) Children's Shoe
65324,Germano Girone,IT,Orion Club Gold members low activity,48,46-60 years,M,2,1244231889,17519,17522,1,,2,69.8,2202001,2202,22,220200100160,Eclipse Mens Off Court Tennis Shoes
77175,José Manuel Mota Molina,ES,Orion Club Gold members low activity,48,46-60 years,M,3,1244257378,17522,17527,2,,2,20.2,2102007,2102,21,210200700013,Slomo Balance Children's Shoes
59738,Eric Ruble,FR,Orion Club Gold members low activity,48,46-60 years,M,3,1244265728,17523,17524,1,,4,18.4,2401001,2401,24,240100100429,"Shoelace 140 Cm, Assorted Colours"
93710,Josee Dekeyser,FR,Orion Club Gold members low activity,19,15-30 years,F,3,1230295295,15759,15760,1,,1,36.7,2102010,2102,21,210201000183,Kola Children's Shoes
94220,Mario Mentini,IT,Orion Club Gold members low activity,68,61-75 years,M,2,1230376575,15774,15778,1,,1,105.4,2202001,2202,22,220200100142,Big Guy Men's Span Triax Shoes
93392,Cristina Elvira,ES,Orion Club Gold members low activity,19,15-30 years,F,2,1231252317,15934,15937,1,,2,53.8,2102009,2102,21,210200900027,Osprey Cuda Lo Jr. Shoes Synthetic
93142,Esmeralda Rivero Antonio,ES,Orion Club Gold members low activity,48,46-60 years,F,2,1231604577,15998,16002,1,,1,179,2202001,2202,22,220200100107,Big Guy Men's Air Zoom Citizen Shoes
93522,Valerie Piacentini,FR,Orion Club Gold members low activity,33,31-45 years,F,2,1231677225,16011,16014,2,,1,39.7,2102010,2102,21,210201000175,Freestyle Children's Velcro Shoes
93522,Valerie Piacentini,FR,Orion Club Gold members low activity,33,31-45 years,F,3,1232808618,16192,16197,1,,3,180.3,2102004,2102,21,210200400076,Tony's Children's Terra Reach(Bg) Shoes
92859,Vina Lucchesi,IT,Orion Club Gold members low activity,68,61-75 years,F,2,1232998123,16220,16224,1,,1,120.7,2202001,2202,22,220200100098,Big Guy Men's Air Tuned Max Shoes
94247,R.E.M. Hellwich,NL,Orion Club Gold members low activity,33,31-45 years,F,2,1233186086,16248,16253,1,,3,100.2,2202001,2202,22,220200100126,Big Guy Men's Gts Canvas Plus Shoes
93004,Andrea Povesi,IT,Orion Club Gold members low activity,53,46-60 years,M,3,1233203545,16251,16255,2,,2,207.8,2202002,2202,22,220200200068,Twain Men's Exentric Ii X-Hiking Shoes
92681,R.l. Giesolf,NL,Orion Club Gold members low activity,21,15-30 years,M,3,1233210834,16252,16255,1,,3,181.8,2202003,2202,22,220200300110,Qrs Men's Street Shoes
93004,Andrea Povesi,IT,Orion Club Gold members low activity,53,46-60 years,M,3,1233866700,16351,16355,1,,1,65.7,2202001,2202,22,220200100120,Big Guy Men's Cortez Iii Leather Shoes
93976,Alessandro Gallifuoco,IT,Orion Club Gold members low activity,58,46-60 years,M,3,1233933278,16361,16365,1,,2,162.4,2202003,2202,22,220200300129,Torino Men's Leather Adventure Shoes
93873,Bertilla Pilotti,IT,Orion Club Gold members low activity,48,46-60 years,F,3,1236043791,16595,16599,1,,2,168.4,2202003,2202,22,220200300014,Men's Running Shoes Ozweego
94204,J.J. Veenstra,NL,Orion Club Gold members low activity,58,46-60 years,F,2,1236336968,16624,16629,3,,3,249.9,2202003,2202,22,220200300153,Hardcore Junior/Women's Street Shoes Small
93862,Christiane Thiery,FR,Orion Club Gold members low activity,33,31-45 years,F,3,1238056757,16795,16797,1,,2,66.8,2102004,2102,21,210200400012,Kid Trainer Lite V(Bp) Street Shoes
93893,Ricciano Branca,IT,Orion Club Gold members low activity,58,46-60 years,M,3,1238302252,16824,16828,1,,1,64,2202002,2202,22,220200200021,Pro Fit  Gel Ds Trainer Iv Men's Running Shoe
92681,R.l. Giesolf,NL,Orion Club Gold members low activity,21,15-30 years,M,2,1238495603,16848,16850,1,,1,55,2202003,2202,22,220200300126,The Wish L Women's Running Shoes
94204,J.J. Veenstra,NL,Orion Club Gold members low activity,58,46-60 years,F,3,1238710166,16875,16881,1,,1,103.8,2202003,2202,22,220200300071,Hgf  Low Women's Indoor Shoes
93663,Herve Defossez,FR,Orion Club Gold members low activity,19,15-30 years,M,2,1239430413,16965,16967,1,,2,54.2,2102009,2102,21,210200900027,Osprey Cuda Lo Jr. Shoes Synthetic
93449,J.M.V. Prinsen,NL,Orion Club Gold members low activity,21,15-30 years,F,3,1239526765,16977,16991,1,,2,81.6,2202001,2202,22,220200100161,Eclipse Women's Off Court Canvas Shoes
92948,Philippe Lanfiaux,FR,Orion Club Gold members low activity,58,46-60 years,M,2,1240497988,17099,17100,1,,1,41.8,2102004,2102,21,210200400002,Deschutes Boys Outdoors Training Shoes
93138,B.T. Schouten,NL,Orion Club Gold members low activity,23,15-30 years,F,3,1240838831,17141,17146,1,,2,241.4,2202001,2202,22,220200100098,Big Guy Men's Air Tuned Max Shoes
93822,Emilio Trigueros,ES,Orion Club Gold members low activity,28,15-30 years,M,3,1241892178,17261,17265,3,,1,85.8,2202003,2202,22,220200300076,Hi Response Women's Aerobic Shoes Large
93822,Emilio Trigueros,ES,Orion Club Gold members low activity,28,15-30 years,M,3,1241892178,17261,17265,1,,1,33.4,2202001,2202,22,220200100126,Big Guy Men's Gts Canvas Plus Shoes
93449,J.M.V. Prinsen,NL,Orion Club Gold members low activity,21,15-30 years,F,2,1242638483,17343,17344,1,,2,213,2202001,2202,22,220200100084,Big Guy Men's Air Tailwind Shoes
93501,Alain Thouvenin,FR,Orion Club Gold members low activity,38,31-45 years,M,3,1242971272,17380,17382,1,,2,80.6,2102004,2102,21,210200400097,Tony's Extra Children's Multicourt(Bg) Shoes
93651,Izaskun Ramón López,ES,Orion Club Gold members low activity,53,46-60 years,F,3,1243892624,17482,17483,1,,1,64.9,2202001,2202,22,220200100005,4men Men's Air Golden Shoes
93476,Riccardo Caroppo,IT,Orion Club Gold members low activity,73,61-75 years,M,2,1244127095,17507,17508,2,,2,171.6,2202003,2202,22,220200300076,Hi Response Women's Aerobic Shoes Large
93476,Riccardo Caroppo,IT,Orion Club Gold members low activity,73,61-75 years,M,2,1244127095,17507,17508,1,,2,65.6,2202001,2202,22,220200100123,Big Guy Men's Deschutz Slide Shoes
;;;;
run;

data WORK.CLINIC_STATS;
    length Clinic $11;
    infile datalines delimiter = ',' DSD;
    informat month MONYY5. Clinic $11. monyy MONYY5.  ;
    format month monyy MONYY5. ;
    input month : MONYY5. Clinic $ monyy : monyy5. num_surg tot_pts Contact_Resp;
return;
datalines4;
JAN08,MMC-Central,JAN08,55,938,2.37
FEB08,MMC-Central,FEB08,49,993,2.39
MAR08,MMC-Central,MAR08,67,899,2.35
APR08,MMC-Central,APR08,63,489,2.38
MAY08,MMC-Central,MAY08,59,649,2.29
JUN08,MMC-Central,JUN08,50,485,2.38
JUL08,MMC-Central,JUL08,51,642,2.45
AUG08,MMC-Central,AUG08,67,692,2.39
SEP08,MMC-Central,SEP08,79,598,2.46
OCT08,MMC-Central,OCT08,73,597,2.49
NOV08,MMC-Central,NOV08,75,820,2.36
DEC08,MMC-Central,DEC08,72,807,2.44
JAN09,MMC-Central,JAN09,77,854,2.35
FEB09,MMC-Central,FEB09,78,896,2.48
MAR09,MMC-Central,MAR09,74,863,2.46
APR09,MMC-Central,APR09,68,945,2.45
JAN08,MMC-East,JAN08,50,838,2.19
FEB08,MMC-East,FEB08,44,903,2.29
MAR08,MMC-East,MAR08,61,809,2.3
APR08,MMC-East,APR08,53,489,2.19
MAY08,MMC-East,MAY08,53,249,2.25
JUN08,MMC-East,JUN08,40,285,2.18
JUL08,MMC-East,JUL08,41,242,2.25
AUG08,MMC-East,AUG08,57,292,2.25
SEP08,MMC-East,SEP08,49,298,2.16
OCT08,MMC-East,OCT08,63,497,2.24
NOV08,MMC-East,NOV08,64,920,2.16
DEC08,MMC-East,DEC08,62,907,2.23
JAN09,MMC-East,JAN09,67,854,2.25
FEB09,MMC-East,FEB09,68,896,2.28
MAR09,MMC-East,MAR09,75,865,2.27
APR09,MMC-East,APR09,74,876,2.29
;;;;
run;

 data work.Employees  ;
	  length Company $30 Department $40 Employee_Country $2 Employee_Gender $1  
	         Employee_Name $40 Job_Title $25 Org_Group $40 Section $40;
      infile datalines delimiter = ','  DSD ;
      informat Employee_ID 12.  
                  Employee_BirthDate DATE9. 
                  Employee_Hire_Date DATE9.
                  Employee_Term_Date DATE9. ;
      format Employee_ID 12.  
                Employee_Country $COUNTRY.
                Employee_Gender  $GENDER.  
                Salary dollar13.  
                Employee_BirthDate DATE9.  
                Employee_Hire_Date DATE9.  
                Employee_Term_Date DATE9.;  
      input       Employee_ID
                  Employee_Country  $
                  Company  $
                  Department  $
                  Section  $
                  Org_Group  $
                  Job_Title  $
                  Employee_Name  $
                  Employee_Gender  $
                  Salary  : comma.
                  Employee_BirthDate : date9.
                  Employee_Hire_Date : date9.
                  Employee_Term_Date : date9.
                  Manager_Levels
                  Manager_Level1
                  Manager_Level2
                  Manager_Level3
                  Manager_Level4
                  Manager_Level5   
                  Manager_Level6  ;
     label Employee_ID="Employee ID"  Employee_Country="Employee Country"  Company="Company"  
           Department="Department"  Section="Section"  Org_Group="Group"  Job_Title="Job Title"  
           Employee_Name="Employee Name" Employee_Term_Date="Employee Termination Date"
           Manager_Levels="Levels of Management"
           Manager_Level1="Manager at 1. level"
           Manager_Level2="Manager at 2. level"
           Manager_Level3="Manager at 3. level"
           Manager_Level4="Manager at 4. level"
           Manager_Level5="Manager at 5. level"   
           Manager_Level6="Manager at 6. level"   
           Employee_Gender="Employee Gender"  Salary="Annual Salary" 
           Employee_BirthDate="Employee Birthdate" Employee_Hire_Date="Employee Hire Date" ;
return;
datalines4;
120101,AU,Orion Australia,Sales Management,Sales Management,Sales Management,Director,Patrick Lu,M,"$163,040",18AUG1976,01JUL2003,,2,120261,120259,,,,
120102,AU,Orion Australia,Sales Management,Sales Management,Sales Management,Sales Manager,Tom Zhou,M,"$108,255",11AUG1969,01JUN1989,,3,120101,120261,120259,,,
120103,AU,Orion Australia,Sales Management,Sales Management,Sales Management,Sales Manager,Wilson Dawes,M,"$87,975",22JAN1949,01JAN1974,,3,120101,120261,120259,,,
120104,AU,Orion Australia,Administration,Administration,Administration,Administration Manager,Kareen Billington,F,"$46,230",11MAY1954,01JAN1981,,3,120101,120261,120259,,,
120105,AU,Orion Australia,Administration,Administration,Administration,Secretary I,Liz Povey,F,"$27,110",21DEC1974,01MAY1999,,3,120101,120261,120259,,,
120106,AU,Orion Australia,Administration,Administration,Administration,Office Assistant II,John Hornsey,M,"$26,960",23DEC1944,01JAN1974,,4,120104,120101,120261,120259,,
120107,AU,Orion Australia,Administration,Administration,Shipping Charges,Office Assistant III,Sherie Sheedy,F,"$30,475",21JAN1949,01FEB1974,,4,120104,120101,120261,120259,,
120108,AU,Orion Australia,Administration,Goods Entrance,Stock Admin,Warehouse Assistant II,Gladys Gromek,F,"$27,660",23FEB1984,01AUG2006,,4,120104,120101,120261,120259,,
120109,AU,Orion Australia,Administration,Goods Entrance,Stock Admin,Warehouse Assistant I,Gabriele Baker,F,"$26,495",15DEC1986,01OCT2006,,4,120104,120101,120261,120259,,
120110,AU,Orion Australia,Administration,Goods Entrance,Stock Admin,Warehouse Assistant III,Dennis Entwisle,M,"$28,615",20NOV1949,01NOV1979,,4,120104,120101,120261,120259,,
120111,AU,Orion Australia,Administration,Security,Security Guards,Security Guard II,Ubaldo Spillane,M,"$26,895",23JUL1949,01NOV1974,,4,120104,120101,120261,120259,,
120112,AU,Orion Australia,Administration,Security,Security Guards,Security Guard I,Ellis Glattback,F,"$26,550",17FEB1969,01JUL1990,,4,120104,120101,120261,120259,,
120113,AU,Orion Australia,Administration,Security,Security Guards,Security Guard II,Riu Horsey,F,"$26,870",10MAY1944,01JAN1974,,4,120104,120101,120261,120259,,
120114,AU,Orion Australia,Administration,Security,Security Guards,Security Manager,Jeannette Buddery,F,"$31,285",08FEB1944,01JAN1974,,4,120104,120101,120261,120259,,
120115,AU,Orion Australia,Administration,Service Center,Service,Service Assistant I,Hugh Nichollas,M,"$26,500",08MAY1984,01AUG2005,,4,120104,120101,120261,120259,,
120116,AU,Orion Australia,Administration,Service Center,Service,Service Assistant II,Austen Ralston,M,"$29,250",13JUN1959,01FEB1980,,4,120104,120101,120261,120259,,
120117,AU,Orion Australia,Engineering,Engineering,Cabinet Maker's Workshop,Cabinet Maker III,Bill Mccleary,M,"$31,670",11SEP1964,01APR1986,,4,120104,120101,120261,120259,,
120118,AU,Orion Australia,Engineering,Engineering,Cabinet Maker's Workshop,Cabinet Maker II,Darshi Hartshorn,M,"$28,090",03JUN1959,01JUL1984,,4,120104,120101,120261,120259,,
120119,AU,Orion Australia,Engineering,Engineering,Electrical Workshop,Electrician IV,Lal Elleman,M,"$30,255",21DEC1969,01JAN1998,,4,120104,120101,120261,120259,,
120120,AU,Orion Australia,Engineering,Engineering,Electrical Workshop,Electrician II,Krishna Peiris,F,"$27,645",05MAY1944,01JAN1974,,4,120104,120101,120261,120259,,
120121,AU,Orion Australia,Sales,Sales,Assorted Sports Articles,Sales Rep. II,Irenie Elvish,F,"$26,600",02AUG1944,01JAN1974,,4,120102,120101,120261,120259,,
120122,AU,Orion Australia,Sales,Sales,Assorted Sports Articles,Sales Rep. II,Christina Ngan,F,"$27,475",27JUL1954,01JUL1978,,4,120102,120101,120261,120259,,
120123,AU,Orion Australia,Sales,Sales,Assorted Sports Articles,Sales Rep. I,Kimiko Hotstone,F,"$26,190",28SEP1964,01OCT1985,31JAN2005,4,120102,120101,120261,120259,,
120124,AU,Orion Australia,Sales,Sales,Assorted Sports Articles,Sales Rep. I,Lucian Daymond,M,"$26,480",13MAY1959,01MAR1979,,4,120102,120101,120261,120259,,
120125,AU,Orion Australia,Sales,Sales,Children Sports,Sales Rep. IV,Fong Hofmeister,M,"$32,040",06DEC1954,01MAR1979,31JUL2004,4,120102,120101,120261,120259,,
120126,AU,Orion Australia,Sales,Sales,Children Sports,Sales Rep. II,Satyakam Denny,M,"$26,780",20SEP1988,01AUG2006,,4,120102,120101,120261,120259,,
120127,AU,Orion Australia,Sales,Sales,Clothes,Sales Rep. II,Sharryn Clarkson,F,"$28,100",04JAN1979,01NOV1998,,4,120102,120101,120261,120259,,
120128,AU,Orion Australia,Sales,Sales,Clothes,Sales Rep. IV,Monica Kletschkus,F,"$30,890",14JUL1986,01NOV2006,,4,120102,120101,120261,120259,,
120129,AU,Orion Australia,Sales,Sales,Clothes,Sales Rep. III,Alvin Roebuck,M,"$30,070",22NOV1964,01OCT1985,31MAR2003,4,120102,120101,120261,120259,,
120130,AU,Orion Australia,Sales,Sales,Clothes,Sales Rep. I,Kevin Lyon,M,"$26,955",14DEC1984,01MAY2006,,4,120102,120101,120261,120259,,
120131,AU,Orion Australia,Sales,Sales,Golf,Sales Rep. I,Marinus Surawski,M,"$26,910",25SEP1979,01JAN2003,,4,120102,120101,120261,120259,,
120132,AU,Orion Australia,Sales,Sales,Golf,Sales Rep. III,Fancine Kaiser,F,"$28,525",05APR1949,01OCT1978,,4,120102,120101,120261,120259,,
120133,AU,Orion Australia,Sales,Sales,Golf,Sales Rep. II,Petrea Soltau,F,"$27,440",22APR1986,01OCT2006,,4,120102,120101,120261,120259,,
120134,AU,Orion Australia,Sales,Sales,Golf,Sales Rep. II,Sian Shannan,M,"$28,015",06JUN1949,01JAN1974,30JUN2006,4,120102,120101,120261,120259,,
120135,AU,Orion Australia,Sales,Sales,Indoor Sports,Sales Rep. IV,Alexei Platts,M,"$32,490",26JAN1969,01OCT1997,30APR2004,4,120102,120101,120261,120259,,
120136,AU,Orion Australia,Sales,Sales,Indoor Sports,Sales Rep. I,Atul Leyden,M,"$26,605",16SEP1979,01FEB2003,,4,120102,120101,120261,120259,,
120137,AU,Orion Australia,Sales,Sales,Shoes,Sales Rep. III,Marina Iyengar,F,"$29,715",12MAR1979,01MAR2006,,4,120102,120101,120261,120259,,
120138,AU,Orion Australia,Sales,Sales,Shoes,Sales Rep. I,Shani Duckett,F,"$25,795",11JUL1979,01JUL2006,,4,120102,120101,120261,120259,,
120139,AU,Orion Australia,Sales,Sales,Shoes,Sales Rep. II,Fang Wilson,F,"$26,810",18AUG1986,01SEP2006,,4,120102,120101,120261,120259,,
120140,AU,Orion Australia,Sales,Sales,Outdoors,Sales Rep. I,Michael Minas,M,"$26,970",03AUG1988,01OCT2006,,4,120103,120101,120261,120259,,
120141,AU,Orion Australia,Sales,Sales,Outdoors,Sales Rep. II,Amanda Liebman,F,"$27,465",12MAR1988,01MAY2006,,4,120103,120101,120261,120259,,
120142,AU,Orion Australia,Sales,Sales,Outdoors,Sales Rep. III,Vincent Eastley,M,"$29,695",14JUN1986,01JUL2006,,4,120103,120101,120261,120259,,
120143,AU,Orion Australia,Sales,Sales,Outdoors,Sales Rep. II,Phu Sloey,M,"$26,790",17MAY1959,01OCT1982,,4,120103,120101,120261,120259,,
120144,AU,Orion Australia,Sales,Sales,Outdoors,Sales Rep. III,Viney Barbis,M,"$30,265",07MAR1986,01OCT2006,,4,120103,120101,120261,120259,,
120145,AU,Orion Australia,Sales,Sales,Outdoors,Sales Rep. II,Sandy Aisbitt,M,"$26,060",22JAN1964,01JUN1985,,4,120103,120101,120261,120259,,
120146,AU,Orion Australia,Sales,Sales,Outdoors,Sales Rep. I,Wendall Cederlund,M,"$25,985",02OCT1959,01AUG1980,30SEP2005,4,120103,120101,120261,120259,,
120147,AU,Orion Australia,Sales,Sales,Outdoors,Sales Rep. II,Skev Rusli,F,"$26,580",19JAN1988,01OCT2006,,4,120103,120101,120261,120259,,
120148,AU,Orion Australia,Sales,Sales,Outdoors,Sales Rep. III,Michael Zubak,M,"$28,480",13SEP1949,01JUN1978,,4,120103,120101,120261,120259,,
120149,AU,Orion Australia,Sales,Sales,Outdoors,Sales Rep. I,Judy Chantharasy,F,"$26,390",21NOV1974,01JAN1993,,4,120103,120101,120261,120259,,
120150,AU,Orion Australia,Sales,Sales,Outdoors,Sales Rep. III,John Filo,M,"$29,965",09JUL1954,01AUG1982,30APR2004,4,120103,120101,120261,120259,,
120151,AU,Orion Australia,Sales,Sales,Outdoors,Sales Rep. II,Julianna Phaiyakounh,F,"$26,520",21NOV1944,01JAN1974,,4,120103,120101,120261,120259,,
120152,AU,Orion Australia,Sales,Sales,Racket Sports,Sales Rep. I,Sean Dives,M,"$26,515",01MAY1979,01APR2005,,4,120102,120101,120261,120259,,
120153,AU,Orion Australia,Sales,Sales,Racket Sports,Sales Rep. I,Samantha Waal,F,"$27,260",07MAY1979,01JAN1998,31JAN2006,4,120102,120101,120261,120259,,
120154,AU,Orion Australia,Sales,Sales,Racket Sports,Sales Rep. III,Caterina Hayawardhana,F,"$30,490",20JUL1944,01JAN1974,,4,120102,120101,120261,120259,,
120155,AU,Orion Australia,Sales,Sales,Racket Sports,Sales Rep. III,Narelle James,F,"$29,990",22APR1984,01APR2006,,4,120102,120101,120261,120259,,
120156,AU,Orion Australia,Sales,Sales,Racket Sports,Sales Rep. I,Gerry Snellings,F,"$26,445",01SEP1988,01MAR2006,,4,120102,120101,120261,120259,,
120157,AU,Orion Australia,Sales,Sales,Racket Sports,Sales Rep. II,Leonid Karavdic,M,"$27,860",21FEB1986,01DEC2006,,4,120102,120101,120261,120259,,
120158,AU,Orion Australia,Sales,Sales,Racket Sports,Sales Rep. III,Daniel Pilgrim,M,"$36,605",14JUL1964,01JUL1987,31AUG2005,4,120102,120101,120261,120259,,
120159,AU,Orion Australia,Sales,Sales,Racket Sports,Sales Rep. IV,Lynelle Phoumirath,F,"$30,765",24FEB1964,01JUL1986,,4,120102,120101,120261,120259,,
120160,AU,Orion Australia,Sales,Sales,Racket Sports,Sales Rep. I,Chuck Segrave,M,"$27,115",09SEP1954,01OCT1974,,4,120102,120101,120261,120259,,
120161,AU,Orion Australia,Sales,Sales,Running - Jogging,Sales Rep. III,Rosette Martines,F,"$30,785",07MAR1988,01OCT2006,,4,120102,120101,120261,120259,,
120162,AU,Orion Australia,Sales,Sales,Running - Jogging,Sales Rep. I,Randal Scordia,M,"$27,215",05SEP1988,01FEB2006,,4,120102,120101,120261,120259,,
120163,AU,Orion Australia,Sales,Sales,Running - Jogging,Sales Rep. II,Brett Magrath,M,"$26,735",22MAY1964,01JAN1991,,4,120102,120101,120261,120259,,
120164,AU,Orion Australia,Sales,Sales,Running - Jogging,Sales Rep. II,Ranj Stamalis,F,"$27,450",26NOV1959,01FEB1982,,4,120102,120101,120261,120259,,
120165,AU,Orion Australia,Sales,Sales,Running - Jogging,Sales Rep. I,Tadashi Pretorius,M,"$27,050",19MAR1984,01MAR2006,,4,120102,120101,120261,120259,,
120166,AU,Orion Australia,Sales,Sales,Running - Jogging,Sales Rep. IV,Fadi Nowd,M,"$30,660",14JUN1944,01JAN1974,31AUG2006,4,120102,120101,120261,120259,,
120167,AU,Orion Australia,Sales,Sales,Running - Jogging,Sales Rep. I,Kimiko Tilley,F,"$25,185",04MAY1954,01FEB1974,31MAR2006,4,120102,120101,120261,120259,,
120168,AU,Orion Australia,Sales,Sales,Swim Sports,Sales Rep. I,Selina Barcoe,F,"$25,275",24MAR1984,01NOV2006,,4,120102,120101,120261,120259,,
120169,AU,Orion Australia,Sales,Sales,Swim Sports,Sales Rep. III,Cos Tannous,M,"$28,135",02JAN1984,01MAY2006,,4,120102,120101,120261,120259,,
120170,AU,Orion Australia,Sales,Sales,Swim Sports,Sales Rep. III,Alban Kingston,M,"$28,830",25FEB1974,01OCT1992,31OCT2006,4,120102,120101,120261,120259,,
120171,AU,Orion Australia,Sales,Sales,Swim Sports,Sales Rep. II,Alena Moody,F,"$26,205",19JUL1984,01SEP2006,,4,120102,120101,120261,120259,,
120172,AU,Orion Australia,Sales,Sales,Swim Sports,Sales Rep. III,Edwin Comber,M,"$28,345",01APR1944,01JAN1974,,4,120102,120101,120261,120259,,
120173,AU,Orion Australia,Sales,Sales,Swim Sports,Sales Rep. I,Hernani Osborn,M,"$26,715",23FEB1954,01JUN1977,31JUL2004,4,120102,120101,120261,120259,,
120174,AU,Orion Australia,Sales,Sales,Swim Sports,Sales Rep. I,Doungkamol Simms,F,"$26,850",10JAN1944,01JAN1974,30OCT2005,4,120102,120101,120261,120259,,
120175,AU,Orion Australia,Sales,Sales,Swim Sports,Sales Rep. I,Andrew Conolly,M,"$25,745",18AUG1988,01OCT2006,,4,120102,120101,120261,120259,,
120176,AU,Orion Australia,Sales,Sales,Team Sports,Sales Rep. I,Koavea Pa),M,"$26,095",09NOV1986,01NOV2006,,4,120102,120101,120261,120259,,
120177,AU,Orion Australia,Sales,Sales,Team Sports,Sales Rep. III,Franca Kierce,F,"$28,745",05APR1979,01FEB1998,,4,120102,120101,120261,120259,,
120178,AU,Orion Australia,Sales,Sales,Team Sports,Sales Rep. II,Billy Plested,M,"$26,165",23NOV1954,01APR1974,,4,120102,120101,120261,120259,,
120179,AU,Orion Australia,Sales,Sales,Team Sports,Sales Rep. III,Matsuoka Wills,M,"$28,510",15MAR1974,01JAN2004,31AUG2004,4,120102,120101,120261,120259,,
120180,AU,Orion Australia,Sales,Sales,Team Sports,Sales Rep. II,Vino George,M,"$26,970",27JUN1954,01DEC1978,,4,120102,120101,120261,120259,,
120181,AU,Orion Australia,Sales,Sales,Temporary,Temp. Sales Rep.,Lorian Cantatore,F,"$27,065",28NOV1988,01DEC2006,31MAR2007,4,120103,120101,120261,120259,,
120182,AU,Orion Australia,Sales,Sales,Temporary,Temp. Sales Rep.,Geok-Seng Barreto,M,"$25,020",05OCT1984,01DEC2006,31DEC2006,4,120103,120101,120261,120259,,
120183,AU,Orion Australia,Sales,Sales,Temporary,Temp. Sales Rep.,Brig Blanton,M,"$26,910",10SEP1969,01DEC2006,31DEC2006,4,120103,120101,120261,120259,,
120184,AU,Orion Australia,Sales,Sales,Temporary,Temp. Sales Rep.,Ari Moore,M,"$25,820",01DEC1949,01DEC2006,30APR2007,4,120103,120101,120261,120259,,
120185,AU,Orion Australia,Sales,Sales,Temporary,Temp. Sales Rep.,Sharon Bahlman,F,"$25,080",07APR1974,01DEC2006,31JAN2007,4,120103,120101,120261,120259,,
120186,AU,Orion Australia,Sales,Sales,Temporary,Temp. Sales Rep.,Merryn Quinby,F,"$26,795",19APR1979,01DEC2006,30JUN2007,4,120103,120101,120261,120259,,
120187,AU,Orion Australia,Sales,Sales,Temporary,Temp. Sales Rep.,Reyne Catenacci,F,"$26,665",10DEC1984,01DEC2006,31MAY2007,4,120103,120101,120261,120259,,
120188,AU,Orion Australia,Sales,Sales,Temporary,Temp. Sales Rep.,Shanmuganathan Baran,F,"$26,715",01MAR1954,01DEC2006,31DEC2006,4,120103,120101,120261,120259,,
120189,AU,Orion Australia,Sales,Sales,Temporary,Temp. Sales Rep.,Mihailo Lachlan,M,"$25,180",03JUL1984,01DEC2006,31MAR2007,4,120103,120101,120261,120259,,
120190,AU,Orion Australia,Sales,Sales,Trainees,Trainee,Ivor Czernezkyi,M,"$24,100",05DEC1984,01NOV2004,30APR2005,4,120103,120101,120261,120259,,
120191,AU,Orion Australia,Sales,Sales,Trainees,Trainee,Jannene Graham-Rowe,F,"$24,015",17JAN1959,01JAN2003,30JUN2003,4,120103,120101,120261,120259,,
120192,AU,Orion Australia,Sales,Sales,Trainees,Trainee,Anthony Nichollas,M,"$26,185",08MAY1984,01JUN2005,30NOV2005,4,120103,120101,120261,120259,,
120193,AU,Orion Australia,Sales,Sales,Trainees,Trainee,Russell Streit,M,"$24,515",06DEC1984,01SEP2005,28FEB2006,4,120103,120101,120261,120259,,
120194,AU,Orion Australia,Sales,Sales,Trainees,Trainee,Reece Harwood,M,"$25,985",23SEP1984,01FEB2005,31JUL2005,4,120103,120101,120261,120259,,
120195,AU,Orion Australia,Sales,Sales,Trainees,Trainee,Jina Fiocca,F,"$24,990",25DEC1984,01JUL2006,31DEC2006,4,120103,120101,120261,120259,,
120196,AU,Orion Australia,Sales,Sales,Trainees,Trainee,Merle Hieds,F,"$24,025",31JAN1984,01JAN2003,30JUN2003,4,120103,120101,120261,120259,,
120197,AU,Orion Australia,Sales,Sales,Trainees,Trainee,Kerrin Dillin,F,"$25,580",08AUG1954,01JAN2003,30JUN2003,4,120103,120101,120261,120259,,
120198,AU,Orion Australia,Sales,Sales,Winter Sports,Sales Rep. III,Meera Body,F,"$28,025",21JAN1988,01DEC2006,,4,120103,120101,120261,120259,,
120199,BE,Orion Belgium,Administration,Administration,Administration,Office Assistant I,Sandra Van Dorst,F,"$26,400",07JAN1949,01JAN2003,,4,120201,120257,120261,120259,,
120200,BE,Orion Belgium,Administration,Administration,Administration,Office Assistant II,Eddy Alvaro,F,"$26,155",02AUG1959,01JAN2003,,4,120201,120257,120261,120259,,
120201,BE,Orion Belgium,Administration,Administration,Shipping Charges,Administration Manager,Jean-Pierre Lemahieu,M,"$43,280",20JUL1974,01JAN2003,,3,120257,120261,120259,,,
120202,BE,Orion Belgium,Administration,Goods Entrance,Stock Admin,Warehouse Assistant III,Marie-Hélène Verboomen,F,"$29,370",18SEP1954,01JAN2003,,4,120201,120257,120261,120259,,
120203,BE,Orion Belgium,Administration,Goods Entrance,Stock Admin,Warehouse Assistant II,Blanche Molenaar,F,"$28,455",01MAY1949,01JAN2003,,4,120201,120257,120261,120259,,
120204,BE,Orion Belgium,Administration,Security,Security Guards,Security Guard I,Joel Geers,M,"$25,045",21APR1986,01NOV2006,,4,120201,120257,120261,120259,,
120205,BE,Orion Belgium,Administration,Security,Security Guards,Security Guard I,Kas Jagannathan,M,"$30,980",15MAR1959,01JAN2003,,4,120201,120257,120261,120259,,
120206,BE,Orion Belgium,Administration,Security,Security Guards,Security Manager,Rein Claerbout,F,"$30,665",16NOV1974,01JAN2003,,4,120201,120257,120261,120259,,
120207,BE,Orion Belgium,Administration,Service Center,Service,Service Assistant I,Jacky Rahier,M,"$26,010",27FEB1964,01JAN2003,,4,120201,120257,120261,120259,,
120208,BE,Orion Belgium,Administration,Service Center,Service,Service Assistant III,Gilbert Croufer,M,"$30,860",15JUL1964,01JAN2003,,4,120201,120257,120261,120259,,
120209,BE,Orion Belgium,Administration,Service Center,Service,Service Assistant I,Elfriede Depienne,F,"$27,000",06JUL1969,01JAN2003,,4,120201,120257,120261,120259,,
120210,BE,Orion Belgium,Engineering,Engineering,Cabinet Maker's Workshop,Cabinet Maker II,Nelly Baes,F,"$29,805",09MAY1949,01JAN2003,,4,120201,120257,120261,120259,,
120211,BE,Orion Belgium,Engineering,Engineering,Electrical Workshop,Electrician I,Johan Sarrand,M,"$27,260",16NOV1949,01JAN2003,,4,120201,120257,120261,120259,,
120212,BE,Orion Belgium,Sales,Sales,Assorted Sports Articles,Sales Rep. I,Judd Masson,M,"$26,720",06APR1959,01JAN2003,31AUG2006,4,120258,120257,120261,120259,,
120213,BE,Orion Belgium,Sales,Sales,Assorted Sports Articles,Sales Rep. II,Adrian de Pelsemaecker,M,"$27,310",16OCT1954,01JAN2003,,4,120258,120257,120261,120259,,
120214,BE,Orion Belgium,Sales,Sales,Assorted Sports Articles,Sales Rep. I,Anne-Mie Nelles,F,"$26,030",08FEB1979,01OCT2006,,4,120258,120257,120261,120259,,
120215,BE,Orion Belgium,Sales,Sales,Children Sports,Sales Rep. I,Anne-Laure Arnotte,F,"$26,600",09JUL1954,01JAN2003,30NOV2006,4,120258,120257,120261,120259,,
120216,BE,Orion Belgium,Sales,Sales,Children Sports,Sales Rep. II,Justo Fabry,M,"$27,935",23MAR1964,01JAN2003,,4,120258,120257,120261,120259,,
120217,BE,Orion Belgium,Sales,Sales,Children Sports,Sales Rep. II,Raffaele Staessen,M,"$28,230",24FEB1969,01JAN2003,,4,120258,120257,120261,120259,,
120218,BE,Orion Belgium,Sales,Sales,Clothes,Sales Rep. I,Martine Steverlinck,F,"$26,630",22OCT1984,01APR2006,,4,120258,120257,120261,120259,,
120219,BE,Orion Belgium,Sales,Sales,Clothes,Sales Rep. IV,Karel de Streel,F,"$32,470",01MAR1964,01JAN2003,,4,120258,120257,120261,120259,,
120220,BE,Orion Belgium,Sales,Sales,Golf,Sales Rep. II,Mark Henri Van Grimbergen,M,"$27,365",19MAY1969,01JAN2003,,4,120258,120257,120261,120259,,
120221,BE,Orion Belgium,Sales,Sales,Golf,Sales Rep. II,Denise Deguent,F,"$26,860",14MAY1964,01JAN2003,,4,120258,120257,120261,120259,,
120222,BE,Orion Belgium,Sales,Sales,Golf,Sales Rep. II,Olivier Bolsens,M,"$27,080",04NOV1964,01JAN2003,,4,120258,120257,120261,120259,,
120223,BE,Orion Belgium,Sales,Sales,Golf,Sales Rep. I,Vincent Dumalin,M,"$27,265",21APR1988,01MAY2006,,4,120258,120257,120261,120259,,
120224,BE,Orion Belgium,Sales,Sales,Golf,Sales Rep. II,Elsy Ernoux,F,"$26,350",21SEP1959,01JAN2003,30APR2004,4,120258,120257,120261,120259,,
120225,BE,Orion Belgium,Sales,Sales,Golf,Sales Rep. I,Maddy Chardome,F,"$25,240",26JUN1988,01JAN2007,,4,120258,120257,120261,120259,,
120226,BE,Orion Belgium,Sales,Sales,Indoor Sports,Sales Rep. II,Wambuna Menten,M,"$28,185",11JAN1988,01NOV2006,,4,120258,120257,120261,120259,,
120227,BE,Orion Belgium,Sales,Sales,Shoes,Sales Rep. I,Marie Pascale Baffioni,M,"$27,485",28AUG1988,01FEB2006,,4,120258,120257,120261,120259,,
120228,BE,Orion Belgium,Sales,Sales,Shoes,Sales Rep. II,Rigo Dossantos,F,"$26,500",06AUG1969,01JAN2003,30APR2004,4,120258,120257,120261,120259,,
120229,BE,Orion Belgium,Sales,Sales,Outdoors,Sales Rep. II,Jean-Pierre Allouche,M,"$27,185",23MAR1979,01JAN2003,,4,120258,120257,120261,120259,,
120230,BE,Orion Belgium,Sales,Sales,Outdoors,Sales Rep. I,Rufijn Valvekens,M,"$27,155",03JUN1969,01JAN2003,31DEC2004,4,120258,120257,120261,120259,,
120231,BE,Orion Belgium,Sales,Sales,Outdoors,Sales Rep. II,Luk de Muylder,M,"$27,070",08SEP1964,01JAN2003,,4,120258,120257,120261,120259,,
120232,BE,Orion Belgium,Sales,Sales,Outdoors,Sales Rep. II,Elly Bullen,F,"$27,800",15NOV1944,01JAN2003,31JUL2005,4,120258,120257,120261,120259,,
120233,BE,Orion Belgium,Sales,Sales,Outdoors,Sales Rep. I,Els Van Der Hulst,F,"$26,020",14DEC1954,01JAN2003,,4,120258,120257,120261,120259,,
120234,BE,Orion Belgium,Sales,Sales,Outdoors,Sales Rep. II,Candice Famaey,F,"$26,515",26JUN1949,01JAN2003,,4,120258,120257,120261,120259,,
120235,BE,Orion Belgium,Sales,Sales,Outdoors,Sales Rep. III,Claude Temara,F,"$30,590",15JAN1986,01NOV2006,,4,120258,120257,120261,120259,,
120236,BE,Orion Belgium,Sales,Sales,Racket Sports,Sales Rep. I,Chrystelle Vandenbosch,F,"$27,475",28JAN1979,01JAN2003,,4,120258,120257,120261,120259,,
120237,BE,Orion Belgium,Sales,Sales,Racket Sports,Sales Rep. II,Sheila Geyssens,F,"$28,300",09APR1986,01NOV2006,,4,120258,120257,120261,120259,,
120238,BE,Orion Belgium,Sales,Sales,Racket Sports,Sales Rep. I,André Biermans,M,"$26,870",10FEB1988,01OCT2006,,4,120258,120257,120261,120259,,
120239,BE,Orion Belgium,Sales,Sales,Running - Jogging,Sales Rep. III,Michel Van de Broeck,M,"$29,700",28OCT1959,01JAN2003,,4,120258,120257,120261,120259,,
120240,BE,Orion Belgium,Sales,Sales,Running - Jogging,Sales Rep. III,Cathy Hurchon,F,"$29,725",21MAR1964,01JAN2003,,4,120258,120257,120261,120259,,
120241,BE,Orion Belgium,Sales,Sales,Running - Jogging,Sales Rep. I,Rigo Ramakers,F,"$25,430",19OCT1959,01JAN2003,30APR2004,4,120258,120257,120261,120259,,
120242,BE,Orion Belgium,Sales,Sales,Running - Jogging,Sales Rep. I,Edwin Houba,M,"$26,865",23JUN1974,01JAN2003,,4,120258,120257,120261,120259,,
120243,BE,Orion Belgium,Sales,Sales,Running - Jogging,Sales Rep. II,Jari Stokowski,M,"$28,580",23OCT1969,01JAN2003,30JUN2003,4,120258,120257,120261,120259,,
120244,BE,Orion Belgium,Sales,Sales,Swim Sports,Sales Rep. II,Jan Van Caillie,M,"$28,140",06AUG1964,01JAN2003,,4,120258,120257,120261,120259,,
120245,BE,Orion Belgium,Sales,Sales,Swim Sports,Sales Rep. II,Hilde de Potter,M,"$28,130",12JUL1988,01MAR2006,,4,120258,120257,120261,120259,,
120246,BE,Orion Belgium,Sales,Sales,Swim Sports,Sales Rep. IV,Mrc Lemaître,M,"$31,645",18SEP1944,01JAN2003,,4,120258,120257,120261,120259,,
120247,BE,Orion Belgium,Sales,Sales,Swim Sports,Sales Rep. II,Jean-Marc Shannon,M,"$26,590",24DEC1988,01JUN2006,,4,120258,120257,120261,120259,,
120248,BE,Orion Belgium,Sales,Sales,Team Sports,Sales Rep. II,François Stas de Richelle,M,"$26,800",17DEC1944,01JAN2003,30SEP2005,4,120258,120257,120261,120259,,
120249,BE,Orion Belgium,Sales,Sales,Team Sports,Sales Rep. II,William Looze,M,"$27,775",25JAN1969,01JAN2003,,4,120258,120257,120261,120259,,
120250,BE,Orion Belgium,Sales,Sales,Team Sports,Sales Rep. II,Madeleine Rajkowski,F,"$26,015",15DEC1954,01JAN2003,,4,120258,120257,120261,120259,,
120251,BE,Orion Belgium,Sales,Sales,Temporary,Temp. Sales Rep.,Fr. Rochtus,M,"$25,785",11SEP1959,01DEC2006,31MAY2007,4,120258,120257,120261,120259,,
120252,BE,Orion Belgium,Sales,Sales,Temporary,Temp. Sales Rep.,Jean-Do Lenaers,M,"$26,450",08AUG1969,01DEC2006,28FEB2007,4,120258,120257,120261,120259,,
120253,BE,Orion Belgium,Sales,Sales,Temporary,Temp. Sales Rep.,Harry Demaeghdt,M,"$25,545",06MAR1954,01DEC2006,31MAR2007,4,120258,120257,120261,120259,,
120254,BE,Orion Belgium,Sales,Sales,Temporary,Temp. Sales Rep.,Linda Cheruy,F,"$27,310",19DEC1954,01DEC2006,31MAY2007,4,120258,120257,120261,120259,,
120255,BE,Orion Belgium,Sales,Sales,Winter Sports,Sales Rep. II,Gaétane Hubrecht,F,"$27,285",03AUG1964,01JAN2003,,4,120258,120257,120261,120259,,
120256,BE,Orion Belgium,Sales,Sales,Winter Sports,Sales Rep. I,Remi Vermaillen,M,"$27,295",23JUN1949,01JAN2003,30SEP2005,4,120258,120257,120261,120259,,
120257,BE,Orion Belgium,Sales Management,Sales Management,Sales Management,Director,Pascal Hast,F,"$156,245",22MAY1974,01JAN2003,,2,120261,120259,,,,
120258,BE,Orion Belgium,Sales Management,Sales Management,Sales Management,Sales Manager,Kenneth Van Heembeek,M,"$83,305",22JUN1954,01JAN2003,,3,120257,120261,120259,,,
120259,US,Board of Directors,Executives,Executives,Executives,Chief Executive Officer,Anthony Miller,M,"$433,800",25JAN1964,01SEP1989,,0,,,,,,
120260,US,Board of Directors,Executives,Executives,Executives,Chief Marketing Officer,Christine Fletcher,F,"$207,885",02DEC1964,01NOV1984,,1,120259,,,,,
120261,US,Board of Directors,Executives,Executives,Executives,Chief Sales Officer,Harry Highpoint,M,"$243,190",21FEB1969,01AUG1987,,1,120259,,,,,
120262,US,Board of Directors,Executives,Executives,Executives,Chief Financial Officer,Max Crown,M,"$268,455",21OCT1969,01SEP1988,,1,120259,,,,,
120263,US,Board of Directors,Group Financials,Group Finance,Group Finance,Financial Analyst III,Bobby Cleverley,M,"$42,605",10FEB1964,01OCT1983,31DEC2003,2,120262,120259,,,,
120264,US,Board of Directors,Group Financials,Group Finance,Group Finance,Financial Analyst II,Latonya Croome,F,"$37,510",23JAN1984,01DEC2006,,2,120262,120259,,,,
120265,US,Board of Directors,Group Financials,Group Finance,Group Finance,Auditor III,Wanda Branly,F,"$51,950",04OCT1944,01JAN1974,31DEC2002,2,120262,120259,,,,
120266,US,Board of Directors,Secretary of the Board,Secretary of the Board,Secretary,Secretary IV,Bao Krafve,F,"$31,750",01JUL1969,01APR1989,,1,120259,,,,,
120267,US,Board of Directors,Secretary of the Board,Secretary of the Board,Secretary,Secretary III,Belanda Rink,F,"$28,585",02JUN1986,01FEB2003,,1,120259,,,,,
120268,US,Board of Directors,Strategy,Strategy,Strategy,Senior Strategist,Jacques Villeneuve,M,"$76,105",01SEP1974,01MAY1997,,2,120260,120259,,,,
120269,US,Board of Directors,Strategy,Strategy,Strategy,Strategist II,Shrimatee Kagolanu,F,"$52,540",27SEP1944,01JAN1974,30APR2004,2,120260,120259,,,,
120270,US,Concession,Concession Management,Concession Management,Concession Management,Concession Director,Grezegorz Nuss,M,"$48,435",25MAR1954,01JAN1974,,2,120261,120259,,,,
120271,US,Concession,Concession Management,Concession Management,Concession Management,Concession Manager,Kenisha Winge,F,"$43,635",06AUG1964,01SEP1986,,3,120270,120261,120259,,,
120272,US,Concession,Concession Management,Concession Management,Eclipse,Concession Consultant II,Febin Flow,M,"$34,390",15MAR1944,01JAN1974,,4,120271,120270,120261,120259,,
120273,US,Concession,Concession Management,Concession Management,Eclipse,Concession Assistant III,Doris Antonini,F,"$28,455",07JUN1986,01MAR2006,,4,120271,120270,120261,120259,,
120274,US,Concession,Concession Management,Concession Management,Eclipse,Concession Assistant I,Angela Landry,F,"$26,840",09JAN1964,01DEC1993,,4,120271,120270,120261,120259,,
120275,US,Concession,Concession Management,Concession Management,N.D. Gear,Concession Consultant II,Brandy Lattimer,F,"$32,195",27DEC1959,01OCT1984,,4,120271,120270,120261,120259,,
120276,US,Concession,Concession Management,Concession Management,N.D. Gear,Concession Assistant II,Nicholas Plybon,M,"$28,090",16DEC1944,01JAN1974,31MAY2003,4,120271,120270,120261,120259,,
120277,US,Concession,Concession Management,Concession Management,Tracker,Concession Consultant I,Wesley Shirts,F,"$32,645",16AUG1988,01MAY2004,31MAY2005,4,120271,120270,120261,120259,,
120278,US,Concession,Concession Management,Concession Management,Tracker,Concession Assistant III,Binit Jongleux,M,"$27,685",17DEC1986,01AUG2006,,4,120271,120270,120261,120259,,
120279,US,Concession,Concession Management,International Concession,International Concession,Concession Consultant I,Kareema Dunlap,F,"$32,925",20OCT1969,01MAY1996,,4,120271,120270,120261,120259,,
120280,US,Concession,Concession Management,International Concession,International Concession,Concession Consultant III,Jaime Laurer,F,"$36,930",11NOV1964,01MAY1988,30JUN2002,4,120271,120270,120261,120259,,
120281,DK,Orion Denmark,Administration,Administration,Administration,Office Assistant II,Birthe Kirstine Wiuff,F,"$26,605",18FEB1954,01JAN1981,,4,120283,120331,120261,120259,,
120282,DK,Orion Denmark,Administration,Administration,Administration,Secretary III,Vagn Kristian Thiberg,M,"$29,915",06SEP1986,01APR2006,,4,120283,120331,120261,120259,,
120283,DK,Orion Denmark,Administration,Administration,Shipping Charges,Administration Manager,Kurt Ivan Toxwenius,M,"$25,780",26SEP1986,01NOV2004,,3,120331,120261,120259,,,
120284,DK,Orion Denmark,Administration,Goods Entrance,Stock Admin,Warehouse Manager,Knud Aage Bøttger,M,"$42,095",19AUG1964,01NOV1986,,4,120283,120331,120261,120259,,
120285,DK,Orion Denmark,Administration,Goods Entrance,Stock Admin,Warehouse Assistant I,Lars Peter Clausen,M,"$27,425",18DEC1964,01OCT1994,,5,120284,120283,120331,120261,120259,
120286,DK,Orion Denmark,Administration,Security,Security Guards,Security Manager,Jørgen Bak Galdyn,M,"$32,970",15MAY1979,01SEP1997,,4,120283,120331,120261,120259,,
120287,DK,Orion Denmark,Administration,Security,Security Guards,Security Guard II,Steffen Louis Grenander,M,"$27,230",02JAN1949,01JAN1974,,5,120286,120283,120331,120261,120259,
120288,DK,Orion Denmark,Administration,Service Center,Service,Service Assistant I,Jan Lennart Pilgård,M,"$27,165",28JAN1954,01FEB1976,,4,120283,120331,120261,120259,,
120289,DK,Orion Denmark,Administration,Service Center,Service,Service Assistant II,Eva Charlotte Lindsted-Holm,F,"$29,620",09DEC1969,01MAR1990,,4,120283,120331,120261,120259,,
120290,DK,Orion Denmark,Engineering,Engineering,Cabinet Maker's Workshop,Cabinet Maker II,Lisbeth Christina Dreisig,F,"$29,020",04MAR1969,01JAN1989,,4,120283,120331,120261,120259,,
120291,DK,Orion Denmark,Engineering,Engineering,Electrical Workshop,Electrician III,Brita Fisker Gloggengiehser,F,"$28,345",12JUN1986,01OCT2006,,4,120283,120331,120261,120259,,
120292,DK,Orion Denmark,Sales,Sales,Assorted Sports Articles,Sales Rep. III,Fritz Thomas Helvig,M,"$30,450",20MAY1974,01APR1999,30NOV2005,4,120330,120331,120261,120259,,
120293,DK,Orion Denmark,Sales,Sales,Assorted Sports Articles,Sales Rep. I,Poul Ib Schlegel,M,"$26,975",18MAY1988,01JAN2007,,4,120330,120331,120261,120259,,
120294,DK,Orion Denmark,Sales,Sales,Assorted Sports Articles,Sales Rep. I,Anne Kirstine Markussen,F,"$26,655",09SEP1954,01JUL1980,,4,120330,120331,120261,120259,,
120295,DK,Orion Denmark,Sales,Sales,Children Sports,Sales Rep. II,Inez Anna Ingves,F,"$27,170",01OCT1969,01APR1993,,4,120330,120331,120261,120259,,
120296,DK,Orion Denmark,Sales,Sales,Children Sports,Sales Rep. III,Michael Svend Hersbo,M,"$30,610",26APR1988,01OCT2006,,4,120330,120331,120261,120259,,
120297,DK,Orion Denmark,Sales,Sales,Clothes,Sales Rep. I,Per Hjort Stensgaard,M,"$26,635",10JUN1964,01SEP1987,,4,120330,120331,120261,120259,,
120298,DK,Orion Denmark,Sales,Sales,Clothes,Sales Rep. II,Lars Guldberg Berggreen,M,"$26,415",11MAR1984,01DEC2006,,4,120330,120331,120261,120259,,
120299,DK,Orion Denmark,Sales,Sales,Golf,Sales Rep. II,Leif Ove Perauer,M,"$26,435",24OCT1944,01JAN1974,31MAY2006,4,120330,120331,120261,120259,,
120300,DK,Orion Denmark,Sales,Sales,Golf,Sales Rep. III,Hanne Løvkvist Schumann,F,"$29,805",06NOV1944,01JAN1974,,4,120330,120331,120261,120259,,
120301,DK,Orion Denmark,Sales,Sales,Indoor Sports,Sales Rep. I,Rita Tidemann Jernfort,F,"$29,710",15SEP1954,01MAR1983,,4,120330,120331,120261,120259,,
120302,DK,Orion Denmark,Sales,Sales,Shoes,Sales Rep. I,Jane Sehested Kirchhof,F,"$26,180",03MAY1964,01DEC1983,,4,120330,120331,120261,120259,,
120303,DK,Orion Denmark,Sales,Sales,Shoes,Sales Rep. II,Henning Egon Plesner,M,"$28,555",12JUN1949,01FEB1974,31MAY2006,4,120330,120331,120261,120259,,
120304,DK,Orion Denmark,Sales,Sales,Outdoors,Sales Rep. III,Ilse Bryde,F,"$28,825",20MAY1988,01AUG2006,,4,120330,120331,120261,120259,,
120305,DK,Orion Denmark,Sales,Sales,Outdoors,Sales Rep. I,Mogens Georg Bothager,M,"$27,260",01AUG1949,01FEB1979,,4,120330,120331,120261,120259,,
120306,DK,Orion Denmark,Sales,Sales,Outdoors,Sales Rep. II,Connie Ilona Lurendreier,F,"$26,585",05JUN1986,01MAR2006,,4,120330,120331,120261,120259,,
120307,DK,Orion Denmark,Sales,Sales,Outdoors,Sales Rep. IV,Ellinor Jytte Buusman,F,"$30,170",13NOV1964,01AUG1986,,4,120330,120331,120261,120259,,
120308,DK,Orion Denmark,Sales,Sales,Outdoors,Sales Rep. II,Birgit Melgaard Vikkelsø,F,"$27,555",15APR1954,01SEP1982,31DEC2003,4,120330,120331,120261,120259,,
120309,DK,Orion Denmark,Sales,Sales,Outdoors,Sales Rep. II,Allan Moslund Brusch,M,"$27,325",09SEP1949,01JAN1974,,4,120330,120331,120261,120259,,
120310,DK,Orion Denmark,Sales,Sales,Racket Sports,Sales Rep. I,Anita Dahl Ohlsen,F,"$25,495",18NOV1944,01JAN1974,31MAR2006,4,120330,120331,120261,120259,,
120311,DK,Orion Denmark,Sales,Sales,Racket Sports,Sales Rep. III,Bo Sønderberg Skjørringe,M,"$28,585",23JUN1986,01AUG2006,01FEB2007,4,120330,120331,120261,120259,,
120312,DK,Orion Denmark,Sales,Sales,Racket Sports,Sales Rep. II,Leif Wiid Petersen,M,"$27,645",16SEP1988,01APR2006,,4,120330,120331,120261,120259,,
120313,DK,Orion Denmark,Sales,Sales,Racket Sports,Sales Rep. II,Anders Ove Ingerslev,M,"$26,230",26APR1944,01JAN1974,31DEC2004,4,120330,120331,120261,120259,,
120314,DK,Orion Denmark,Sales,Sales,Running - Jogging,Sales Rep. II,Dorthe Skjærris Hye-Knudsen,F,"$27,840",27SEP1959,01MAR1979,31OCT2005,4,120330,120331,120261,120259,,
120315,DK,Orion Denmark,Sales,Sales,Running - Jogging,Sales Rep. II,Lone Wibeke Wiuff,F,"$27,785",02APR1954,01FEB1976,,4,120330,120331,120261,120259,,
120316,DK,Orion Denmark,Sales,Sales,Running - Jogging,Sales Rep. IV,Merethe Pedersen Lykkeskov,F,"$31,495",16APR1959,01AUG1983,,4,120330,120331,120261,120259,,
120317,DK,Orion Denmark,Sales,Sales,Running - Jogging,Sales Rep. II,Johnny Krøyer Jaedeke,M,"$28,160",05JAN1979,01MAY2004,,4,120330,120331,120261,120259,,
120318,DK,Orion Denmark,Sales,Sales,Running - Jogging,Sales Rep. I,Anders Hvarre,M,"$27,250",11MAY1964,01MAR1991,,4,120330,120331,120261,120259,,
120319,DK,Orion Denmark,Sales,Sales,Swim Sports,Sales Rep. III,Jørgen Leif Støvring,M,"$29,340",01MAY1979,01JAN2001,,4,120330,120331,120261,120259,,
120320,DK,Orion Denmark,Sales,Sales,Swim Sports,Sales Rep. II,Martha Kiilerich Damkier,F,"$27,740",06JAN1984,01MAR2002,30APR2004,4,120330,120331,120261,120259,,
120321,DK,Orion Denmark,Sales,Sales,Swim Sports,Sales Rep. I,Henning Leif Stefansen,M,"$25,250",14OCT1988,01MAY2006,01NOV2006,4,120330,120331,120261,120259,,
120322,DK,Orion Denmark,Sales,Sales,Swim Sports,Sales Rep. I,Jim Keller Seide,M,"$25,560",24MAY1974,01NOV2000,,4,120330,120331,120261,120259,,
120323,DK,Orion Denmark,Sales,Sales,Team Sports,Sales Rep. II,Merete Møller Birkholm,F,"$27,980",23JUL1984,01JUL2004,,4,120330,120331,120261,120259,,
120324,DK,Orion Denmark,Sales,Sales,Team Sports,Sales Rep. II,Ketty Nielsen,F,"$28,580",15FEB1986,01NOV2006,,4,120330,120331,120261,120259,,
120325,DK,Orion Denmark,Sales,Sales,Temporary,Temp. Sales Rep.,Nadja Micheelsen,F,"$26,370",27MAR1988,01DEC2006,31MAY2007,4,120330,120331,120261,120259,,
120326,DK,Orion Denmark,Sales,Sales,Temporary,Temp. Sales Rep.,Hanne Møller Hardsner,F,"$25,640",05APR1959,01DEC2006,31DEC2006,4,120330,120331,120261,120259,,
120327,DK,Orion Denmark,Sales,Sales,Temporary,Temp. Sales Rep.,Bjarne Rask Skou,M,"$25,165",01OCT1949,01DEC2006,31MAR2007,4,120330,120331,120261,120259,,
120328,DK,Orion Denmark,Sales,Sales,Winter Sports,Sales Rep. I,Elin Hugger,F,"$25,530",08MAY1954,01APR1977,,4,120330,120331,120261,120259,,
120329,DK,Orion Denmark,Sales,Sales,Winter Sports,Sales Rep. I,Jesper Reinholt Jagd,M,"$25,965",14APR1954,01JUL1979,30JUN2005,4,120330,120331,120261,120259,,
120330,DK,Orion Denmark,Sales Management,Sales Management,Sales Management,Sales Manager,Bjarne Gudomlund Buch-Larsen,M,"$87,750",24OCT1976,01JUL2002,,3,120331,120261,120259,,,
120331,DK,Orion Denmark,Sales Management,Sales Management,Sales Management,Director,Harald Schkliaroff,M,"$151,285",04APR1969,01DEC1995,,2,120261,120259,,,,
120332,FR,Orion France,Administration,Administration,Administration,Office Assistant I,Dominique Claverie,M,"$25,070",05OCT1969,01DEC1994,,4,120335,120412,120261,120259,,
120333,FR,Orion France,Administration,Administration,Administration,Office Assistant II,Juan Alberto Duchemin,M,"$26,330",06JUL1974,01SEP1996,,4,120335,120412,120261,120259,,
120334,FR,Orion France,Administration,Administration,Administration,Secretary III,Veronique Cambien,F,"$28,015",24JUL1979,01JAN2000,,4,120335,120412,120261,120259,,
120335,FR,Orion France,Administration,Administration,Shipping Charges,Administration Manager,Jean-Claude Willmann,M,"$47,230",11MAR1949,01APR1976,,3,120412,120261,120259,,,
120336,FR,Orion France,Administration,Goods Entrance,Stock Admin,Warehouse Manager,Anne Poisson,F,"$43,950",11FEB1976,01MAY2001,,4,120335,120412,120261,120259,,
120337,FR,Orion France,Administration,Goods Entrance,Stock Admin,Warehouse Assistant I,Laurent Le Neve - Ricordel,M,"$26,540",28MAY1949,01MAY1976,31MAR2003,5,120336,120335,120412,120261,120259,
120338,FR,Orion France,Administration,Goods Entrance,Stock Admin,Warehouse Assistant II,Alain Rodrigues,M,"$28,415",01NOV1984,01OCT2006,,5,120336,120335,120412,120261,120259,
120339,FR,Orion France,Administration,Security,Security Guards,Security Manager,Jean-Pierre Abdelhamid,M,"$31,690",07DEC1944,01JAN1974,,4,120335,120412,120261,120259,,
120340,FR,Orion France,Administration,Security,Security Guards,Security Guard I,Valerie Robain,F,"$27,330",28FEB1979,01DEC2006,,5,120339,120335,120412,120261,120259,
120341,FR,Orion France,Administration,Security,Security Guards,Security Guard II,Patrick Charlier,M,"$26,220",23JAN1986,01MAR2006,,5,120339,120335,120412,120261,120259,
120342,FR,Orion France,Administration,Service Center,Service,Service Assistant I,Alice Cousin,F,"$23,585",10AUG1959,01AUG1985,31JAN2003,4,120335,120412,120261,120259,,
120343,FR,Orion France,Administration,Service Center,Service,Service Assistant I,Michelle Cayet,F,"$27,300",13JUN1944,01JAN1974,,4,120335,120412,120261,120259,,
120344,FR,Orion France,Administration,Service Center,Service,Service Assistant III,Etienne Bourdas,F,"$31,595",10JUL1969,01OCT1994,,4,120335,120412,120261,120259,,
120345,FR,Orion France,Engineering,Engineering,Cabinet Maker's Workshop,Cabinet Maker IV,Eliane Pastorelli,F,"$32,560",24MAY1984,01JUN2006,,4,120335,120412,120261,120259,,
120346,FR,Orion France,Engineering,Engineering,Cabinet Maker's Workshop,Cabinet Maker I,Jean-Michel Michon,M,"$26,960",28JAN1954,01MAR1980,,4,120335,120412,120261,120259,,
120347,FR,Orion France,Engineering,Engineering,Electrical Workshop,Electrician III,Regine Balestan,F,"$28,940",10SEP1979,01JUL2005,,4,120335,120412,120261,120259,,
120348,FR,Orion France,Sales,Sales,Assorted Sports Articles,Sales Rep. III,Jean-Luc Lebourgeois,M,"$28,205",15JUL1944,01JAN1974,31JAN2003,4,120415,120412,120261,120259,,
120349,FR,Orion France,Sales,Sales,Assorted Sports Articles,Sales Rep. III,Cedric Desqueyroux,M,"$30,510",24OCT1944,01JAN1974,,4,120415,120412,120261,120259,,
120350,FR,Orion France,Sales,Sales,Assorted Sports Articles,Sales Rep. IV,Eric Golliot,M,"$32,770",11JUN1944,01JAN1974,,4,120415,120412,120261,120259,,
120351,FR,Orion France,Sales,Sales,Assorted Sports Articles,Sales Rep. II,Marie-Christine Le Bihen,F,"$27,030",06FEB1974,01DEC1997,,4,120415,120412,120261,120259,,
120352,FR,Orion France,Sales,Sales,Assorted Sports Articles,Sales Rep. I,Michele Dewerdt,F,"$25,490",19APR1984,01FEB2007,,4,120415,120412,120261,120259,,
120353,FR,Orion France,Sales,Sales,Children Sports,Sales Rep. I,Valerie Fichou,F,"$26,240",12JAN1944,01JAN1974,,4,120415,120412,120261,120259,,
120354,FR,Orion France,Sales,Sales,Children Sports,Sales Rep. II,Cristiana Parniere,F,"$26,340",19MAR1988,01NOV2006,,4,120415,120412,120261,120259,,
120355,FR,Orion France,Sales,Sales,Children Sports,Sales Rep. I,Sandra Guillemard,F,"$26,610",28JUL1984,01FEB2006,,4,120415,120412,120261,120259,,
120356,FR,Orion France,Sales,Sales,Children Sports,Sales Rep. IV,Anne Broussole,F,"$32,680",26FEB1944,01JAN1974,30NOV2003,4,120415,120412,120261,120259,,
120357,FR,Orion France,Sales,Sales,Children Sports,Sales Rep. II,Bernard Bladt,M,"$28,045",17AUG1969,01JUL1988,,4,120415,120412,120261,120259,,
120358,FR,Orion France,Sales,Sales,Children Sports,Sales Rep. I,Daniel Dezard,M,"$25,100",14JAN1986,01JAN2007,,4,120415,120412,120261,120259,,
120359,FR,Orion France,Sales,Sales,Clothes,Sales Rep. II,Christelle Bourrier,F,"$27,555",25OCT1969,01NOV1992,,4,120415,120412,120261,120259,,
120360,FR,Orion France,Sales,Sales,Clothes,Sales Rep. I,Bernard Toumi,M,"$26,325",25AUG1949,01JAN1974,31DEC2004,4,120415,120412,120261,120259,,
120361,FR,Orion France,Sales,Sales,Clothes,Sales Rep. II,Agnes de Fourtou,F,"$26,790",03FEB1944,01JAN1974,,4,120415,120412,120261,120259,,
120362,FR,Orion France,Sales,Sales,Golf,Sales Rep. II,Marie Antoinette Boudard,F,"$26,780",06OCT1988,01DEC2006,,4,120415,120412,120261,120259,,
120363,FR,Orion France,Sales,Sales,Golf,Sales Rep. IV,Agnes Saulou,F,"$31,605",11SEP1944,01JAN1974,31AUG2005,4,120415,120412,120261,120259,,
120364,FR,Orion France,Sales,Sales,Golf,Sales Rep. IV,Christine Redais,F,"$32,270",22FEB1959,01JUN1982,,4,120415,120412,120261,120259,,
120365,FR,Orion France,Sales,Sales,Indoor Sports,Sales Rep. II,Sylvie Latimier,F,"$26,020",12JUN1959,01JAN1981,,4,120415,120412,120261,120259,,
120366,FR,Orion France,Sales,Sales,Indoor Sports,Sales Rep. I,Francoise Schmaltz,F,"$26,945",26AUG1944,01JAN1974,30SEP2004,4,120415,120412,120261,120259,,
120367,FR,Orion France,Sales,Sales,Shoes,Sales Rep. I,July Chiron,F,"$25,320",23MAR1964,01JUN1983,,4,120415,120412,120261,120259,,
120368,FR,Orion France,Sales,Sales,Shoes,Sales Rep. I,Andre Gaudin,M,"$27,095",11JAN1969,01JAN1991,,4,120415,120412,120261,120259,,
120369,FR,Orion France,Sales,Sales,Shoes,Sales Rep. I,Jean Desgens,M,"$27,225",17SEP1974,01JAN1997,,4,120415,120412,120261,120259,,
120370,FR,Orion France,Sales,Sales,Shoes,Sales Rep. II,Marie Claire Cros,F,"$27,795",15JUN1984,01JAN2006,,4,120415,120412,120261,120259,,
120371,FR,Orion France,Sales,Sales,Shoes,Sales Rep. IV,Philippe Monsieurle Directeur,M,"$30,635",04APR1979,01JAN2003,,4,120415,120412,120261,120259,,
120372,FR,Orion France,Sales,Sales,Shoes,Sales Rep. II,Michel Ramanantoandro,M,"$26,835",03MAY1954,01JAN1974,31AUG2003,4,120415,120412,120261,120259,,
120373,FR,Orion France,Sales,Sales,Outdoors,Sales Rep. IV,Cyril Soudant,M,"$31,590",04NOV1954,01DEC1977,30APR2002,4,120413,120412,120261,120259,,
120374,FR,Orion France,Sales,Sales,Outdoors,Sales Rep. I,Marie-Paul Olive,F,"$25,425",14APR1944,01JAN1974,,4,120413,120412,120261,120259,,
120375,FR,Orion France,Sales,Sales,Outdoors,Sales Rep. I,Isabelle de Milleville,F,"$25,050",02FEB1969,01APR1993,,4,120413,120412,120261,120259,,
120376,FR,Orion France,Sales,Sales,Outdoors,Sales Rep. I,Maryline Leger,F,"$26,745",03APR1944,01JAN1974,,4,120413,120412,120261,120259,,
120377,FR,Orion France,Sales,Sales,Outdoors,Sales Rep. II,Eric Dagiral,M,"$28,040",09DEC1984,01AUG2004,30SEP2005,4,120413,120412,120261,120259,,
120378,FR,Orion France,Sales,Sales,Outdoors,Sales Rep. III,Gabriele Vigneron,F,"$28,135",14FEB1969,01DEC1994,,4,120413,120412,120261,120259,,
120379,FR,Orion France,Sales,Sales,Outdoors,Sales Rep. III,Bernard Caron,M,"$30,540",21OCT1949,01FEB1975,,4,120413,120412,120261,120259,,
120380,FR,Orion France,Sales,Sales,Outdoors,Sales Rep. IV,Bernard David,M,"$32,075",03MAY1969,01NOV1996,28FEB2003,4,120413,120412,120261,120259,,
120381,FR,Orion France,Sales,Sales,Outdoors,Sales Rep. I,Didier Regent,M,"$26,975",14JUN1964,01JUN1991,,4,120413,120412,120261,120259,,
120382,FR,Orion France,Sales,Sales,Outdoors,Sales Rep. II,Anne-Laure Rish,F,"$27,070",19SEP1959,01MAR1979,,4,120413,120412,120261,120259,,
120383,FR,Orion France,Sales,Sales,Racket Sports,Sales Rep. I,Abdelhadi Sarpy,M,"$25,190",15MAY1964,01JUL1989,30APR2005,4,120415,120412,120261,120259,,
120384,FR,Orion France,Sales,Sales,Racket Sports,Sales Rep. II,Marc Zampa,M,"$26,210",28APR1959,01NOV1983,,4,120415,120412,120261,120259,,
120385,FR,Orion France,Sales,Sales,Racket Sports,Sales Rep. I,Ivan Carbillet,M,"$26,865",09MAY1959,01APR1987,31MAR2003,4,120415,120412,120261,120259,,
120386,FR,Orion France,Sales,Sales,Running - Jogging,Sales Rep. II,Christian Barkat,M,"$27,490",13MAR1949,01JAN1974,,4,120415,120412,120261,120259,,
120387,FR,Orion France,Sales,Sales,Running - Jogging,Sales Rep. I,Berengere Schultz,F,"$25,065",19FEB1944,01JAN1974,,4,120415,120412,120261,120259,,
120388,FR,Orion France,Sales,Sales,Running - Jogging,Sales Rep. III,Francois Delclos,M,"$28,635",08FEB1959,01NOV1981,,4,120415,120412,120261,120259,,
120389,FR,Orion France,Sales,Sales,Swim Sports,Sales Rep. II,Marc Duhil,M,"$26,420",07APR1969,01JAN1994,,4,120415,120412,120261,120259,,
120390,FR,Orion France,Sales,Sales,Swim Sports,Sales Rep. III,Alain Henry,M,"$30,480",12SEP1986,01NOV2004,,4,120415,120412,120261,120259,,
120391,FR,Orion France,Sales,Sales,Swim Sports,Sales Rep. III,Marie-Pierre Brunel,F,"$29,445",27MAY1984,01SEP2002,,4,120415,120412,120261,120259,,
120392,FR,Orion France,Sales,Sales,Swim Sports,Sales Rep. IV,Lauro Hardouin,M,"$30,340",15JUL1969,01AUG1996,30SEP2003,4,120415,120412,120261,120259,,
120393,FR,Orion France,Sales,Sales,Swim Sports,Sales Rep. I,Paulina Moisenier,F,"$26,625",07MAY1959,01NOV1988,,4,120415,120412,120261,120259,,
120394,FR,Orion France,Sales,Sales,Team Sports,Sales Rep. III,Thierry Merlette,M,"$30,235",03FEB1974,01OCT1994,,4,120415,120412,120261,120259,,
120395,FR,Orion France,Sales,Sales,Team Sports,Sales Rep. II,Patrick Hill,M,"$27,145",02DEC1986,01FEB2005,,4,120415,120412,120261,120259,,
120396,FR,Orion France,Sales,Sales,Team Sports,Sales Rep. IV,Francois Louis,M,"$31,430",26NOV1944,01JAN1974,,4,120415,120412,120261,120259,,
120397,FR,Orion France,Sales,Sales,Temporary,Temp. Sales Rep.,Marie-Therese Triebel,F,"$27,480",20MAY1988,01DEC2006,31JAN2007,4,120413,120412,120261,120259,,
120398,FR,Orion France,Sales,Sales,Temporary,Temp. Sales Rep.,Damien Bascle,M,"$26,910",07FEB1959,01DEC2006,31JAN2007,4,120413,120412,120261,120259,,
120399,FR,Orion France,Sales,Sales,Temporary,Temp. Sales Rep.,Stephan Gaubert,M,"$25,605",11OCT1954,01DEC2006,31DEC2006,4,120413,120412,120261,120259,,
120400,FR,Orion France,Sales,Sales,Temporary,Temp. Sales Rep.,Franck Ferbu,M,"$27,225",14DEC1969,01DEC2006,31MAY2007,4,120413,120412,120261,120259,,
120401,FR,Orion France,Sales,Sales,Temporary,Temp. Sales Rep.,Marie-Pierre Maire,F,"$26,725",27JAN1974,01DEC2006,31MAY2007,4,120413,120412,120261,120259,,
120402,FR,Orion France,Sales,Sales,Temporary,Temp. Sales Rep.,Nathalie Dienne,F,"$26,325",14DEC1984,01DEC2006,28FEB2007,4,120413,120412,120261,120259,,
120403,FR,Orion France,Sales,Sales,Temporary,Temp. Sales Rep.,Georges Gauchi,M,"$26,115",06JUL1979,01DEC2006,31DEC2006,4,120413,120412,120261,120259,,
120404,FR,Orion France,Sales,Sales,Temporary,Temp. Sales Rep.,Marc Demaria,M,"$27,100",03MAR1986,01DEC2006,31MAY2007,4,120413,120412,120261,120259,,
120405,FR,Orion France,Sales,Sales,Temporary,Temp. Sales Rep.,Joelle Turpin,F,"$27,180",15JUL1944,01DEC2006,28FEB2007,4,120413,120412,120261,120259,,
120406,FR,Orion France,Sales,Sales,Temporary,Temp. Sales Rep.,Gaelle Gonsard,F,"$26,420",05AUG1986,01DEC2006,28FEB2007,4,120413,120412,120261,120259,,
120407,FR,Orion France,Sales,Sales,Temporary,Temp. Sales Rep.,Christophe Suraud,M,"$27,170",20JUN1984,01DEC2006,30APR2007,4,120413,120412,120261,120259,,
120408,FR,Orion France,Sales,Sales,Trainees,Trainee,Albert Laly,M,"$26,330",27DEC1988,01FEB2007,31JUL2007,4,120413,120412,120261,120259,,
120409,FR,Orion France,Sales,Sales,Winter Sports,Sales Rep. III,Isabelle Charonnat,F,"$28,460",26OCT1979,01MAR2005,,4,120413,120412,120261,120259,,
120410,FR,Orion France,Sales,Sales,Winter Sports,Sales Rep. I,Monique Venchiarutti,F,"$25,105",13FEB1964,01JUL1986,,4,120413,120412,120261,120259,,
120411,FR,Orion France,Sales,Sales,Winter Sports,Sales Rep. II,Andre Noel,M,"$27,600",17JAN1954,01NOV1975,,4,120413,120412,120261,120259,,
120412,FR,Orion France,Sales Management,Sales Management,Sales Management,Vice President,Rodolphe Boudard,M,"$192,940",26AUG1978,01JUN2003,,2,120261,120259,,,,
120413,FR,Orion France,Sales Management,Sales Management,Sales Management,Sales Manager,Abderhaman Ferbu,M,"$84,285",14DEC1969,01JUN1999,,3,120412,120261,120259,,,
120414,FR,Orion France,Sales Management,Sales Management,Sales Management,Secretary IV,Jacques Billaud,M,"$31,555",02AUG1959,01MAY1986,,3,120412,120261,120259,,,
120415,FR,Orion France,Sales Management,Sales Management,Sales Management,Senior Sales Manager,Alain-Patrick Da Cunha,M,"$91,580",16FEB1974,01OCT2000,,3,120412,120261,120259,,,
120416,DE,Orion Germany,Administration,Administration,Administration,Office Assistant II,Annedore Thiel,F,"$28,500",08JAN1959,01OCT1985,31MAR2004,4,120420,120510,120261,120259,,
120417,DE,Orion Germany,Administration,Administration,Administration,Office Assistant I,Wilfried Kalbfuss,M,"$25,850",11FEB1969,01DEC1995,30SEP2005,4,120420,120510,120261,120259,,
120418,DE,Orion Germany,Administration,Administration,Administration,Office Assistant I,Rainer Breitel,M,"$25,705",02AUG1988,01NOV2006,,4,120420,120510,120261,120259,,
120419,DE,Orion Germany,Administration,Administration,Administration,Office Assistant II,Ralph Vohl,M,"$26,735",21MAR1988,01AUG2006,,4,120420,120510,120261,120259,,
120420,DE,Orion Germany,Administration,Administration,Shipping Charges,Administration Manager,Berit Brunen,F,"$48,100",04OCT1969,01JAN1989,,3,120510,120261,120259,,,
120421,DE,Orion Germany,Administration,Administration,Shipping Charges,Clerk I,Bernd Recklies,M,"$26,090",06MAR1986,01MAY2006,,4,120420,120510,120261,120259,,
120422,DE,Orion Germany,Administration,Goods Entrance,Stock Admin,Warehouse Manager,Esther Schmidt,F,"$42,305",21NOV1978,01JUN2006,,4,120420,120510,120261,120259,,
120423,DE,Orion Germany,Administration,Goods Entrance,Stock Admin,Warehouse Assistant I,Martina Wimmer,F,"$26,380",20NOV1949,01FEB1978,,5,120422,120420,120510,120261,120259,
120424,DE,Orion Germany,Administration,Goods Entrance,Stock Admin,Warehouse Assistant III,Ullrich Beekmann,M,"$27,760",08MAR1964,01OCT1983,,5,120422,120420,120510,120261,120259,
120425,DE,Orion Germany,Administration,Security,Security Guards,Security Manager,Itta Schneider,F,"$30,545",12JUL1984,01APR2006,,4,120420,120510,120261,120259,,
120426,DE,Orion Germany,Administration,Security,Security Guards,Security Guard II,Irmgard Spill,F,"$35,525",11NOV1986,01MAY2006,,5,120425,120420,120510,120261,120259,
120427,DE,Orion Germany,Administration,Service Center,Service,Service Assistant II,Karl W. Spieth,M,"$28,540",08OCT1988,01SEP2006,,5,120425,120420,120510,120261,120259,
120428,DE,Orion Germany,Administration,Service Center,Service,Service Assistant I,Frank Braune,M,"$27,180",02JAN1986,01JUN2006,,5,120425,120420,120510,120261,120259,
120429,DE,Orion Germany,Engineering,Engineering,Cabinet Maker's Workshop,Engineering Manager,Walter Szczesniak,M,"$36,240",13APR1984,01APR2005,,4,120420,120510,120261,120259,,
120430,DE,Orion Germany,Engineering,Engineering,Cabinet Maker's Workshop,Cabinet Maker I,Hans-Martin de Palacios,M,"$27,250",09SEP1974,01MAR2000,,5,120429,120420,120510,120261,120259,
120431,DE,Orion Germany,Engineering,Engineering,Cabinet Maker's Workshop,Cabinet Maker II,Susanne Kitta,F,"$29,430",17MAR1979,01AUG2001,,5,120429,120420,120510,120261,120259,
120432,DE,Orion Germany,Engineering,Engineering,Electrical Workshop,Electrician III,Michael Endejan,M,"$27,735",13JUL1986,01MAY2006,,5,120429,120420,120510,120261,120259,
120433,DE,Orion Germany,Engineering,Engineering,Electrical Workshop,Electrician I,Curt-M. Thompson,M,"$27,380",11OCT1984,01JUL2006,,5,120429,120420,120510,120261,120259,
120434,DE,Orion Germany,Sales,Sales,Assorted Sports Articles,Sales Rep. I,Birgit Steppich,F,"$26,575",25JUN1979,01JUN2006,,4,120511,120510,120261,120259,,
120435,DE,Orion Germany,Sales,Sales,Assorted Sports Articles,Sales Rep. III,Astrid Poggensee,F,"$28,680",28DEC1954,01FEB1981,,4,120511,120510,120261,120259,,
120436,DE,Orion Germany,Sales,Sales,Assorted Sports Articles,Sales Rep. I,Claudia Rückmann,F,"$25,400",17MAR1959,01APR1984,,4,120511,120510,120261,120259,,
120437,DE,Orion Germany,Sales,Sales,Assorted Sports Articles,Sales Rep. I,Friedrich Kuch,M,"$26,195",27NOV1979,01DEC2006,,4,120511,120510,120261,120259,,
120438,DE,Orion Germany,Sales,Sales,Assorted Sports Articles,Sales Rep. II,Elisabeth Seyd,F,"$26,535",28JAN1954,01JUL1974,,4,120511,120510,120261,120259,,
120439,DE,Orion Germany,Sales,Sales,Assorted Sports Articles,Sales Rep. III,Egmont Gstettner,M,"$28,590",07JAN1959,01JUL1985,,4,120511,120510,120261,120259,,
120440,DE,Orion Germany,Sales,Sales,Children Sports,Sales Rep. I,Torsten Ember,M,"$27,325",10DEC1979,01OCT2006,,4,120511,120510,120261,120259,,
120441,DE,Orion Germany,Sales,Sales,Children Sports,Sales Rep. II,Roland Meuer,M,"$26,065",03MAR1988,01JUL2006,,4,120511,120510,120261,120259,,
120442,DE,Orion Germany,Sales,Sales,Children Sports,Sales Rep. IV,Susanne Solomé,F,"$39,185",16DEC1969,01MAR1988,,4,120511,120510,120261,120259,,
120443,DE,Orion Germany,Sales,Sales,Children Sports,Sales Rep. II,Manfred Von Rueden,M,"$26,805",20JUL1988,01DEC2006,,4,120511,120510,120261,120259,,
120444,DE,Orion Germany,Sales,Sales,Clothes,Sales Rep. I,Urs Penschke,M,"$26,145",19NOV1944,01JAN1974,,4,120511,120510,120261,120259,,
120445,DE,Orion Germany,Sales,Sales,Clothes,Sales Rep. I,Michaela Kockerols,F,"$25,820",14MAR1954,01NOV1983,,4,120511,120510,120261,120259,,
120446,DE,Orion Germany,Sales,Sales,Clothes,Sales Rep. III,Peter Melcher,M,"$29,660",23SEP1944,01JAN1974,,4,120511,120510,120261,120259,,
120447,DE,Orion Germany,Sales,Sales,Clothes,Sales Rep. II,Jasmin Bonifer,F,"$27,900",06AUG1959,01OCT1983,31AUG2005,4,120511,120510,120261,120259,,
120448,DE,Orion Germany,Sales,Sales,Clothes,Sales Rep. I,Kristina Engelhardt,F,"$26,290",06NOV1988,01SEP2006,,4,120511,120510,120261,120259,,
120449,DE,Orion Germany,Sales,Sales,Golf,Sales Rep. I,Susana Pohl,F,"$26,775",06NOV1986,01NOV2006,,4,120511,120510,120261,120259,,
120450,DE,Orion Germany,Sales,Sales,Golf,Sales Rep. I,Rüdiger Neske,M,"$25,265",21NOV1979,01MAY2004,,4,120511,120510,120261,120259,,
120451,DE,Orion Germany,Sales,Sales,Golf,Sales Rep. III,Sabine Weidenbach,F,"$28,140",16NOV1974,01NOV1997,,4,120511,120510,120261,120259,,
120452,DE,Orion Germany,Sales,Sales,Indoor Sports,Sales Rep. II,Wolfgang Jülich,M,"$27,310",23APR1984,01AUG2006,,4,120511,120510,120261,120259,,
120453,DE,Orion Germany,Sales,Sales,Indoor Sports,Sales Rep. III,Melanie Delarue,F,"$30,620",26APR1969,01MAR1992,,4,120511,120510,120261,120259,,
120454,DE,Orion Germany,Sales,Sales,Shoes,Sales Rep. II,Ingolf Zehetmaier,M,"$27,770",20AUG1954,01DEC1977,,4,120511,120510,120261,120259,,
120455,DE,Orion Germany,Sales,Sales,Shoes,Sales Rep. I,Ellen Raum-Deinzer,F,"$28,555",01FEB1944,01JAN1974,31JAN2004,4,120511,120510,120261,120259,,
120456,DE,Orion Germany,Sales,Sales,Shoes,Sales Rep. I,Robert Derheld,M,"$25,465",21JUN1986,01FEB2006,,4,120511,120510,120261,120259,,
120457,DE,Orion Germany,Sales,Sales,Shoes,Sales Rep. IV,Robert Schhenoy,M,"$31,745",08AUG1979,01NOV2001,,4,120511,120510,120261,120259,,
120458,DE,Orion Germany,Sales,Sales,Shoes,Sales Rep. II,Margitta Kleinmichel,F,"$27,480",21DEC1954,01SEP1978,,4,120511,120510,120261,120259,,
120459,DE,Orion Germany,Sales,Sales,Outdoors,Sales Rep. I,Kerrin Saucke,F,"$26,150",18FEB1949,01JAN1974,,4,120512,120510,120261,120259,,
120460,DE,Orion Germany,Sales,Sales,Outdoors,Sales Rep. II,Frank-Michael Wehlmann,M,"$28,040",09JAN1959,01JAN1982,,4,120512,120510,120261,120259,,
120461,DE,Orion Germany,Sales,Sales,Outdoors,Sales Rep. III,Christian Sellschopp,M,"$30,385",28MAY1964,01NOV1983,,4,120512,120510,120261,120259,,
120462,DE,Orion Germany,Sales,Sales,Outdoors,Sales Rep. II,Kurt Schmid,M,"$28,580",09APR1949,01JAN1974,,4,120512,120510,120261,120259,,
120463,DE,Orion Germany,Sales,Sales,Outdoors,Sales Rep. III,Andreas Aichele,M,"$28,310",14APR1974,01JAN2004,,4,120512,120510,120261,120259,,
120464,DE,Orion Germany,Sales,Sales,Outdoors,Sales Rep. II,Werner Forbeger,M,"$27,205",12OCT1979,01MAY1999,,4,120512,120510,120261,120259,,
120465,DE,Orion Germany,Sales,Sales,Outdoors,Sales Rep. I,Jürgen Blank,M,"$25,045",23FEB1979,01MAY2003,,4,120512,120510,120261,120259,,
120466,DE,Orion Germany,Sales,Sales,Outdoors,Sales Rep. II,Sabine Krüger,F,"$26,125",16JUN1984,01MAR2006,,4,120512,120510,120261,120259,,
120467,DE,Orion Germany,Sales,Sales,Outdoors,Sales Rep. III,Ralf Haberer,M,"$28,115",10FEB1944,01JAN1974,,4,120512,120510,120261,120259,,
120468,DE,Orion Germany,Sales,Sales,Racket Sports,Sales Rep. II,Horst Koehler,M,"$28,360",13MAY1974,01APR1996,,4,120511,120510,120261,120259,,
120469,DE,Orion Germany,Sales,Sales,Racket Sports,Sales Rep. III,Kristin Lütkepohl,F,"$28,185",12SEP1979,01OCT1999,,4,120511,120510,120261,120259,,
120470,DE,Orion Germany,Sales,Sales,Racket Sports,Sales Rep. III,Carlhans Lange,M,"$28,120",23MAR1969,01MAY1994,,4,120511,120510,120261,120259,,
120471,DE,Orion Germany,Sales,Sales,Racket Sports,Sales Rep. I,Detlef Kreuzhuber,M,"$26,960",20MAR1954,01MAY1980,,4,120511,120510,120261,120259,,
120472,DE,Orion Germany,Sales,Sales,Racket Sports,Sales Rep. I,Helmar Kamp,M,"$25,010",03JAN1974,01JUN1992,,4,120511,120510,120261,120259,,
120473,DE,Orion Germany,Sales,Sales,Racket Sports,Sales Rep. II,Peter Matthäus,M,"$27,180",19SEP1949,01JAN1974,,4,120511,120510,120261,120259,,
120474,DE,Orion Germany,Sales,Sales,Racket Sports,Sales Rep. I,Eva Hellbach,F,"$26,250",28SEP1984,01NOV2004,,4,120511,120510,120261,120259,,
120475,DE,Orion Germany,Sales,Sales,Running - Jogging,Sales Rep. II,Yvonne Ilmer,F,"$27,375",04MAR1986,01DEC2006,,4,120511,120510,120261,120259,,
120476,DE,Orion Germany,Sales,Sales,Running - Jogging,Sales Rep. II,Andre Kroll,M,"$28,325",21NOV1954,01FEB1980,,4,120511,120510,120261,120259,,
120477,DE,Orion Germany,Sales,Sales,Running - Jogging,Sales Rep. II,Gerhard Hanshen,M,"$26,095",23JUL1959,01OCT1977,,4,120511,120510,120261,120259,,
120478,DE,Orion Germany,Sales,Sales,Running - Jogging,Sales Rep. I,Svenja Holomek,F,"$25,560",16SEP1964,01JUN1994,,4,120511,120510,120261,120259,,
120479,DE,Orion Germany,Sales,Sales,Running - Jogging,Sales Rep. II,Martin Bujard,M,"$27,745",20MAR1984,01JUN2005,,4,120511,120510,120261,120259,,
120480,DE,Orion Germany,Sales,Sales,Running - Jogging,Sales Rep. II,Brigitte Böhme,F,"$26,535",17JAN1988,01SEP2006,,4,120511,120510,120261,120259,,
120481,DE,Orion Germany,Sales,Sales,Running - Jogging,Sales Rep. I,Christoph Hilgartner,M,"$26,620",28JUL1964,01JUN1994,,4,120511,120510,120261,120259,,
120482,DE,Orion Germany,Sales,Sales,Running - Jogging,Sales Rep. III,Petra Tepel,F,"$29,805",10APR1954,01APR1978,,4,120511,120510,120261,120259,,
120483,DE,Orion Germany,Sales,Sales,Running - Jogging,Sales Rep. III,Karl Damwerth,M,"$28,430",25APR1949,01JAN1974,,4,120511,120510,120261,120259,,
120484,DE,Orion Germany,Sales,Sales,Swim Sports,Sales Rep. I,Janina Scheuermann,F,"$27,225",26OCT1984,01OCT2006,,4,120511,120510,120261,120259,,
120485,DE,Orion Germany,Sales,Sales,Swim Sports,Sales Rep. III,Ernst-Ludwig Hembury,M,"$29,490",04DEC1949,01NOV1979,,4,120511,120510,120261,120259,,
120486,DE,Orion Germany,Sales,Sales,Swim Sports,Sales Rep. I,Annette Freund,F,"$25,395",20MAY1944,01JAN1974,,4,120511,120510,120261,120259,,
120487,DE,Orion Germany,Sales,Sales,Swim Sports,Sales Rep. II,Claudia Korte,F,"$33,040",07JUN1988,01APR2006,,4,120511,120510,120261,120259,,
120488,DE,Orion Germany,Sales,Sales,Swim Sports,Sales Rep. I,Sigrun Bonk,F,"$27,350",23APR1974,01APR1995,31DEC2004,4,120511,120510,120261,120259,,
120489,DE,Orion Germany,Sales,Sales,Swim Sports,Sales Rep. I,Hartmut Fürniß,M,"$26,830",17JUL1974,01SEP2001,,4,120511,120510,120261,120259,,
120490,DE,Orion Germany,Sales,Sales,Team Sports,Sales Rep. I,Inga Schmidt,F,"$27,425",22FEB1959,01JUL1978,,4,120511,120510,120261,120259,,
120491,DE,Orion Germany,Sales,Sales,Team Sports,Sales Rep. II,Matthias Knittel,M,"$26,600",06DEC1984,01SEP2006,,4,120511,120510,120261,120259,,
120492,DE,Orion Germany,Sales,Sales,Team Sports,Sales Rep. II,Gerhard Dierstein,M,"$26,675",07APR1974,01OCT2002,,4,120511,120510,120261,120259,,
120493,DE,Orion Germany,Sales,Sales,Team Sports,Sales Rep. I,Jürgen Kreuzhuber,M,"$25,240",20MAR1954,01FEB1979,,4,120511,120510,120261,120259,,
120494,DE,Orion Germany,Sales,Sales,Team Sports,Sales Rep. I,Gudrun Menzel,F,"$27,050",25MAR1964,01JAN1990,,4,120511,120510,120261,120259,,
120495,DE,Orion Germany,Sales,Sales,Team Sports,Sales Rep. III,Hans-Jürgen Leyer,M,"$28,180",16AUG1974,01DEC2002,31AUG2004,4,120511,120510,120261,120259,,
120496,DE,Orion Germany,Sales,Sales,Temporary,Temp. Sales Rep.,Simone Roegner,F,"$25,240",04JUN1969,01DEC2006,31DEC2006,4,120512,120510,120261,120259,,
120497,DE,Orion Germany,Sales,Sales,Temporary,Temp. Sales Rep.,Andreas Riegger,M,"$26,695",28SEP1979,01DEC2006,30APR2007,4,120512,120510,120261,120259,,
120498,DE,Orion Germany,Sales,Sales,Temporary,Temp. Sales Rep.,Dorit Peinelt,F,"$25,665",11MAR1959,01DEC2006,30APR2007,4,120512,120510,120261,120259,,
120499,DE,Orion Germany,Sales,Sales,Temporary,Temp. Sales Rep.,Helmut Rettig,M,"$28,885",03JUL1944,01DEC2006,28FEB2007,4,120512,120510,120261,120259,,
120500,DE,Orion Germany,Sales,Sales,Temporary,Temp. Sales Rep.,Markus Haßelberg,M,"$27,475",15DEC1974,01DEC2006,31MAR2007,4,120512,120510,120261,120259,,
120501,DE,Orion Germany,Sales,Sales,Temporary,Temp. Sales Rep.,Ina Geiß,F,"$26,140",13NOV1974,01DEC2006,30APR2007,4,120512,120510,120261,120259,,
120502,DE,Orion Germany,Sales,Sales,Trainees,Trainee,Rüdiger Cruse,M,"$24,050",09SEP1988,01FEB2007,31JUL2007,4,120512,120510,120261,120259,,
120503,DE,Orion Germany,Sales,Sales,Trainees,Trainee,Alfons Rockel,M,"$24,580",22FEB1986,01OCT2005,31MAR2006,4,120512,120510,120261,120259,,
120504,DE,Orion Germany,Sales,Sales,Trainees,Trainee,Christina Muster,F,"$24,030",20OCT1969,01JAN2003,30JUN2003,4,120512,120510,120261,120259,,
120505,DE,Orion Germany,Sales,Sales,Trainees,Trainee,Katharina Laute,F,"$25,545",14APR1964,01JAN2003,30JUN2003,4,120512,120510,120261,120259,,
120506,DE,Orion Germany,Sales,Sales,Winter Sports,Sales Rep. I,Kathrin Janko,F,"$25,990",12APR1949,01JAN1974,,4,120512,120510,120261,120259,,
120507,DE,Orion Germany,Sales,Sales,Winter Sports,Sales Rep. I,Dieter Kohlepp,M,"$25,795",02FEB1964,01APR1984,,4,120512,120510,120261,120259,,
120508,DE,Orion Germany,Sales,Sales,Winter Sports,Sales Rep. I,Elsbeth Schmolt,F,"$27,270",01OCT1959,01OCT1981,31MAY2006,4,120512,120510,120261,120259,,
120509,DE,Orion Germany,Sales,Sales,Winter Sports,Sales Rep. I,Wolfgang Wohleber,M,"$26,345",02MAR1954,01JAN1974,31JUL2005,4,120512,120510,120261,120259,,
120510,DE,Orion Germany,Sales Management,Sales Management,Sales Management,Director,Sabine Doerr,F,"$151,940",22AUG1976,01NOV1997,,2,120261,120259,,,,
120511,DE,Orion Germany,Sales Management,Sales Management,Sales Management,Sales Manager,Alexandra Bulst,F,"$87,535",24MAY1944,01JAN1974,,3,120510,120261,120259,,,
120512,DE,Orion Germany,Sales Management,Sales Management,Sales Management,Sales Manager,Sigrid Lotfalikhani,F,"$86,055",25FEB1964,01DEC1992,,3,120510,120261,120259,,,
120513,DE,Orion Germany,Sales Management,Sales Management,Sales Management,Secretary III,Doris Schnabel,F,"$35,080",28JUL1969,01FEB1998,,3,120510,120261,120259,,,
120514,NL,Orion Holland,Administration,Administration,Administration,Office Assistant II,J.A.J. Slomp,M,"$28,170",20JAN1944,01JAN1974,,4,120516,120576,120261,120259,,
120515,NL,Orion Holland,Administration,Administration,Administration,Office Assistant III,M.A.R. Wiersema,M,"$30,140",17AUG1979,01NOV2003,,4,120516,120576,120261,120259,,
120516,NL,Orion Holland,Administration,Administration,Shipping Charges,Administration Manager,Veronique Konings,F,"$43,620",04FEB1984,01NOV2004,,3,120576,120261,120259,,,
120517,NL,Orion Holland,Administration,Goods Entrance,Stock Admin,Warehouse Manager,K.T.l Ligtvoet,F,"$41,965",23AUG1976,01MAY2000,,4,120516,120576,120261,120259,,
120518,NL,Orion Holland,Administration,Goods Entrance,Stock Admin,Warehouse Assistant I,G.J.E. Van Wattingen,M,"$26,440",18MAY1959,01NOV1987,,5,120517,120516,120576,120261,120259,
120519,NL,Orion Holland,Administration,Security,Security Guards,Security Manager,Tine Pijpers,F,"$32,195",10AUG1979,01SEP2002,,4,120516,120576,120261,120259,,
120520,NL,Orion Holland,Administration,Security,Security Guards,Security Guard I,M.E. Siepman,F,"$25,820",01MAR1969,01AUG1992,,5,120519,120516,120576,120261,120259,
120521,NL,Orion Holland,Administration,Service Center,Service,Service Assistant II,T.M.C. Verweij,F,"$34,865",26MAR1988,01MAR2006,,5,120519,120516,120576,120261,120259,
120522,NL,Orion Holland,Administration,Service Center,Service,Service Assistant I,J.A. Ruiter,F,"$27,420",17FEB1979,01MAR1999,,5,120519,120516,120576,120261,120259,
120523,NL,Orion Holland,Engineering,Engineering,Cabinet Maker's Workshop,Cabinet Maker II,H.G. Piet,M,"$28,925",19JAN1964,01OCT1989,,4,120516,120576,120261,120259,,
120524,NL,Orion Holland,Engineering,Engineering,Electrical Workshop,Electrician II,Anita Buursema Nri,F,"$27,060",04NOV1984,01AUG2004,,4,120516,120576,120261,120259,,
120525,NL,Orion Holland,Sales,Sales,Assorted Sports Articles,Sales Rep. II,H.C. Gobel,F,"$28,120",11JUL1988,02AUG2003,,4,120577,120576,120261,120259,,
120526,NL,Orion Holland,Sales,Sales,Assorted Sports Articles,Sales Rep. II,Gerard Blanken,M,"$27,640",25JUN1969,01OCT1987,,4,120577,120576,120261,120259,,
120527,NL,Orion Holland,Sales,Sales,Assorted Sports Articles,Sales Rep. III,Jan-Reijer Rutten,F,"$30,135",26NOV1964,01JUL1984,,4,120577,120576,120261,120259,,
120528,NL,Orion Holland,Sales,Sales,Children Sports,Sales Rep. II,J.C. Benard,F,"$27,785",08SEP1944,01JAN1974,31AUG2003,4,120577,120576,120261,120259,,
120529,NL,Orion Holland,Sales,Sales,Children Sports,Sales Rep. I,J.C. Kelder,F,"$27,030",20OCT1949,01APR1974,,4,120577,120576,120261,120259,,
120530,NL,Orion Holland,Sales,Sales,Children Sports,Sales Rep. I,A.M. Van Veen,F,"$25,340",20NOV1986,11DEC2001,,4,120577,120576,120261,120259,,
120531,NL,Orion Holland,Sales,Sales,Clothes,Sales Rep. IV,F.A.H. Zwikker,M,"$31,920",04APR1969,01FEB1997,,4,120577,120576,120261,120259,,
120532,NL,Orion Holland,Sales,Sales,Clothes,Sales Rep. II,A.G. Elsenga,M,"$26,090",18JUL1979,01NOV2002,,4,120577,120576,120261,120259,,
120533,NL,Orion Holland,Sales,Sales,Clothes,Sales Rep. III,C.M. Caspers,F,"$37,320",17SEP1944,01JAN1974,30APR2004,4,120577,120576,120261,120259,,
120534,NL,Orion Holland,Sales,Sales,Golf,Sales Rep. II,A.J.M. Talsma,M,"$26,350",06NOV1988,01OCT2006,,4,120577,120576,120261,120259,,
120535,NL,Orion Holland,Sales,Sales,Golf,Sales Rep. I,T.A.F.A. Trockenbrodt,F,"$26,455",07MAY1954,01JAN1983,,4,120577,120576,120261,120259,,
120536,NL,Orion Holland,Sales,Sales,Indoor Sports,Sales Rep. III,Anne Marie Heijne,F,"$30,280",19JUN1944,01JAN1974,31MAY2003,4,120577,120576,120261,120259,,
120537,NL,Orion Holland,Sales,Sales,Shoes,Sales Rep. III,l.J. Oberman,M,"$29,860",08AUG1974,01JAN2001,,4,120577,120576,120261,120259,,
120538,NL,Orion Holland,Sales,Sales,Shoes,Sales Rep. III,B.T. Van Der Cruyssen,F,"$28,615",09SEP1944,01JAN1974,,4,120577,120576,120261,120259,,
120539,NL,Orion Holland,Sales,Sales,Shoes,Sales Rep. II,Sabine Versteegh,F,"$28,510",11OCT1969,01JUN1994,31JAN2003,4,120577,120576,120261,120259,,
120540,NL,Orion Holland,Sales,Sales,Outdoors,Sales Rep. I,K.S. Wakker,M,"$26,585",03JAN1949,01JAN1974,,4,120577,120576,120261,120259,,
120541,NL,Orion Holland,Sales,Sales,Outdoors,Sales Rep. III,d.K. Hoen,M,"$30,260",13JUL1964,01OCT1987,,4,120577,120576,120261,120259,,
120542,NL,Orion Holland,Sales,Sales,Outdoors,Sales Rep. I,Tine Van Der Werk,F,"$27,410",20MAR1988,01MAR2006,,4,120577,120576,120261,120259,,
120543,NL,Orion Holland,Sales,Sales,Outdoors,Sales Rep. I,N.U. Gülcher,M,"$26,980",11FEB1944,01JAN1974,31DEC2003,4,120577,120576,120261,120259,,
120544,NL,Orion Holland,Sales,Sales,Outdoors,Sales Rep. I,P.J.M. Koekkoek,M,"$33,925",22DEC1988,01AUG2004,,4,120577,120576,120261,120259,,
120545,NL,Orion Holland,Sales,Sales,Outdoors,Sales Rep. I,H.F.R. Bottema,F,"$30,460",16SEP1974,01JAN1999,30APR2004,4,120577,120576,120261,120259,,
120546,NL,Orion Holland,Sales,Sales,Outdoors,Sales Rep. III,A.J. Schmitz du Moulin,M,"$28,955",05NOV1984,01JUL2004,,4,120577,120576,120261,120259,,
120547,NL,Orion Holland,Sales,Sales,Racket Sports,Sales Rep. I,F.M. Yspeert,M,"$27,125",28MAY1964,01AUG1993,,4,120577,120576,120261,120259,,
120548,NL,Orion Holland,Sales,Sales,Racket Sports,Sales Rep. I,J.T. Van Der Weg,F,"$25,050",23MAR1988,01AUG2006,,4,120577,120576,120261,120259,,
120549,NL,Orion Holland,Sales,Sales,Racket Sports,Sales Rep. I,H.F.R. Jansen,F,"$26,180",21JUN1959,01JUN1985,30SEP2003,4,120577,120576,120261,120259,,
120550,NL,Orion Holland,Sales,Sales,Racket Sports,Sales Rep. I,B.N.B. Peter,F,"$26,090",01NOV1988,01MAR2006,,4,120577,120576,120261,120259,,
120551,NL,Orion Holland,Sales,Sales,Racket Sports,Sales Rep. I,Paul Kuipers,M,"$25,110",18MAR1979,01AUG2000,,4,120577,120576,120261,120259,,
120552,NL,Orion Holland,Sales,Sales,Running - Jogging,Sales Rep. II,P.A.B.M. Eger,M,"$27,430",22MAR1988,01OCT2006,,4,120577,120576,120261,120259,,
120553,NL,Orion Holland,Sales,Sales,Running - Jogging,Sales Rep. I,J.l. Tasche,M,"$20,835",21FEB1954,01SEP1980,,4,120577,120576,120261,120259,,
120554,NL,Orion Holland,Sales,Sales,Running - Jogging,Sales Rep. II,C.H.W.M. Scholten,M,"$26,560",09SEP1949,01SEP1979,,4,120577,120576,120261,120259,,
120555,NL,Orion Holland,Sales,Sales,Running - Jogging,Sales Rep. III,J.W. Pot,M,"$29,360",13NOV1979,01DEC2003,,4,120577,120576,120261,120259,,
120556,NL,Orion Holland,Sales,Sales,Running - Jogging,Sales Rep. I,A R J Lepikko,M,"$26,080",13JUL1959,01OCT1988,,4,120577,120576,120261,120259,,
120557,NL,Orion Holland,Sales,Sales,Swim Sports,Sales Rep. I,A.G. Andel,M,"$26,915",06DEC1964,01NOV1985,28FEB2003,4,120577,120576,120261,120259,,
120558,NL,Orion Holland,Sales,Sales,Swim Sports,Sales Rep. I,J.B.M.M. Van Noordennen,M,"$25,410",28APR1979,01MAR2005,,4,120577,120576,120261,120259,,
120559,NL,Orion Holland,Sales,Sales,Swim Sports,Sales Rep. II,B.W.V. Van Oordt,F,"$27,150",13JUN1944,01JAN1974,,4,120577,120576,120261,120259,,
120560,NL,Orion Holland,Sales,Sales,Swim Sports,Sales Rep. III,R.A.P. Van Raalte,M,"$29,995",22DEC1986,01JUN2006,,4,120577,120576,120261,120259,,
120561,NL,Orion Holland,Sales,Sales,Team Sports,Sales Rep. I,Friedrich Mens,M,"$25,515",13JUL1974,01JUL1998,,4,120577,120576,120261,120259,,
120562,NL,Orion Holland,Sales,Sales,Team Sports,Sales Rep. I,J.A.E. Looije,F,"$26,525",11NOV1988,01JUN2004,31JAN2005,4,120577,120576,120261,120259,,
120563,NL,Orion Holland,Sales,Sales,Team Sports,Sales Rep. III,A.A. Icario,M,"$29,920",23MAR1974,01JUN1998,,4,120577,120576,120261,120259,,
120564,NL,Orion Holland,Sales,Sales,Temporary,Temp. Sales Rep.,R.M.d. Van Den Heuvel,F,"$27,465",06MAY1969,01DEC2006,31DEC2006,4,120577,120576,120261,120259,,
120565,NL,Orion Holland,Sales,Sales,Temporary,Temp. Sales Rep.,F.R.E. Van Den Nobelen,M,"$26,075",10AUG1969,01DEC2006,31MAY2007,4,120577,120576,120261,120259,,
120566,NL,Orion Holland,Sales,Sales,Temporary,Temp. Sales Rep.,C.G.V.M. Van Der Lingen,M,"$27,490",13MAR1988,01DEC2006,30JUN2007,4,120577,120576,120261,120259,,
120567,NL,Orion Holland,Sales,Sales,Temporary,Temp. Sales Rep.,F.N. Beukers,M,"$25,820",18JAN1988,01DEC2006,30JUN2007,4,120577,120576,120261,120259,,
120568,NL,Orion Holland,Sales,Sales,Temporary,Temp. Sales Rep.,J.C. Traas,F,"$26,305",08FEB1969,01DEC2006,30JUN2007,4,120577,120576,120261,120259,,
120569,NL,Orion Holland,Sales,Sales,Temporary,Temp. Sales Rep.,I.H.H.M. Pijpers,F,"$27,265",22FEB1964,01DEC2006,31MAR2007,4,120577,120576,120261,120259,,
120570,NL,Orion Holland,Sales,Sales,Temporary,Temp. Sales Rep.,Friedrich Wuck,M,"$27,380",21JAN1944,01DEC2006,28FEB2007,4,120577,120576,120261,120259,,
120571,NL,Orion Holland,Sales,Sales,Temporary,Temp. Sales Rep.,M.M.J. Bossink,F,"$26,495",01MAR1949,01DEC2006,30APR2007,4,120577,120576,120261,120259,,
120572,NL,Orion Holland,Sales,Sales,Trainees,Trainee,I.H.H.M. Prins,F,"$25,225",09APR1959,01JAN2003,30JUN2003,4,120577,120576,120261,120259,,
120573,NL,Orion Holland,Sales,Sales,Winter Sports,Sales Rep. III,Tom Vaessen,M,"$29,275",03DEC1954,01OCT1975,,4,120577,120576,120261,120259,,
120574,NL,Orion Holland,Sales,Sales,Winter Sports,Sales Rep. I,H.l.M. Gunay,M,"$26,840",16AUG1969,01DEC1989,,4,120577,120576,120261,120259,,
120575,NL,Orion Holland,Sales,Sales,Winter Sports,Sales Rep. II,R.d. Kruize,M,"$26,395",24DEC1986,01AUG2006,,4,120577,120576,120261,120259,,
120576,NL,Orion Holland,Sales Management,Sales Management,Sales Management,Director,G.J. Oberman,M,"$151,190",08AUG1974,01JUN1998,,2,120261,120259,,,,
120577,NL,Orion Holland,Sales Management,Sales Management,Sales Management,Sales Manager,S.E.G. Konig,F,"$80,890",18MAR1974,01JUL1993,,3,120576,120261,120259,,,
120578,NL,Orion Holland,Sales Management,Sales Management,Sales Management,Secretary II,F.C.A.J. Van de Water,M,"$27,640",08JUN1984,01AUG2006,,3,120576,120261,120259,,,
120579,IT,Orion Italy,Administration,Administration,Administration,Office Assistant I,Ferruccio Delfini,M,"$25,120",20NOV1959,01JAN1979,,4,120581,120653,120261,120259,,
120580,IT,Orion Italy,Administration,Administration,Administration,Office Assistant I,Antonella Della Scala,F,"$27,055",04APR1979,01JUL2006,,4,120581,120653,120261,120259,,
120581,IT,Orion Italy,Administration,Administration,Shipping Charges,Administration Manager,Silvia Indiani,F,"$43,720",14JAN1984,01JUN2002,,3,120653,120261,120259,,,
120582,IT,Orion Italy,Administration,Goods Entrance,Stock Admin,Warehouse Manager,Luca Cordero Saieva,M,"$42,875",09APR1954,01JAN1974,,4,120581,120653,120261,120259,,
120583,IT,Orion Italy,Administration,Goods Entrance,Stock Admin,Warehouse Assistant II,Marcello Pistorello,M,"$26,080",03JUN1969,01JUL1996,,5,120582,120581,120653,120261,120259,
120584,IT,Orion Italy,Administration,Security,Security Guards,Security Manager,Daniela Marcoaldi,F,"$32,355",25JUL1949,01JAN1974,,4,120581,120653,120261,120259,,
120585,IT,Orion Italy,Administration,Security,Security Guards,Security Guard II,Evelina Rivoli,F,"$28,035",01JAN1984,01APR2006,,5,120584,120581,120653,120261,120259,
120586,IT,Orion Italy,Administration,Security,Security Guards,Security Guard I,Grazia Querci,F,"$27,180",28MAR1954,01MAR1975,,5,120584,120581,120653,120261,120259,
120587,IT,Orion Italy,Administration,Service Center,Service,Service Assistant I,Giovanni Battista Forestieri,M,"$27,220",20APR1949,01JUL1974,,5,120584,120581,120653,120261,120259,
120588,IT,Orion Italy,Administration,Service Center,Service,Service Assistant II,Andrea Pierse,M,"$28,995",05FEB1988,01JUL2006,,5,120584,120581,120653,120261,120259,
120589,IT,Orion Italy,Engineering,Engineering,Cabinet Maker's Workshop,Cabinet Maker II,Luigi Branda,M,"$28,725",16FEB1988,01OCT2006,,4,120581,120653,120261,120259,,
120590,IT,Orion Italy,Engineering,Engineering,Cabinet Maker's Workshop,Cabinet Maker III,Eleonora Bizai,F,"$32,800",16APR1984,01NOV2006,,4,120581,120653,120261,120259,,
120591,IT,Orion Italy,Sales,Sales,Assorted Sports Articles,Sales Rep. II,Jose' Luis Cacciapaglia,M,"$26,275",28MAR1986,01AUG2006,,4,120654,120653,120261,120259,,
120592,IT,Orion Italy,Sales,Sales,Assorted Sports Articles,Sales Rep. II,Leo Aldo Benetollo,M,"$26,945",08FEB1984,01APR2006,,4,120654,120653,120261,120259,,
120593,IT,Orion Italy,Sales,Sales,Assorted Sports Articles,Sales Rep. III,Silvana Riggio,F,"$29,500",21AUG1949,01JAN1974,,4,120654,120653,120261,120259,,
120594,IT,Orion Italy,Sales,Sales,Assorted Sports Articles,Sales Rep. III,Francesco Cioni,M,"$28,735",28JAN1984,01JUL2006,,4,120654,120653,120261,120259,,
120595,IT,Orion Italy,Sales,Sales,Assorted Sports Articles,Sales Rep. II,Fabia Dini,F,"$26,190",01NOV1984,01APR2006,,4,120654,120653,120261,120259,,
120596,IT,Orion Italy,Sales,Sales,Children Sports,Sales Rep. II,Laura Cornaglia,F,"$28,435",21DEC1986,01AUG2006,,4,120654,120653,120261,120259,,
120597,IT,Orion Italy,Sales,Sales,Children Sports,Sales Rep. I,Renato Tacchini,M,"$25,940",26FEB1984,01APR2006,,4,120654,120653,120261,120259,,
120598,IT,Orion Italy,Sales,Sales,Children Sports,Sales Rep. III,Mariateresa Davies,F,"$30,210",04JUN1986,01MAR2006,,4,120654,120653,120261,120259,,
120599,IT,Orion Italy,Sales,Sales,Children Sports,Sales Rep. III,Giulia Buonocunto,F,"$29,555",25OCT1944,01JAN1974,31AUG2006,4,120654,120653,120261,120259,,
120600,IT,Orion Italy,Sales,Sales,Children Sports,Sales Rep. I,Germano de Grossi,M,"$29,805",14MAY1959,01APR1978,,4,120654,120653,120261,120259,,
120601,IT,Orion Italy,Sales,Sales,Clothes,Sales Rep. II,Paolo Mestitz,M,"$28,580",26OCT1944,01JAN1974,31MAY2003,4,120654,120653,120261,120259,,
120602,IT,Orion Italy,Sales,Sales,Clothes,Sales Rep. I,Maria Ruscello,F,"$25,940",20JUL1959,01APR1980,,4,120654,120653,120261,120259,,
120603,IT,Orion Italy,Sales,Sales,Clothes,Sales Rep. II,Nicoletta Bandella,M,"$26,425",05AUG1954,01DEC1981,,4,120654,120653,120261,120259,,
120604,IT,Orion Italy,Sales,Sales,Clothes,Sales Rep. III,Esther Bolchini,F,"$30,525",28DEC1969,01JUL1994,,4,120654,120653,120261,120259,,
120605,IT,Orion Italy,Sales,Sales,Clothes,Sales Rep. I,Rosella Redigolo,F,"$27,135",11JUN1949,01JAN1974,31MAR2006,4,120654,120653,120261,120259,,
120606,IT,Orion Italy,Sales,Sales,Golf,Sales Rep. III,Pina Cellamare,F,"$30,040",08AUG1959,01JUL1983,,4,120654,120653,120261,120259,,
120607,IT,Orion Italy,Sales,Sales,Golf,Sales Rep. IV,Vittorio Minihan,M,"$30,655",26AUG1959,01DEC1984,31AUG2004,4,120654,120653,120261,120259,,
120608,IT,Orion Italy,Sales,Sales,Golf,Sales Rep. III,Giuseppe Franco Scoditti,M,"$30,460",16NOV1979,01JUN2001,31JAN2004,4,120654,120653,120261,120259,,
120609,IT,Orion Italy,Sales,Sales,Golf,Sales Rep. I,Sabrina Corradetti,F,"$26,890",11JAN1988,01MAR2006,,4,120654,120653,120261,120259,,
120610,IT,Orion Italy,Sales,Sales,Golf,Sales Rep. II,Agata Blundo,F,"$26,900",16MAR1974,01AUG2003,,4,120654,120653,120261,120259,,
120611,IT,Orion Italy,Sales,Sales,Indoor Sports,Sales Rep. II,Giovanni Nitti,M,"$26,590",09MAR1988,01MAY2006,,4,120654,120653,120261,120259,,
120612,IT,Orion Italy,Sales,Sales,Indoor Sports,Sales Rep. I,Dominique Bajetti,M,"$26,220",15DEC1988,01JAN2007,,4,120654,120653,120261,120259,,
120613,IT,Orion Italy,Sales,Sales,Shoes,Sales Rep. II,Claudio Pertotti,M,"$28,415",22MAY1944,01JAN1974,30SEP2006,4,120654,120653,120261,120259,,
120614,IT,Orion Italy,Sales,Sales,Shoes,Sales Rep. I,Elena Orlandini,F,"$26,735",15APR1969,01MAR1994,28FEB2006,4,120654,120653,120261,120259,,
120615,IT,Orion Italy,Sales,Sales,Shoes,Sales Rep. III,Pierluigi Diversi,M,"$29,235",10MAY1959,01APR1988,,4,120654,120653,120261,120259,,
120616,IT,Orion Italy,Sales,Sales,Shoes,Sales Rep. I,Gianpaolo Bonasso,M,"$26,765",05JAN1979,01OCT2006,,4,120654,120653,120261,120259,,
120617,IT,Orion Italy,Sales,Sales,Shoes,Sales Rep. I,Timothy-Lucie Ferracin,M,"$25,655",11OCT1964,01OCT1984,31JAN2005,4,120654,120653,120261,120259,,
120618,IT,Orion Italy,Sales,Sales,Shoes,Sales Rep. II,Nilla Patrizia Alquati,F,"$28,075",23JAN1949,01JAN1977,,4,120654,120653,120261,120259,,
120619,IT,Orion Italy,Sales,Sales,Outdoors,Sales Rep. I,Eugenio Bottazzo,M,"$26,105",09DEC1954,01JAN1974,,4,120654,120653,120261,120259,,
120620,IT,Orion Italy,Sales,Sales,Outdoors,Sales Rep. III,Giuseppe Dezzani,M,"$29,445",15MAR1959,01DEC1977,,4,120654,120653,120261,120259,,
120621,IT,Orion Italy,Sales,Sales,Outdoors,Sales Rep. I,Piera Bvenigni,F,"$25,895",02OCT1954,01DEC1982,,4,120654,120653,120261,120259,,
120622,IT,Orion Italy,Sales,Sales,Outdoors,Sales Rep. I,Gianluca Lo Bianco,M,"$26,530",02JAN1964,01JUN1985,31MAR2003,4,120654,120653,120261,120259,,
120623,IT,Orion Italy,Sales,Sales,Outdoors,Sales Rep. I,Patrizia Moraschini,F,"$27,095",11SEP1964,01NOV1988,,4,120654,120653,120261,120259,,
120624,IT,Orion Italy,Sales,Sales,Outdoors,Sales Rep. II,Umberto Salvagnin,M,"$27,155",08JUN1984,01SEP2006,,4,120654,120653,120261,120259,,
120625,IT,Orion Italy,Sales,Sales,Outdoors,Sales Rep. IV,Caterina Seghi,F,"$32,015",23JUN1984,01NOV2006,,4,120654,120653,120261,120259,,
120626,IT,Orion Italy,Sales,Sales,Outdoors,Sales Rep. I,Odetta Sias,F,"$21,660",22AUG1959,01AUG1978,,4,120654,120653,120261,120259,,
120627,IT,Orion Italy,Sales,Sales,Outdoors,Sales Rep. IV,Maurizio Modeo,M,"$32,355",23AUG1986,01MAY2006,,4,120654,120653,120261,120259,,
120628,IT,Orion Italy,Sales,Sales,Outdoors,Sales Rep. I,Maria Paola Borzini,F,"$26,815",14FEB1988,01FEB2007,,4,120654,120653,120261,120259,,
120629,IT,Orion Italy,Sales,Sales,Racket Sports,Sales Rep. I,Stefano Orabona,M,"$26,035",10JUL1984,01DEC2004,,4,120654,120653,120261,120259,,
120630,IT,Orion Italy,Sales,Sales,Racket Sports,Sales Rep. IV,Francesco Malknecht,M,"$30,150",10AUG1969,01FEB1991,,4,120654,120653,120261,120259,,
120631,IT,Orion Italy,Sales,Sales,Racket Sports,Sales Rep. I,Bertilla Brambillasca,F,"$25,475",15JUL1944,01JAN1974,,4,120654,120653,120261,120259,,
120632,IT,Orion Italy,Sales,Sales,Racket Sports,Sales Rep. I,Giovanni Di Lernia,M,"$26,150",26JUL1986,01JUL2006,01JAN2007,4,120654,120653,120261,120259,,
120633,IT,Orion Italy,Sales,Sales,Running - Jogging,Sales Rep. III,Luciano Laudani,M,"$30,320",26AUG1944,01JAN1974,,4,120654,120653,120261,120259,,
120634,IT,Orion Italy,Sales,Sales,Running - Jogging,Sales Rep. III,Aprognano Lea,M,"$28,115",11APR1964,01FEB1990,,4,120654,120653,120261,120259,,
120635,IT,Orion Italy,Sales,Sales,Swim Sports,Sales Rep. I,Cristina de Gisi,F,"$27,055",16JUL1974,01SEP1999,,4,120654,120653,120261,120259,,
120636,IT,Orion Italy,Sales,Sales,Swim Sports,Sales Rep. I,Alessandro Di Lernia,M,"$26,525",26JUL1986,01FEB2007,01AUG2007,4,120654,120653,120261,120259,,
120637,IT,Orion Italy,Sales,Sales,Swim Sports,Sales Rep. I,Maurizio d'Antona,M,"$25,900",11DEC1986,01APR2006,,4,120654,120653,120261,120259,,
120638,IT,Orion Italy,Sales,Sales,Team Sports,Sales Rep. III,Silvio Granzini,M,"$28,985",02JUN1988,01JAN2007,,4,120654,120653,120261,120259,,
120639,IT,Orion Italy,Sales,Sales,Team Sports,Sales Rep. III,Marcella Gattico,F,"$28,430",18NOV1969,01SEP1990,,4,120654,120653,120261,120259,,
120640,IT,Orion Italy,Sales,Sales,Team Sports,Sales Rep. II,Edoardo Capocasale,M,"$28,040",02DEC1944,01JAN1974,,4,120654,120653,120261,120259,,
120641,IT,Orion Italy,Sales,Sales,Temporary,Temp. Sales Rep.,Roberto Zaffaroni,M,"$26,165",19JAN1949,01DEC2006,31MAR2007,4,120654,120653,120261,120259,,
120642,IT,Orion Italy,Sales,Sales,Temporary,Temp. Sales Rep.,Alberto Andrea Kali,M,"$25,275",13NOV1979,01DEC2006,31DEC2006,4,120654,120653,120261,120259,,
120643,IT,Orion Italy,Sales,Sales,Temporary,Temp. Sales Rep.,Jose' Luis Ingravalle,M,"$25,640",07SEP1959,01DEC2006,31MAY2007,4,120654,120653,120261,120259,,
120644,IT,Orion Italy,Sales,Sales,Temporary,Temp. Sales Rep.,Paola Calcinati,F,"$26,330",25APR1954,01DEC2006,31DEC2006,4,120654,120653,120261,120259,,
120645,IT,Orion Italy,Sales,Sales,Temporary,Temp. Sales Rep.,Daniela Luisa Notargiacomo,F,"$26,405",15MAY1979,01DEC2006,30APR2007,4,120654,120653,120261,120259,,
120646,IT,Orion Italy,Sales,Sales,Temporary,Temp. Sales Rep.,Ante Bernardis,M,"$26,720",04NOV1964,01DEC2006,31MAR2007,4,120654,120653,120261,120259,,
120647,IT,Orion Italy,Sales,Sales,Temporary,Temp. Sales Rep.,Cinzia Dalla Grisa,M,"$25,470",10AUG1954,01DEC2006,31JAN2007,4,120654,120653,120261,120259,,
120648,IT,Orion Italy,Sales,Sales,Trainees,Trainee,Fabio Cantiani,M,"$25,555",20FEB1979,01JAN2003,30JUN2003,4,120654,120653,120261,120259,,
120649,IT,Orion Italy,Sales,Sales,Trainees,Trainee,Antonella Carissimi,F,"$21,615",24FEB1964,01JAN2003,30JUN2003,4,120654,120653,120261,120259,,
120650,IT,Orion Italy,Sales,Sales,Winter Sports,Sales Rep. II,Antonietta Cardellini,F,"$26,020",23OCT1944,01JAN1974,,4,120654,120653,120261,120259,,
120651,IT,Orion Italy,Sales,Sales,Winter Sports,Sales Rep. I,Brunner Nossa,F,"$27,055",28JUL1979,01APR2001,,4,120654,120653,120261,120259,,
120652,IT,Orion Italy,Sales,Sales,Winter Sports,Sales Rep. II,Giuseppe Giubbolini,M,"$26,675",21FEB1988,01NOV2006,,4,120654,120653,120261,120259,,
120653,IT,Orion Italy,Sales Management,Sales Management,Sales Management,Director,Bruno Bruzzi,M,"$163,125",26JUL1964,01NOV1985,,2,120261,120259,,,,
120654,IT,Orion Italy,Sales Management,Sales Management,Sales Management,Sales Manager,Francesca Crescenzio,F,"$80,470",14JAN1978,01NOV2000,,3,120653,120261,120259,,,
120655,IT,Orion Italy,Sales Management,Sales Management,Sales Management,Secretary II,Andreana Comacchio,F,"$27,975",15NOV1979,01DEC1999,,3,120653,120261,120259,,,
120656,US,Logistics,Logistics Management,Logistics,External,Logistics Coordinator II,Salley Amos,F,"$42,570",28JAN1974,01MAR1999,,3,120660,120659,120259,,,
120657,US,Logistics,Logistics Management,Logistics,External,Logistics Coordinator I,Theresa Weisbarth,F,"$36,110",07JAN1964,01NOV1990,,3,120660,120659,120259,,,
120658,US,Logistics,Logistics Management,Logistics,External,Logistics Coordinator II,Kenneth Kennedy,M,"$42,485",20DEC1954,01FEB1981,,3,120660,120659,120259,,,
120659,US,Logistics,Logistics Management,Logistics,Logistics,Director,Jay Havasy,M,"$161,290",16JUL1949,01JAN1974,,1,120259,,,,,
120660,US,Logistics,Logistics Management,Logistics,Logistics,Logistics Manager,Robert Smith,M,"$61,125",06JUN1978,01MAR2005,,2,120659,120259,,,,
120661,US,Logistics,Logistics Management,Logistics,Logistics,Senior Logistics Manager,Cynthia Racine,F,"$85,495",27NOV1954,01JAN1984,30JUN2003,2,120659,120259,,,,
120662,US,Logistics,Logistics Management,Logistics,Logistics,Secretary II,Lemonica Burroughs,M,"$27,045",25JUN1988,01NOV2006,,2,120659,120259,,,,
120663,US,Logistics,Logistics Management,Logistics,Pricing,Pricing Manager,Anglar Kornblith,F,"$56,385",26MAR1969,01MAR1997,,2,120659,120259,,,,
120664,US,Logistics,Logistics Management,Logistics,Pricing,Pricing Specialist,Brock Senchak,M,"$47,605",18FEB1954,01MAY1975,,3,120663,120659,120259,,,
120665,US,Logistics,Logistics Management,Secretariat,Import/Export,Senior Logistics Manager,Jill Leacock,F,"$80,070",24OCT1974,01MAR2002,,2,120659,120259,,,,
120666,US,Logistics,Logistics Management,Secretariat,Import/Export,Logistics Manager,John Onuscheck,M,"$64,555",22JUN1969,01DEC1991,30APR2004,2,120659,120259,,,,
120667,US,Logistics,Logistics Management,Secretariat,Import/Export,Office Assistant III,Edwin Droste,M,"$29,980",21JUN1979,01FEB2006,,3,120666,120659,120259,,,
120668,US,Logistics,Logistics Management,Secretariat,Office Services,Services Manager,Thyland Dolan,M,"$47,785",23OCT1949,01DEC1978,,2,120659,120259,,,,
120669,US,Logistics,Logistics Management,Secretariat,Office Services,Services Assistant IV,Ronald Hill,M,"$36,370",23JUL1944,01JAN1974,,3,120668,120659,120259,,,
120670,US,Logistics,Stock & Shipping,Stock & Shipping,Stock & Shipping Americas,Shipping Manager,Odudu Zisek,M,"$65,420",26MAR1944,01JAN1974,31DEC2002,2,120659,120259,,,,
120671,US,Logistics,Stock & Shipping,Stock & Shipping,Stock & Shipping Americas,Shipping Agent III,William Latty,M,"$40,080",27MAY1954,01FEB1983,,3,120670,120659,120259,,,
120672,AU,Logistics,Stock & Shipping,Stock & Shipping,Stock & Shipping Asia/Pacific,Shipping Manager,Verne Guscott,M,"$60,980",25AUG1964,01MAR1992,,2,120659,120259,,,,
120673,AU,Logistics,Stock & Shipping,Stock & Shipping,Stock & Shipping Asia/Pacific,Shipping Agent II,Pearl Santomaggio,F,"$35,935",27JUN1944,01JAN1974,,3,120672,120659,120259,,,
120674,FR,Logistics,Stock & Shipping,Stock & Shipping,Stock & Shipping EMEA,Shipping Manager,Corinne Bourreau,F,"$62,685",18MAY1949,01JAN1974,,2,120659,120259,,,,
120675,FR,Logistics,Stock & Shipping,Stock & Shipping,Stock & Shipping EMEA,Shipping Agent II,Xavier Kergoat,M,"$36,600",17FEB1988,01MAY2006,,3,120674,120659,120259,,,
120676,FR,Logistics,Stock & Shipping,Stock & Shipping,Stock & Shipping EMEA,Shipping Agent I,Jean Marc Bouteille,M,"$31,690",23AUG1974,01NOV1996,,3,120674,120659,120259,,,
120677,US,Logistics,Stock & Shipping,Stock & Shipping,Export Stock,Shipping Manager,Suad Sochacki,F,"$65,555",02SEP1969,01FEB1993,,2,120659,120259,,,,
120678,US,Logistics,Stock & Shipping,Stock & Shipping,Export Stock,Shipping Agent III,Lucretta Octetree,F,"$40,035",12JAN1949,01MAY1978,31AUG2003,3,120677,120659,120259,,,
120679,US,Logistics,Stock & Shipping,Stock & Shipping,Stock & Shipping Americas,Shipping Manager,Chrisy Cutucache,F,"$46,190",07NOV1976,01JUL2002,,2,120659,120259,,,,
120680,US,Logistics,Stock & Shipping,Stock & Shipping,Stock & Shipping Americas,Shipping Agent I,Raymondria Desaulniers,F,"$27,295",25AUG1969,01MAY1991,,3,120679,120659,120259,,,
120681,US,Logistics,Stock & Shipping,Stock & Shipping,Stock & Shipping Americas,Shipping Agent II,Elery Tolbet,M,"$30,950",12AUG1979,01APR2004,,3,120679,120659,120259,,,
120682,US,Logistics,Stock & Shipping,Stock & Shipping,Stock & Shipping Americas,Shipping Agent I,Barbara Kennedy,F,"$26,760",20DEC1969,01APR1996,,3,120679,120659,120259,,,
120683,US,Logistics,Stock & Shipping,Stock & Shipping,Stock & Shipping Americas,Shipping Agent III,Deven Kochneff,F,"$36,315",12NOV1954,01JAN1974,28FEB2003,3,120679,120659,120259,,,
120684,US,Logistics,Stock & Shipping,Stock & Shipping,Stock & Shipping Americas,Warehouse Assistant I,Suzon Woyach,F,"$26,960",26NOV1986,01NOV2006,,3,120679,120659,120259,,,
120685,US,Logistics,Stock & Shipping,Stock & Shipping,Stock & Shipping Americas,Warehouse Assistant I,Anita Howard,F,"$25,130",01MAR1984,01NOV2006,,3,120679,120659,120259,,,
120686,US,Logistics,Stock & Shipping,Stock & Shipping,Stock & Shipping Americas,Warehouse Assistant II,Berether Tucker,F,"$26,690",07MAY1944,01JAN1974,,3,120679,120659,120259,,,
120687,US,Logistics,Stock & Shipping,Stock & Shipping,Stock & Shipping Americas,Warehouse Assistant I,Freda Dannin,F,"$26,800",25MAY1979,01AUG2004,31JAN2005,3,120679,120659,120259,,,
120688,US,Logistics,Stock & Shipping,Stock & Shipping,Stock & Shipping Americas,Warehouse Assistant I,Lisa Carcaterra,F,"$25,905",25DEC1949,01JAN1974,31AUG2002,3,120679,120659,120259,,,
120689,US,Logistics,Stock & Shipping,Stock & Shipping,Stock & Shipping Americas,Warehouse Assistant III,Katherine Pongor,F,"$27,780",20JUL1979,01JUL2006,,3,120679,120659,120259,,,
120690,US,Logistics,Stock & Shipping,Stock & Shipping,Stock & Shipping Americas,Warehouse Assistant I,Taronda Langston,F,"$25,185",17JAN1984,01DEC2004,,3,120679,120659,120259,,,
120691,AU,Logistics,Stock & Shipping,Stock & Shipping,Stock & Shipping Asia/Pacific,Shipping Manager,Sek Habres,M,"$49,240",15SEP1944,01JAN1974,,2,120659,120259,,,,
120692,AU,Logistics,Stock & Shipping,Stock & Shipping,Stock & Shipping Asia/Pacific,Shipping Agent II,Rit Tregonning,M,"$32,485",22NOV1954,01APR1982,,3,120691,120659,120259,,,
120693,AU,Logistics,Stock & Shipping,Stock & Shipping,Stock & Shipping Asia/Pacific,Shipping Agent I,Diaz Tellam,M,"$26,625",02MAY1959,01JUN1979,,3,120691,120659,120259,,,
120694,AU,Logistics,Stock & Shipping,Stock & Shipping,Stock & Shipping Asia/Pacific,Warehouse Assistant I,Sharon Leazer,F,"$27,365",16AUG1988,01APR2006,,3,120691,120659,120259,,,
120695,AU,Logistics,Stock & Shipping,Stock & Shipping,Stock & Shipping Asia/Pacific,Warehouse Assistant II,Trent Moffat,M,"$28,180",13JUL1964,01JUL1989,31JUL2006,3,120691,120659,120259,,,
120696,AU,Logistics,Stock & Shipping,Stock & Shipping,Stock & Shipping Asia/Pacific,Warehouse Assistant I,Peter Pettolino,M,"$26,615",14AUG1954,01MAR1974,31MAR2006,3,120691,120659,120259,,,
120697,AU,Logistics,Stock & Shipping,Stock & Shipping,Stock & Shipping Asia/Pacific,Warehouse Assistant IV,Madelaine Fouche,F,"$29,625",27JUN1988,01JUN2006,,3,120691,120659,120259,,,
120698,AU,Logistics,Stock & Shipping,Stock & Shipping,Stock & Shipping Asia/Pacific,Warehouse Assistant I,Geoff Kistanna,M,"$26,160",17MAY1954,01AUG1976,28FEB2005,3,120691,120659,120259,,,
120699,FR,Logistics,Stock & Shipping,Stock & Shipping,Stock & Shipping EMEA,Shipping Manager,Pierre Dezafit,M,"$48,565",25MAR1978,01JAN1999,,2,120659,120259,,,,
120700,FR,Logistics,Stock & Shipping,Stock & Shipping,Stock & Shipping EMEA,Shipping Agent II,Farida Hamon,F,"$30,290",10DEC1949,01JAN1974,,3,120699,120659,120259,,,
120701,FR,Logistics,Stock & Shipping,Stock & Shipping,Stock & Shipping EMEA,Shipping Agent II,Nadege Michel,F,"$32,545",15SEP1984,01MAR2003,,3,120699,120659,120259,,,
120702,FR,Logistics,Stock & Shipping,Stock & Shipping,Stock & Shipping EMEA,Shipping Agent I,Damien Simon,M,"$25,730",24APR1974,01NOV2001,,3,120699,120659,120259,,,
120703,FR,Logistics,Stock & Shipping,Stock & Shipping,Stock & Shipping EMEA,Warehouse Assistant I,Corinne Barens,F,"$26,790",04NOV1944,01JAN1974,,3,120699,120659,120259,,,
120704,FR,Logistics,Stock & Shipping,Stock & Shipping,Stock & Shipping EMEA,Warehouse Assistant I,Claude Millequant,M,"$27,185",28MAR1974,01DEC1996,,3,120699,120659,120259,,,
120705,FR,Logistics,Stock & Shipping,Stock & Shipping,Stock & Shipping EMEA,Warehouse Assistant II,Rodolphe Auge,M,"$26,190",13APR1969,01APR1996,,3,120699,120659,120259,,,
120706,FR,Logistics,Stock & Shipping,Stock & Shipping,Stock & Shipping EMEA,Warehouse Assistant I,Jean-Pail Lagier,M,"$25,295",01JUN1974,01MAY1999,,3,120699,120659,120259,,,
120707,FR,Logistics,Stock & Shipping,Stock & Shipping,Stock & Shipping EMEA,Warehouse Assistant IV,Christine Rustenholz,F,"$30,460",16SEP1979,01MAY2000,,3,120699,120659,120259,,,
120708,FR,Logistics,Stock & Shipping,Stock & Shipping,Stock & Shipping EMEA,Warehouse Assistant I,Isabelle Spira,F,"$25,825",22JUL1964,01JUL1986,,3,120699,120659,120259,,,
120709,FR,Logistics,Stock & Shipping,Stock & Shipping,Stock & Shipping EMEA,Warehouse Assistant II,Remy Thomet,M,"$27,205",28FEB1988,01MAR2006,,3,120699,120659,120259,,,
120710,US,Marketing,Marketing,CRM,CRM,Business Analyst II,Timothy Baltzell,M,"$54,840",24NOV1974,01JAN1998,,3,120719,120260,120259,,,
120711,US,Marketing,Marketing,CRM,CRM,Business Analyst III,Gloria Drew,F,"$59,130",28MAY1969,01MAR1994,,3,120719,120260,120259,,,
120712,US,Marketing,Marketing,DotCom & Catalog,Catalog,Marketing Manager,Elisabeth Motashaw,F,"$63,640",12JUN1949,01JAN1974,,3,120719,120260,120259,,,
120713,US,Marketing,Marketing,DotCom & Catalog,Catalog,Marketing Assistant III,Carston Campbell,M,"$31,630",23FEB1944,01JAN1974,,4,120712,120719,120260,120259,,
120714,US,Marketing,Marketing,DotCom & Catalog,DotCom,Marketing Manager,Robert Dinley,M,"$62,625",04APR1976,01SEP1998,,3,120719,120260,120259,,,
120715,US,Marketing,Marketing,DotCom & Catalog,DotCom,Marketing Assistant II,Angelia Neal,F,"$28,535",12JUN1979,01FEB2005,,4,120714,120719,120260,120259,,
120716,US,Marketing,Marketing,Events & PR,Events & PR,Events Manager,Kenneth Juif,M,"$53,015",24JUL1974,01AUG1993,,3,120719,120260,120259,,,
120717,US,Marketing,Marketing,Events & PR,Events & PR,Marketing Assistant II,Jon Sleva,M,"$30,155",09JAN1954,01AUG1981,,4,120716,120719,120260,120259,,
120718,US,Marketing,Marketing,Events & PR,Events & PR,Marketing Assistant II,Charles Hennington,M,"$29,190",08JUL1964,01MAY1990,,4,120716,120719,120260,120259,,
120719,US,Marketing,Marketing,Marketing,Marketing,Senior Marketing Manager,Roya Ridley,F,"$87,420",22JAN1969,01FEB1996,,2,120260,120259,,,,
120720,US,Marketing,Marketing,Marketing,Marketing,Corp. Comm. Manager,John Spingola,M,"$46,580",07MAY1964,01APR1992,,3,120719,120260,120259,,,
120721,US,Marketing,Marketing,Marketing,Marketing,Marketing Assistant II,Dlutomi Knust,F,"$29,870",21OCT1944,01JAN1974,,4,120720,120719,120260,120259,,
120722,US,Marketing,Marketing,Marketing,Marketing,Corp. Comm. Specialist I,Ishmar Sheffield,M,"$32,460",22SEP1959,01OCT1985,,4,120720,120719,120260,120259,,
120723,US,Marketing,Marketing,Marketing,Marketing,Corp. Comm. Specialist II,Deanna Olsen,F,"$33,950",10AUG1949,01JAN1974,,4,120720,120719,120260,120259,,
120724,US,Marketing,Marketing,Organization,Organization,Marketing Manager,Hampie Brown,M,"$63,705",27JAN1964,01APR1992,,3,120719,120260,120259,,,
120725,US,Marketing,Marketing,Organization,Organization,Marketing Assistant II,Robert Whitlock,M,"$29,970",24OCT1979,01JUN2004,31DEC2004,4,120724,120719,120260,120259,,
120726,US,Marketing,Marketing,Orion Club Member Service,Orion Club Member Service,Marketing Assistant I,Lutezenia Obermeyer,F,"$27,380",01JUL1988,01SEP2006,,4,120724,120719,120260,120259,,
120727,US,Marketing,Marketing,Orion Club Member Service,Orion Club Member Service,Marketing Assistant IV,Donald Marples,M,"$34,925",25JUN1964,01JUN1986,,4,120724,120719,120260,120259,,
120728,US,Purchasing,Purchasing,Children's Sports,Children's Sports,Purchasing Agent II,Kathryn Borge,F,"$35,070",04DEC1954,01JAN1982,,3,120735,120261,120259,,,
120729,US,Purchasing,Purchasing,Children's Sports,Children's Sports,Purchasing Agent I,Kimberly Howell,F,"$31,495",03APR1988,25APR2003,23SEP2005,3,120735,120261,120259,,,
120730,US,Purchasing,Purchasing,Children's Sports,Children's Sports,Purchasing Agent I,Woodson Burt,M,"$30,195",16DEC1964,01OCT1988,,3,120735,120261,120259,,,
120731,US,Purchasing,Purchasing,Children's Sports,Children's Sports,Purchasing Agent II,Robert Lerew,M,"$34,150",15MAR1959,01SEP1983,,3,120735,120261,120259,,,
120732,US,Purchasing,Purchasing,Outdoors,Outdoors,Purchasing Agent III,Kent Uenking,M,"$35,870",14AUG1949,01JAN1974,,3,120736,120261,120259,,,
120733,US,Purchasing,Purchasing,Outdoors,Outdoors,Purchasing Agent I,Michael Bezinque,M,"$31,760",03APR1964,01NOV1990,,3,120736,120261,120259,,,
120734,US,Purchasing,Purchasing,Outdoors,Outdoors,Purchasing Agent III,Svein Saylor,M,"$34,270",26APR1979,01MAR2006,,3,120736,120261,120259,,,
120735,US,Purchasing,Purchasing,Purchasing Management,Team Administration,Purchasing Manager,Brenda Bilobran,F,"$61,985",13JUN1954,01MAY1978,,2,120261,120259,,,,
120736,US,Purchasing,Purchasing,Purchasing Management,Team Administration,Purchasing Manager,Parie Kiemle,F,"$63,985",27NOV1964,01OCT1991,,2,120261,120259,,,,
120737,US,Purchasing,Purchasing,Purchasing Management,Team Administration,Purchasing Manager,Brenner Toner,F,"$63,605",28MAR1959,01NOV1988,,2,120261,120259,,,,
120738,US,Purchasing,Purchasing,Sports,Sports,Purchasing Agent I,Huilun Swaiti,F,"$30,025",06JUL1949,01JAN1974,,3,120737,120261,120259,,,
120739,US,Purchasing,Purchasing,Sports,Sports,Purchasing Agent III,Bryon Cooper,M,"$36,970",07AUG1986,01MAY2006,,3,120737,120261,120259,,,
120740,US,Purchasing,Purchasing,Sports,Sports,Purchasing Agent II,Lisa Koonce,F,"$35,110",19OCT1949,01JAN1974,31AUG2003,3,120737,120261,120259,,,
120741,US,Purchasing,Purchasing,Sports,Sports,Purchasing Agent III,Keisha Court,F,"$36,365",28NOV1944,01JAN1974,,3,120737,120261,120259,,,
120742,US,Purchasing,Purchasing,Sports,Sports,Purchasing Agent I,Ronald Shewitz,M,"$31,020",04FEB1944,01JAN1974,,3,120737,120261,120259,,,
120743,US,Purchasing,Purchasing,Sports,Sports,Purchasing Agent II,Chimena Harrison,F,"$34,620",01FEB1969,01JUN1997,,3,120737,120261,120259,,,
120744,US,Purchasing,Purchasing,Sports,Sports,Purchasing Agent II,Alden Feigenbaum,F,"$33,490",19JUN1988,01JUL2004,30OCT2005,3,120737,120261,120259,,,
120745,US,Purchasing,Purchasing,Sports,Sports,Purchasing Agent I,Barbara Harvill,F,"$31,365",05JUL1986,01JUN2006,,3,120737,120261,120259,,,
120746,US,Shared Functions,Accounts,Accounts Center,Accounting & Budgeting,Account Manager,Kevie Kimmerle,M,"$46,090",10OCT1974,01APR2002,,2,120262,120259,,,,
120747,US,Shared Functions,Accounts,Accounts Center,Accounting & Budgeting,Financial Controller I,Zashia Farthing,F,"$43,590",20JUN1974,01AUG1995,,3,120746,120262,120259,,,
120748,US,Shared Functions,Accounts,Accounts Center,Building Administration,Building Admin. Manager,Nahliah Post,F,"$48,380",05JUL1976,01MAR2003,,2,120262,120259,,,,
120749,US,Shared Functions,Accounts,Accounts Center,Building Administration,Office Assistant II,Kevin Niemann,M,"$26,545",20SEP1974,01OCT1996,,3,120748,120262,120259,,,
120750,US,Shared Functions,Accounts,Finance,Accounting & Budgeting,Accountant I,Connie Woods,F,"$32,675",07JUN1954,01FEB1979,31JAN2002,3,120751,120262,120259,,,
120751,US,Shared Functions,Accounts,Finance,Accounting & Budgeting,Finance Manager,Azavi0us Mea,M,"$58,200",05APR1964,01AUG1988,,2,120262,120259,,,,
120752,US,Shared Functions,Accounts,Finance,Accounting & Budgeting,Accountant I,Pieter Slykhuis,M,"$30,590",17FEB1954,01AUG1975,30APR2003,3,120751,120262,120259,,,
120753,US,Shared Functions,Accounts,Finance,Accounting & Budgeting,Financial Controller II,Ralph Ferrari,M,"$47,000",15JUN1976,01AUG1994,,3,120751,120262,120259,,,
120754,US,Shared Functions,Accounts,Finance,Concession Billing,Accountant II,John Atkins,M,"$34,760",02JUN1988,01MAY2006,,3,120751,120262,120259,,,
120755,US,Shared Functions,Accounts,Finance,Concession Billing,Accountant III,Elizabeth Thoits,F,"$36,440",24AUG1964,01AUG1983,,3,120751,120262,120259,,,
120756,US,Shared Functions,Accounts,Finance,Head Cashier,Financial Controller III,Wendy Asta,F,"$52,295",20FEB1974,01JUL1996,,3,120751,120262,120259,,,
120757,US,Shared Functions,Accounts,Finance,Head Cashier,Accountant III,Paul Knopfmacher,M,"$38,545",18MAR1944,01JAN1974,30JUN2004,3,120751,120262,120259,,,
120758,US,Shared Functions,Accounts,Finance,Head Cashier,Accountant II,Sal Voltz,M,"$34,040",22OCT1964,01OCT1992,,3,120751,120262,120259,,,
120759,US,Shared Functions,Accounts,Operations Accounting,Operations Accounting,Accountant II,Nishan Apr,M,"$36,230",04NOV1964,01JAN1983,,3,120746,120262,120259,,,
120760,US,Shared Functions,Accounts,Operations Accounting,Operations Accounting,Financial Controller III,Pamela Miller,F,"$53,475",06JAN1969,01MAY1993,,3,120746,120262,120259,,,
120761,US,Shared Functions,Accounts,Operations Accounting,Operations Accounting,Accountant I,Tameaka Akinfolarin,F,"$30,960",28DEC1986,01JUL2006,,3,120746,120262,120259,,,
120762,US,Shared Functions,Accounts,Operations Accounting,Operations Accounting,Accountant I,Marvin Leone,M,"$30,625",02NOV1979,01MAR2006,,3,120746,120262,120259,,,
120763,US,Shared Functions,Accounts Management,Auditing & Salary,Auditing & Wages,Auditor II,Ramond Capps,M,"$45,100",26OCT1944,01JAN1974,,3,120766,120262,120259,,,
120764,US,Shared Functions,Accounts Management,Auditing & Salary,Auditing & Wages,Auditor I,Steven Worton,M,"$40,450",22DEC1974,01DEC2002,,3,120766,120262,120259,,,
120765,US,Shared Functions,Accounts Management,Auditing & Salary,Auditing & Wages,Financial Controller III,Nikeisha Kokoszka,F,"$51,950",17DEC1954,01JAN1974,,3,120766,120262,120259,,,
120766,US,Shared Functions,Accounts Management,Auditing & Salary,Auditing & Wages,Auditing Manager,Janelle Kempster,F,"$53,400",05NOV1974,01MAR2001,,2,120262,120259,,,,
120767,US,Shared Functions,Accounts Management,Auditing & Salary,Auditing & Wages,Accountant I,Legette Terricciano,M,"$32,965",09MAY1964,01APR1987,,3,120766,120262,120259,,,
120768,US,Shared Functions,Accounts Management,Auditing & Salary,External Auditing,Accountant II,Roland Rayburn,M,"$44,955",22JUL1954,01OCT1981,30NOV2003,3,120766,120262,120259,,,
120769,US,Shared Functions,Accounts Management,Auditing & Salary,External Auditing,Auditor II,Abelino Lightbourne,M,"$47,990",24MAY1974,01APR1996,,3,120766,120262,120259,,,
120770,US,Shared Functions,Accounts Management,Auditing & Salary,Internal Auditing,Auditor I,Julia Pascoe,F,"$43,930",24APR1964,01APR1987,30APR2003,3,120766,120262,120259,,,
120771,US,Shared Functions,Accounts Management,Auditing & Salary,Internal Auditing,Accountant II,Wei  Xing Moore,F,"$36,435",04AUG1954,01DEC1976,,3,120766,120262,120259,,,
120772,US,Shared Functions,Group HR Management,Group HR,Group HR,HR Generalist I,Erich Overdorff,M,"$27,365",08APR1988,01AUG2006,,3,120780,120262,120259,,,
120773,US,Shared Functions,Group HR Management,Group HR,Group HR,HR Generalist II,Entrisse Horne,F,"$27,370",22FEB1959,01APR1981,,3,120780,120262,120259,,,
120774,US,Shared Functions,Group HR Management,Group HR,Group HR,HR Specialist II,Sue El-Amin,F,"$45,155",17SEP1978,01MAR2002,31OCT2005,3,120780,120262,120259,,,
120775,US,Shared Functions,Group HR Management,Group HR,Group HR,HR Analyst II,Tanya Thompson,F,"$41,580",11FEB1969,01NOV1996,,3,120780,120262,120259,,,
120776,US,Shared Functions,Group HR Management,Group HR,Retirement Club,HR Generalist III,Ratna Silverthorne,M,"$32,580",21SEP1979,01APR2001,,3,120780,120262,120259,,,
120777,US,Shared Functions,Group HR Management,Group HR,Retirement Club,HR Specialist I,Kary Sacher,M,"$40,955",26MAR1969,01MAY1994,,3,120780,120262,120259,,,
120778,US,Shared Functions,Group HR Management,Group HR,Retirement Club,HR Specialist I,Angela Gardner,F,"$43,650",08DEC1954,01FEB1984,,3,120780,120262,120259,,,
120779,US,Shared Functions,Group HR Management,Group HR,Staff Administration,HR Analyst II,Jennifer Eggleston,F,"$43,690",04OCT1976,01MAR1997,,3,120780,120262,120259,,,
120780,US,Shared Functions,Group HR Management,Group HR,Staff Administration,HR Manager,Kimberly Walcott,F,"$62,995",01SEP1969,01OCT1991,,2,120262,120259,,,,
120781,US,Shared Functions,Group HR Management,Recruitment & Training,Group Recruitment,Recruiter I,Sarah Sitnik,F,"$32,620",23JAN1988,01DEC2004,31DEC2005,3,120782,120262,120259,,,
120782,US,Shared Functions,Group HR Management,Recruitment & Training,Group Recruitment,Recruitment Manager,Rilma Sines,F,"$63,915",29NOV1974,01JUN1999,,2,120262,120259,,,,
120783,US,Shared Functions,Group HR Management,Recruitment & Training,Group Recruitment,Recruiter III,Davis Karp,M,"$42,975",20DEC1974,01JAN1996,,3,120782,120262,120259,,,
120784,US,Shared Functions,Group HR Management,Recruitment & Training,Group Recruitment,Recruiter II,Jennifer Pinol,F,"$35,715",24APR1979,01SEP2004,,3,120782,120262,120259,,,
120785,US,Shared Functions,Group HR Management,Recruitment & Training,Recruitment & Training,Training Manager,Damesha Donnell,F,"$48,335",21JAN1969,01JUN1993,,3,120780,120262,120259,,,
120786,US,Shared Functions,Group HR Management,Recruitment & Training,Recruitment & Training,Trainer I,Chris-Anne Delafuente,F,"$32,650",18MAR1944,01JAN1974,,4,120785,120780,120262,120259,,
120787,US,Shared Functions,Group HR Management,Recruitment & Training,Recruitment & Training,Trainer II,Carl Peachey,M,"$34,000",22AUG1969,01JAN1996,,4,120785,120780,120262,120259,,
120788,US,Shared Functions,Group HR Management,Recruitment & Training,Recruitment & Training,Trainer I,Smitty Lisowe,M,"$33,530",13JUN1969,01DEC1994,,4,120785,120780,120262,120259,,
120789,US,Shared Functions,Group HR Management,Recruitment & Training,Recruitment & Training,Trainer III,Julius Denhollem,M,"$39,330",14JUL1964,01DEC1982,31MAY2003,4,120785,120780,120262,120259,,
120790,US,Shared Functions,IS,Applications,Applications,ETL Specialist II,Tara O'Toole,F,"$53,740",07DEC1974,01MAY1995,,5,120791,120798,120800,120262,120259,
120791,US,Shared Functions,IS,Applications,Applications,Systems Architect IV,Richard Chiseloff,M,"$61,115",26JUL1964,01OCT1986,,4,120798,120800,120262,120259,,
120792,US,Shared Functions,IS,Applications,Applications,Systems Architect II,Omeba Horne,F,"$54,760",19MAR1976,01AUG1997,,5,120791,120798,120800,120262,120259,
120793,US,Shared Functions,IS,Applications,Applications,ETL Specialist I,William Mamo,M,"$47,155",08AUG1969,01JUN1996,,5,120791,120798,120800,120262,120259,
120794,US,Shared Functions,IS,Applications,Management Applications,Applications Developer IV,Samantha Cross,F,"$51,265",31DEC1978,01JUL2003,,3,120800,120262,120259,,,
120795,US,Shared Functions,IS,Applications,Management Applications,Applications Developer II,David Deacon,M,"$49,105",16JAN1969,01AUG1988,31JAN2003,4,120794,120800,120262,120259,,
120796,US,Shared Functions,IS,Applications,Management Applications,Applications Developer II,Philip Kellis,M,"$47,030",12MAY1954,01MAR1983,,4,120794,120800,120262,120259,,
120797,US,Shared Functions,IS,Applications,Management Applications,Applications Developer I,Sherrie Jones,F,"$43,385",17NOV1954,01DEC1977,,4,120794,120800,120262,120259,,
120798,US,Shared Functions,IS,IS Management,IS Management,Senior Project Manager,Elizabeth Ardskin,F,"$80,755",23JUN1959,01JAN1987,,3,120800,120262,120259,,,
120799,US,Shared Functions,IS,IS Management,IS Management,Office Assistant III,Jeffery Stefandonovan,M,"$29,070",23MAR1979,01NOV1998,,3,120800,120262,120259,,,
120800,US,Shared Functions,IS,IS Management,IS Management,IS Director,Fred Benyami,M,"$80,210",20DEC1974,01JUN1997,31JAN2003,2,120262,120259,,,,
120801,US,Shared Functions,IS,IS Operations,Applications,Applications Developer I,Kathryn Kennedy,F,"$40,040",06MAR1974,01JUL1999,,4,120798,120800,120262,120259,,
120802,US,Shared Functions,IS,IS Operations,Applications,Applications Developer IV,U'Vonda Parker,F,"$65,125",11MAY1949,01JAN1978,30JUN2004,4,120798,120800,120262,120259,,
120803,US,Shared Functions,IS,IS Operations,Applications,Applications Developer I,Victor Droste,M,"$43,630",06JUN1954,01JAN1978,,4,120798,120800,120262,120259,,
120804,US,Shared Functions,IS,IS Operations,IS operations,IS Administrator III,Ahmed Zied,M,"$55,400",11FEB1944,01JAN1974,,4,120798,120800,120262,120259,,
120805,US,Shared Functions,IS,IS Operations,IS operations,BI Administrator IV,Robert Walker,M,"$58,530",27JUN1978,01APR2000,,4,120798,120800,120262,120259,,
120806,US,Shared Functions,IS,IS Operations,IS operations,IS Administrator II,Lorna Ousley,F,"$47,285",25FEB1974,01FEB1992,,4,120798,120800,120262,120259,,
120807,US,Shared Functions,IS,IS Operations,IS operations,IS Administrator I,Gerlinde Peppers,F,"$43,325",14DEC1959,01JAN1982,31AUG2004,4,120798,120800,120262,120259,,
120808,US,Shared Functions,IS,Planning & Design,Planning,BI Specialist II,Marcel Dupree,M,"$44,425",01JUN1964,01JUN1984,,4,120798,120800,120262,120259,,
120809,US,Shared Functions,IS,Planning & Design,Planning,BI Architect II,Chiorene Marion,F,"$47,155",14JAN1944,01JAN1974,,4,120798,120800,120262,120259,,
120810,US,Shared Functions,IS,Planning & Design,Planning,IS Architect III,Loyal Esguerra,M,"$58,375",04OCT1954,01MAR1980,,4,120798,120800,120262,120259,,
120811,US,Shared Functions,IS,Till Systems,Till Systems,Applications Developer I,Dale Bergeron-Jeter,M,"$43,985",26SEP1969,01JUL1993,,4,120814,120800,120262,120259,,
120812,US,Shared Functions,IS,Till Systems,Till Systems,Applications Developer II,Fauver Arruza,M,"$45,810",19FEB1974,01AUG2001,,4,120814,120800,120262,120259,,
120813,US,Shared Functions,IS,Till Systems,Till Systems,Applications Developer IV,John Heinsler,M,"$50,865",14SEP1969,01JAN1993,31DEC2003,4,120814,120800,120262,120259,,
120814,US,Shared Functions,IS,Till Systems,Till Systems,Project Manager,Victor Scroggin,M,"$59,140",03JUN1959,01SEP1979,,3,120800,120262,120259,,,
120815,US,Shared Functions,Marketing,Orion Club Member Service,Orion Club Member Service,Service Administrator III,Craig Honore,M,"$31,590",27DEC1988,01APR2006,,3,120719,120260,120259,,,
120816,US,Shared Functions,Marketing,Orion Club Member Service,Orion Club Member Service,Service Administrator I,Tessia Hart,F,"$30,485",03MAY1969,01AUG1993,,3,120719,120260,120259,,,
120817,ES,Orion Spain,Administration,Administration,Administration,Office Assistant I,Carlos Sifre Vila,M,"$26,310",21DEC1954,01AUG1981,,4,120819,120880,120261,120259,,
120818,ES,Orion Spain,Administration,Administration,Administration,Office Assistant II,Horacio González Aguilera,M,"$27,780",04FEB1944,01JAN1974,,4,120819,120880,120261,120259,,
120819,ES,Orion Spain,Administration,Administration,Shipping Charges,Administration Manager,María Martínez Martínez,F,"$47,200",17MAR1986,01APR2006,,3,120880,120261,120259,,,
120820,ES,Orion Spain,Administration,Goods Entrance,Stock Admin,Warehouse Manager,Pablo Martínez,M,"$43,740",23FEB1969,01DEC1996,,4,120819,120880,120261,120259,,
120821,ES,Orion Spain,Administration,Security,Security Guards,Security Guard I,José María Montserrat,M,"$26,960",11OCT1979,01JUN2006,,5,120820,120819,120880,120261,120259,
120822,ES,Orion Spain,Administration,Security,Security Guards,Security Guard III,María Dolores García,F,"$28,825",23OCT1986,01SEP2006,,5,120820,120819,120880,120261,120259,
120823,ES,Orion Spain,Administration,Service Center,Service,Service Assistant I,Rafael Suárez de Peón Carbó,M,"$26,645",19MAY1979,01MAR1999,,5,120820,120819,120880,120261,120259,
120824,ES,Orion Spain,Administration,Service Center,Service,Service Assistant II,Jaime Esnaola Sukía,M,"$27,520",27OCT1944,01JAN1974,,5,120820,120819,120880,120261,120259,
120825,ES,Orion Spain,Engineering,Engineering,Cabinet Maker's Workshop,Cabinet Maker II,Jorge Azemar Santiago,M,"$28,800",07DEC1979,01JUN2001,,4,120819,120880,120261,120259,,
120826,ES,Orion Spain,Engineering,Engineering,Electrical Workshop,Electrician I,Víctor Pérez Cimarro,M,"$26,500",16AUG1988,01AUG2006,,4,120819,120880,120261,120259,,
120827,ES,Orion Spain,Sales,Sales,Assorted Sports Articles,Sales Rep. I,Francisco Martínez Terol,M,"$25,365",22FEB1964,01MAR1988,,4,120881,120880,120261,120259,,
120828,ES,Orion Spain,Sales,Sales,Assorted Sports Articles,Sales Rep. I,Juan Cuellas,M,"$26,340",20MAY1984,01AUG2006,,4,120881,120880,120261,120259,,
120829,ES,Orion Spain,Sales,Sales,Assorted Sports Articles,Sales Rep. III,Juan Pablo Vilalta,M,"$29,920",26JUN1944,01JAN1974,,4,120881,120880,120261,120259,,
120830,ES,Orion Spain,Sales,Sales,Assorted Sports Articles,Sales Rep. II,Ignacio Álvarez Morales,M,"$27,985",06MAY1959,01SEP1983,,4,120881,120880,120261,120259,,
120831,ES,Orion Spain,Sales,Sales,Children Sports,Sales Rep. III,Nicolás Carriles,M,"$28,365",19FEB1986,01JUN2006,,4,120881,120880,120261,120259,,
120832,ES,Orion Spain,Sales,Sales,Children Sports,Sales Rep. II,Pilar Álvarez Sanz,F,"$26,625",11JAN1974,01SEP1996,,4,120881,120880,120261,120259,,
120833,ES,Orion Spain,Sales,Sales,Children Sports,Sales Rep. III,Catalina Martínez de Irujo García,F,"$31,275",19MAR1969,01SEP1997,,4,120881,120880,120261,120259,,
120834,ES,Orion Spain,Sales,Sales,Clothes,Sales Rep. I,Lourdes Iriarte,F,"$25,225",10FEB1988,01JUL2006,,4,120881,120880,120261,120259,,
120835,ES,Orion Spain,Sales,Sales,Clothes,Sales Rep. I,María José López,F,"$27,480",10MAR1959,01MAY1979,31AUG2003,4,120881,120880,120261,120259,,
120836,ES,Orion Spain,Sales,Sales,Clothes,Sales Rep. IV,Inés Niqui Salvat,F,"$31,515",07NOV1979,01JUL2001,,4,120881,120880,120261,120259,,
120837,ES,Orion Spain,Sales,Sales,Golf,Sales Rep. I,José Rodríguez Mazquiarán,M,"$26,180",02NOV1974,01OCT1993,,4,120881,120880,120261,120259,,
120838,ES,Orion Spain,Sales,Sales,Golf,Sales Rep. II,Ana Montalvo,F,"$26,970",23NOV1959,01NOV1985,,4,120881,120880,120261,120259,,
120839,ES,Orion Spain,Sales,Sales,Golf,Sales Rep. I,Francisco Javier Sala López,M,"$25,420",12MAY1969,01JAN1992,,4,120881,120880,120261,120259,,
120840,ES,Orion Spain,Sales,Sales,Indoor Sports,Sales Rep. II,Ismael Alonso Sanz,M,"$28,160",16NOV1944,01JAN1974,,4,120881,120880,120261,120259,,
120841,ES,Orion Spain,Sales,Sales,Shoes,Sales Rep. I,María Aránzazu Serrats,F,"$22,705",24NOV1964,01APR1983,30APR2003,4,120881,120880,120261,120259,,
120842,ES,Orion Spain,Sales,Sales,Shoes,Sales Rep. I,Miguel Ángel Laguna Hurtado,M,"$26,795",04JUL1949,01AUG1978,,4,120881,120880,120261,120259,,
120843,ES,Orion Spain,Sales,Sales,Shoes,Sales Rep. I,Gregorio Díez Martín,M,"$25,660",21DEC1969,01DEC1998,,4,120881,120880,120261,120259,,
120844,ES,Orion Spain,Sales,Sales,Shoes,Sales Rep. I,Luis Bautista,M,"$25,895",20SEP1979,01SEP2005,,4,120881,120880,120261,120259,,
120845,ES,Orion Spain,Sales,Sales,Shoes,Sales Rep. I,Alicia Sánchez-Manjavacas,F,"$25,855",06FEB1969,01OCT1990,,4,120881,120880,120261,120259,,
120846,ES,Orion Spain,Sales,Sales,Shoes,Sales Rep. I,Concepción Jiménez Castillo,F,"$25,070",12AUG1964,01MAY1993,30SEP2004,4,120881,120880,120261,120259,,
120847,ES,Orion Spain,Sales,Sales,Shoes,Sales Rep. II,María Ángeles Lacambra,F,"$28,595",17DEC1959,01JAN1986,,4,120881,120880,120261,120259,,
120848,ES,Orion Spain,Sales,Sales,Outdoors,Sales Rep. III,Carlos Vivar Zamorano,M,"$28,665",03JAN1954,01JAN1974,,4,120881,120880,120261,120259,,
120849,ES,Orion Spain,Sales,Sales,Outdoors,Sales Rep. IV,Félix Marcos,M,"$31,765",15AUG1979,01JUN2004,,4,120881,120880,120261,120259,,
120850,ES,Orion Spain,Sales,Sales,Outdoors,Sales Rep. III,Izaskun Manzanero,F,"$34,060",20SEP1974,01SEP2000,,4,120881,120880,120261,120259,,
120851,ES,Orion Spain,Sales,Sales,Outdoors,Sales Rep. I,Javier Vázquez Eceizabarrena,M,"$26,610",08MAY1986,01NOV2005,01MAY2006,4,120881,120880,120261,120259,,
120852,ES,Orion Spain,Sales,Sales,Outdoors,Sales Rep. I,José Ramón de la Cruz,M,"$27,035",11SEP1979,01MAY2001,,4,120881,120880,120261,120259,,
120853,ES,Orion Spain,Sales,Sales,Outdoors,Sales Rep. I,María Teresa Freire,F,"$26,645",07JAN1944,01JAN1974,,4,120881,120880,120261,120259,,
120854,ES,Orion Spain,Sales,Sales,Outdoors,Sales Rep. II,José Luis Rubio Blanco,M,"$28,295",25JUN1959,01JUN1988,,4,120881,120880,120261,120259,,
120855,ES,Orion Spain,Sales,Sales,Outdoors,Sales Rep. IV,María Teresa Falcón de Andrés,F,"$30,895",17APR1944,01JAN1974,,4,120881,120880,120261,120259,,
120856,ES,Orion Spain,Sales,Sales,Racket Sports,Sales Rep. I,Pedro Oller,M,"$30,835",25OCT1984,01MAY2006,,4,120881,120880,120261,120259,,
120857,ES,Orion Spain,Sales,Sales,Racket Sports,Sales Rep. II,Pedro Pérez Cimarro,M,"$27,495",16AUG1988,07SEP2003,06APR2006,4,120881,120880,120261,120259,,
120858,ES,Orion Spain,Sales,Sales,Racket Sports,Sales Rep. II,Izaskun Picouto Ramos,F,"$26,325",06DEC1979,01JAN2004,,4,120881,120880,120261,120259,,
120859,ES,Orion Spain,Sales,Sales,Running - Jogging,Sales Rep. I,José Antonio Vidal Peroy,M,"$25,965",09JAN1974,01DEC1992,,4,120881,120880,120261,120259,,
120860,ES,Orion Spain,Sales,Sales,Running - Jogging,Sales Rep. I,Conxi Goldstein,F,"$25,560",14MAY1979,01AUG2000,,4,120881,120880,120261,120259,,
120861,ES,Orion Spain,Sales,Sales,Running - Jogging,Sales Rep. IV,Alberto Calvo Pumpido,M,"$30,765",15DEC1969,01JAN1992,,4,120881,120880,120261,120259,,
120862,ES,Orion Spain,Sales,Sales,Swim Sports,Sales Rep. III,Joan Fernández,M,"$29,505",26JUN1974,01OCT1998,31MAY2003,4,120881,120880,120261,120259,,
120863,ES,Orion Spain,Sales,Sales,Swim Sports,Sales Rep. II,María Aránzazu Sierra,F,"$27,990",23NOV1969,01JUL1999,,4,120881,120880,120261,120259,,
120864,ES,Orion Spain,Sales,Sales,Swim Sports,Sales Rep. III,María Ángeles Cervantes Blanco,F,"$28,460",18NOV1949,01JAN1976,,4,120881,120880,120261,120259,,
120865,ES,Orion Spain,Sales,Sales,Swim Sports,Sales Rep. IV,Amaia García Hoz,F,"$30,565",01APR1944,01JAN1974,,4,120881,120880,120261,120259,,
120866,ES,Orion Spain,Sales,Sales,Swim Sports,Sales Rep. II,Antonio Cárdenas Ramos,M,"$27,050",12NOV1944,01JAN1974,,4,120881,120880,120261,120259,,
120867,ES,Orion Spain,Sales,Sales,Swim Sports,Sales Rep. III,María Dolores Remiro,F,"$29,540",17MAY1979,01JUL1999,,4,120881,120880,120261,120259,,
120868,ES,Orion Spain,Sales,Sales,Team Sports,Sales Rep. I,Lourdes Miralles Miralles,F,"$26,430",03DEC1988,01OCT2006,,4,120881,120880,120261,120259,,
120869,ES,Orion Spain,Sales,Sales,Temporary,Temp. Sales Rep.,Victoria Sánchez Héctor,F,"$27,485",03DEC1959,01DEC2004,31MAY2005,4,120881,120880,120261,120259,,
120870,ES,Orion Spain,Sales,Sales,Temporary,Temp. Sales Rep.,Nadia Ribera Lapiedra,F,"$25,005",20JUL1984,11AUG1999,,4,120881,120880,120261,120259,,
120871,ES,Orion Spain,Sales,Sales,Temporary,Temp. Sales Rep.,Antonio Castillo Oya,M,"$21,580",10JAN1964,01DEC2000,28FEB2003,4,120881,120880,120261,120259,,
120872,ES,Orion Spain,Sales,Sales,Temporary,Temp. Sales Rep.,Mónica Puigros,F,"$25,480",04JAN1986,25JAN2001,,4,120881,120880,120261,120259,,
120873,ES,Orion Spain,Sales,Sales,Temporary,Temp. Sales Rep.,Mónica García-Santesmases,F,"$26,175",17OCT1954,01DEC2006,31DEC2006,4,120881,120880,120261,120259,,
120874,ES,Orion Spain,Sales,Sales,Temporary,Temp. Sales Rep.,Rafael Serrano,M,"$25,985",02APR1969,01DEC2002,31MAR2004,4,120881,120880,120261,120259,,
120875,ES,Orion Spain,Sales,Sales,Temporary,Temp. Sales Rep.,Mar Vives Civit,F,"$25,215",19OCT1986,01DEC2003,31MAR2005,4,120881,120880,120261,120259,,
120876,ES,Orion Spain,Sales,Sales,Trainees,Trainee,Alfonso Tormo,M,"$26,380",11AUG1984,01DEC2004,31MAY2005,4,120881,120880,120261,120259,,
120877,ES,Orion Spain,Sales,Sales,Winter Sports,Sales Rep. I,Lluis Rivera Caja,M,"$26,680",25MAY1949,01JAN1974,,4,120881,120880,120261,120259,,
120878,ES,Orion Spain,Sales,Sales,Winter Sports,Sales Rep. II,Tomás Torrelles,M,"$27,540",05MAR1964,01JUN1993,,4,120881,120880,120261,120259,,
120879,ES,Orion Spain,Sales,Sales,Winter Sports,Sales Rep. IV,Emilia González Quesada,F,"$40,755",13SEP1959,01MAY1984,,4,120881,120880,120261,120259,,
120880,ES,Orion Spain,Sales Management,Sales Management,Sales Management,Director,Eugenia Mirón Gómez,F,"$163,315",19OCT1969,01APR1991,,2,120261,120259,,,,
120881,ES,Orion Spain,Sales Management,Sales Management,Sales Management,Sales Manager,Juan Sánchez Marín,M,"$82,880",01JUN1969,01AUG1996,,3,120880,120261,120259,,,
120882,ES,Orion Spain,Sales Management,Sales Management,Sales Management,Secretary III,José Luis Ceruelo Fernández,M,"$29,585",16SEP1959,01NOV1977,,3,120880,120261,120259,,,
120883,GB,Orion UK,Administration,Administration,Administration,Office Assistant I,David Liveing,M,"$26,090",18FEB1979,01APR2004,30SEP2005,4,120887,120988,120261,120259,,
120884,GB,Orion UK,Administration,Administration,Administration,Office Assistant I,David Geoghegan,M,"$27,205",18AUG1979,01JUL2004,,4,120887,120988,120261,120259,,
120885,GB,Orion UK,Administration,Administration,Administration,Office Assistant IV,Robin Donaldson,M,"$32,240",14JUL1954,01JAN1974,,4,120887,120988,120261,120259,,
120886,GB,Orion UK,Administration,Administration,Shipping Charges,Clerk I,Rhiannedd Earshaw,M,"$26,205",01FEB1984,01MAY2006,,4,120887,120988,120261,120259,,
120887,GB,Orion UK,Administration,Administration,Shipping Charges,Administration Manager,Jurgen Jenkins,M,"$45,500",21JAN1974,01JUL2001,,3,120988,120261,120259,,,
120888,GB,Orion UK,Administration,Goods Entrance,Stock Admin,Warehouse Manager,Donnie Raabe,M,"$43,560",10AUG1969,01JUL1997,,4,120887,120988,120261,120259,,
120889,GB,Orion UK,Administration,Goods Entrance,Stock Admin,Warehouse Assistant I,Robert Bissett,M,"$25,765",08JAN1949,01JAN1974,,5,120888,120887,120988,120261,120259,
120890,GB,Orion UK,Administration,Security,Security Guards,Security Manager,Sheridan Flaye,M,"$32,520",18JUL1986,01JUN2006,,4,120887,120988,120261,120259,,
120891,GB,Orion UK,Administration,Security,Security Guards,Security Guard I,Fay Hurley,F,"$26,335",25JAN1988,01MAY2006,,5,120890,120887,120988,120261,120259,
120892,GB,Orion UK,Administration,Security,Security Guards,Security Guard II,Sue Furihata,F,"$26,780",25JUL1959,01MAR1987,,5,120890,120887,120988,120261,120259,
120893,GB,Orion UK,Administration,Service Center,Service,Service Assistant I,Azzeddine Clift,M,"$27,170",07MAR1984,01FEB2007,,5,120890,120887,120988,120261,120259,
120894,GB,Orion UK,Administration,Service Center,Service,Service Assistant I,Margaret Plaisted,F,"$26,910",07MAY1954,01MAY1977,31OCT2005,5,120890,120887,120988,120261,120259,
120895,GB,Orion UK,Administration,Service Center,Service,Service Assistant III,Beverley Olney,F,"$31,060",01APR1959,01OCT1977,,5,120890,120887,120988,120261,120259,
120896,GB,Orion UK,Administration,Service Center,Service,Service Assistant II,Joanne Branter,F,"$27,465",28JAN1944,01JAN1974,,5,120890,120887,120988,120261,120259,
120897,GB,Orion UK,Engineering,Engineering,Cabinet Maker's Workshop,Cabinet Maker IV,Magalie Corbett,F,"$42,530",18NOV1959,01DEC1981,,4,120887,120988,120261,120259,,
120898,GB,Orion UK,Engineering,Engineering,Cabinet Maker's Workshop,Cabinet Maker I,Patricia Parker,F,"$26,740",24APR1944,01JAN1974,,4,120887,120988,120261,120259,,
120899,GB,Orion UK,Engineering,Engineering,Electrical Workshop,Electrician III,Pauline Lockton,F,"$28,345",08JAN1969,01APR1997,,4,120887,120988,120261,120259,,
120900,GB,Orion UK,Engineering,Engineering,Electrical Workshop,Electrician I,Hilary Whetton,F,"$26,645",15MAY1959,01DEC1988,,4,120887,120988,120261,120259,,
120901,GB,Orion UK,Sales,Sales,Assorted Sports Articles,Sales Rep. II,Flavia Killean,F,"$26,560",11APR1954,01OCT1983,,4,120989,120988,120261,120259,,
120902,GB,Orion UK,Sales,Sales,Assorted Sports Articles,Sales Rep. I,James W Wiedmann,M,"$25,830",25DEC1986,01JUL2006,,4,120989,120988,120261,120259,,
120903,GB,Orion UK,Sales,Sales,Assorted Sports Articles,Sales Rep. III,Shelley Mcivor,F,"$30,425",02FEB1954,01APR1978,,4,120989,120988,120261,120259,,
120904,GB,Orion UK,Sales,Sales,Assorted Sports Articles,Sales Rep. I,Suella Crag,F,"$25,480",16DEC1949,01FEB1979,,4,120989,120988,120261,120259,,
120905,GB,Orion UK,Sales,Sales,Assorted Sports Articles,Sales Rep. II,Andrew Norman,M,"$26,415",08OCT1954,01FEB1979,,4,120989,120988,120261,120259,,
120906,GB,Orion UK,Sales,Sales,Assorted Sports Articles,Sales Rep. I,Mike Mutyora,M,"$25,055",06MAY1944,01JAN1974,,4,120989,120988,120261,120259,,
120907,GB,Orion UK,Sales,Sales,Children Sports,Sales Rep. II,Andrew Whales,M,"$28,000",19JUL1964,01MAR1986,,4,120989,120988,120261,120259,,
120908,GB,Orion UK,Sales,Sales,Children Sports,Sales Rep. IV,Shalini Deas,F,"$31,615",13AUG1974,01AUG2003,,4,120989,120988,120261,120259,,
120909,GB,Orion UK,Sales,Sales,Children Sports,Sales Rep. III,Reshna Doole,F,"$29,045",07SEP1986,01FEB2004,01AUG2005,4,120989,120988,120261,120259,,
120910,GB,Orion UK,Sales,Sales,Children Sports,Sales Rep. III,Nicola Mooney,F,"$28,435",18DEC1954,01DEC1974,,4,120989,120988,120261,120259,,
120911,GB,Orion UK,Sales,Sales,Children Sports,Sales Rep. II,Maeve Wardle,F,"$27,600",28MAR1979,01MAR2001,28FEB2006,4,120989,120988,120261,120259,,
120912,GB,Orion UK,Sales,Sales,Children Sports,Sales Rep. IV,Ruth Ribbons,F,"$31,105",24AUG1969,01AUG1994,,4,120989,120988,120261,120259,,
120913,GB,Orion UK,Sales,Sales,Children Sports,Sales Rep. I,Pearl Jones,F,"$26,575",08NOV1969,01MAR1990,,4,120989,120988,120261,120259,,
120914,GB,Orion UK,Sales,Sales,Clothes,Sales Rep. III,Gary Jerrard,M,"$29,920",03MAR1984,01JUL2006,01JAN2007,4,120989,120988,120261,120259,,
120915,GB,Orion UK,Sales,Sales,Clothes,Sales Rep. III,Howard Pearson,M,"$28,330",08SEP1974,01JUL1999,,4,120989,120988,120261,120259,,
120916,GB,Orion UK,Sales,Sales,Clothes,Sales Rep. I,Ross Flint,F,"$26,495",21AUG1986,01MAY2006,30SEP2006,4,120989,120988,120261,120259,,
120917,GB,Orion UK,Sales,Sales,Clothes,Sales Rep. II,Patricia Cutri,F,"$26,765",14AUG1974,01JUL1994,,4,120989,120988,120261,120259,,
120918,GB,Orion UK,Sales,Sales,Clothes,Sales Rep. II,Steve Speel,M,"$27,630",08AUG1964,01MAR1985,,4,120989,120988,120261,120259,,
120919,GB,Orion UK,Sales,Sales,Clothes,Sales Rep. I,Christopher Dennison,M,"$26,540",01JUL1984,01JUN2006,,4,120989,120988,120261,120259,,
120920,GB,Orion UK,Sales,Sales,Golf,Sales Rep. I,Mungo Laing,M,"$25,515",26OCT1984,01MAR2004,,4,120989,120988,120261,120259,,
120921,GB,Orion UK,Sales,Sales,Golf,Sales Rep. III,Jackie Burnie,F,"$28,150",01DEC1964,01MAY1989,31OCT2004,4,120989,120988,120261,120259,,
120922,GB,Orion UK,Sales,Sales,Golf,Sales Rep. II,Joanne Naito,F,"$28,130",07JAN1964,01JUN1993,,4,120989,120988,120261,120259,,
120923,GB,Orion UK,Sales,Sales,Golf,Sales Rep. II,Mark Rymer,M,"$28,145",15JAN1949,01JAN1974,,4,120989,120988,120261,120259,,
120924,GB,Orion UK,Sales,Sales,Golf,Sales Rep. III,Manoj Manville,M,"$29,370",16APR1984,01JAN2007,,4,120989,120988,120261,120259,,
120925,GB,Orion UK,Sales,Sales,Golf,Sales Rep. I,James W Narayan,M,"$27,465",19FEB1959,01DEC1981,,4,120989,120988,120261,120259,,
120926,GB,Orion UK,Sales,Sales,Golf,Sales Rep. III,Guy Gourley,M,"$29,435",22NOV1959,01AUG1981,,4,120989,120988,120261,120259,,
120927,GB,Orion UK,Sales,Sales,Indoor Sports,Sales Rep. I,Nicolette Kuner,F,"$27,830",24JUL1964,01FEB1989,30JUN2006,4,120989,120988,120261,120259,,
120928,GB,Orion UK,Sales,Sales,Indoor Sports,Sales Rep. I,Stuart Cohen,M,"$26,700",17MAR1986,01JUL2006,,4,120989,120988,120261,120259,,
120929,GB,Orion UK,Sales,Sales,Shoes,Sales Rep. III,Lynne M Merga,F,"$29,520",27FEB1949,01JAN1974,31DEC2003,4,120989,120988,120261,120259,,
120930,GB,Orion UK,Sales,Sales,Shoes,Sales Rep. II,Trak Durston,F,"$27,420",14DEC1959,01MAY1989,31JUL2003,4,120989,120988,120261,120259,,
120931,GB,Orion UK,Sales,Sales,Shoes,Sales Rep. I,Andy Forissier,M,"$26,660",17DEC1949,01APR1976,31OCT2004,4,120989,120988,120261,120259,,
120932,GB,Orion UK,Sales,Sales,Shoes,Sales Rep. II,Richard Estachy,M,"$28,165",10NOV1964,01JUL1985,,4,120989,120988,120261,120259,,
120933,GB,Orion UK,Sales,Sales,Shoes,Sales Rep. II,Allene Chance,F,"$26,875",14DEC1949,01APR1975,,4,120989,120988,120261,120259,,
120934,GB,Orion UK,Sales,Sales,Shoes,Sales Rep. I,Kalpana Sweeny,F,"$27,460",23MAY1959,01FEB1980,30SEP2006,4,120989,120988,120261,120259,,
120935,GB,Orion UK,Sales,Sales,Shoes,Sales Rep. I,Sue Walduck,F,"$26,385",10OCT1954,01JAN1979,,4,120989,120988,120261,120259,,
120936,GB,Orion UK,Sales,Sales,Shoes,Sales Rep. III,Gordon Johnson Mbe,M,"$28,580",21JUL1949,01JUN1977,,4,120989,120988,120261,120259,,
120937,GB,Orion UK,Sales,Sales,Shoes,Sales Rep. I,Aqul Redfern,M,"$25,410",12DEC1988,01JAN2007,,4,120989,120988,120261,120259,,
120938,GB,Orion UK,Sales,Sales,Outdoors,Sales Rep. I,Pearl Neill,F,"$26,265",17JAN1979,01AUG2006,01FEB2007,4,120991,120988,120261,120259,,
120939,GB,Orion UK,Sales,Sales,Outdoors,Sales Rep. II,Paul Wallace,M,"$27,595",16FEB1974,01MAR1994,,4,120991,120988,120261,120259,,
120940,GB,Orion UK,Sales,Sales,Outdoors,Sales Rep. I,Andy Hughes,M,"$26,530",18APR1984,01JUN2003,01DEC2004,4,120991,120988,120261,120259,,
120941,GB,Orion UK,Sales,Sales,Outdoors,Sales Rep. I,Nick Narayan,M,"$26,125",19FEB1959,01JAN1979,30JUN2005,4,120991,120988,120261,120259,,
120942,GB,Orion UK,Sales,Sales,Outdoors,Sales Rep. III,Andrew Quarendon,M,"$29,195",28JUL1944,01JAN1974,31MAY2006,4,120991,120988,120261,120259,,
120943,GB,Orion UK,Sales,Sales,Outdoors,Sales Rep. IV,Debora Hobjen,F,"$30,650",01MAR1969,01APR1991,,4,120991,120988,120261,120259,,
120944,GB,Orion UK,Sales,Sales,Outdoors,Sales Rep. I,Marcus Randle,F,"$26,610",11AUG1949,01JAN1974,,4,120991,120988,120261,120259,,
120945,GB,Orion UK,Sales,Sales,Outdoors,Sales Rep. I,Claudine Lloyd-Barnes,F,"$25,405",21APR1964,01JUL1993,,4,120991,120988,120261,120259,,
120946,GB,Orion UK,Sales,Sales,Outdoors,Sales Rep. I,Tim Clarke,M,"$26,680",03NOV1974,01NOV1993,30JUN2005,4,120991,120988,120261,120259,,
120947,GB,Orion UK,Sales,Sales,Racket Sports,Sales Rep. III,Jodie Angelo,F,"$30,770",22MAR1988,01NOV2006,,4,120989,120988,120261,120259,,
120948,GB,Orion UK,Sales,Sales,Racket Sports,Sales Rep. III,Winyard Caplin,M,"$29,640",24MAR1944,01MAR1974,31AUG2004,4,120989,120988,120261,120259,,
120949,GB,Orion UK,Sales,Sales,Racket Sports,Sales Rep. III,Tomohiro Howatt,M,"$30,410",03JAN1944,01JAN1974,,4,120989,120988,120261,120259,,
120950,GB,Orion UK,Sales,Sales,Racket Sports,Sales Rep. II,Franklin Steedman,M,"$26,800",05MAY1984,01JUL2005,01JAN2006,4,120989,120988,120261,120259,,
120951,GB,Orion UK,Sales,Sales,Racket Sports,Sales Rep. I,Sarah Shamker,F,"$27,010",24FEB1944,01JAN1974,,4,120989,120988,120261,120259,,
120952,GB,Orion UK,Sales,Sales,Running - Jogging,Sales Rep. III,Peter Brettell,M,"$28,200",04OCT1944,01JAN1974,,4,120989,120988,120261,120259,,
120953,GB,Orion UK,Sales,Sales,Running - Jogging,Sales Rep. I,Dana Read,M,"$25,705",19AUG1959,01NOV1980,,4,120989,120988,120261,120259,,
120954,GB,Orion UK,Sales,Sales,Running - Jogging,Sales Rep. I,Jonathan Truman,M,"$26,895",09NOV1979,01JUL2006,,4,120989,120988,120261,120259,,
120955,GB,Orion UK,Sales,Sales,Running - Jogging,Sales Rep. II,Robert de la Mer,M,"$28,430",05JUN1979,01MAY2006,,4,120989,120988,120261,120259,,
120956,GB,Orion UK,Sales,Sales,Running - Jogging,Sales Rep. I,Steve Beaham,M,"$26,780",08JUN1969,01JAN1989,30JUN2003,4,120989,120988,120261,120259,,
120957,GB,Orion UK,Sales,Sales,Running - Jogging,Sales Rep. IV,Hebi Price,M,"$31,080",03APR1986,01MAY2006,,4,120989,120988,120261,120259,,
120958,GB,Orion UK,Sales,Sales,Running - Jogging,Sales Rep. III,David Lugger,M,"$29,670",06MAY1974,01FEB1997,,4,120989,120988,120261,120259,,
120959,GB,Orion UK,Sales,Sales,Swim Sports,Sales Rep. I,David Morgan,M,"$27,175",05JUL1984,01MAY2004,,4,120989,120988,120261,120259,,
120960,GB,Orion UK,Sales,Sales,Swim Sports,Sales Rep. IV,Biddy Chalisey,F,"$30,615",22JAN1969,01OCT1989,,4,120989,120988,120261,120259,,
120961,GB,Orion UK,Sales,Sales,Swim Sports,Sales Rep. II,John Holding,M,"$27,785",27DEC1988,01DEC2006,,4,120989,120988,120261,120259,,
120962,GB,Orion UK,Sales,Sales,Swim Sports,Sales Rep. II,Alison Bailey,F,"$27,960",07DEC1988,01MAR2006,,4,120989,120988,120261,120259,,
120963,GB,Orion UK,Sales,Sales,Swim Sports,Sales Rep. II,Teresa Celebi,F,"$26,130",15SEP1969,01JAN1991,,4,120989,120988,120261,120259,,
120964,GB,Orion UK,Sales,Sales,Swim Sports,Sales Rep. IV,Shelagh Mitchumm,F,"$32,165",12FEB1984,01MAY2003,31JUL2005,4,120989,120988,120261,120259,,
120965,GB,Orion UK,Sales,Sales,Team Sports,Sales Rep. II,Kasha Byrne,F,"$26,930",01OCT1964,01AUG1992,,4,120989,120988,120261,120259,,
120966,GB,Orion UK,Sales,Sales,Team Sports,Sales Rep. I,Sally-Faye Koldynski,F,"$25,615",20JAN1964,01SEP1993,,4,120989,120988,120261,120259,,
120967,GB,Orion UK,Sales,Sales,Team Sports,Sales Rep. IV,Jane Wallis,F,"$32,745",24JUL1986,01OCT2006,,4,120989,120988,120261,120259,,
120968,GB,Orion UK,Sales,Sales,Team Sports,Sales Rep. IV,Pauline Nasreen,F,"$32,475",17NOV1959,01DEC1986,,4,120989,120988,120261,120259,,
120969,GB,Orion UK,Sales,Sales,Team Sports,Sales Rep. II,David Whitty,M,"$27,020",07JAN1974,01JUN1995,,4,120989,120988,120261,120259,,
120970,GB,Orion UK,Sales,Sales,Temporary,Temp. Sales Rep.,Edward Kershi,F,"$25,870",28APR1974,01DEC2006,31DEC2006,4,120991,120988,120261,120259,,
120971,GB,Orion UK,Sales,Sales,Temporary,Temp. Sales Rep.,Jane Chong,F,"$26,610",24SEP1969,01DEC2006,31JAN2007,4,120991,120988,120261,120259,,
120972,GB,Orion UK,Sales,Sales,Temporary,Temp. Sales Rep.,Alan Trouse,M,"$26,640",06JAN1974,01DEC2006,31MAR2007,4,120991,120988,120261,120259,,
120973,GB,Orion UK,Sales,Sales,Temporary,Temp. Sales Rep.,Raymond Bullman,M,"$26,175",22JUN1988,01DEC2006,30APR2007,4,120991,120988,120261,120259,,
120974,GB,Orion UK,Sales,Sales,Temporary,Temp. Sales Rep.,Fiona Shadbolt,F,"$27,085",28MAY1954,01DEC2006,31MAR2007,4,120991,120988,120261,120259,,
120975,GB,Orion UK,Sales,Sales,Temporary,Temp. Sales Rep.,Malcolm F Quenzel,M,"$27,180",07APR1944,01DEC2006,31MAY2007,4,120991,120988,120261,120259,,
120976,GB,Orion UK,Sales,Sales,Temporary,Temp. Sales Rep.,Genevieve Donoghue,F,"$27,110",16JUN1949,01DEC2006,28FEB2007,4,120991,120988,120261,120259,,
120977,GB,Orion UK,Sales,Sales,Temporary,Temp. Sales Rep.,Rob Wood,M,"$26,890",04MAY1954,01DEC2006,28FEB2007,4,120991,120988,120261,120259,,
120978,GB,Orion UK,Sales,Sales,Temporary,Temp. Sales Rep.,Gareth Kara,M,"$25,420",18SEP1944,01DEC2006,30APR2007,4,120991,120988,120261,120259,,
120979,GB,Orion UK,Sales,Sales,Temporary,Temp. Sales Rep.,Sanaya Bag,F,"$25,725",23MAY1964,01DEC2006,28FEB2007,4,120991,120988,120261,120259,,
120980,GB,Orion UK,Sales,Sales,Temporary,Temp. Sales Rep.,Steve Anderson,M,"$25,910",13JUL1974,01DEC2006,30APR2007,4,120991,120988,120261,120259,,
120981,GB,Orion UK,Sales,Sales,Temporary,Temp. Sales Rep.,Moria Barnes,F,"$27,310",09JAN1988,01DEC2006,30JUN2007,4,120991,120988,120261,120259,,
120982,GB,Orion UK,Sales,Sales,Trainees,Trainee,Sylvia Screeton,F,"$25,870",22DEC1974,01JAN2003,30JUN2003,4,120991,120988,120261,120259,,
120983,GB,Orion UK,Sales,Sales,Trainees,Trainee,Grif Morton,M,"$24,375",06JUL1979,01JAN2003,30JUN2003,4,120991,120988,120261,120259,,
120984,GB,Orion UK,Sales,Sales,Winter Sports,Sales Rep. IV,Debbie Taylor,F,"$30,380",04MAY1944,01JAN1974,31MAR2004,4,120991,120988,120261,120259,,
120985,GB,Orion UK,Sales,Sales,Winter Sports,Sales Rep. III,David Dann,M,"$30,410",04FEB1949,01MAR1977,31AUG2005,4,120991,120988,120261,120259,,
120986,GB,Orion UK,Sales,Sales,Winter Sports,Sales Rep. I,Alastair Watson,M,"$27,260",26JUL1969,01JAN1988,31MAY2004,4,120991,120988,120261,120259,,
120987,GB,Orion UK,Sales,Sales,Winter Sports,Sales Rep. IV,Bert Mulvihill,M,"$32,775",21MAR1988,01MAR2006,,4,120991,120988,120261,120259,,
120988,GB,Orion UK,Sales Management,Sales Management,Sales Management,Director,Phillip Sanctuary,M,"$161,295",18OCT1959,01JUL1984,,2,120261,120259,,,,
120989,GB,Orion UK,Sales Management,Sales Management,Sales Management,Senior Sales Manager,Byron Baker,M,"$92,105",27DEC1954,01JUL1976,,3,120988,120261,120259,,,
120990,GB,Orion UK,Sales Management,Sales Management,Sales Management,Secretary II,Charles Brody,M,"$28,885",15OCT1959,01MAY1988,,3,120988,120261,120259,,,
120991,GB,Orion UK,Sales Management,Sales Management,Sales Management,Sales Manager,Sajeel Withe,M,"$81,510",12JUL1974,01APR1994,,3,120988,120261,120259,,,
120992,US,Orion USA,Administration,Administration,Administration,Office Assistant I,Lisa Kicak,F,"$26,940",17FEB1979,01AUG2000,,5,120996,121000,121141,120261,120259,
120993,US,Orion USA,Administration,Administration,Administration,Office Assistant I,Lorraine Boatright,F,"$26,260",18DEC1969,01MAR1997,,5,120996,121000,121141,120261,120259,
120994,US,Orion USA,Administration,Administration,Administration,Office Administrator I,Danelle Sergeant,F,"$31,645",16JUN1974,01NOV1994,,5,120996,121000,121141,120261,120259,
120995,US,Orion USA,Administration,Administration,Administration,Office Administrator II,Lily-Ann Gordo,F,"$34,850",13JUN1984,01AUG2006,,5,120996,121000,121141,120261,120259,
120996,US,Orion USA,Administration,Administration,Administration,Office Assistant IV,Johannes Wade,M,"$32,745",21JUL1974,01SEP2002,,4,121000,121141,120261,120259,,
120997,US,Orion USA,Administration,Administration,Shipping Charges,Shipping Administrator I,Mary Donathan,F,"$27,420",21NOV1974,01SEP1996,,4,121000,121141,120261,120259,,
120998,US,Orion USA,Administration,Administration,Shipping Charges,Clerk I,Tondelayo Benedicto,F,"$26,330",06DEC1979,01APR2005,,5,120997,121000,121141,120261,120259,
120999,US,Orion USA,Administration,Administration,Shipping Charges,Clerk I,Sherelyn Heilmann,F,"$27,215",28DEC1959,01APR1984,,5,120997,121000,121141,120261,120259,
121000,US,Orion USA,Administration,Administration,Shipping Charges,Administration Manager,Herman Supple,M,"$48,600",25JAN1964,01DEC1993,,3,121141,120261,120259,,,
121001,US,Orion USA,Administration,Goods Entrance,Stock Admin,Warehouse Manager,Tony House,M,"$43,615",21JAN1959,01SEP1977,,4,121000,121141,120261,120259,,
121002,US,Orion USA,Administration,Goods Entrance,Stock Admin,Warehouse Assistant II,Terry-Ann Clark,F,"$26,650",18SEP1954,01DEC1979,31AUG2004,5,121001,121000,121141,120261,120259,
121003,US,Orion USA,Administration,Goods Entrance,Stock Admin,Warehouse Assistant I,Troyce Van Der Wiele,M,"$26,000",05MAY1988,01JUL2006,,5,121001,121000,121141,120261,120259,
121004,US,Orion USA,Administration,Security,Security Guards,Security Manager,Kellen Smith,M,"$30,895",03AUG1944,01JAN1974,,4,121000,121141,120261,120259,,
121005,US,Orion USA,Administration,Security,Security Guards,Security Guard I,Yuh-Lang Mclamb,M,"$25,020",15JUL1984,01FEB2004,,5,121004,121000,121141,120261,120259,
121006,US,Orion USA,Administration,Security,Security Guards,Security Guard I,Bernard Bolster,M,"$26,145",12OCT1986,01NOV2004,31OCT2005,5,121004,121000,121141,120261,120259,
121007,US,Orion USA,Administration,Security,Security Guards,Security Guard II,John Banaszak,M,"$27,290",12OCT1964,01FEB1987,,5,121004,121000,121141,120261,120259,
121008,US,Orion USA,Administration,Security,Security Guards,Security Guard II,Eron Mckenzie,M,"$27,875",03JUL1969,01AUG1993,,5,121004,121000,121141,120261,120259,
121009,US,Orion USA,Administration,Service Center,Service,Service Administrator I,Robert Goodwin,M,"$32,955",04DEC1979,01AUG1999,,4,121000,121141,120261,120259,,
121010,US,Orion USA,Administration,Service Center,Service,Service Assistant I,Donald Lamp,M,"$25,195",14AUG1984,01MAR2006,,5,121009,121000,121141,120261,120259,
121011,US,Orion USA,Administration,Service Center,Service,Service Assistant I,Steven Banchi,M,"$25,735",11MAR1944,01JAN1974,,5,121009,121000,121141,120261,120259,
121012,US,Orion USA,Administration,Service Center,Service,Service Assistant II,Carmelo Broome,M,"$29,575",26JAN1986,01SEP2003,30NOV2004,5,121009,121000,121141,120261,120259,
121013,US,Orion USA,Engineering,Engineering,Electrical Workshop,Electrician II,Seco Hargrave,M,"$26,675",28APR1979,01APR2000,,5,121016,121000,121141,120261,120259,
121014,US,Orion USA,Engineering,Engineering,Electrical Workshop,Electrician III,Donelle Liguori,F,"$28,510",01MAY1974,01AUG1999,,5,121016,121000,121141,120261,120259,
121015,US,Orion USA,Engineering,Engineering,Engineering,Technician I,Wilson Elmoslamy,M,"$26,140",13DEC1979,01SEP2000,,5,121016,121000,121141,120261,120259,
121016,US,Orion USA,Engineering,Engineering,Engineering,Technical Manager,Lutezenia Sullivan,F,"$48,075",19JAN1976,01SEP2004,,4,121000,121141,120261,120259,,
121017,US,Orion USA,Engineering,Engineering,Engineering,Technician II,Gilbert Arizmendi,M,"$29,225",06JAN1984,01MAR2005,,5,121016,121000,121141,120261,120259,
121018,US,Orion USA,Sales,Sales,Assorted Sports Articles,Sales Rep. II,Julienne Magolan,F,"$27,560",03JAN1944,01JAN1974,30APR2003,5,121144,121142,121141,120261,120259,
121019,US,Orion USA,Sales,Sales,Assorted Sports Articles,Sales Rep. IV,Scott Desanctis,M,"$31,320",25JUN1986,01JUN2004,31JUL2005,5,121144,121142,121141,120261,120259,
121020,US,Orion USA,Sales,Sales,Assorted Sports Articles,Sales Rep. IV,Cherda Ridley,F,"$31,750",23FEB1984,01MAY2002,,5,121144,121142,121141,120261,120259,
121021,US,Orion USA,Sales,Sales,Assorted Sports Articles,Sales Rep. IV,Priscilla Farren,F,"$32,985",10DEC1974,01MAR1994,,5,121144,121142,121141,120261,120259,
121022,US,Orion USA,Sales,Sales,Assorted Sports Articles,Sales Rep. IV,Robert Stevens,M,"$32,210",28OCT1979,01FEB2002,31AUG2004,5,121144,121142,121141,120261,120259,
121023,US,Orion USA,Sales,Sales,Assorted Sports Articles,Sales Rep. I,Shawn Fuller,M,"$26,010",13MAR1964,01MAY1989,31AUG2005,5,121144,121142,121141,120261,120259,
121024,US,Orion USA,Sales,Sales,Assorted Sports Articles,Sales Rep. II,Michael Westlund,M,"$26,600",21SEP1984,01MAY2004,,5,121144,121142,121141,120261,120259,
121025,US,Orion USA,Sales,Sales,Assorted Sports Articles,Sales Rep. II,Barnaby Cassey,M,"$28,295",10OCT1949,01SEP1975,,5,121144,121142,121141,120261,120259,
121026,US,Orion USA,Sales,Sales,Children Sports,Sales Rep. IV,Terrill Jaime,M,"$31,515",08NOV1986,01APR2006,,5,121144,121142,121141,120261,120259,
121027,US,Orion USA,Sales,Sales,Children Sports,Sales Rep. II,Allan Rudder,M,"$26,165",05MAY1964,01DEC1989,,5,121144,121142,121141,120261,120259,
121028,US,Orion USA,Sales,Sales,Children Sports,Sales Rep. I,William Smades,M,"$26,585",27APR1988,01NOV2006,,5,121144,121142,121141,120261,120259,
121029,US,Orion USA,Sales,Sales,Children Sports,Sales Rep. I,Kuo-Chung Mcelwee,M,"$27,225",22DEC1964,01DEC1989,,5,121144,121142,121141,120261,120259,
121030,US,Orion USA,Sales,Sales,Children Sports,Sales Rep. I,Jeryl Areu,M,"$26,745",12NOV1979,01FEB2001,,5,121144,121142,121141,120261,120259,
121031,US,Orion USA,Sales,Sales,Children Sports,Sales Rep. III,Scott Filan,M,"$28,060",09JUL1964,01AUG1985,,5,121144,121142,121141,120261,120259,
121032,US,Orion USA,Sales,Sales,Children Sports,Sales Rep. IV,Nasim Smith,M,"$31,335",24FEB1988,01MAR2006,,5,121144,121142,121141,120261,120259,
121033,US,Orion USA,Sales,Sales,Children Sports,Sales Rep. III,Kristie Snitzer,F,"$29,775",06NOV1986,01JUN2004,,5,121144,121142,121141,120261,120259,
121034,US,Orion USA,Sales,Sales,Children Sports,Sales Rep. II,John Kirkman,M,"$27,110",23AUG1988,01JAN2007,,5,121144,121142,121141,120261,120259,
121035,US,Orion USA,Sales,Sales,Children Sports,Sales Rep. II,James Blackley,M,"$26,460",25MAR1944,01JAN1974,,5,121144,121142,121141,120261,120259,
121036,US,Orion USA,Sales,Sales,Clothes,Sales Rep. I,Teresa Mesley,F,"$25,965",18JUL1988,01OCT2003,31OCT2005,5,121144,121142,121141,120261,120259,
121037,US,Orion USA,Sales,Sales,Clothes,Sales Rep. III,Muthukumar Miketa,M,"$28,310",12JUN1974,01MAR2002,,5,121144,121142,121141,120261,120259,
121038,US,Orion USA,Sales,Sales,Clothes,Sales Rep. I,David Anstey,M,"$25,285",13FEB1988,01AUG2006,01FEB2007,5,121144,121142,121141,120261,120259,
121039,US,Orion USA,Sales,Sales,Clothes,Sales Rep. II,Donald Washington,M,"$27,460",03JUN1954,01MAY1980,,5,121144,121142,121141,120261,120259,
121040,US,Orion USA,Sales,Sales,Clothes,Sales Rep. III,Brienne Darrohn,F,"$29,525",06JUL1959,01NOV1982,,5,121144,121142,121141,120261,120259,
121041,US,Orion USA,Sales,Sales,Clothes,Sales Rep. II,Jaime Wetherington,F,"$26,120",04FEB1944,01JAN1974,,5,121144,121142,121141,120261,120259,
121042,US,Orion USA,Sales,Sales,Clothes,Sales Rep. III,Joseph Robbin-Coker,M,"$28,845",04APR1979,01NOV1999,,5,121144,121142,121141,120261,120259,
121043,US,Orion USA,Sales,Sales,Clothes,Sales Rep. II,Sigrid Kagarise,F,"$28,225",09NOV1969,01MAR1992,,5,121144,121142,121141,120261,120259,
121044,US,Orion USA,Sales,Sales,Clothes,Sales Rep. I,Ray Abbott,M,"$25,660",11DEC1954,01AUG1975,,5,121144,121142,121141,120261,120259,
121045,US,Orion USA,Sales,Sales,Golf,Sales Rep. II,Cascile Hampton,F,"$28,560",13JUN1964,01JAN1994,29FEB2004,5,121143,121142,121141,120261,120259,
121046,US,Orion USA,Sales,Sales,Golf,Sales Rep. I,Roger Mandzak,M,"$25,845",07SEP1984,01JUL2006,01JAN2007,5,121143,121142,121141,120261,120259,
121047,US,Orion USA,Sales,Sales,Golf,Sales Rep. I,Karen Grzebien,F,"$25,820",26NOV1979,01SEP2006,01MAR2007,5,121143,121142,121141,120261,120259,
121048,US,Orion USA,Sales,Sales,Golf,Sales Rep. I,Lawrie Clark,F,"$26,560",24JUN1984,01SEP2006,01MAR2007,5,121143,121142,121141,120261,120259,
121049,US,Orion USA,Sales,Sales,Golf,Sales Rep. I,Perrior Bataineh,F,"$26,930",14FEB1986,01DEC2006,,5,121143,121142,121141,120261,120259,
121050,US,Orion USA,Sales,Sales,Golf,Sales Rep. II,Patricia Capristo-Abramczyk,F,"$26,080",12JAN1986,01DEC2006,,5,121143,121142,121141,120261,120259,
121051,US,Orion USA,Sales,Sales,Golf,Sales Rep. I,Glorina Myers,F,"$26,025",02MAY1949,01NOV1978,,5,121143,121142,121141,120261,120259,
121052,US,Orion USA,Sales,Sales,Golf,Sales Rep. II,Richard Fay,M,"$26,900",09JAN1986,01NOV2006,,5,121143,121142,121141,120261,120259,
121053,US,Orion USA,Sales,Sales,Indoor Sports,Sales Rep. III,Tywanna Mcdade,F,"$29,955",23SEP1944,01FEB1974,,5,121143,121142,121141,120261,120259,
121054,US,Orion USA,Sales,Sales,Indoor Sports,Sales Rep. III,Daniel Pulliam,M,"$29,805",12NOV1954,01NOV1976,,5,121143,121142,121141,120261,120259,
121055,US,Orion USA,Sales,Sales,Indoor Sports,Sales Rep. III,Clement Davis,M,"$30,185",08JAN1988,01AUG2006,,5,121143,121142,121141,120261,120259,
121056,US,Orion USA,Sales,Sales,Shoes,Sales Rep. II,Stacey Lyszyk,F,"$28,325",05JUL1984,01MAY2003,,5,121143,121142,121141,120261,120259,
121057,US,Orion USA,Sales,Sales,Shoes,Sales Rep. I,Tachaun Voron,M,"$25,125",26DEC1959,01DEC1980,,5,121143,121142,121141,120261,120259,
121058,US,Orion USA,Sales,Sales,Shoes,Sales Rep. I,Del Kohake,M,"$26,270",12JUL1974,01OCT2002,,5,121143,121142,121141,120261,120259,
121059,US,Orion USA,Sales,Sales,Shoes,Sales Rep. II,Jacqulin Carhide,F,"$27,425",25OCT1959,01APR1981,31DEC2003,5,121143,121142,121141,120261,120259,
121060,US,Orion USA,Sales,Sales,Shoes,Sales Rep. III,Elizabeth Spofford,F,"$28,800",08JUN1944,01JAN1974,,5,121143,121142,121141,120261,120259,
121061,US,Orion USA,Sales,Sales,Shoes,Sales Rep. III,Lauris Hassam,M,"$29,815",16JUL1954,01JUL1984,,5,121143,121142,121141,120261,120259,
121062,US,Orion USA,Sales,Sales,Outdoors,Sales Rep. IV,Debra Armant,F,"$30,305",28OCT1984,01AUG2006,,5,121145,121142,121141,120261,120259,
121063,US,Orion USA,Sales,Sales,Outdoors,Sales Rep. II,Regi Kinol,M,"$35,990",27JUL1979,01AUG2005,,5,121145,121142,121141,120261,120259,
121064,US,Orion USA,Sales,Sales,Outdoors,Sales Rep. I,Asishana Polky,M,"$25,110",28JAN1964,01SEP1991,,5,121145,121142,121141,120261,120259,
121065,US,Orion USA,Sales,Sales,Outdoors,Sales Rep. III,Corneille Malta,F,"$28,040",05SEP1984,01APR2006,,5,121145,121142,121141,120261,120259,
121066,US,Orion USA,Sales,Sales,Outdoors,Sales Rep. II,Ceresh Norman,F,"$27,250",23AUG1944,01JAN1974,31OCT2005,5,121145,121142,121141,120261,120259,
121067,US,Orion USA,Sales,Sales,Outdoors,Sales Rep. IV,Jeanilla Macnair,F,"$31,865",18JAN1986,01MAR2006,01SEP2006,5,121145,121142,121141,120261,120259,
121068,US,Orion USA,Sales,Sales,Outdoors,Sales Rep. II,Salaheloin Osuba,M,"$27,550",02DEC1969,01SEP1992,,5,121145,121142,121141,120261,120259,
121069,US,Orion USA,Sales,Sales,Outdoors,Sales Rep. II,Jason Lapsley,M,"$26,195",19MAR1969,01OCT1990,,5,121145,121142,121141,120261,120259,
121070,US,Orion USA,Sales,Sales,Outdoors,Sales Rep. III,Agnieszka Holthouse,F,"$29,385",04NOV1984,01FEB2006,,5,121145,121142,121141,120261,120259,
121071,US,Orion USA,Sales,Sales,Outdoors,Sales Rep. III,John Hoppmann,M,"$28,625",10SEP1959,01SEP1977,,5,121145,121142,121141,120261,120259,
121072,US,Orion USA,Sales,Sales,Outdoors,Sales Rep. I,Christer North,M,"$26,105",10JAN1979,01SEP2004,31OCT2005,5,121145,121142,121141,120261,120259,
121073,US,Orion USA,Sales,Sales,Outdoors,Sales Rep. I,Donald Court,M,"$27,100",15MAY1949,01JAN1974,,5,121145,121142,121141,120261,120259,
121074,US,Orion USA,Sales,Sales,Outdoors,Sales Rep. I,Eric Michonski,M,"$26,990",01MAR1959,01OCT1988,,5,121145,121142,121141,120261,120259,
121075,US,Orion USA,Sales,Sales,Outdoors,Sales Rep. II,Kasha Sugg,F,"$28,395",23DEC1944,01JAN1974,,5,121145,121142,121141,120261,120259,
121076,US,Orion USA,Sales,Sales,Racket Sports,Sales Rep. II,Micah Cobb,M,"$26,685",09OCT1964,01JAN1983,31MAY2004,5,121143,121142,121141,120261,120259,
121077,US,Orion USA,Sales,Sales,Racket Sports,Sales Rep. III,Bryce Smotherly,M,"$28,585",05SEP1984,01OCT2006,,5,121143,121142,121141,120261,120259,
121078,US,Orion USA,Sales,Sales,Racket Sports,Sales Rep. I,Lionel Wende,M,"$27,485",01MAY1949,01NOV1978,,5,121143,121142,121141,120261,120259,
121079,US,Orion USA,Sales,Sales,Racket Sports,Sales Rep. I,Azmi Mees,M,"$25,770",03JUN1974,01NOV1997,,5,121143,121142,121141,120261,120259,
121080,US,Orion USA,Sales,Sales,Racket Sports,Sales Rep. I,Kumar Chinnis,M,"$32,235",24JAN1959,01SEP1987,,5,121143,121142,121141,120261,120259,
121081,US,Orion USA,Sales,Sales,Racket Sports,Sales Rep. III,Susie Knudson,F,"$30,235",28MAR1949,01APR1976,,5,121143,121142,121141,120261,120259,
121082,US,Orion USA,Sales,Sales,Racket Sports,Sales Rep. III,Richard Debank,M,"$28,510",05JUL1949,01OCT1977,,5,121143,121142,121141,120261,120259,
121083,US,Orion USA,Sales,Sales,Racket Sports,Sales Rep. I,Tingmei Sutton,F,"$27,245",11MAR1959,01MAR1979,,5,121143,121142,121141,120261,120259,
121084,US,Orion USA,Sales,Sales,Racket Sports,Sales Rep. I,Tulsidas Ould,M,"$22,710",16AUG1964,01JAN1991,,5,121143,121142,121141,120261,120259,
121085,US,Orion USA,Sales,Sales,Running - Jogging,Sales Rep. IV,Rebecca Huslage,M,"$32,235",12NOV1986,01JAN2007,,5,121143,121142,121141,120261,120259,
121086,US,Orion USA,Sales,Sales,Running - Jogging,Sales Rep. I,John-Michael Plybon,M,"$26,820",16DEC1944,01JAN1974,,5,121143,121142,121141,120261,120259,
121087,US,Orion USA,Sales,Sales,Running - Jogging,Sales Rep. II,Virtina O'Suilleabhain,F,"$28,325",07DEC1974,01MAR1999,31MAR2006,5,121143,121142,121141,120261,120259,
121088,US,Orion USA,Sales,Sales,Running - Jogging,Sales Rep. I,Momolu Kernitzki,M,"$27,240",10JUN1988,01JAN2007,,5,121143,121142,121141,120261,120259,
121089,US,Orion USA,Sales,Sales,Running - Jogging,Sales Rep. II,Gregory Sauder,M,"$28,095",21AUG1954,01JUL1974,31OCT2006,5,121143,121142,121141,120261,120259,
121090,US,Orion USA,Sales,Sales,Running - Jogging,Sales Rep. I,Betty Klibbe,F,"$26,600",19JUN1954,01FEB1980,,5,121143,121142,121141,120261,120259,
121091,US,Orion USA,Sales,Sales,Running - Jogging,Sales Rep. II,Ernest Kadiri,M,"$27,325",19FEB1969,01JAN1989,,5,121143,121142,121141,120261,120259,
121092,US,Orion USA,Sales,Sales,Running - Jogging,Sales Rep. I,Gynell Pritt,F,"$25,680",08MAR1974,01AUG2002,,5,121143,121142,121141,120261,120259,
121093,US,Orion USA,Sales,Sales,Running - Jogging,Sales Rep. I,Carl Vasconcellos,M,"$27,410",18JUL1964,01JAN1994,30JUN2003,5,121143,121142,121141,120261,120259,
121094,US,Orion USA,Sales,Sales,Running - Jogging,Sales Rep. I,Larry Tate,M,"$26,555",07JAN1954,01SEP1978,,5,121143,121142,121141,120261,120259,
121095,US,Orion USA,Sales,Sales,Swim Sports,Sales Rep. II,Sara Kratzke,F,"$28,010",14APR1969,01JUL1991,,5,121143,121142,121141,120261,120259,
121096,US,Orion USA,Sales,Sales,Swim Sports,Sales Rep. I,Robert Newstead,M,"$26,335",18MAY1969,01MAY1995,,5,121143,121142,121141,120261,120259,
121097,US,Orion USA,Sales,Sales,Swim Sports,Sales Rep. II,Willeta Chernega,F,"$26,830",23OCT1974,01OCT1995,,5,121143,121142,121141,120261,120259,
121098,US,Orion USA,Sales,Sales,Swim Sports,Sales Rep. I,Hal Heatwole,M,"$27,475",22MAR1988,01MAY2006,,5,121143,121142,121141,120261,120259,
121099,US,Orion USA,Sales,Sales,Swim Sports,Sales Rep. IV,Royall Mrvichin,M,"$32,725",19MAR1979,01MAY2000,,5,121143,121142,121141,120261,120259,
121100,US,Orion USA,Sales,Sales,Swim Sports,Sales Rep. II,Tzue-Ing Cormell,M,"$28,135",27APR1949,01APR1976,,5,121143,121142,121141,120261,120259,
121101,US,Orion USA,Sales,Sales,Swim Sports,Sales Rep. I,Burnetta Buckner,F,"$25,390",28AUG1986,01NOV2006,,5,121143,121142,121141,120261,120259,
121102,US,Orion USA,Sales,Sales,Team Sports,Sales Rep. I,Rocheal Flammia,F,"$27,115",26JUN1979,01JUN2006,,5,121143,121142,121141,120261,120259,
121103,US,Orion USA,Sales,Sales,Team Sports,Sales Rep. I,Brian Farnsworth,M,"$27,260",28APR1988,01SEP2006,,5,121143,121142,121141,120261,120259,
121104,US,Orion USA,Sales,Sales,Team Sports,Sales Rep. II,Leoma Johnson,F,"$28,315",12NOV1964,01APR1986,31JAN2002,5,121143,121142,121141,120261,120259,
121105,US,Orion USA,Sales,Sales,Team Sports,Sales Rep. III,Jessica Savacool,F,"$29,545",09MAY1979,01JAN2003,,5,121143,121142,121141,120261,120259,
121106,US,Orion USA,Sales,Sales,Team Sports,Sales Rep. I,James Hilburger,M,"$25,880",02FEB1969,01FEB1996,,5,121143,121142,121141,120261,120259,
121107,US,Orion USA,Sales,Sales,Team Sports,Sales Rep. IV,Rose Anger,F,"$31,380",24APR1986,01JUL2006,,5,121143,121142,121141,120261,120259,
121108,US,Orion USA,Sales,Sales,Team Sports,Sales Rep. I,Libby Levi,F,"$25,930",04JUL1988,01NOV2006,01MAY2007,5,121143,121142,121141,120261,120259,
121109,US,Orion USA,Sales,Sales,Team Sports,Sales Rep. I,Harold Boulus,M,"$26,035",05NOV1969,01MAY1990,,5,121143,121142,121141,120261,120259,
121110,US,Orion USA,Sales,Sales,Temporary,Temp. Sales Rep.,Albert Knapp,M,"$26,370",14APR1944,01DEC2006,31DEC2006,5,121145,121142,121141,120261,120259,
121111,US,Orion USA,Sales,Sales,Temporary,Temp. Sales Rep.,Salim Maholo,M,"$26,885",17JUL1944,01DEC2006,30APR2007,5,121145,121142,121141,120261,120259,
121112,US,Orion USA,Sales,Sales,Temporary,Temp. Sales Rep.,Lee Stouchko,M,"$26,855",13DEC1986,01DEC2006,31DEC2006,5,121145,121142,121141,120261,120259,
121113,US,Orion USA,Sales,Sales,Temporary,Temp. Sales Rep.,Karen Costine,F,"$27,480",21FEB1954,01DEC2006,31JAN2007,5,121145,121142,121141,120261,120259,
121114,US,Orion USA,Sales,Sales,Temporary,Temp. Sales Rep.,Okema Whipkey,F,"$26,515",04NOV1944,01DEC2006,30JUN2007,5,121145,121142,121141,120261,120259,
121115,US,Orion USA,Sales,Sales,Temporary,Temp. Sales Rep.,Aquilla O'Carroll,M,"$26,430",13FEB1959,01DEC2006,30APR2007,5,121145,121142,121141,120261,120259,
121116,US,Orion USA,Sales,Sales,Temporary,Temp. Sales Rep.,Mary Bond-Teague,F,"$26,670",23SEP1964,01DEC2006,31MAR2007,5,121145,121142,121141,120261,120259,
121117,US,Orion USA,Sales,Sales,Temporary,Temp. Sales Rep.,Teresa Sergi,F,"$26,640",18MAR1974,01DEC2006,31DEC2006,5,121145,121142,121141,120261,120259,
121118,US,Orion USA,Sales,Sales,Temporary,Temp. Sales Rep.,Paul Lawson,M,"$25,725",01MAR1979,01DEC2006,31MAY2007,5,121145,121142,121141,120261,120259,
121119,US,Orion USA,Sales,Sales,Temporary,Temp. Sales Rep.,Bruce Armogida,M,"$25,205",03NOV1964,01DEC2006,28FEB2007,5,121145,121142,121141,120261,120259,
121120,US,Orion USA,Sales,Sales,Temporary,Temp. Sales Rep.,Susan Labach,F,"$25,020",25OCT1974,01DEC2006,28FEB2007,5,121145,121142,121141,120261,120259,
121121,US,Orion USA,Sales,Sales,Temporary,Temp. Sales Rep.,Halouise Cassone,F,"$25,735",05MAR1986,01DEC2006,31MAY2007,5,121145,121142,121141,120261,120259,
121122,US,Orion USA,Sales,Sales,Temporary,Temp. Sales Rep.,Stancey Scarbrough,M,"$26,265",01MAR1986,01DEC2006,31MAR2007,5,121145,121142,121141,120261,120259,
121123,US,Orion USA,Sales,Sales,Temporary,Temp. Sales Rep.,Randy Helyar,M,"$26,410",27APR1944,01DEC2006,31MAR2007,5,121145,121142,121141,120261,120259,
121124,US,Orion USA,Sales,Sales,Temporary,Temp. Sales Rep.,Deginald Gonzalez,M,"$26,925",15FEB1969,01DEC2006,31DEC2006,5,121145,121142,121141,120261,120259,
121125,US,Orion USA,Sales,Sales,Trainees,Trainee,Michael Holt,M,"$25,315",17APR1974,01JAN2003,30JUN2003,5,121145,121142,121141,120261,120259,
121126,US,Orion USA,Sales,Sales,Trainees,Trainee,James Penhale,M,"$26,015",26OCT1954,01JAN2003,30JUN2003,5,121145,121142,121141,120261,120259,
121127,US,Orion USA,Sales,Sales,Trainees,Trainee,Keyna Mangini,F,"$25,435",03SEP1986,01JUN2005,30NOV2005,5,121145,121142,121141,120261,120259,
121128,US,Orion USA,Sales,Sales,Trainees,Trainee,Glacia Nazar,F,"$25,405",26JUN1974,01JAN2003,30JUN2003,5,121145,121142,121141,120261,120259,
121129,US,Orion USA,Sales,Sales,Trainees,Trainee,Yusef Hafley,M,"$30,945",01MAY1964,01JAN2003,30JUN2003,5,121145,121142,121141,120261,120259,
121130,US,Orion USA,Sales,Sales,Trainees,Trainee,Gary Herndon,M,"$25,255",21JAN1984,01FEB2004,31JUL2004,5,121145,121142,121141,120261,120259,
121131,US,Orion USA,Sales,Sales,Trainees,Trainee,William Pantages,M,"$25,445",30JUN1969,01JAN2003,30JUN2003,5,121145,121142,121141,120261,120259,
121132,US,Orion USA,Sales,Sales,Trainees,Trainee,Shia-Ling Digiorgio,M,"$24,390",08FEB1954,01JAN2003,30JUN2003,5,121145,121142,121141,120261,120259,
121133,US,Orion USA,Sales,Sales,Trainees,Trainee,Peter Pringley,M,"$25,405",10NOV1979,01JAN2003,30JUN2003,5,121145,121142,121141,120261,120259,
121134,US,Orion USA,Sales,Sales,Trainees,Trainee,Paul Tacosa,M,"$25,585",02JUL1964,01JAN2003,30JUN2003,5,121145,121142,121141,120261,120259,
121135,US,Orion USA,Sales,Sales,Winter Sports,Sales Rep. I,Tammy Ruta,F,"$27,010",07JUN1954,01AUG1974,,5,121145,121142,121141,120261,120259,
121136,US,Orion USA,Sales,Sales,Winter Sports,Sales Rep. I,Lesia Galarneau,F,"$27,460",15JUL1974,01DEC2002,30SEP2004,5,121145,121142,121141,120261,120259,
121137,US,Orion USA,Sales,Sales,Winter Sports,Sales Rep. I,Michael. R. Boocks,M,"$27,055",18JAN1988,01APR2006,,5,121145,121142,121141,120261,120259,
121138,US,Orion USA,Sales,Sales,Winter Sports,Sales Rep. I,Hershell Tolley,M,"$27,265",28FEB1949,01JAN1974,,5,121145,121142,121141,120261,120259,
121139,US,Orion USA,Sales,Sales,Winter Sports,Sales Rep. II,Diosdado Mckee,F,"$27,700",19AUG1959,01JUL1987,,5,121145,121142,121141,120261,120259,
121140,US,Orion USA,Sales,Sales,Winter Sports,Sales Rep. I,Saunders Briggi,M,"$26,335",23JAN1979,01APR2001,31JAN2006,5,121145,121142,121141,120261,120259,
121141,US,Orion USA,Sales Management,Sales Management,Sales Management,Vice President,Henri Le Bleu,M,"$194,885",19JUN1944,01JAN1974,,2,120261,120259,,,,
121142,US,Orion USA,Sales Management,Sales Management,Sales Management,Director,Reginald Steiber,M,"$156,065",14FEB1969,01MAY1993,,3,121141,120261,120259,,,
121143,US,Orion USA,Sales Management,Sales Management,Sales Management,Senior Sales Manager,Louis Favaron,M,"$95,090",26NOV1969,01JUL1997,,4,121142,121141,120261,120259,,
121144,US,Orion USA,Sales Management,Sales Management,Sales Management,Sales Manager,Renee Capachietti,F,"$83,505",28JUN1964,01NOV1991,,4,121142,121141,120261,120259,,
121145,US,Orion USA,Sales Management,Sales Management,Sales Management,Sales Manager,Dennis Lansberry,M,"$84,260",22NOV1949,01APR1976,,4,121142,121141,120261,120259,,
121146,US,Orion USA,Sales Management,Sales Management,Sales Management,Secretary III,Julieanne Sangiorgio,F,"$29,320",09DEC1986,01APR2006,,3,121141,120261,120259,,,
121147,US,Orion USA,Sales Management,Sales Management,Sales Management,Secretary II,Christine Sneed,F,"$29,145",28MAY1969,01SEP1987,,4,121142,121141,120261,120259,,
121148,US,Orion USA,Sales Management,Sales Management,Sales Management,Business Analyst II,Shane Sadig,M,"$52,930",01JAN1969,01JAN1998,31JAN2003,3,121141,120261,120259,,,
99999999,,Logistics,Stock & Shipping,Stock & Shipping,Internet/Catalog Sales Management,,Internet/Catalog Sales,,,,,,0,,,,,,
;;;;
run;

 

data work.order_summary;
  infile datalines dlm=',' dsd;
  input Customer_ID Order_Month Sale_Amt;
  label Customer_ID='Customer ID';
  format Customer_ID 12.;
return;
datalines4;
5,5,478.00
5,6,126.80
5,9,52.50
5,12,33.80
10,3,32.60
10,4,250.80
10,5,79.80
10,6,12.20
10,7,163.29
10,8,902.50
10,11,1894.60
10,12,143.30
11,9,78.20
12,2,117.60
12,6,48.40
12,9,87.20
18,2,29.40
24,1,195.60
24,3,46.90
24,7,70.20
24,9,46.10
27,1,174.40
27,3,140.70
27,4,205.00
27,6,91.60
27,7,403.50
27,9,78.40
31,3,64.20
31,4,57.30
31,6,609.00
31,9,50.30
31,10,236.00
31,12,760.80
34,6,642.50
34,11,86.30
41,2,36.20
41,5,19.90
41,7,89.80
41,8,17.60
41,9,134.00
41,10,29.40
41,11,239.30
45,4,216.20
45,6,56.00
45,8,40.20
45,9,78.20
45,12,309.68
49,12,24.80
53,1,400.40
53,8,180.40
56,4,37.90
65,8,351.40
69,9,23.50
69,10,3.20
89,1,160.80
89,6,134.60
89,10,366.00
89,12,75.20
90,5,279.90
90,6,33.60
90,7,110.20
90,8,47.60
90,11,69.40
92,3,16.90
92,5,160.50
111,1,697.60
171,1,378.80
171,2,977.60
171,4,19.10
171,5,189.40
171,6,73.99
171,7,35.20
171,8,25.50
171,10,101.50
171,11,48.90
183,4,147.10
215,11,60.80
908,11,519.30
928,9,86.30
1033,5,355.80
2550,5,231.60
2806,1,37.40
2806,6,994.40
2806,7,54.30
2806,8,244.80
2806,11,176.00
3959,1,215.60
14104,12,194.60
17023,3,121.00
17023,6,168.00
46966,4,107.30
46966,5,174.40
70079,5,29.40
70079,10,14.60
70100,3,150.10
70100,6,1937.20
70165,6,702.00
70165,7,16.60
70187,5,706.20
70187,11,8.20
70201,8,1075.50
;;;;
run;

data work.orders;
   length StateCode $2 Region $9 Supplier $9 Order_Type $8;
   format price dollar8.2;
   infile datalines dlm=',' dsd;
  input StateCode $ Region $ Supplier $ Order_Type $ Orders Price ;
  label Order_Type='Order Type' ;
datalines4;
"AK","Portland","Domestic","Internet",19,1757.08
"AK","Portland","Domestic","Catalog",1,2000.29
"AK","Portland","Domestic","In Store",21,699.81
"AK","Portland","Foreign","Internet",10,1141.46
"AK","Portland","Foreign","Catalog",25,1620.28
"AK","Portland","Foreign","In Store",13,210.03
"AL","Raleigh","Domestic","Internet",30,558.38
"AL","Raleigh","Domestic","Catalog",13,2422.46
"AL","Raleigh","Domestic","In Store",17,1484.32
"AL","Raleigh","Foreign","Internet",46,661.76
"AL","Raleigh","Foreign","Catalog",7,2398.06
"AL","Raleigh","Foreign","In Store",38,1429.01
"AR","Beaumont","Domestic","Internet",0,0.00
"AR","Beaumont","Domestic","Catalog",39,1122.67
"AR","Beaumont","Domestic","In Store",12,729.82
"AR","Beaumont","Foreign","Internet",2,430.92
"AR","Beaumont","Foreign","Catalog",44,617.99
"AR","Beaumont","Foreign","In Store",28,172.06
"AZ","Portland","Domestic","Internet",15,1359.46
"AZ","Portland","Domestic","Catalog",50,2887.42
"AZ","Portland","Domestic","In Store",3,3902.29
"AZ","Portland","Foreign","Internet",51,3694.26
"AZ","Portland","Foreign","Catalog",7,2339.70
"AZ","Portland","Foreign","In Store",14,761.74
"CA","Portland","Domestic","Internet",94,6529.93
"CA","Portland","Domestic","Catalog",67,3977.59
"CA","Portland","Domestic","In Store",194,12563.68
"CA","Portland","Foreign","Internet",30,7489.82
"CA","Portland","Foreign","Catalog",56,3224.10
"CA","Portland","Foreign","In Store",39,3384.69
"CO","Cheyenne","Domestic","Internet",74,1729.02
"CO","Cheyenne","Domestic","Catalog",15,404.09
"CO","Cheyenne","Domestic","In Store",35,2155.30
"CO","Cheyenne","Foreign","Internet",21,667.37
"CO","Cheyenne","Foreign","Catalog",61,354.03
"CO","Cheyenne","Foreign","In Store",69,2315.13
"CT","Boston","Domestic","Internet",2,1598.40
"CT","Boston","Domestic","Catalog",28,66.39
"CT","Boston","Domestic","In Store",40,3047.80
"CT","Boston","Foreign","Internet",65,1451.22
"CT","Boston","Foreign","Catalog",31,2512.89
"CT","Boston","Foreign","In Store",40,2605.71
"DE","Boston","Domestic","Internet",28,206.88
"DE","Boston","Domestic","Catalog",19,2077.76
"DE","Boston","Domestic","In Store",56,95.23
"DE","Boston","Foreign","Internet",41,979.74
"DE","Boston","Foreign","Catalog",22,2406.41
"DE","Boston","Foreign","In Store",32,2380.72
"FL","Raleigh","Domestic","Internet",63,4042.78
"FL","Raleigh","Domestic","Catalog",28,259.16
"FL","Raleigh","Domestic","In Store",59,1598.84
"FL","Raleigh","Foreign","Internet",20,1703.39
"FL","Raleigh","Foreign","Catalog",85,2525.28
"FL","Raleigh","Foreign","In Store",86,3212.90
"GA","Raleigh","Domestic","Internet",48,3306.98
"GA","Raleigh","Domestic","Catalog",35,3796.36
"GA","Raleigh","Domestic","In Store",55,2223.09
"GA","Raleigh","Foreign","Internet",9,3373.85
"GA","Raleigh","Foreign","Catalog",18,3377.77
"GA","Raleigh","Foreign","In Store",43,1183.26
"HI","Portland","Domestic","Internet",31,1009.16
"HI","Portland","Domestic","Catalog",36,1472.88
"HI","Portland","Domestic","In Store",32,2466.85
"HI","Portland","Foreign","Internet",2,2052.45
"HI","Portland","Foreign","Catalog",47,191.05
"HI","Portland","Foreign","In Store",45,1879.00
"IA","Cheyenne","Domestic","Internet",0,0.00
"IA","Cheyenne","Domestic","Catalog",2,641.77
"IA","Cheyenne","Domestic","In Store",17,1145.16
"IA","Cheyenne","Foreign","Internet",20,1706.22
"IA","Cheyenne","Foreign","Catalog",31,489.91
"IA","Cheyenne","Foreign","In Store",26,1496.19
"ID","Portland","Domestic","Internet",24,580.00
"ID","Portland","Domestic","Catalog",31,389.52
"ID","Portland","Domestic","In Store",41,1542.07
"ID","Portland","Foreign","Internet",28,659.47
"ID","Portland","Foreign","Catalog",39,337.74
"ID","Portland","Foreign","In Store",35,1668.17
"IL","Rockford","Domestic","Internet",30,70.65
"IL","Rockford","Domestic","Catalog",13,3894.18
"IL","Rockford","Domestic","In Store",10,545.69
"IL","Rockford","Foreign","Internet",78,2700.50
"IL","Rockford","Foreign","Catalog",57,1154.07
"IL","Rockford","Foreign","In Store",97,687.78
"IN","Rockford","Domestic","Internet",26,8788.44
"IN","Rockford","Domestic","Catalog",161,7678.97
"IN","Rockford","Domestic","In Store",157,4844.73
"IN","Rockford","Foreign","Internet",174,5854.18
"IN","Rockford","Foreign","Catalog",109,6120.85
"IN","Rockford","Foreign","In Store",2,3813.02
"KS","Cheyenne","Domestic","Internet",10,1312.97
"KS","Cheyenne","Domestic","Catalog",5,505.58
"KS","Cheyenne","Domestic","In Store",24,1534.39
"KS","Cheyenne","Foreign","Internet",7,1502.13
"KS","Cheyenne","Foreign","Catalog",32,204.84
"KS","Cheyenne","Foreign","In Store",21,290.21
"KY","Rockford","Domestic","Internet",80,5065.86
"KY","Rockford","Domestic","Catalog",69,1595.04
"KY","Rockford","Domestic","In Store",7,2059.50
"KY","Rockford","Foreign","Internet",5,1469.79
"KY","Rockford","Foreign","Catalog",113,2028.38
"KY","Rockford","Foreign","In Store",4,156.37
"LA","Beaumont","Domestic","Internet",20,1081.18
"LA","Beaumont","Domestic","Catalog",94,1017.82
"LA","Beaumont","Domestic","In Store",60,4838.99
"LA","Beaumont","Foreign","Internet",79,1683.59
"LA","Beaumont","Foreign","Catalog",98,3854.76
"LA","Beaumont","Foreign","In Store",3,784.03
"MA","Boston","Domestic","Internet",49,354.61
"MA","Boston","Domestic","Catalog",20,135.85
"MA","Boston","Domestic","In Store",50,1852.56
"MA","Boston","Foreign","Internet",42,1346.03
"MA","Boston","Foreign","Catalog",13,728.78
"MA","Boston","Foreign","In Store",27,372.71
"MD","Boston","Domestic","Internet",39,2503.74
"MD","Boston","Domestic","Catalog",57,635.80
"MD","Boston","Domestic","In Store",53,2178.17
"MD","Boston","Foreign","Internet",67,2890.94
"MD","Boston","Foreign","Catalog",7,738.95
"MD","Boston","Foreign","In Store",23,704.56
"ME","Boston","Domestic","Internet",45,3421.72
"ME","Boston","Domestic","Catalog",97,414.80
"ME","Boston","Domestic","In Store",11,3102.78
"ME","Boston","Foreign","Internet",88,2770.77
"ME","Boston","Foreign","Catalog",55,3276.97
"ME","Boston","Foreign","In Store",3,3529.58
"MI","Rockford","Domestic","Internet",62,4170.93
"MI","Rockford","Domestic","Catalog",30,3589.85
"MI","Rockford","Domestic","In Store",62,1259.03
"MI","Rockford","Foreign","Internet",79,2036.84
"MI","Rockford","Foreign","Catalog",15,2025.87
"MI","Rockford","Foreign","In Store",16,5675.16
"MN","Rockford","Domestic","Internet",0,0.00
"MN","Rockford","Domestic","Catalog",47,680.28
"MN","Rockford","Domestic","In Store",1,836.22
"MN","Rockford","Foreign","Internet",37,1476.91
"MN","Rockford","Foreign","Catalog",19,245.85
"MN","Rockford","Foreign","In Store",0,0.00
"MO","Cheyenne","Domestic","Internet",16,314.23
"MO","Cheyenne","Domestic","Catalog",5,108.80
"MO","Cheyenne","Domestic","In Store",14,785.14
"MO","Cheyenne","Foreign","Internet",4,616.18
"MO","Cheyenne","Foreign","Catalog",11,258.86
"MO","Cheyenne","Foreign","In Store",17,415.55
"MS","Raleigh","Domestic","Internet",15,1084.32
"MS","Raleigh","Domestic","Catalog",30,52.65
"MS","Raleigh","Domestic","In Store",12,1079.19
"MS","Raleigh","Foreign","Internet",33,23.41
"MS","Raleigh","Foreign","Catalog",9,1327.62
"MS","Raleigh","Foreign","In Store",18,85.41
"MT","Cheyenne","Domestic","Internet",75,592.39
"MT","Cheyenne","Domestic","Catalog",86,3401.28
"MT","Cheyenne","Domestic","In Store",46,572.70
"MT","Cheyenne","Foreign","Internet",71,3271.89
"MT","Cheyenne","Foreign","Catalog",64,3036.15
"MT","Cheyenne","Foreign","In Store",7,699.31
"NC","Raleigh","Domestic","Internet",9,1265.69
"NC","Raleigh","Domestic","Catalog",16,3043.50
"NC","Raleigh","Domestic","In Store",21,1531.74
"NC","Raleigh","Foreign","Internet",51,3091.38
"NC","Raleigh","Foreign","Catalog",18,2061.52
"NC","Raleigh","Foreign","In Store",9,467.84
"NE","Cheyenne","Domestic","Internet",6,711.81
"NE","Cheyenne","Domestic","Catalog",21,895.13
"NE","Cheyenne","Domestic","In Store",3,443.41
"NE","Cheyenne","Foreign","Internet",9,457.77
"NE","Cheyenne","Foreign","Catalog",5,142.32
"NE","Cheyenne","Foreign","In Store",5,606.18
"NH","Boston","Domestic","Internet",5,602.51
"NH","Boston","Domestic","Catalog",33,1055.30
"NH","Boston","Domestic","In Store",37,2061.58
"NH","Boston","Foreign","Internet",29,2116.79
"NH","Boston","Foreign","Catalog",45,2041.00
"NH","Boston","Foreign","In Store",43,2164.13
"NJ","Boston","Domestic","Internet",107,943.76
"NJ","Boston","Domestic","Catalog",92,200.46
"NJ","Boston","Domestic","In Store",31,3215.35
"NJ","Boston","Foreign","Internet",95,236.50
"NJ","Boston","Foreign","Catalog",3,88.13
"NJ","Boston","Foreign","In Store",47,4259.70
"NV","Portland","Domestic","Internet",89,242.58
"NV","Portland","Domestic","Catalog",59,1086.61
"NV","Portland","Domestic","In Store",128,1783.33
"NV","Portland","Foreign","Internet",35,4120.24
"NV","Portland","Foreign","Catalog",87,3930.18
"NV","Portland","Foreign","In Store",148,7048.00
"NY","Boston","Domestic","Internet",16,6936.53
"NY","Boston","Domestic","Catalog",102,4812.46
"NY","Boston","Domestic","In Store",106,4338.21
"NY","Boston","Foreign","Internet",71,5397.38
"NY","Boston","Foreign","Catalog",86,3308.71
"NY","Boston","Foreign","In Store",20,4926.55
"OH","Rockford","Domestic","Internet",55,1839.11
"OH","Rockford","Domestic","Catalog",10,3508.09
"OH","Rockford","Domestic","In Store",90,34.29
"OH","Rockford","Foreign","Internet",20,1796.17
"OH","Rockford","Foreign","Catalog",88,400.26
"OH","Rockford","Foreign","In Store",1,906.74
"OK","Beaumont","Domestic","Internet",1,1115.23
"OK","Beaumont","Domestic","Catalog",25,2296.72
"OK","Beaumont","Domestic","In Store",39,2006.10
"OK","Beaumont","Foreign","Internet",33,602.13
"OK","Beaumont","Foreign","Catalog",14,749.67
"OK","Beaumont","Foreign","In Store",37,1939.62
"OR","Portland","Domestic","Internet",70,5787.68
"OR","Portland","Domestic","Catalog",67,4358.33
"OR","Portland","Domestic","In Store",60,843.62
"OR","Portland","Foreign","Internet",99,6230.78
"OR","Portland","Foreign","Catalog",8,3756.69
"OR","Portland","Foreign","In Store",46,3720.73
"PA","Boston","Domestic","Internet",7,1140.31
"PA","Boston","Domestic","Catalog",20,291.41
"PA","Boston","Domestic","In Store",19,794.12
"PA","Boston","Foreign","Internet",27,429.05
"PA","Boston","Foreign","Catalog",15,89.40
"PA","Boston","Foreign","In Store",21,1102.32
"RI","Boston","Domestic","Internet",52,3115.87
"RI","Boston","Domestic","Catalog",48,1334.37
"RI","Boston","Domestic","In Store",67,832.35
"RI","Boston","Foreign","Internet",39,353.08
"RI","Boston","Foreign","Catalog",52,2121.30
"RI","Boston","Foreign","In Store",40,3520.74
"SC","Raleigh","Domestic","Internet",66,1841.97
"SC","Raleigh","Domestic","Catalog",74,1038.02
"SC","Raleigh","Domestic","In Store",60,227.46
"SC","Raleigh","Foreign","Internet",41,4001.69
"SC","Raleigh","Foreign","Catalog",53,3280.60
"SC","Raleigh","Foreign","In Store",34,335.29
"SD","Cheyenne","Domestic","Internet",31,1300.25
"SD","Cheyenne","Domestic","Catalog",9,4.80
"SD","Cheyenne","Domestic","In Store",30,280.40
"SD","Cheyenne","Foreign","Internet",6,210.25
"SD","Cheyenne","Foreign","Catalog",0,0.00
"SD","Cheyenne","Foreign","In Store",22,1159.98
"TN","Raleigh","Domestic","Internet",34,171.34
"TN","Raleigh","Domestic","Catalog",46,2112.02
"TN","Raleigh","Domestic","In Store",1,641.09
"TN","Raleigh","Foreign","Internet",12,296.35
"TN","Raleigh","Foreign","Catalog",3,2096.53
"TN","Raleigh","Foreign","In Store",7,2017.77
"TX","Beaumont","Domestic","Internet",52,2501.34
"TX","Beaumont","Domestic","Catalog",0,0.00
"TX","Beaumont","Domestic","In Store",2,1983.48
"TX","Beaumont","Foreign","Internet",25,2636.13
"TX","Beaumont","Foreign","Catalog",66,2569.25
"TX","Beaumont","Foreign","In Store",61,1753.11
"UT","Cheyenne","Domestic","Internet",70,4372.40
"UT","Cheyenne","Domestic","Catalog",77,594.74
"UT","Cheyenne","Domestic","In Store",54,2482.73
"UT","Cheyenne","Foreign","Internet",83,2630.80
"UT","Cheyenne","Foreign","Catalog",28,756.24
"UT","Cheyenne","Foreign","In Store",2,438.58
"VA","Boston","Domestic","Internet",69,89.22
"VA","Boston","Domestic","Catalog",81,4057.94
"VA","Boston","Domestic","In Store",59,2530.09
"VA","Boston","Foreign","Internet",2,593.50
"VA","Boston","Foreign","Catalog",0,0.00
"VA","Boston","Foreign","In Store",9,1985.00
"VT","Boston","Domestic","Internet",15,1663.75
"VT","Boston","Domestic","Catalog",15,1955.67
"VT","Boston","Domestic","In Store",23,1530.93
"VT","Boston","Foreign","Internet",34,622.26
"VT","Boston","Foreign","Catalog",7,184.35
"VT","Boston","Foreign","In Store",29,1589.03
"WA","Portland","Domestic","Internet",23,1045.47
"WA","Portland","Domestic","Catalog",49,1635.15
"WA","Portland","Domestic","In Store",16,2229.12
"WA","Portland","Foreign","Internet",58,5240.81
"WA","Portland","Foreign","Catalog",18,165.14
"WA","Portland","Foreign","In Store",96,4981.04
"WI","Rockford","Domestic","Internet",25,758.30
"WI","Rockford","Domestic","Catalog",10,593.13
"WI","Rockford","Domestic","In Store",34,211.96
"WI","Rockford","Foreign","Internet",32,635.18
"WI","Rockford","Foreign","Catalog",32,176.66
"WI","Rockford","Foreign","In Store",4,768.49
"WV","Boston","Domestic","Internet",18,3172.55
"WV","Boston","Domestic","Catalog",61,510.94
"WV","Boston","Domestic","In Store",57,3690.26
"WV","Boston","Foreign","Internet",28,1842.28
"WV","Boston","Foreign","Catalog",22,3953.40
"WV","Boston","Foreign","In Store",84,1238.96
"WY","Cheyenne","Domestic","Internet",0,0.00
"WY","Cheyenne","Domestic","Catalog",25,607.46
"WY","Cheyenne","Domestic","In Store",35,411.39
"WY","Cheyenne","Foreign","Internet",33,527.27
"WY","Cheyenne","Foreign","Catalog",31,226.86
"WY","Cheyenne","Foreign","In Store",34,112.73
;;;;
run;

data work.profit;
  length Company $30;
  format Sales Cost Dollar13. Salaries Profit dollar12. YYMM yymm5.;
  infile datalines dlm=',' dsd;
  input Company $ YYMM  Sales Cost Salaries Profit;
  label YYMM="Year-Month";
datalines4;
"Board of Directors",15706,".",".",113027.50,-113027.50
"Board of Directors",15737,".",".",113027.50,-113027.50
"Board of Directors",15765,".",".",113027.50,-113027.50
"Board of Directors",15796,".",".",113027.50,-113027.50
"Board of Directors",15826,".",".",113027.50,-113027.50
"Board of Directors",15857,".",".",113027.50,-113027.50
"Board of Directors",15887,".",".",113027.50,-113027.50
"Board of Directors",15918,".",".",113027.50,-113027.50
"Board of Directors",15949,".",".",113027.50,-113027.50
"Board of Directors",15979,".",".",113027.50,-113027.50
"Board of Directors",16010,".",".",113027.50,-113027.50
"Board of Directors",16040,".",".",117356.67,-117356.67
"Board of Directors",16071,".",".",109477.08,-109477.08
"Board of Directors",16102,".",".",111859.17,-111859.17
"Board of Directors",16131,".",".",111859.17,-111859.17
"Board of Directors",16162,".",".",111859.17,-111859.17
"Board of Directors",16192,".",".",111859.17,-111859.17
"Board of Directors",16223,".",".",111859.17,-111859.17
"Board of Directors",16253,".",".",111859.17,-111859.17
"Board of Directors",16284,".",".",111859.17,-111859.17
"Board of Directors",16315,".",".",111859.17,-111859.17
"Board of Directors",16345,".",".",111859.17,-111859.17
"Board of Directors",16376,".",".",111859.17,-111859.17
"Board of Directors",16406,".",".",115409.58,-115409.58
"Board of Directors",16437,".",".",107480.83,-107480.83
"Board of Directors",16468,".",".",107480.83,-107480.83
"Board of Directors",16496,".",".",107480.83,-107480.83
"Board of Directors",16527,".",".",111859.17,-111859.17
"Board of Directors",16557,".",".",111859.17,-111859.17
"Board of Directors",16588,".",".",111859.17,-111859.17
"Board of Directors",16618,".",".",111859.17,-111859.17
"Board of Directors",16649,".",".",111859.17,-111859.17
"Board of Directors",16680,".",".",111859.17,-111859.17
"Board of Directors",16710,".",".",111859.17,-111859.17
"Board of Directors",16741,".",".",111859.17,-111859.17
"Board of Directors",16771,".",".",111859.17,-111859.17
"Board of Directors",16802,".",".",107480.83,-107480.83
"Board of Directors",16833,".",".",107480.83,-107480.83
"Board of Directors",16861,".",".",107480.83,-107480.83
"Board of Directors",16892,".",".",107480.83,-107480.83
"Board of Directors",16922,".",".",107480.83,-107480.83
"Board of Directors",16953,".",".",107480.83,-107480.83
"Board of Directors",16983,".",".",107480.83,-107480.83
"Board of Directors",17014,".",".",107480.83,-107480.83
"Board of Directors",17045,".",".",107480.83,-107480.83
"Board of Directors",17075,".",".",107480.83,-107480.83
"Board of Directors",17106,".",".",107480.83,-107480.83
"Board of Directors",17136,".",".",107480.83,-107480.83
"Board of Directors",17167,".",".",107480.83,-107480.83
"Board of Directors",17198,".",".",107480.83,-107480.83
"Board of Directors",17226,".",".",107480.83,-107480.83
"Board of Directors",17257,".",".",107480.83,-107480.83
"Board of Directors",17287,".",".",107480.83,-107480.83
"Board of Directors",17318,".",".",107480.83,-107480.83
"Board of Directors",17348,".",".",107480.83,-107480.83
"Board of Directors",17379,".",".",107480.83,-107480.83
"Board of Directors",17410,".",".",107480.83,-107480.83
"Board of Directors",17440,".",".",107480.83,-107480.83
"Board of Directors",17471,".",".",107480.83,-107480.83
"Board of Directors",17501,".",".",110606.67,-110606.67
"Concession",15706,".",".",20542.50,-20542.50
"Concession",15737,".",".",20542.50,-20542.50
"Concession",15765,".",".",20542.50,-20542.50
"Concession",15796,".",".",20542.50,-20542.50
"Concession",15826,".",".",20542.50,-20542.50
"Concession",15857,".",".",23620.00,-23620.00
"Concession",15887,".",".",23620.00,-23620.00
"Concession",15918,".",".",23620.00,-23620.00
"Concession",15949,".",".",23620.00,-23620.00
"Concession",15979,".",".",23620.00,-23620.00
"Concession",16010,".",".",23620.00,-23620.00
"Concession",16040,".",".",23620.00,-23620.00
"Concession",16071,".",".",18201.67,-18201.67
"Concession",16102,".",".",18201.67,-18201.67
"Concession",16131,".",".",18201.67,-18201.67
"Concession",16162,".",".",18201.67,-18201.67
"Concession",16192,".",".",20542.50,-20542.50
"Concession",16223,".",".",20542.50,-20542.50
"Concession",16253,".",".",20542.50,-20542.50
"Concession",16284,".",".",20542.50,-20542.50
"Concession",16315,".",".",20542.50,-20542.50
"Concession",16345,".",".",20542.50,-20542.50
"Concession",16376,".",".",20542.50,-20542.50
"Concession",16406,".",".",20542.50,-20542.50
"Concession",16437,".",".",18201.67,-18201.67
"Concession",16468,".",".",18201.67,-18201.67
"Concession",16496,".",".",18201.67,-18201.67
"Concession",16527,".",".",18201.67,-18201.67
"Concession",16557,".",".",20922.08,-20922.08
"Concession",16588,".",".",20922.08,-20922.08
"Concession",16618,".",".",20922.08,-20922.08
"Concession",16649,".",".",20922.08,-20922.08
"Concession",16680,".",".",20922.08,-20922.08
"Concession",16710,".",".",20922.08,-20922.08
"Concession",16741,".",".",20922.08,-20922.08
"Concession",16771,".",".",20922.08,-20922.08
"Concession",16802,".",".",18201.67,-18201.67
"Concession",16833,".",".",18201.67,-18201.67
"Concession",16861,".",".",18201.67,-18201.67
"Concession",16892,".",".",18201.67,-18201.67
"Concession",16922,".",".",20922.08,-20922.08
"Concession",16953,".",".",20922.08,-20922.08
"Concession",16983,".",".",20922.08,-20922.08
"Concession",17014,".",".",20922.08,-20922.08
"Concession",17045,".",".",20922.08,-20922.08
"Concession",17075,".",".",20922.08,-20922.08
"Concession",17106,".",".",20922.08,-20922.08
"Concession",17136,".",".",20922.08,-20922.08
"Concession",17167,".",".",18201.67,-18201.67
"Concession",17198,".",".",18201.67,-18201.67
"Concession",17226,".",".",20572.92,-20572.92
"Concession",17257,".",".",20572.92,-20572.92
"Concession",17287,".",".",20572.92,-20572.92
"Concession",17318,".",".",20572.92,-20572.92
"Concession",17348,".",".",20572.92,-20572.92
"Concession",17379,".",".",22880.00,-22880.00
"Concession",17410,".",".",22880.00,-22880.00
"Concession",17440,".",".",22880.00,-22880.00
"Concession",17471,".",".",22880.00,-22880.00
"Concession",17501,".",".",22880.00,-22880.00
"Logistics",15706,457809.00,210914.07,127525.42,119369.51
"Logistics",15737,325137.78,149717.63,127525.42,47894.73
"Logistics",15765,276805.34,127827.48,134197.92,14779.94
"Logistics",15796,558806.13,264867.65,134197.92,159740.56
"Logistics",15826,641953.82,303324.23,134197.92,204431.67
"Logistics",15857,827975.92,389207.03,134197.92,304570.97
"Logistics",15887,819372.84,389019.82,138047.08,292305.93
"Logistics",15918,794750.12,373204.49,140205.83,281339.79
"Logistics",15949,214991.68,100263.20,140205.83,-25477.35
"Logistics",15979,288214.34,135418.73,140205.83,12589.78
"Logistics",16010,337270.16,157196.50,140205.83,39867.83
"Logistics",16040,859980.29,398563.18,145657.50,315759.61
"Logistics",16071,479969.22,221808.18,124560.00,133601.04
"Logistics",16102,365251.89,168651.47,127586.25,69014.17
"Logistics",16131,293231.36,136114.75,130298.33,26818.28
"Logistics",16162,609833.54,295487.55,130298.33,184047.66
"Logistics",16192,702369.61,329893.22,130298.33,242178.06
"Logistics",16223,889078.69,422884.45,137422.92,328771.32
"Logistics",16253,898122.97,429002.25,137422.92,331697.80
"Logistics",16284,838288.93,397860.48,140759.17,299669.29
"Logistics",16315,237815.36,111369.46,140759.17,-14313.27
"Logistics",16345,310085.30,145301.12,140759.17,24025.01
"Logistics",16376,384605.85,178259.41,140759.17,65587.27
"Logistics",16406,905786.40,421088.29,140759.17,343938.94
"Logistics",16437,586220.33,273092.09,121892.50,191235.74
"Logistics",16468,413466.19,190609.62,121892.50,100964.07
"Logistics",16496,356373.74,165559.08,121892.50,68922.16
"Logistics",16527,715090.64,344246.67,129851.25,240992.72
"Logistics",16557,864324.66,407344.26,129851.25,327129.15
"Logistics",16588,1050702.27,498416.58,129851.25,422434.43
"Logistics",16618,1019560.16,487988.73,129851.25,401720.18
"Logistics",16649,1049059.32,497570.52,132084.58,419404.22
"Logistics",16680,278917.84,130851.92,132084.58,15981.34
"Logistics",16710,392202.08,183304.44,132084.58,76813.06
"Logistics",16741,458878.11,213181.43,132084.58,113612.10
"Logistics",16771,1063357.88,493700.60,134183.33,435473.95
"Logistics",16802,497860.09,230765.73,126623.75,140470.61
"Logistics",16833,347374.12,159915.55,128803.75,58654.82
"Logistics",16861,326105.15,150691.16,133897.50,41516.49
"Logistics",16892,644708.28,309061.15,133897.50,201749.63
"Logistics",16922,734414.85,346412.54,133897.50,254104.81
"Logistics",16953,930344.49,441905.03,133897.50,354541.96
"Logistics",16983,907232.28,432541.64,133897.50,340793.13
"Logistics",17014,898186.70,427138.09,133897.50,337151.11
"Logistics",17045,216955.18,101860.04,133897.50,-18802.36
"Logistics",17075,339084.76,157941.24,133897.50,47246.02
"Logistics",17106,391437.24,180817.77,133897.50,76721.97
"Logistics",17136,917944.65,427450.18,133897.50,356596.96
"Logistics",17167,535949.00,247341.19,124917.92,163689.89
"Logistics",17198,389429.37,181184.55,127416.25,80828.57
"Logistics",17226,313761.81,145103.42,131901.25,36757.14
"Logistics",17257,642969.89,309098.54,134181.67,199689.69
"Logistics",17287,760089.18,358051.28,137231.67,264806.23
"Logistics",17318,932190.85,443198.05,139700.42,349292.39
"Logistics",17348,964122.81,458860.29,144363.75,360898.77
"Logistics",17379,935970.04,443150.50,144363.75,348455.79
"Logistics",17410,241862.57,113211.76,144363.75,-15712.94
"Logistics",17440,339880.39,158695.66,144363.75,36820.98
"Logistics",17471,432257.04,199525.53,150958.33,81773.17
"Logistics",17501,947059.91,442395.87,150958.33,353705.71
"Marketing",15706,".",".",59427.92,-59427.92
"Marketing",15737,".",".",59427.92,-59427.92
"Marketing",15765,".",".",59427.92,-59427.92
"Marketing",15796,".",".",59427.92,-59427.92
"Marketing",15826,".",".",59427.92,-59427.92
"Marketing",15857,".",".",59427.92,-59427.92
"Marketing",15887,".",".",59427.92,-59427.92
"Marketing",15918,".",".",59427.92,-59427.92
"Marketing",15949,".",".",59427.92,-59427.92
"Marketing",15979,".",".",59427.92,-59427.92
"Marketing",16010,".",".",59427.92,-59427.92
"Marketing",16040,".",".",59427.92,-59427.92
"Marketing",16071,".",".",59427.92,-59427.92
"Marketing",16102,".",".",59427.92,-59427.92
"Marketing",16131,".",".",59427.92,-59427.92
"Marketing",16162,".",".",59427.92,-59427.92
"Marketing",16192,".",".",59427.92,-59427.92
"Marketing",16223,".",".",59427.92,-59427.92
"Marketing",16253,".",".",59427.92,-59427.92
"Marketing",16284,".",".",59427.92,-59427.92
"Marketing",16315,".",".",59427.92,-59427.92
"Marketing",16345,".",".",59427.92,-59427.92
"Marketing",16376,".",".",59427.92,-59427.92
"Marketing",16406,".",".",59427.92,-59427.92
"Marketing",16437,".",".",59427.92,-59427.92
"Marketing",16468,".",".",59427.92,-59427.92
"Marketing",16496,".",".",59427.92,-59427.92
"Marketing",16527,".",".",59427.92,-59427.92
"Marketing",16557,".",".",59427.92,-59427.92
"Marketing",16588,".",".",61925.42,-61925.42
"Marketing",16618,".",".",61925.42,-61925.42
"Marketing",16649,".",".",61925.42,-61925.42
"Marketing",16680,".",".",61925.42,-61925.42
"Marketing",16710,".",".",61925.42,-61925.42
"Marketing",16741,".",".",61925.42,-61925.42
"Marketing",16771,".",".",61925.42,-61925.42
"Marketing",16802,".",".",59427.92,-59427.92
"Marketing",16833,".",".",61805.83,-61805.83
"Marketing",16861,".",".",61805.83,-61805.83
"Marketing",16892,".",".",61805.83,-61805.83
"Marketing",16922,".",".",61805.83,-61805.83
"Marketing",16953,".",".",61805.83,-61805.83
"Marketing",16983,".",".",61805.83,-61805.83
"Marketing",17014,".",".",61805.83,-61805.83
"Marketing",17045,".",".",61805.83,-61805.83
"Marketing",17075,".",".",61805.83,-61805.83
"Marketing",17106,".",".",61805.83,-61805.83
"Marketing",17136,".",".",61805.83,-61805.83
"Marketing",17167,".",".",61805.83,-61805.83
"Marketing",17198,".",".",61805.83,-61805.83
"Marketing",17226,".",".",61805.83,-61805.83
"Marketing",17257,".",".",61805.83,-61805.83
"Marketing",17287,".",".",61805.83,-61805.83
"Marketing",17318,".",".",61805.83,-61805.83
"Marketing",17348,".",".",61805.83,-61805.83
"Marketing",17379,".",".",61805.83,-61805.83
"Marketing",17410,".",".",64087.50,-64087.50
"Marketing",17440,".",".",64087.50,-64087.50
"Marketing",17471,".",".",64087.50,-64087.50
"Marketing",17501,".",".",64087.50,-64087.50
"Orion Australia",15706,151065.85,72184.75,128765.83,-49884.73
"Orion Australia",15737,132570.18,63127.30,128765.83,-59322.95
"Orion Australia",15765,71320.23,32945.05,128765.83,-90390.65
"Orion Australia",15796,63854.55,30347.65,128765.83,-95258.93
"Orion Australia",15826,64282.77,29710.43,128765.83,-94193.50
"Orion Australia",15857,54912.23,25643.01,128765.83,-99496.61
"Orion Australia",15887,67506.30,31443.70,128765.83,-92703.23
"Orion Australia",15918,54908.78,25511.10,128765.83,-99368.15
"Orion Australia",15949,54783.47,25318.85,128765.83,-99301.21
"Orion Australia",15979,112216.57,53191.00,128765.83,-69740.27
"Orion Australia",16010,112898.98,53095.75,128765.83,-68962.60
"Orion Australia",16040,144229.23,68085.10,128765.83,-52621.70
"Orion Australia",16071,175264.11,81941.29,134637.50,-41314.68
"Orion Australia",16102,171613.46,80405.00,136854.58,-45646.12
"Orion Australia",16131,75581.67,34926.70,139360.42,-98705.45
"Orion Australia",16162,66279.92,31151.10,139360.42,-104231.60
"Orion Australia",16192,71810.65,33793.53,139360.42,-101343.30
"Orion Australia",16223,67769.75,32352.58,139360.42,-103943.25
"Orion Australia",16253,71169.94,33598.93,152947.08,-115376.07
"Orion Australia",16284,65570.71,31382.20,152947.08,-118758.57
"Orion Australia",16315,58811.29,27812.30,152947.08,-121948.09
"Orion Australia",16345,115467.90,55262.80,152947.08,-92741.98
"Orion Australia",16376,128399.21,60544.60,152947.08,-85092.47
"Orion Australia",16406,150417.58,69442.75,152947.08,-71972.25
"Orion Australia",16437,196226.83,92016.50,136581.25,-32370.92
"Orion Australia",16468,184981.97,86671.65,136581.25,-38270.93
"Orion Australia",16496,94585.20,44444.50,136581.25,-86440.55
"Orion Australia",16527,74684.71,35128.05,141785.83,-102229.17
"Orion Australia",16557,74136.32,34879.00,141785.83,-102528.51
"Orion Australia",16588,64929.36,30354.40,141785.83,-107210.87
"Orion Australia",16618,88033.59,40886.38,146682.08,-99534.87
"Orion Australia",16649,67838.43,31901.60,146682.08,-110745.25
"Orion Australia",16680,61017.33,28808.40,146682.08,-114473.15
"Orion Australia",16710,112793.67,53105.53,146682.08,-86993.94
"Orion Australia",16741,151614.35,70364.10,148690.42,-67440.17
"Orion Australia",16771,136492.45,62755.90,148690.42,-74953.87
"Orion Australia",16802,180952.60,85474.55,126752.08,-31274.03
"Orion Australia",16833,116253.89,54756.00,128917.50,-67419.61
"Orion Australia",16861,69822.28,33041.75,128917.50,-92136.97
"Orion Australia",16892,53513.27,25356.75,133135.42,-104978.90
"Orion Australia",16922,61266.79,27980.25,133135.42,-99848.88
"Orion Australia",16953,55597.01,26368.95,135317.50,-106089.44
"Orion Australia",16983,57961.13,27495.80,135317.50,-104852.17
"Orion Australia",17014,66854.47,31410.81,140576.25,-105132.59
"Orion Australia",17045,58669.95,27245.15,144784.58,-113359.78
"Orion Australia",17075,107017.52,51294.30,147022.08,-91298.86
"Orion Australia",17106,116753.40,55241.70,147022.08,-85510.38
"Orion Australia",17136,117447.02,54254.50,147022.08,-83829.56
"Orion Australia",17167,159404.39,74771.40,119596.67,-34963.68
"Orion Australia",17198,146003.78,69396.05,123907.50,-47299.77
"Orion Australia",17226,64236.40,30403.00,132940.42,-99107.02
"Orion Australia",17257,52774.18,24577.13,135439.58,-107242.53
"Orion Australia",17287,80430.52,37396.75,142319.17,-99285.40
"Orion Australia",17318,78476.89,37313.35,144653.75,-103490.21
"Orion Australia",17348,89256.68,41680.05,151360.42,-103783.79
"Orion Australia",17379,75442.73,35232.13,158452.08,-118241.48
"Orion Australia",17410,79059.67,36897.58,162870.00,-120707.91
"Orion Australia",17440,163110.44,77704.65,181462.50,-96056.71
"Orion Australia",17471,186130.87,87454.10,188317.50,-89640.73
"Orion Australia",17501,257931.09,121059.90,212578.75,-75707.56
"Orion Belgium",15706,".",".",0.00,0.00
"Orion Belgium",15737,".",".",0.00,0.00
"Orion Belgium",15765,".",".",0.00,0.00
"Orion Belgium",15796,".",".",0.00,0.00
"Orion Belgium",15826,".",".",0.00,0.00
"Orion Belgium",15857,".",".",0.00,0.00
"Orion Belgium",15887,".",".",0.00,0.00
"Orion Belgium",15918,".",".",0.00,0.00
"Orion Belgium",15949,".",".",0.00,0.00
"Orion Belgium",15979,".",".",0.00,0.00
"Orion Belgium",16010,".",".",0.00,0.00
"Orion Belgium",16040,".",".",0.00,0.00
"Orion Belgium",16071,33618.70,15687.70,118640.42,-100709.42
"Orion Belgium",16102,20887.03,9812.03,118640.42,-107565.42
"Orion Belgium",16131,25146.53,11649.21,118640.42,-105143.10
"Orion Belgium",16162,48001.02,22577.63,118640.42,-93217.03
"Orion Belgium",16192,57988.91,28188.60,118640.42,-88840.11
"Orion Belgium",16223,73726.31,34531.77,118640.42,-79445.88
"Orion Belgium",16253,59161.46,28037.83,118640.42,-87516.79
"Orion Belgium",16284,62522.42,29811.81,118640.42,-85929.81
"Orion Belgium",16315,32069.70,15208.00,118640.42,-101778.72
"Orion Belgium",16345,25449.87,11611.69,118640.42,-104802.24
"Orion Belgium",16376,25094.32,11577.46,118640.42,-105123.56
"Orion Belgium",16406,57612.11,26180.33,118640.42,-87208.64
"Orion Belgium",16437,39848.64,18451.68,107472.50,-86075.54
"Orion Belgium",16468,34016.77,15872.41,107472.50,-89328.14
"Orion Belgium",16496,37726.99,18029.58,107472.50,-87775.09
"Orion Belgium",16527,45413.68,21865.96,113995.83,-90448.11
"Orion Belgium",16557,59957.33,28696.04,113995.83,-82734.54
"Orion Belgium",16588,80590.13,37644.92,113995.83,-71050.62
"Orion Belgium",16618,72265.68,34572.14,113995.83,-76302.29
"Orion Belgium",16649,78723.01,37306.45,113995.83,-72579.27
"Orion Belgium",16680,31622.84,14796.78,113995.83,-97169.77
"Orion Belgium",16710,24995.55,11466.99,113995.83,-100467.27
"Orion Belgium",16741,33836.09,15640.73,113995.83,-95800.47
"Orion Belgium",16771,56138.97,26091.45,116258.75,-86211.23
"Orion Belgium",16802,39315.50,18112.56,100647.92,-79444.98
"Orion Belgium",16833,38219.54,17075.96,100647.92,-79504.34
"Orion Belgium",16861,37500.25,17497.53,100647.92,-80645.20
"Orion Belgium",16892,55254.54,26691.08,100647.92,-72084.46
"Orion Belgium",16922,75420.46,36282.02,100647.92,-61509.48
"Orion Belgium",16953,91481.90,43219.57,100647.92,-52385.59
"Orion Belgium",16983,77755.79,35752.70,102964.58,-60961.50
"Orion Belgium",17014,86620.10,40554.10,102964.58,-56898.58
"Orion Belgium",17045,34261.11,16038.98,107472.50,-89250.37
"Orion Belgium",17075,35207.55,16422.30,107472.50,-88687.25
"Orion Belgium",17106,43917.38,20313.38,107472.50,-83868.50
"Orion Belgium",17136,71472.17,33352.00,107472.50,-69352.33
"Orion Belgium",17167,41180.48,19069.68,96204.58,-74093.78
"Orion Belgium",17198,41659.22,19617.38,98495.00,-76453.16
"Orion Belgium",17226,35735.23,16913.13,100839.17,-82017.07
"Orion Belgium",17257,68578.39,32891.93,103058.33,-67371.87
"Orion Belgium",17287,91827.06,42737.36,105330.42,-56240.72
"Orion Belgium",17318,108368.14,51398.03,107546.25,-50576.14
"Orion Belgium",17348,110008.11,52332.27,107546.25,-49870.41
"Orion Belgium",17379,106125.81,50913.91,109772.92,-54561.02
"Orion Belgium",17410,44924.89,20733.68,109772.92,-85581.71
"Orion Belgium",17440,50820.90,23380.24,114181.25,-86740.59
"Orion Belgium",17471,57579.98,26681.71,125741.25,-94842.98
"Orion Belgium",17501,113515.73,53076.91,134498.75,-74059.93
"Orion Denmark",15706,31024.15,13607.25,85817.50,-68400.60
"Orion Denmark",15737,39614.50,17042.85,85817.50,-63245.85
"Orion Denmark",15765,22525.23,10153.90,88129.17,-75757.84
"Orion Denmark",15796,31232.10,14755.55,88129.17,-71652.62
"Orion Denmark",15826,34001.68,15982.10,88129.17,-70109.59
"Orion Denmark",15857,49556.85,23110.10,88129.17,-61682.42
"Orion Denmark",15887,37003.05,16723.35,95441.67,-75161.97
"Orion Denmark",15918,42593.13,20241.55,95441.67,-73090.09
"Orion Denmark",15949,25416.30,11371.00,95441.67,-81396.37
"Orion Denmark",15979,20743.95,9306.80,95441.67,-84004.52
"Orion Denmark",16010,23471.90,10235.75,95441.67,-82205.52
"Orion Denmark",16040,44303.03,20525.45,95441.67,-71664.09
"Orion Denmark",16071,23532.23,10754.40,93145.42,-80367.59
"Orion Denmark",16102,34529.95,15478.25,93145.42,-74093.72
"Orion Denmark",16131,25183.30,11607.70,93145.42,-79569.82
"Orion Denmark",16162,23168.21,10750.25,93145.42,-80727.46
"Orion Denmark",16192,31635.48,14730.50,93145.42,-76240.44
"Orion Denmark",16223,50734.08,23987.25,93145.42,-66398.59
"Orion Denmark",16253,46397.02,22209.85,93145.42,-68958.25
"Orion Denmark",16284,43462.89,20429.55,93145.42,-70112.08
"Orion Denmark",16315,19644.52,8286.35,93145.42,-81787.24
"Orion Denmark",16345,22733.75,9921.85,93145.42,-80333.52
"Orion Denmark",16376,24847.60,11120.05,93145.42,-79417.87
"Orion Denmark",16406,48702.09,22594.20,95441.67,-69333.78
"Orion Denmark",16437,35619.70,16052.70,88647.92,-69080.92
"Orion Denmark",16468,35438.17,15644.55,88647.92,-68854.29
"Orion Denmark",16496,27278.05,12509.10,88647.92,-73878.97
"Orion Denmark",16527,32131.14,15195.55,90959.58,-74024.00
"Orion Denmark",16557,43310.20,19885.30,93306.25,-69881.35
"Orion Denmark",16588,50731.02,23688.30,93306.25,-66263.53
"Orion Denmark",16618,40301.33,18638.75,95637.92,-73975.34
"Orion Denmark",16649,60499.97,28511.90,95637.92,-63649.85
"Orion Denmark",16680,29663.35,13876.70,95637.92,-79851.27
"Orion Denmark",16710,24691.50,11347.05,95637.92,-82293.47
"Orion Denmark",16741,27950.13,12722.60,97786.25,-82558.73
"Orion Denmark",16771,53368.61,24702.55,99972.08,-71306.03
"Orion Denmark",16802,30444.50,13629.05,88453.33,-71637.88
"Orion Denmark",16833,26549.68,12020.65,88453.33,-73924.30
"Orion Denmark",16861,23398.00,10790.50,88453.33,-75845.83
"Orion Denmark",16892,28187.10,13102.55,88453.33,-73368.78
"Orion Denmark",16922,33635.63,15585.35,88453.33,-70403.05
"Orion Denmark",16953,60553.34,28610.45,90617.08,-58674.19
"Orion Denmark",16983,39227.42,18297.60,90617.08,-69687.26
"Orion Denmark",17014,38360.61,18199.75,90617.08,-70456.22
"Orion Denmark",17045,22316.18,10440.50,90617.08,-78741.41
"Orion Denmark",17075,23744.88,10987.70,92937.08,-80179.91
"Orion Denmark",17106,25567.80,11775.90,95474.58,-81682.68
"Orion Denmark",17136,47609.59,20984.75,95474.58,-68849.74
"Orion Denmark",17167,32013.65,14458.90,81746.25,-64191.50
"Orion Denmark",17198,23455.82,10567.70,81746.25,-68858.13
"Orion Denmark",17226,22590.18,10507.65,86086.25,-74003.72
"Orion Denmark",17257,32889.80,15197.85,90882.92,-73190.97
"Orion Denmark",17287,35108.61,16130.95,97569.58,-78591.92
"Orion Denmark",17318,41036.08,18811.90,97569.58,-75345.41
"Orion Denmark",17348,40557.15,18584.06,97569.58,-75596.49
"Orion Denmark",17379,48433.24,22863.40,102353.75,-76783.91
"Orion Denmark",17410,24230.28,11039.30,102353.75,-89162.78
"Orion Denmark",17440,29292.00,13572.15,107266.67,-91546.82
"Orion Denmark",17471,33654.58,15550.35,109648.33,-91544.11
"Orion Denmark",17501,69325.70,31554.15,118280.83,-80509.29
"Orion France",15706,147116.32,67664.10,136197.92,-56745.70
"Orion France",15737,116047.65,53386.38,136197.92,-73536.64
"Orion France",15765,100198.75,46516.90,136197.92,-82516.07
"Orion France",15796,148211.75,69931.55,138830.42,-60550.22
"Orion France",15826,178441.26,84304.90,138830.42,-44694.06
"Orion France",15857,229838.61,106852.75,138830.42,-15844.56
"Orion France",15887,207472.27,99221.35,138830.42,-30579.49
"Orion France",15918,222625.98,105002.65,138830.42,-21207.09
"Orion France",15949,104690.08,48514.45,141284.17,-85108.54
"Orion France",15979,101315.42,46861.64,141284.17,-86830.39
"Orion France",16010,112119.37,51558.08,141284.17,-80722.88
"Orion France",16040,249031.54,114351.77,141284.17,-6604.40
"Orion France",16071,210443.59,97017.25,126593.33,-13166.99
"Orion France",16102,159661.67,72935.43,129266.25,-42540.01
"Orion France",16131,136851.06,63354.28,133716.67,-60219.88
"Orion France",16162,189759.18,90352.60,133716.67,-34310.09
"Orion France",16192,205979.34,97111.31,133716.67,-24848.64
"Orion France",16223,277131.71,130868.16,149795.00,-3531.45
"Orion France",16253,280379.73,133164.65,149795.00,-2579.92
"Orion France",16284,264143.13,124482.29,152031.25,-12370.41
"Orion France",16315,124677.06,58077.71,154559.58,-87960.24
"Orion France",16345,124512.01,57283.76,154559.58,-87331.34
"Orion France",16376,145203.52,67336.95,157282.92,-79416.35
"Orion France",16406,327245.40,152696.70,157282.92,17265.78
"Orion France",16437,198625.57,92036.28,133916.67,-27327.38
"Orion France",16468,150051.19,68917.35,133916.67,-52782.83
"Orion France",16496,132910.74,61488.83,133916.67,-62494.76
"Orion France",16527,181715.50,87141.91,133916.67,-39343.08
"Orion France",16557,205533.04,96466.79,133916.67,-24850.41
"Orion France",16588,282918.92,134571.05,133916.67,14431.20
"Orion France",16618,264753.33,126550.20,133916.67,4286.47
"Orion France",16649,271874.99,128797.12,136253.33,6824.54
"Orion France",16680,143463.21,66965.13,138498.75,-62000.67
"Orion France",16710,137712.63,63757.60,138498.75,-64543.72
"Orion France",16741,143773.53,66347.63,141038.75,-63612.85
"Orion France",16771,334606.44,155861.12,143232.50,35512.82
"Orion France",16802,173829.13,79704.25,131723.75,-37598.87
"Orion France",16833,129409.52,58639.65,133985.83,-63215.96
"Orion France",16861,140510.58,65182.13,136357.50,-61029.05
"Orion France",16892,188792.88,90440.28,138456.67,-40104.06
"Orion France",16922,205191.69,96783.46,138456.67,-30048.44
"Orion France",16953,247199.21,116470.15,138456.67,-7727.61
"Orion France",16983,241627.77,114718.37,140868.33,-13958.94
"Orion France",17014,241914.18,114375.85,143502.08,-15963.76
"Orion France",17045,120378.65,55854.43,145838.75,-81314.54
"Orion France",17075,110633.64,51252.40,145838.75,-86457.51
"Orion France",17106,140687.05,65883.93,145838.75,-71035.63
"Orion France",17136,276683.93,128545.15,145838.75,2300.03
"Orion France",17167,191514.89,88154.43,141085.42,-37724.96
"Orion France",17198,171769.70,78390.10,143302.92,-49923.32
"Orion France",17226,155045.68,72043.70,145487.92,-62485.94
"Orion France",17257,198044.51,93432.72,145487.92,-40876.12
"Orion France",17287,217004.07,101154.30,145487.92,-29638.15
"Orion France",17318,289529.50,137441.74,148201.25,3886.51
"Orion France",17348,257413.73,122375.73,148201.25,-13163.25
"Orion France",17379,284101.62,133334.22,148201.25,2566.15
"Orion France",17410,136141.30,63653.00,148201.25,-75712.95
"Orion France",17440,138345.00,64435.35,150569.17,-76659.51
"Orion France",17471,153756.41,71097.04,152764.17,-70104.80
"Orion France",17501,396451.17,184282.27,181794.58,30374.31
"Orion Germany",15706,181352.79,82875.71,149784.17,-51307.09
"Orion Germany",15737,173002.98,77936.63,149784.17,-54717.82
"Orion Germany",15765,150203.71,68974.76,149784.17,-68555.22
"Orion Germany",15796,176304.90,82686.09,149784.17,-56165.36
"Orion Germany",15826,202727.97,93711.25,149784.17,-40767.45
"Orion Germany",15857,261868.23,122019.23,149784.17,-9935.16
"Orion Germany",15887,260460.83,122134.05,149784.17,-11457.38
"Orion Germany",15918,261390.64,122692.30,149784.17,-11085.83
"Orion Germany",15949,138969.04,63967.24,149784.17,-74782.36
"Orion Germany",15979,134999.88,61297.97,152007.08,-78305.18
"Orion Germany",16010,139731.70,63856.57,152007.08,-76131.95
"Orion Germany",16040,318617.38,146442.10,154355.42,17819.86
"Orion Germany",16071,214307.05,97914.26,158486.67,-42093.88
"Orion Germany",16102,187257.00,84785.34,158486.67,-56015.01
"Orion Germany",16131,170482.99,78598.53,158486.67,-66602.21
"Orion Germany",16162,239885.56,112994.65,158486.67,-31595.76
"Orion Germany",16192,245627.46,114157.59,160573.75,-29103.88
"Orion Germany",16223,329740.09,154731.10,160573.75,14435.24
"Orion Germany",16253,297302.40,141656.87,160573.75,-4928.22
"Orion Germany",16284,310843.69,145810.02,160573.75,4459.92
"Orion Germany",16315,148669.91,68917.27,160573.75,-80821.11
"Orion Germany",16345,129721.82,59935.46,160573.75,-90787.39
"Orion Germany",16376,166687.03,76799.87,160573.75,-70686.59
"Orion Germany",16406,366657.41,169383.90,160573.75,36699.76
"Orion Germany",16437,272165.10,124819.62,151799.17,-4453.69
"Orion Germany",16468,237239.41,107594.35,151799.17,-22154.11
"Orion Germany",16496,184677.30,84982.77,154174.17,-54479.64
"Orion Germany",16527,246145.54,116982.86,154174.17,-25011.48
"Orion Germany",16557,275972.01,129259.69,156279.58,-9567.26
"Orion Germany",16588,373849.17,177159.01,156279.58,40410.58
"Orion Germany",16618,327719.75,155680.42,156279.58,15759.75
"Orion Germany",16649,337825.80,159109.79,158627.92,20088.10
"Orion Germany",16680,193166.09,88885.81,158627.92,-54347.64
"Orion Germany",16710,167388.03,76563.89,158627.92,-67803.78
"Orion Germany",16741,187695.46,85777.31,160815.42,-58897.27
"Orion Germany",16771,405376.64,188297.46,163094.58,53984.59
"Orion Germany",16802,217431.16,99755.88,147037.92,-29362.64
"Orion Germany",16833,187943.78,85724.41,147037.92,-44818.55
"Orion Germany",16861,164504.07,75324.79,147037.92,-57858.64
"Orion Germany",16892,215656.46,100971.80,150057.92,-35373.26
"Orion Germany",16922,250076.06,116348.36,150057.92,-16330.22
"Orion Germany",16953,288842.96,134495.63,152370.00,1977.33
"Orion Germany",16983,303343.68,142979.23,154565.42,5799.04
"Orion Germany",17014,309841.42,144107.39,156890.42,8843.61
"Orion Germany",17045,146027.27,68087.48,159044.58,-81104.79
"Orion Germany",17075,144693.50,66481.41,161092.92,-82880.83
"Orion Germany",17106,154750.45,70804.28,161092.92,-77146.75
"Orion Germany",17136,348204.36,158613.24,161092.92,28498.21
"Orion Germany",17167,195602.31,89287.24,150097.50,-43782.43
"Orion Germany",17198,168970.58,77257.42,152219.58,-60506.42
"Orion Germany",17226,163737.23,75724.49,156445.00,-68432.26
"Orion Germany",17257,213325.25,100190.72,161743.75,-48609.22
"Orion Germany",17287,252481.14,117876.53,171462.08,-36857.47
"Orion Germany",17318,344770.08,162194.51,179467.08,3108.48
"Orion Germany",17348,339715.67,161462.88,183920.83,-5668.04
"Orion Germany",17379,342659.06,160400.68,188424.58,-6166.20
"Orion Germany",17410,174913.31,80798.09,197421.67,-103306.45
"Orion Germany",17440,185080.65,85070.04,201967.50,-101956.89
"Orion Germany",17471,192126.47,88241.50,206340.83,-102455.86
"Orion Germany",17501,463448.19,214583.17,226380.42,22484.60
"Orion Holland",15706,63648.59,30021.08,99458.33,-65830.82
"Orion Holland",15737,46410.19,21213.70,99458.33,-74261.84
"Orion Holland",15765,55802.48,25623.60,99458.33,-69279.45
"Orion Holland",15796,80624.37,38814.85,99458.33,-57648.81
"Orion Holland",15826,94918.17,45237.00,99458.33,-49777.16
"Orion Holland",15857,116640.35,55557.50,99458.33,-38375.48
"Orion Holland",15887,105481.06,50299.85,99458.33,-44277.13
"Orion Holland",15918,116897.37,55658.10,99458.33,-38219.06
"Orion Holland",15949,66075.90,30789.25,102141.25,-66854.60
"Orion Holland",15979,54426.52,25451.41,102141.25,-73166.14
"Orion Holland",16010,53447.97,24962.15,104315.42,-75829.59
"Orion Holland",16040,133461.10,59556.00,104315.42,-30410.32
"Orion Holland",16071,80411.64,37378.98,94905.83,-51873.17
"Orion Holland",16102,70823.06,32643.00,99492.08,-61312.02
"Orion Holland",16131,64218.27,30295.25,99492.08,-65569.06
"Orion Holland",16162,110667.55,53181.15,99492.08,-42005.69
"Orion Holland",16192,102007.66,48851.55,102015.42,-48859.31
"Orion Holland",16223,163416.38,78804.30,102015.42,-17403.34
"Orion Holland",16253,137038.74,67069.46,102015.42,-32046.14
"Orion Holland",16284,146390.05,69982.55,104330.83,-27923.33
"Orion Holland",16315,65634.03,31006.43,106512.50,-71884.90
"Orion Holland",16345,58319.72,27193.08,106512.50,-75385.86
"Orion Holland",16376,69925.19,32203.48,109024.17,-71302.46
"Orion Holland",16406,118018.35,54962.70,113719.17,-50663.52
"Orion Holland",16437,89840.98,41787.45,92081.25,-44027.72
"Orion Holland",16468,72692.25,33023.10,92081.25,-52412.10
"Orion Holland",16496,74193.87,34573.93,92081.25,-52461.31
"Orion Holland",16527,125909.77,61326.60,97729.58,-33146.41
"Orion Holland",16557,117916.13,57327.81,97729.58,-37141.27
"Orion Holland",16588,144168.96,68266.91,99940.00,-24037.95
"Orion Holland",16618,183007.06,88189.30,102352.92,-7535.16
"Orion Holland",16649,180453.48,86011.30,107435.00,-12992.82
"Orion Holland",16680,79697.98,37908.45,107435.00,-65645.47
"Orion Holland",16710,69243.25,32601.30,107435.00,-70793.06
"Orion Holland",16741,82632.93,39037.78,111070.00,-67474.85
"Orion Holland",16771,159187.62,73972.95,111070.00,-25855.33
"Orion Holland",16802,84819.90,39698.45,105421.67,-60300.22
"Orion Holland",16833,82489.98,38214.35,105421.67,-61146.04
"Orion Holland",16861,69114.16,32449.75,107539.17,-70874.75
"Orion Holland",16892,116775.10,58001.25,107539.17,-48765.32
"Orion Holland",16922,131728.68,62923.95,107539.17,-38734.44
"Orion Holland",16953,172714.93,84658.95,107539.17,-19483.19
"Orion Holland",16983,156576.57,76224.75,107539.17,-27187.35
"Orion Holland",17014,156671.89,75620.80,107539.17,-26488.08
"Orion Holland",17045,79249.09,36858.40,107539.17,-65148.48
"Orion Holland",17075,70005.87,32779.60,107539.17,-70312.89
"Orion Holland",17106,77544.34,36617.85,107539.17,-66612.68
"Orion Holland",17136,138886.82,65052.70,107539.17,-33705.05
"Orion Holland",17167,90880.18,41888.95,105328.75,-56337.52
"Orion Holland",17198,74482.74,34340.05,105328.75,-65186.06
"Orion Holland",17226,87773.55,41182.40,112692.50,-66101.35
"Orion Holland",17257,138600.31,68612.80,112692.50,-42705.00
"Orion Holland",17287,150122.46,70729.65,112692.50,-33299.69
"Orion Holland",17318,211951.43,100329.05,115192.08,-3569.70
"Orion Holland",17348,200833.44,96658.90,115192.08,-11017.54
"Orion Holland",17379,177727.98,84799.39,121782.50,-28853.91
"Orion Holland",17410,89018.93,41676.30,121782.50,-74439.87
"Orion Holland",17440,87820.50,41723.50,126264.17,-80167.16
"Orion Holland",17471,108322.70,50174.35,126264.17,-68115.82
"Orion Holland",17501,257448.01,120292.12,144122.08,-6966.20
"Orion Italy",15706,108296.92,49585.80,109710.42,-50999.29
"Orion Italy",15737,106416.02,48782.90,109710.42,-52077.29
"Orion Italy",15765,88129.82,40635.85,109710.42,-62216.44
"Orion Italy",15796,121943.85,56706.15,109710.42,-44472.72
"Orion Italy",15826,144134.05,67838.30,109710.42,-33414.67
"Orion Italy",15857,185164.50,86586.05,113353.75,-14775.30
"Orion Italy",15887,168128.00,78414.75,113353.75,-23640.50
"Orion Italy",15918,175474.88,81869.70,113353.75,-19748.57
"Orion Italy",15949,80853.13,37482.55,113353.75,-69983.17
"Orion Italy",15979,86169.02,39538.90,113353.75,-66723.63
"Orion Italy",16010,89128.02,41421.00,113353.75,-65646.73
"Orion Italy",16040,216193.80,99147.35,113353.75,3692.70
"Orion Italy",16071,150733.49,69826.20,112692.08,-31784.79
"Orion Italy",16102,121436.22,55529.25,112692.08,-46785.11
"Orion Italy",16131,119357.40,55174.15,114902.92,-50719.67
"Orion Italy",16162,159028.73,74546.70,114902.92,-30420.89
"Orion Italy",16192,186362.16,88025.35,117284.58,-18947.77
"Orion Italy",16223,235931.20,112124.95,117284.58,6521.67
"Orion Italy",16253,188436.02,88966.85,117284.58,-17815.41
"Orion Italy",16284,199449.16,93886.45,119526.25,-13963.54
"Orion Italy",16315,89386.22,41208.10,119526.25,-71348.13
"Orion Italy",16345,96377.28,44607.20,119526.25,-67756.17
"Orion Italy",16376,96291.28,44867.50,119526.25,-68102.47
"Orion Italy",16406,203269.40,94859.80,119526.25,-11116.66
"Orion Italy",16437,180165.44,83065.90,108448.33,-11348.79
"Orion Italy",16468,157274.08,71434.75,108448.33,-22609.01
"Orion Italy",16496,147091.35,68224.05,108448.33,-29581.03
"Orion Italy",16527,179134.78,84091.35,108448.33,-13404.90
"Orion Italy",16557,204629.50,96446.55,108448.33,-265.38
"Orion Italy",16588,269544.09,125991.80,108448.33,35103.96
"Orion Italy",16618,291764.43,137517.50,108448.33,45798.60
"Orion Italy",16649,285562.35,135284.00,111002.92,39275.43
"Orion Italy",16680,129519.07,59947.75,111002.92,-41431.59
"Orion Italy",16710,126721.18,58420.05,111002.92,-42701.79
"Orion Italy",16741,137506.48,63322.35,111002.92,-36818.79
"Orion Italy",16771,277160.38,129382.85,113172.50,34605.03
"Orion Italy",16802,160998.06,73760.60,108079.58,-20842.13
"Orion Italy",16833,131144.94,59826.60,108079.58,-36761.24
"Orion Italy",16861,129959.12,59970.85,108079.58,-38091.31
"Orion Italy",16892,153405.08,71944.40,108079.58,-26618.90
"Orion Italy",16922,219236.05,102776.15,108079.58,8380.32
"Orion Italy",16953,266684.19,125481.25,108079.58,33123.35
"Orion Italy",16983,226428.97,106298.25,108079.58,12051.13
"Orion Italy",17014,236307.01,110601.20,108079.58,17626.23
"Orion Italy",17045,120931.54,56041.40,108079.58,-43189.44
"Orion Italy",17075,106217.30,49161.00,108079.58,-51023.28
"Orion Italy",17106,133667.10,61483.10,108079.58,-35895.58
"Orion Italy",17136,279949.57,128360.05,108079.58,43509.94
"Orion Italy",17167,163397.16,75584.90,96621.67,-8809.41
"Orion Italy",17198,169219.95,76735.70,98849.58,-6365.34
"Orion Italy",17226,129498.50,59186.10,105869.17,-35556.77
"Orion Italy",17257,187151.50,86832.75,116953.33,-16634.58
"Orion Italy",17287,256815.08,120293.50,121865.42,14656.16
"Orion Italy",17318,305601.95,144656.95,121865.42,39079.58
"Orion Italy",17348,353190.16,167618.65,131110.00,54461.51
"Orion Italy",17379,351737.92,165134.55,138132.08,48471.28
"Orion Italy",17410,189276.45,87819.30,142762.92,-41305.77
"Orion Italy",17440,179589.20,82061.50,147387.08,-49859.38
"Orion Italy",17471,208860.44,95255.55,155011.25,-41406.36
"Orion Italy",17501,517645.37,241097.60,170178.33,106369.44
"Orion Spain",15706,100365.50,47077.85,128640.00,-75352.35
"Orion Spain",15737,72738.35,33676.60,128640.00,-89578.25
"Orion Spain",15765,94830.20,44886.15,128640.00,-78695.95
"Orion Spain",15796,133375.13,63182.95,128640.00,-58447.83
"Orion Spain",15826,159129.17,75310.45,128640.00,-44821.28
"Orion Spain",15857,223163.38,104954.40,128640.00,-10431.03
"Orion Spain",15887,233383.85,110448.35,128640.00,-5704.50
"Orion Spain",15918,227710.45,106652.85,128640.00,-7582.40
"Orion Spain",15949,84297.90,40388.25,128640.00,-84730.35
"Orion Spain",15979,81539.03,38597.25,128640.00,-85698.22
"Orion Spain",16010,89964.75,42110.45,128640.00,-80785.70
"Orion Spain",16040,202429.07,95328.35,130805.42,-23704.69
"Orion Spain",16071,100967.22,47406.80,122366.25,-68805.83
"Orion Spain",16102,75958.05,35633.75,124164.58,-83840.28
"Orion Spain",16131,94843.53,45066.15,124164.58,-74387.21
"Orion Spain",16162,129297.00,61990.65,126056.67,-58750.32
"Orion Spain",16192,154807.90,73119.30,128515.42,-46826.82
"Orion Spain",16223,182099.03,85492.05,128515.42,-31908.44
"Orion Spain",16253,179016.43,84388.10,128515.42,-33887.09
"Orion Spain",16284,195970.60,91825.60,130805.42,-26660.42
"Orion Spain",16315,70465.87,33277.75,130805.42,-93617.29
"Orion Spain",16345,69021.00,32250.50,130805.42,-94034.92
"Orion Spain",16376,72010.15,33736.15,130805.42,-92531.42
"Orion Spain",16406,174679.83,82326.55,132906.67,-40553.39
"Orion Spain",16437,120410.00,56270.80,120115.42,-55976.22
"Orion Spain",16468,97459.93,46417.55,120115.42,-69073.04
"Orion Spain",16496,112891.17,53225.55,122280.83,-62615.21
"Orion Spain",16527,151867.47,71787.75,122280.83,-42201.12
"Orion Spain",16557,200519.57,94383.85,124572.08,-18436.36
"Orion Spain",16588,234978.53,111394.25,127219.17,-3634.89
"Orion Spain",16618,254834.02,120401.90,127219.17,7212.95
"Orion Spain",16649,259950.06,122150.20,127219.17,10580.69
"Orion Spain",16680,113524.85,52957.80,129308.33,-68741.28
"Orion Spain",16710,88567.85,41712.90,129308.33,-82453.38
"Orion Spain",16741,94512.95,44146.60,129308.33,-78941.98
"Orion Spain",16771,252606.26,120084.65,133797.08,-1275.47
"Orion Spain",16802,107259.40,50024.80,116454.17,-59219.57
"Orion Spain",16833,88151.30,41120.90,118537.92,-71507.52
"Orion Spain",16861,94177.15,44004.40,122762.50,-72589.75
"Orion Spain",16892,144418.10,68663.45,122762.50,-47007.85
"Orion Spain",16922,164711.44,77884.80,127251.25,-40424.61
"Orion Spain",16953,182115.71,85582.35,127251.25,-30717.89
"Orion Spain",16983,212608.98,102971.45,127251.25,-17613.72
"Orion Spain",17014,200849.71,94474.40,127251.25,-20875.94
"Orion Spain",17045,96644.28,46009.75,129409.17,-78774.64
"Orion Spain",17075,82959.68,38823.85,129409.17,-85273.34
"Orion Spain",17106,90233.17,42532.80,131626.67,-83926.29
"Orion Spain",17136,195062.18,93326.25,131626.67,-29890.73
"Orion Spain",17167,113441.45,53163.00,118612.08,-58333.63
"Orion Spain",17198,76273.35,35928.50,118612.08,-78267.23
"Orion Spain",17226,97471.42,45916.65,118612.08,-67057.31
"Orion Spain",17257,162565.14,77551.85,122545.42,-37532.13
"Orion Spain",17287,182567.91,85735.05,127332.50,-30499.64
"Orion Spain",17318,269504.62,128732.70,131942.92,8829.00
"Orion Spain",17348,256664.58,121603.95,134045.00,1015.63
"Orion Spain",17379,273313.19,129012.80,138448.33,5852.06
"Orion Spain",17410,126540.57,59557.25,140850.42,-73867.09
"Orion Spain",17440,119178.97,55801.55,143052.92,-79675.49
"Orion Spain",17471,124991.50,58971.15,143052.92,-77032.57
"Orion Spain",17501,282957.78,132695.40,145234.17,5028.21
"Orion UK",15706,108512.29,50699.73,178536.67,-120724.11
"Orion UK",15737,87090.12,39279.85,178536.67,-130726.40
"Orion UK",15765,106629.08,50154.23,178536.67,-122061.82
"Orion UK",15796,127734.56,60814.18,178536.67,-111616.29
"Orion UK",15826,172245.86,81260.40,178536.67,-87551.21
"Orion UK",15857,234425.06,110389.80,178536.67,-54501.41
"Orion UK",15887,240349.43,113075.41,178536.67,-51262.65
"Orion UK",15918,213329.95,99477.60,178536.67,-64684.32
"Orion UK",15949,107123.90,49073.50,178536.67,-120486.27
"Orion UK",15979,96386.20,44353.30,178536.67,-126503.77
"Orion UK",16010,95711.90,43464.68,178536.67,-126289.44
"Orion UK",16040,218324.55,101358.10,178536.67,-61570.22
"Orion UK",16071,123760.92,57760.26,175747.08,-109746.42
"Orion UK",16102,104245.02,48237.33,175747.08,-119739.39
"Orion UK",16131,106736.81,49379.00,175747.08,-118389.27
"Orion UK",16162,171925.82,82002.71,175747.08,-85823.97
"Orion UK",16192,186224.69,86602.30,178427.50,-78805.11
"Orion UK",16223,252622.33,120145.45,182870.00,-50393.12
"Orion UK",16253,249418.97,118382.76,185155.00,-54118.79
"Orion UK",16284,231254.24,108825.40,187789.58,-65360.75
"Orion UK",16315,106722.05,50085.15,187789.58,-131152.68
"Orion UK",16345,104922.08,47469.20,187789.58,-130336.70
"Orion UK",16376,103518.05,47226.91,187789.58,-131498.44
"Orion UK",16406,237606.27,111232.60,190249.58,-63875.91
"Orion UK",16437,178265.31,82002.13,165034.17,-68770.99
"Orion UK",16468,153570.96,70257.50,167454.58,-84141.12
"Orion UK",16496,165624.49,77919.83,172112.50,-84407.84
"Orion UK",16527,221268.23,103665.03,174286.67,-56683.47
"Orion UK",16557,278080.25,130137.91,178822.92,-30880.58
"Orion UK",16588,366456.64,173350.00,178822.92,14283.72
"Orion UK",16618,359508.53,170744.40,181090.00,7674.13
"Orion UK",16649,325248.20,152905.86,183560.00,-11217.66
"Orion UK",16680,183658.05,85243.31,183560.00,-85145.26
"Orion UK",16710,139920.59,64735.43,188127.50,-112942.34
"Orion UK",16741,153784.23,70825.74,188127.50,-105169.01
"Orion UK",16771,323317.25,149588.30,190338.33,-16609.38
"Orion UK",16802,156274.34,71597.66,159834.58,-75157.90
"Orion UK",16833,102533.43,46804.65,159834.58,-104105.80
"Orion UK",16861,124564.70,57803.25,159834.58,-93073.13
"Orion UK",16892,177572.91,82936.18,159834.58,-65197.86
"Orion UK",16922,205876.10,97086.80,159834.58,-51045.28
"Orion UK",16953,294926.84,138065.85,164235.00,-7374.01
"Orion UK",16983,260032.14,124746.55,169148.75,-33863.16
"Orion UK",17014,277718.26,131060.14,174103.33,-27445.21
"Orion UK",17045,121080.53,55519.98,176277.50,-110716.95
"Orion UK",17075,120016.16,54754.20,178520.00,-113258.04
"Orion UK",17106,126941.09,58364.46,178520.00,-109943.37
"Orion UK",17136,264353.97,122132.22,178520.00,-36298.25
"Orion UK",17167,145401.76,66878.70,152727.50,-74204.44
"Orion UK",17198,118265.38,54491.95,155027.50,-91254.07
"Orion UK",17226,127846.74,59542.98,160088.75,-91784.99
"Orion UK",17257,189793.13,89321.35,160088.75,-59616.97
"Orion UK",17287,234994.34,110066.25,174067.08,-49138.99
"Orion UK",17318,297554.48,139330.75,181307.92,-23084.19
"Orion UK",17348,320699.96,151077.15,190420.00,-20797.19
"Orion UK",17379,352647.82,166143.60,192608.75,-6104.53
"Orion UK",17410,152904.62,71088.04,194897.08,-113080.50
"Orion UK",17440,132360.02,61128.69,197625.83,-126394.50
"Orion UK",17471,153281.78,70263.71,200190.00,-117171.93
"Orion UK",17501,309032.83,143994.78,228999.17,-63961.12
"Orion USA",15706,225931.56,103951.45,231745.42,-109765.31
"Orion USA",15737,174599.75,80114.56,234429.58,-139944.39
"Orion USA",15765,178079.57,82650.57,236788.75,-141359.75
"Orion USA",15796,259650.25,123109.05,236788.75,-100247.55
"Orion USA",15826,304482.73,142804.03,239434.58,-77755.88
"Orion USA",15857,364611.03,170933.97,239434.58,-45757.52
"Orion USA",15887,420615.11,199410.36,239434.58,-18229.84
"Orion USA",15918,430906.43,203123.32,241574.58,-13791.47
"Orion USA",15949,190249.20,89319.92,244303.33,-143374.06
"Orion USA",15979,183072.15,85351.95,246492.50,-148772.30
"Orion USA",16010,198565.00,93115.36,246492.50,-141042.86
"Orion USA",16040,471282.15,218007.65,248780.83,4493.66
"Orion USA",16071,293680.43,136148.38,259392.50,-101860.45
"Orion USA",16102,234808.73,107388.34,259392.50,-131972.11
"Orion USA",16131,246300.71,114804.82,259392.50,-127896.61
"Orion USA",16162,336434.36,159694.11,261689.17,-84948.92
"Orion USA",16192,380658.77,178189.46,264049.58,-61580.27
"Orion USA",16223,477598.62,226450.39,266333.75,-15185.52
"Orion USA",16253,445293.33,215113.43,266333.75,-36153.85
"Orion USA",16284,461491.59,218913.06,266333.75,-23755.22
"Orion USA",16315,210967.48,99754.12,268798.33,-157584.97
"Orion USA",16345,201803.96,94598.46,270962.08,-163756.58
"Orion USA",16376,244240.32,114254.63,270962.08,-140976.40
"Orion USA",16406,501889.65,235291.83,273247.50,-6649.68
"Orion USA",16437,365197.72,169607.64,230333.33,-34743.25
"Orion USA",16468,292765.89,133898.20,236902.92,-78035.23
"Orion USA",16496,291342.43,135599.18,236902.92,-81159.67
"Orion USA",16527,415179.20,200262.28,236902.92,-21986.00
"Orion USA",16557,493597.81,233553.42,241343.33,18701.06
"Orion USA",16588,641805.71,304697.80,246434.58,90673.33
"Orion USA",16618,629404.30,303298.98,246434.58,79670.74
"Orion USA",16649,630421.99,299619.49,251339.58,79462.92
"Orion USA",16680,300842.12,140858.55,259809.58,-99826.01
"Orion USA",16710,303502.54,142267.72,259809.58,-98574.76
"Orion USA",16741,310269.25,145514.55,264452.92,-99698.22
"Orion USA",16771,683587.63,318957.92,264452.92,100176.79
"Orion USA",16802,292939.03,136115.27,234520.42,-77696.65
"Orion USA",16833,210246.61,97117.83,234520.42,-121391.64
"Orion USA",16861,229167.55,106735.06,236955.83,-114523.34
"Orion USA",16892,327162.88,156347.73,239150.00,-68334.85
"Orion USA",16922,382384.78,180117.11,239150.00,-36882.33
"Orion USA",16953,460794.06,218823.10,241269.58,701.38
"Orion USA",16983,503019.79,241222.32,243879.58,17917.88
"Orion USA",17014,484314.20,230499.33,249046.25,4768.62
"Orion USA",17045,226015.16,105458.33,249046.25,-128489.42
"Orion USA",17075,213751.80,99632.02,257835.00,-143715.23
"Orion USA",17106,226345.83,104795.52,257835.00,-136284.69
"Orion USA",17136,529445.09,248152.69,257835.00,23457.40
"Orion USA",17167,276007.37,127969.01,237447.50,-89409.14
"Orion USA",17198,236378.47,108007.88,239896.25,-111525.66
"Orion USA",17226,217247.44,101210.16,249622.92,-133585.64
"Orion USA",17257,356954.11,169646.00,259283.75,-71975.64
"Orion USA",17287,383245.49,179867.83,261573.33,-58195.67
"Orion USA",17318,488858.21,231794.14,263832.92,-6768.85
"Orion USA",17348,512249.23,244221.83,270768.33,-2740.93
"Orion USA",17379,517081.15,243610.42,280820.42,-7349.68
"Orion USA",17410,263649.38,123386.87,287457.08,-147194.57
"Orion USA",17440,250917.55,116742.29,292180.42,-158005.16
"Orion USA",17471,293020.14,135564.20,300914.17,-143458.23
"Orion USA",17501,718531.59,336549.69,338259.17,43722.73
"Purchasing",15706,9762.30,4473.90,43646.67,-38358.27
"Purchasing",15737,7858.20,3645.35,43646.67,-39433.82
"Purchasing",15765,8173.20,3745.50,43646.67,-39218.97
"Purchasing",15796,10923.40,5161.65,43646.67,-37884.92
"Purchasing",15826,16634.00,7763.65,43646.67,-34776.32
"Purchasing",15857,18596.20,8916.45,43646.67,-33966.92
"Purchasing",15887,18097.40,8474.85,43646.67,-34024.12
"Purchasing",15918,23688.60,11391.60,43646.67,-31349.67
"Purchasing",15949,12787.60,6448.35,43646.67,-37307.42
"Purchasing",15979,10815.50,4908.55,43646.67,-37739.72
"Purchasing",16010,12080.10,5603.20,43646.67,-37169.77
"Purchasing",16040,23826.00,11307.95,46271.25,-33753.20
"Purchasing",16071,11528.90,5318.25,40720.83,-34510.18
"Purchasing",16102,9196.20,4369.10,40720.83,-35893.73
"Purchasing",16131,13253.10,6151.10,40720.83,-33618.83
"Purchasing",16162,12968.60,6046.10,40720.83,-33798.33
"Purchasing",16192,18269.20,8773.75,40720.83,-31225.38
"Purchasing",16223,23117.62,11456.05,40720.83,-29059.26
"Purchasing",16253,17482.56,7936.25,40720.83,-31174.52
"Purchasing",16284,18907.70,8980.35,43646.67,-33719.32
"Purchasing",16315,9616.90,4628.90,43646.67,-38658.67
"Purchasing",16345,12721.60,5832.60,43646.67,-36757.67
"Purchasing",16376,12437.40,5834.25,43646.67,-37043.52
"Purchasing",16406,18118.66,8503.95,43646.67,-34031.96
"Purchasing",16437,17499.50,8191.35,40720.83,-31412.68
"Purchasing",16468,9294.18,4385.45,40720.83,-35812.10
"Purchasing",16496,15609.00,7352.05,40720.83,-32463.88
"Purchasing",16527,20341.80,9606.15,40720.83,-29985.18
"Purchasing",16557,30266.60,14113.40,40720.83,-24567.63
"Purchasing",16588,40042.88,18963.60,40720.83,-19641.55
"Purchasing",16618,28381.40,13579.05,43511.67,-28709.32
"Purchasing",16649,21605.50,10685.50,43511.67,-32591.67
"Purchasing",16680,17032.70,7944.15,43511.67,-34423.12
"Purchasing",16710,16374.30,7633.80,43511.67,-34771.17
"Purchasing",16741,13677.50,6291.20,43511.67,-36125.37
"Purchasing",16771,21526.06,9836.60,43511.67,-31822.21
"Purchasing",16802,16844.50,7889.45,40720.83,-31765.78
"Purchasing",16833,11918.70,5605.40,40720.83,-34407.53
"Purchasing",16861,8683.10,4020.80,40720.83,-36058.53
"Purchasing",16892,19226.30,9160.45,40720.83,-30654.98
"Purchasing",16922,18988.20,8974.20,40720.83,-30706.83
"Purchasing",16953,23052.50,11063.70,40720.83,-28732.03
"Purchasing",16983,19486.88,9331.70,40720.83,-30565.65
"Purchasing",17014,19404.10,9430.05,40720.83,-30746.78
"Purchasing",17045,11784.00,5526.85,40720.83,-34463.68
"Purchasing",17075,10328.00,4875.95,43511.67,-38059.62
"Purchasing",17106,12518.40,5775.75,43511.67,-36769.02
"Purchasing",17136,13832.04,6683.90,43511.67,-36363.53
"Purchasing",17167,15335.80,7127.65,40720.83,-32512.68
"Purchasing",17198,17313.28,7989.95,40720.83,-31397.50
"Purchasing",17226,18058.80,8320.25,43576.67,-33838.12
"Purchasing",17257,32331.40,15834.60,43576.67,-27079.87
"Purchasing",17287,30894.60,14313.95,46657.50,-30076.85
"Purchasing",17318,40184.96,18830.45,49271.25,-27916.74
"Purchasing",17348,48917.60,23352.20,49271.25,-23705.85
"Purchasing",17379,30777.40,14726.90,49271.25,-33220.75
"Purchasing",17410,14357.10,6844.55,49271.25,-41758.70
"Purchasing",17440,17091.30,8045.20,49271.25,-40225.15
"Purchasing",17471,23711.10,10932.05,49271.25,-36492.20
"Purchasing",17501,27918.84,13240.70,49271.25,-34593.11
"Shared Functions",15706,".",".",226150.42,-226150.42
"Shared Functions",15737,".",".",226150.42,-226150.42
"Shared Functions",15765,".",".",229913.33,-229913.33
"Shared Functions",15796,".",".",233754.17,-233754.17
"Shared Functions",15826,".",".",233754.17,-233754.17
"Shared Functions",15857,".",".",233754.17,-233754.17
"Shared Functions",15887,".",".",233754.17,-233754.17
"Shared Functions",15918,".",".",233754.17,-233754.17
"Shared Functions",15949,".",".",233754.17,-233754.17
"Shared Functions",15979,".",".",233754.17,-233754.17
"Shared Functions",16010,".",".",233754.17,-233754.17
"Shared Functions",16040,".",".",237125.00,-237125.00
"Shared Functions",16071,".",".",216929.58,-216929.58
"Shared Functions",16102,".",".",216929.58,-216929.58
"Shared Functions",16131,".",".",220961.25,-220961.25
"Shared Functions",16162,".",".",227171.25,-227171.25
"Shared Functions",16192,".",".",230448.75,-230448.75
"Shared Functions",16223,".",".",230448.75,-230448.75
"Shared Functions",16253,".",".",234720.83,-234720.83
"Shared Functions",16284,".",".",234720.83,-234720.83
"Shared Functions",16315,".",".",234720.83,-234720.83
"Shared Functions",16345,".",".",234720.83,-234720.83
"Shared Functions",16376,".",".",238467.08,-238467.08
"Shared Functions",16406,".",".",242705.83,-242705.83
"Shared Functions",16437,".",".",202207.50,-202207.50
"Shared Functions",16468,".",".",202207.50,-202207.50
"Shared Functions",16496,".",".",202207.50,-202207.50
"Shared Functions",16527,".",".",202207.50,-202207.50
"Shared Functions",16557,".",".",202207.50,-202207.50
"Shared Functions",16588,".",".",210846.67,-210846.67
"Shared Functions",16618,".",".",210846.67,-210846.67
"Shared Functions",16649,".",".",214457.08,-214457.08
"Shared Functions",16680,".",".",217433.33,-217433.33
"Shared Functions",16710,".",".",217433.33,-217433.33
"Shared Functions",16741,".",".",217433.33,-217433.33
"Shared Functions",16771,".",".",220151.67,-220151.67
"Shared Functions",16802,".",".",201420.83,-201420.83
"Shared Functions",16833,".",".",201420.83,-201420.83
"Shared Functions",16861,".",".",201420.83,-201420.83
"Shared Functions",16892,".",".",201420.83,-201420.83
"Shared Functions",16922,".",".",201420.83,-201420.83
"Shared Functions",16953,".",".",201420.83,-201420.83
"Shared Functions",16983,".",".",201420.83,-201420.83
"Shared Functions",17014,".",".",201420.83,-201420.83
"Shared Functions",17045,".",".",201420.83,-201420.83
"Shared Functions",17075,".",".",205183.75,-205183.75
"Shared Functions",17106,".",".",205183.75,-205183.75
"Shared Functions",17136,".",".",207902.08,-207902.08
"Shared Functions",17167,".",".",201420.83,-201420.83
"Shared Functions",17198,".",".",201420.83,-201420.83
"Shared Functions",17226,".",".",203972.92,-203972.92
"Shared Functions",17257,".",".",206605.42,-206605.42
"Shared Functions",17287,".",".",209502.08,-209502.08
"Shared Functions",17318,".",".",209502.08,-209502.08
"Shared Functions",17348,".",".",212082.08,-212082.08
"Shared Functions",17379,".",".",214362.50,-214362.50
"Shared Functions",17410,".",".",214362.50,-214362.50
"Shared Functions",17440,".",".",214362.50,-214362.50
"Shared Functions",17471,".",".",214362.50,-214362.50
"Shared Functions",17501,".",".",214362.50,-214362.50
;;;;
run;


** data for ATTRMAP example;
/* Create the input data set ICECREAM */
data icecream;
   length Flavor $10 Rank 3 Grp $1;
   infile datalines dlm=',';
   input Flavor $ Rank  Grp $ ;
   datalines;
Strawberry,2,B
Chocolate,1,B
Vanilla,3,B
Strawberry,2,A
Vanilla,1,A
;
run;
 
proc sort data=icecream;
  by grp;
run;

** data for SGMAP examples;
data work.STATE_INFO;
  infile datalines dsd truncover;
  input State_Name:$15. State:$2. Region:$16. Division:$18. Coastal_State:$3. Coast:$11. State_MedianIncomeEst:DOLLAR16. 
        State_PopulationEst:COMMA16. State_PopChgEst:COMMA16. Capital_City:$14. Capital_Area:COMMA16. 
        Capital_PopulationEst:COMMA16. Capital_PopulationPct:PERCENT7.2;
  format State_MedianIncomeEst DOLLAR16. State_PopulationEst COMMA16. State_PopChgEst COMMA16. Capital_Area COMMA16. 
         Capital_PopulationEst COMMA16. Capital_PopulationPct PERCENT7.2;
  label State_Name="State Name" Coastal_State="Coastal State" Capital_City="Capital City" Capital_Area="Area" 
        Capital_PopulationEst="Population";
datalines4;
Alabama,AL,South Region,East South Central,Yes,Gulf,"$49,936","4,887,871","12,751",Montgomery,160,"198,525",4.06%
Arizona,AZ,West Region,Mountain,No,,"$62,283","7,171,646","122,770",Phoenix,518,"1,680,992",23.4%
Arkansas,AR,South Region,West South Central,No,,"$49,781","3,013,825","10,828",Little Rock,116,"197,312",6.55%
California,CA,West Region,Pacific,Yes,Pacific,"$70,489","39,557,045","157,696",Sacramento,98,"513,624",1.30%
Colorado,CO,West Region,Mountain,No,,"$73,034","5,695,564","79,662",Denver,153,"727,211",12.8%
Connecticut,CT,Northeast Region,New England,Yes,Atlantic,"$72,812","3,572,665","-1,215",Hartford,17,"122,105",3.42%
Delaware,DE,South Region,South Atlantic,Yes,Atlantic,"$65,012","967,171","10,093",Dover,22,"38,079",3.94%
Florida,FL,South Region,South Atlantic,Yes,Atlantic,"$54,644","21,299,325","322,513",Tallahassee,96,"194,500",0.91%
Georgia,GA,South Region,South Atlantic,Yes,Atlantic,"$55,821","10,519,475","106,420",Atlanta,134,"506,811",4.82%
Idaho,ID,West Region,Mountain,No,,"$58,728","1,754,208","35,304",Boise,64,"228,959",13.1%
Illinois,IL,Midwest Region,East North Central,Yes,Great Lakes,"$70,145","12,741,080","-45,116",Springfield,54,"114,230",0.90%
Indiana,IN,Midwest Region,East North Central,Yes,Great Lakes,"$59,892","6,691,878","31,796",Indianapolis,362,"876,384",13.1%
Iowa,IA,Midwest Region,West North Central,No,,"$68,718","3,156,145","12,508",Des Moines,76,"214,237",6.79%
Kansas,KS,Midwest Region,West North Central,No,,"$63,938","2,911,505",816,Topeka,56,"125,310",4.30%
Kentucky,KY,South Region,East South Central,No,,"$54,555","4,468,402","14,528",Frankfort,15,"27,679",0.62%
Louisiana,LA,South Region,West South Central,Yes,Gulf,"$49,973","4,659,978","-10,840",Baton Rouge,77,"220,236",4.73%
Maine,ME,Northeast Region,New England,Yes,Atlantic,"$58,663","1,338,404","3,341",Augusta,55,"18,681",1.40%
Maryland,MD,South Region,South Atlantic,Yes,Atlantic,"$86,223","6,042,718","17,827",Annapolis,7,"39,174",0.65%
Massachusetts,MA,Northeast Region,New England,Yes,Atlantic,"$86,345","6,902,149","38,903",Boston,90,"692,600",10.0%
Michigan,MI,Midwest Region,East North Central,Yes,Great Lakes,"$60,449","9,995,915","19,468",Lansing,35,"118,210",1.18%
Minnesota,MN,Midwest Region,West North Central,Yes,Great Lakes,"$71,817","5,611,179","43,024",Saint Paul,53,"308,096",5.49%
Mississippi,MS,South Region,East South Central,Yes,Gulf,"$42,781","2,986,530","-3,133",Jackson,105,"160,628",5.38%
Missouri,MO,Midwest Region,West North Central,No,,"$61,726","6,126,452","17,840",Jefferson City,27,"42,838",0.70%
Montana,MT,West Region,Mountain,No,,"$57,679","1,062,305","9,215",Helena,14,"32,315",3.04%
Nebraska,NE,Midwest Region,West North Central,No,,"$67,575","1,929,268","11,693",Lincoln,75,"289,102",15.0%
Nevada,NV,West Region,Mountain,No,,"$61,864","3,034,392","61,987",Carson City,143,"55,916",1.84%
New Hampshire,NH,Northeast Region,New England,Yes,Atlantic,"$81,346","1,356,458","6,691",Concord,64,"43,412",3.20%
New Jersey,NJ,Northeast Region,Middle Atlantic,Yes,Atlantic,"$74,176","8,908,520","19,977",Trenton,8,"83,203",0.93%
New Mexico,NM,West Region,Mountain,No,,"$48,283","2,095,428","2,033",Santa Fe,37,"84,683",4.04%
New York,NY,Northeast Region,Middle Atlantic,Yes,"Atlantic, G","$67,274","19,542,209","-48,510",Albany,21,"96,460",0.49%
North Carolina,NC,South Region,South Atlantic,Yes,Atlantic,"$53,369","10,383,620","112,820",Raleigh,115,"474,069",4.57%
North Dakota,ND,Midwest Region,West North Central,No,,"$66,505","760,077","4,901",Bismarck,27,"73,529",9.67%
Ohio,OH,Midwest Region,East North Central,Yes,Great Lakes,"$61,633","11,689,442","25,313",Columbus,210,"898,553",7.69%
Oklahoma,OK,South Region,West South Central,No,,"$54,434","3,943,079","10,439",Oklahoma City,620,"655,057",16.6%
Oregon,OR,West Region,Pacific,Yes,Pacific,"$69,165","4,190,713","44,121",Salem,46,"174,365",4.16%
Pennsylvania,PA,Northeast Region,Middle Atlantic,Yes,Great Lakes,"$64,524","12,807,060","16,613",Harrisburg,8,"49,528",0.39%
Rhode Island,RI,Northeast Region,New England,Yes,Atlantic,"$62,266","1,057,315",829,Providence,19,"179,883",17.0%
South Carolina,SC,South Region,South Atlantic,Yes,Atlantic,"$57,444","5,084,127","62,908",Columbia,125,"131,674",2.59%
South Dakota,SD,Midwest Region,West North Central,No,,"$59,463","882,235","8,949",Pierre,13,"13,646",1.55%
Tennessee,TN,South Region,East South Central,No,,"$56,060","6,770,010","61,216",Nashville,526,"670,820",9.91%
Texas,TX,South Region,West South Central,Yes,Gulf,"$59,785","28,701,845","379,128",Austin,305,"978,908",3.41%
Utah,UT,West Region,Mountain,No,,"$77,067","3,161,105","57,987",Salt Lake City,109,"200,567",6.34%
Vermont,VT,Northeast Region,New England,No,,"$70,066","626,299","1,774",Montpelier,10,"7,855",1.25%
Virginia,VA,South Region,South Atlantic,Yes,Atlantic,"$77,151","8,517,685","52,478",Richmond,60,"230,436",2.71%
Washington,WA,West Region,Pacific,Yes,Pacific,"$79,726","7,535,591","110,159",Olympia,17,"46,478",0.62%
West Virginia,WV,South Region,South Atlantic,No,,"$50,573","1,805,832","-11,216",Charleston,32,"46,536",2.58%
Wisconsin,WI,Midwest Region,East North Central,Yes,Great Lakes,"$62,629","5,813,568","21,517",Madison,69,"259,680",4.47%
Wyoming,WY,West Region,Mountain,No,,"$62,539","577,737","-1,197",Cheyenne,21,"64,235",11.1%
;;;;
run;


data work.STATE_INFO_GEO;
  infile datalines dsd truncover;
  input State_Name:$15. State:$2. Region:$16. Division:$18. Coastal_State:$3. Coast:$11. State_MedianIncomeEst:DOLLAR16. 
        State_PopulationEst:COMMA16. State_PopChgEst:COMMA16. Capital_City:$14. Capital_Area:COMMA16. 
        Capital_PopulationEst:COMMA16. Capital_PopulationPct:PERCENT7.2 Y:32. X:32.;
  format State_MedianIncomeEst DOLLAR16. State_PopulationEst COMMA16. State_PopChgEst COMMA16. 
         Capital_Area COMMA16. Capital_PopulationEst COMMA16. Capital_PopulationPct PERCENT7.2;
  label State_Name="State Name" Coastal_State="Coastal State" Capital_City="Capital City" Capital_Area="Area" 
        Capital_PopulationEst="Population" Y="Capital Latitude (DEGREES)" X="Capital Longitude (DEGREES)";
datalines4;
Alabama,AL,South Region,East South Central,Yes,Gulf,"$49,936","4,887,871","12,751",Montgomery,160,"198,525",4.06%,32.374213212,-86.26258933
Arizona,AZ,West Region,Mountain,No,,"$62,283","7,171,646","122,770",Phoenix,518,"1,680,992",23.4%,33.514439197,-112.0764216
Arkansas,AR,South Region,West South Central,No,,"$49,781","3,013,825","10,828",Little Rock,116,"197,312",6.55%,34.74341832,-92.33653544
California,CA,West Region,Pacific,Yes,Pacific,"$70,489","39,557,045","157,696",Sacramento,98,"513,624",1.30%,38.57439882,-121.4712344
Colorado,CO,West Region,Mountain,No,,"$73,034","5,695,564","79,662",Denver,153,"727,211",12.8%,39.737268318,-104.9821116
Connecticut,CT,Northeast Region,New England,Yes,Atlantic,"$72,812","3,572,665","-1,215",Hartford,17,"122,105",3.42%,41.772460389,-72.68509081
Delaware,DE,South Region,South Atlantic,Yes,Atlantic,"$65,012","967,171","10,093",Dover,22,"38,079",3.94%,39.1674224,-75.5351294
Florida,FL,South Region,South Atlantic,Yes,Atlantic,"$54,644","21,299,325","322,513",Tallahassee,96,"194,500",0.91%,30.44765355,-84.2599008
Georgia,GA,South Region,South Atlantic,Yes,Atlantic,"$55,821","10,519,475","106,420",Atlanta,134,"506,811",4.82%,33.786982663,-84.39070005
Idaho,ID,West Region,Mountain,No,,"$58,728","1,754,208","35,304",Boise,64,"228,959",13.1%,43.60369225,-116.2178835
Illinois,IL,Midwest Region,East North Central,Yes,Great Lakes,"$70,145","12,741,080","-45,116",Springfield,54,"114,230",0.90%,39.790784029,-89.64678463
Indiana,IN,Midwest Region,East North Central,Yes,Great Lakes,"$59,892","6,691,878","31,796",Indianapolis,362,"876,384",13.1%,39.797160541,-86.15447552
Iowa,IA,Midwest Region,West North Central,No,,"$68,718","3,156,145","12,508",Des Moines,76,"214,237",6.79%,41.593497386,-93.65579598
Kansas,KS,Midwest Region,West North Central,No,,"$63,938","2,911,505",816,Topeka,56,"125,310",4.30%,39.040478419,-95.70072355
Kentucky,KY,South Region,East South Central,No,,"$54,555","4,468,402","14,528",Frankfort,15,"27,679",0.62%,38.196887111,-84.88343856
Louisiana,LA,South Region,West South Central,Yes,Gulf,"$49,973","4,659,978","-10,840",Baton Rouge,77,"220,236",4.73%,30.440959667,-91.11825207
Maine,ME,Northeast Region,New England,Yes,Atlantic,"$58,663","1,338,404","3,341",Augusta,55,"18,681",1.40%,44.3305974,-69.7557726
Maryland,MD,South Region,South Atlantic,Yes,Atlantic,"$86,223","6,042,718","17,827",Annapolis,7,"39,174",0.65%,39.001429625,-76.4945465
Massachusetts,MA,Northeast Region,New England,Yes,Atlantic,"$86,345","6,902,149","38,903",Boston,90,"692,600",10.0%,42.355052972,-71.06284489
Michigan,MI,Midwest Region,East North Central,Yes,Great Lakes,"$60,449","9,995,915","19,468",Lansing,35,"118,210",1.18%,42.7213105,-84.57996559
Minnesota,MN,Midwest Region,West North Central,Yes,Great Lakes,"$71,817","5,611,179","43,024",Saint Paul,53,"308,096",5.49%,44.948636,-93.08549626
Mississippi,MS,South Region,East South Central,Yes,Gulf,"$42,781","2,986,530","-3,133",Jackson,105,"160,628",5.38%,32.314539963,-90.19847044
Missouri,MO,Midwest Region,West North Central,No,,"$61,726","6,126,452","17,840",Jefferson City,27,"42,838",0.70%,38.566036455,-92.17663382
Montana,MT,West Region,Mountain,No,,"$57,679","1,062,305","9,215",Helena,14,"32,315",3.04%,46.604746625,-112.0283235
Nebraska,NE,Midwest Region,West North Central,No,,"$67,575","1,929,268","11,693",Lincoln,75,"289,102",15.0%,40.817010517,-96.683642
Nevada,NV,West Region,Mountain,No,,"$61,864","3,034,392","61,987",Carson City,143,"55,916",1.84%,39.1315228,-119.7560008
New Hampshire,NH,Northeast Region,New England,Yes,Atlantic,"$81,346","1,356,458","6,691",Concord,64,"43,412",3.20%,43.2456065,-71.562057
New Jersey,NJ,Northeast Region,Middle Atlantic,Yes,Atlantic,"$74,176","8,908,520","19,977",Trenton,8,"83,203",0.93%,40.218859111,-74.72683278
New Mexico,NM,West Region,Mountain,No,,"$48,283","2,095,428","2,033",Santa Fe,37,"84,683",4.04%,35.692649,-105.9749574
New York,NY,Northeast Region,Middle Atlantic,Yes,"Atlantic, G","$67,274","19,542,209","-48,510",Albany,21,"96,460",0.49%,42.666103625,-73.78636129
North Carolina,NC,South Region,South Atlantic,Yes,Atlantic,"$53,369","10,383,620","112,820",Raleigh,115,"474,069",4.57%,35.813521023,-78.64895498
North Dakota,ND,Midwest Region,West North Central,No,,"$66,505","760,077","4,901",Bismarck,27,"73,529",9.67%,46.808947571,-100.722462
Ohio,OH,Midwest Region,East North Central,Yes,Great Lakes,"$61,633","11,689,442","25,313",Columbus,210,"898,553",7.69%,39.991176311,-82.98887591
Oklahoma,OK,South Region,West South Central,No,,"$54,434","3,943,079","10,439",Oklahoma City,620,"655,057",16.6%,35.4762895,-97.52132642
Oregon,OR,West Region,Pacific,Yes,Pacific,"$69,165","4,190,713","44,121",Salem,46,"174,365",4.16%,44.938091857,-123.013788
Pennsylvania,PA,Northeast Region,Middle Atlantic,Yes,Great Lakes,"$64,524","12,807,060","16,613",Harrisburg,8,"49,528",0.39%,40.274658077,-76.85533431
Rhode Island,RI,Northeast Region,New England,Yes,Atlantic,"$62,266","1,057,315",829,Providence,19,"179,883",17.0%,41.8243555,-71.42062867
South Carolina,SC,South Region,South Atlantic,Yes,Atlantic,"$57,444","5,084,127","62,908",Columbia,125,"131,674",2.59%,34.020462353,-81.02090868
South Dakota,SD,Midwest Region,West North Central,No,,"$59,463","882,235","8,949",Pierre,13,"13,646",1.55%,44.44692,-100.18752
Tennessee,TN,South Region,East South Central,No,,"$56,060","6,770,010","61,216",Nashville,526,"670,820",9.91%,36.146408333,-86.77805367
Texas,TX,South Region,West South Central,Yes,Gulf,"$59,785","28,701,845","379,128",Austin,305,"978,908",3.41%,30.299895946,-97.75469528
Utah,UT,West Region,Mountain,No,,"$77,067","3,161,105","57,987",Salt Lake City,109,"200,567",6.34%,40.728690654,-111.8926818
Vermont,VT,Northeast Region,New England,No,,"$70,066","626,299","1,774",Montpelier,10,"7,855",1.25%,44.257548429,-72.58116986
Virginia,VA,South Region,South Atlantic,Yes,Atlantic,"$77,151","8,517,685","52,478",Richmond,60,"230,436",2.71%,37.536359359,-77.45762195
Washington,WA,West Region,Pacific,Yes,Pacific,"$79,726","7,535,591","110,159",Olympia,17,"46,478",0.62%,47.028008545,-122.8907991
West Virginia,WV,South Region,South Atlantic,No,,"$50,573","1,805,832","-11,216",Charleston,32,"46,536",2.58%,38.357227956,-81.62902002
Wisconsin,WI,Midwest Region,East North Central,Yes,Great Lakes,"$62,629","5,813,568","21,517",Madison,69,"259,680",4.47%,43.078241343,-89.3794364
Wyoming,WY,West Region,Mountain,No,,"$62,539","577,737","-1,197",Cheyenne,21,"64,235",11.1%,41.173754125,-104.8210586
;;;;
run;


data work.ORDERS_SUMMARY_GEO;
  infile datalines dsd truncover;
  input Country:$2. Total_Quantity:32. Sale_Amount_Sum:DOLLAR13.2 Sale_Amount_Avg:DOLLAR13.2 
        QuantityTarget:32. Sale_Amount_Target:DOLLAR16.2 Sale_Amount_Avg_Target:DOLLAR16.2 lat:32. long:32.;
  format Sale_Amount_Sum DOLLAR13.2 Sale_Amount_Avg DOLLAR13.2 Sale_Amount_Target DOLLAR16.2 Sale_Amount_Avg_Target DOLLAR16.2;
  label Country="Customer Country" Total_Quantity="Quantity Ordered" Sale_Amount_Sum="Total Sales" 
        Sale_Amount_Avg="Average Sale Per Order" QuantityTarget="Quantity Target" Sale_Amount_Target="Sale Total Target" 
        Sale_Amount_Avg_Target="Sales Average Target Per Order";
datalines4;
US,539,"$43,525.10",$142.71,582,"$47,057.09",$154.29,37.09024,-95.712891
AU,210,"$17,321.49",$134.28,233,"$19,245.45",$149.19,-25.274398,133.775136
DE,106,"$15,394.60",$265.42,92,"$13,428.34",$231.52,51.165691,10.451526
CA,105,"$11,951.08",$217.29,96,"$10,973.41",$199.52,56.130366,-106.346771
TR,43,"$5,175.80",$199.07,51,"$6,175.66",$237.53,38.963745,35.243322
ZA,47,"$5,149.90",$206.00,46,"$5,113.96",$204.56,-30.559482,22.937506
IL,28,"$1,559.50",$82.08,25,"$1,426.29",$75.07,31.046051,34.851612
;;;;
run;


data work.US_STORES_GEO(label='Geocoded 15Jul2020');
  infile datalines dsd truncover;
  input Y:32. X:32. M_OBS:32. _MATCHED_:$16. State_Name:$15. City:$14. Sales:DOLLAR16. Zip_Code:32.;
  format Sales DOLLAR16.;
  label Y="Geocoded Latitude (DEGREES)" X="Geocoded Longitude (DEGREES)" State_Name="State Name" City="Capital City";
datalines4;
33.449215,-112.069209,35637,ZIP,Arizona,Phoenix,"$16,809,920",85001
34.632983,-92.486426,30301,ZIP,Arkansas,Little Rock,"$2,762,368",72002
38.584351,-121.493764,38489,ZIP,California,Sacramento,"$5,136,240",94203
39.65988,-104.83698,34143,ZIP,Colorado,Denver,"$7,272,110",80014
43.62234,-116.322069,35198,ZIP,Idaho,Boise,"$3,434,385",83701
30.446043,-91.185434,29822,ZIP,Louisiana,Baton Rouge,"$3,303,540",70801
46.625304,-112.009553,25174,ZIP,Montana,Helena,"$581,670",59601
39.270238,-119.538034,36819,ZIP,Nevada,Carson City,"$1,006,488",89403
35.6997,-105.9672,36307,ZIP,New Mexico,Santa Fe,"$1,608,977",87501
35.50294,-97.64479,30856,ZIP,Oklahoma,Oklahoma City,"$5,895,513",73008
44.928656,-122.960707,39843,ZIP,Oregon,Salem,"$1,918,015",97301
30.220228,-97.749942,31012,ZIP,Texas,Austin,"$8,810,172",73301
40.66949,-112.140714,35331,ZIP,Utah,Salt Lake City,"$2,005,670",84044
46.99086,-122.87388,40483,ZIP,Washington,Olympia,"$836,604",98501
41.143114,-104.792918,34777,ZIP,Wyoming,Cheyenne,"$1,220,465",82001
;;;;
run;

** OPENSTREETMAP Example;
** Used sashelp.springs and Michigan data for a Cold Springs;
** to create a dataset for plotting;
data michigan;
  length name $34 Area $14 Type $9;
  infile datalines dlm=',';
  input latitude longitude Name $ Area $ Type $ Farenheit Celsius;
return;
datalines;
45.9585838,-86.2501416, Kitch-iti-kipi, Michigan, Cold,45,7.2
;
run;

data eastUSsprings;
  set michigan 
      sashelp.springs(where=(longitude ge -88.0000));
  if area = 'Michigan' and Type='Cold' then dlabel=catx(' ',Name,'Brrr!!');
  else dlabel=' ';
run;

proc contents data=orion._all_ nods;
title 'Use ORION or WORK to reference these file';
run;
  


